"""This is a wrapper module for Aspose.PSD .NET assembly"""

from typing import Any

def get_pyinstaller_hook_dirs() -> Any:
  """Function required by PyInstaller. Returns paths to module 
  PyInstaller hooks. Not intended to be called explicitly."""
    ...

from typing import List, Optional, Dict, Iterable
import aspose.pycore
import aspose.pydrawing
import aspose.psd
import aspose.psd.asynctask
import aspose.psd.brushes
import aspose.psd.coreexceptions
import aspose.psd.coreexceptions.compressors
import aspose.psd.coreexceptions.imageformats
import aspose.psd.customfonthandler
import aspose.psd.dithering
import aspose.psd.evalute
import aspose.psd.exif
import aspose.psd.exif.enums
import aspose.psd.extensions
import aspose.psd.fileformats
import aspose.psd.fileformats.ai
import aspose.psd.fileformats.bmp
import aspose.psd.fileformats.core
import aspose.psd.fileformats.core.blending
import aspose.psd.fileformats.core.vectorpaths
import aspose.psd.fileformats.jpeg
import aspose.psd.fileformats.jpeg2000
import aspose.psd.fileformats.pdf
import aspose.psd.fileformats.png
import aspose.psd.fileformats.psd
import aspose.psd.fileformats.psd.core
import aspose.psd.fileformats.psd.core.rawcolor
import aspose.psd.fileformats.psd.layers
import aspose.psd.fileformats.psd.layers.adjustmentlayers
import aspose.psd.fileformats.psd.layers.animation
import aspose.psd.fileformats.psd.layers.filllayers
import aspose.psd.fileformats.psd.layers.fillsettings
import aspose.psd.fileformats.psd.layers.gradient
import aspose.psd.fileformats.psd.layers.layereffects
import aspose.psd.fileformats.psd.layers.layerresources
import aspose.psd.fileformats.psd.layers.layerresources.lfx2resources
import aspose.psd.fileformats.psd.layers.layerresources.strokeresources
import aspose.psd.fileformats.psd.layers.layerresources.typetoolinfostructures
import aspose.psd.fileformats.psd.layers.smartfilters
import aspose.psd.fileformats.psd.layers.smartfilters.rendering
import aspose.psd.fileformats.psd.layers.smartobjects
import aspose.psd.fileformats.psd.layers.text
import aspose.psd.fileformats.psd.resources
import aspose.psd.fileformats.psd.resources.enums
import aspose.psd.fileformats.psd.resources.resolutionenums
import aspose.psd.fileformats.tiff
import aspose.psd.fileformats.tiff.enums
import aspose.psd.fileformats.tiff.filemanagement
import aspose.psd.flatarray
import aspose.psd.flatarray.exceptions
import aspose.psd.imagefilters
import aspose.psd.imagefilters.filteroptions
import aspose.psd.imageloadoptions
import aspose.psd.imageoptions
import aspose.psd.interfaces
import aspose.psd.memorymanagement
import aspose.psd.multithreading
import aspose.psd.palettehelper
import aspose.psd.progressmanagement
import aspose.psd.shapes
import aspose.psd.shapesegments
import aspose.psd.sources
import aspose.psd.xmp
import aspose.psd.xmp.schemas
import aspose.psd.xmp.schemas.dublincore
import aspose.psd.xmp.schemas.pdf
import aspose.psd.xmp.schemas.photoshop
import aspose.psd.xmp.schemas.xmpbaseschema
import aspose.psd.xmp.schemas.xmpdm
import aspose.psd.xmp.schemas.xmpmm
import aspose.psd.xmp.schemas.xmprm
import aspose.psd.xmp.types
import aspose.psd.xmp.types.basic
import aspose.psd.xmp.types.complex
import aspose.psd.xmp.types.complex.colorant
import aspose.psd.xmp.types.complex.dimensions
import aspose.psd.xmp.types.complex.font
import aspose.psd.xmp.types.complex.resourceevent
import aspose.psd.xmp.types.complex.resourceref
import aspose.psd.xmp.types.complex.thumbnail
import aspose.psd.xmp.types.complex.version
import aspose.psd.xmp.types.derived

class Blend:
    '''Defines a blend pattern. This class cannot be inherited.'''
    
    @property
    def factors(self) -> List[float]:
        '''Gets the array of blend factors for the gradient.'''
        ...
    
    @factors.setter
    def factors(self, value : List[float]):
        '''Sets the array of blend factors for the gradient.'''
        ...
    
    @property
    def positions(self) -> List[float]:
        '''Gets the array of blend positions for the gradient.'''
        ...
    
    @positions.setter
    def positions(self, value : List[float]):
        '''Sets the array of blend positions for the gradient.'''
        ...
    
    ...

class Brush(DisposableObject):
    '''The base brush class.'''
    
    def deep_clone(self) -> aspose.psd.Brush:
        '''Creates a new deep clone of the current :py:class:`aspose.psd.Brush`.
        
        :returns: A new :py:class:`aspose.psd.Brush` which is the deep clone of this :py:class:`aspose.psd.Brush` instance.'''
        ...
    
    @property
    def disposed(self) -> bool:
        '''Gets a value indicating whether this instance is disposed.'''
        ...
    
    @property
    def opacity(self) -> float:
        '''Gets the brush opacity. The value should be between 0 and 1. Value of 0 means that brush is fully visible, value of 1 means the brush is fully opaque.'''
        ...
    
    @opacity.setter
    def opacity(self, value : float):
        '''Sets the brush opacity. The value should be between 0 and 1. Value of 0 means that brush is fully visible, value of 1 means the brush is fully opaque.'''
        ...
    
    ...

class BuildVersionInfo:
    '''Contains the current build version information.'''
    
    @classmethod
    @property
    def ASSEMBLY_VERSION(cls) -> str:
        ...
    
    @classmethod
    @property
    def FILE_VERSION(cls) -> str:
        ...
    
    @classmethod
    @property
    def PRODUCT(cls) -> str:
        '''The product title.'''
        ...
    
    @classmethod
    @property
    def PRODUCT_MAJOR(cls) -> int:
        ...
    
    @classmethod
    @property
    def PRODUCT_MINOR(cls) -> int:
        ...
    
    @classmethod
    @property
    def RELEASE_DATE(cls) -> DateTime:
        ...
    
    ...

class Cache:
    '''Contains cache settings.'''
    
    @staticmethod
    def set_defaults():
        '''Sets the :py:class:`aspose.psd.Cache` settings to defaults.'''
        ...
    
    @classmethod
    @property
    def exact_reallocate_only(cls) -> bool:
        ...
    
    @classmethod
    @exact_reallocate_only.setter
    def exact_reallocate_only(cls, value : bool):
        ...
    
    @classmethod
    @property
    def cache_folder(cls) -> str:
        ...
    
    @classmethod
    @cache_folder.setter
    def cache_folder(cls, value : str):
        ...
    
    @classmethod
    @property
    def allocated_memory_bytes_count(cls) -> int:
        ...
    
    @classmethod
    @property
    def allocated_disk_bytes_count(cls) -> int:
        ...
    
    @classmethod
    @property
    def max_memory_for_cache(cls) -> int:
        ...
    
    @classmethod
    @max_memory_for_cache.setter
    def max_memory_for_cache(cls, value : int):
        ...
    
    @classmethod
    @property
    def max_disk_space_for_cache(cls) -> int:
        ...
    
    @classmethod
    @max_disk_space_for_cache.setter
    def max_disk_space_for_cache(cls, value : int):
        ...
    
    @classmethod
    @property
    def cache_type(cls) -> aspose.psd.CacheType:
        ...
    
    @classmethod
    @cache_type.setter
    def cache_type(cls, value : aspose.psd.CacheType):
        ...
    
    ...

class CmykColor:
    '''The CMYK color of pixel.'''
    
    @overload
    @staticmethod
    def to_cmyk(argb_pixels : List[int]) -> List[aspose.psd.CmykColor]:
        '''The conversion from 32-bit ARGB color to CMYKColor.
        This method is deprecated. Please use more effective :py:func:`aspose.psd.CmykColorHelper.to_cmyk`.
        
        :param argb_pixels: The pixels of 32-bit ARGB format.
        :returns: The :py:class:`List[Aspose:PSD:CmykColor]`.'''
        ...
    
    @overload
    @staticmethod
    def to_cmyk(argb_pixel : int) -> aspose.psd.CmykColor:
        '''The conversion from 32-bit ARGB to CMYKColor.
        This method is deprecated. Please use more effective :py:func:`aspose.psd.CmykColorHelper.to_cmyk`.
        
        :param argb_pixel: The pixel of 32-bit ARGB format.
        :returns: The :py:class:`Aspose:PSD:CmykColor`.'''
        ...
    
    @overload
    @staticmethod
    def to_color(cmyk_pixels : List[aspose.psd.CmykColor]) -> List[aspose.psd.Color]:
        '''The conversion from CMYKColor to Color using icc conversion  with default profiles.
        This method is deprecated. Please use more effective :py:func:`aspose.psd.CmykColorHelper.to_argb`.
        
        :param cmyk_pixels: The pixels of CMYKColor type in CMYK format.
        :returns: The array of the ARGB colors.'''
        ...
    
    @overload
    @staticmethod
    def to_color(cmyk_pixel : aspose.psd.CmykColor) -> aspose.psd.Color:
        '''The conversion from CMYKColor to Color.
        This method is deprecated. Please use more effective :py:func:`aspose.psd.CmykColorHelper.to_argb`.
        
        :param cmyk_pixel: The pixels of CMYKColor type in CMYK format.
        :returns: The :py:class:`List[aspose.psd.Color]`.'''
        ...
    
    @overload
    @staticmethod
    def to_color_icc(cmyk_pixels : List[aspose.psd.CmykColor]) -> List[aspose.psd.Color]:
        '''The conversion from CMYKColor to Color using icc conversion with default profiles.
        This method is deprecated. Please use more effective :py:func:`aspose.psd.CmykColorHelper.to_argb_icc`.
        
        :param cmyk_pixels: The pixels of CMYKColor type in CMYK format.
        :returns: The :py:class:`List[aspose.psd.Color]`.'''
        ...
    
    @overload
    @staticmethod
    def to_color_icc(cmyk_pixel : aspose.psd.CmykColor) -> aspose.psd.Color:
        '''The conversion from CMYKColor to Color using icc conversion with default profiles.
        This method is deprecated. Please use more effective :py:func:`aspose.psd.CmykColorHelper.to_argb_icc`.
        
        :param cmyk_pixel: The pixel of CMYKColor type in CMYK format.
        :returns: The :py:class:`aspose.psd.Color`.'''
        ...
    
    @overload
    @staticmethod
    def to_color_icc(cmyk_pixels : List[aspose.psd.CmykColor]cmyk_icc_stream : io.RawIOBase, rgb_icc_stream : io.RawIOBase) -> List[aspose.psd.Color]:
        '''The conversion from CMYKColor to Color using icc conversion.
        This method is deprecated. Please use more effective :py:func:`aspose.psd.CmykColorHelper.to_argb_icc`.
        
        :param cmyk_pixels: The pixels of CMYKColor type in CMYK format.
        :param cmyk_icc_stream: The stream containing icc cmyk profile.
        :param rgb_icc_stream: The stream containing icc rgb profile.
        :returns: The :py:class:`List[aspose.psd.Color]`.'''
        ...
    
    @overload
    @staticmethod
    def to_color_icc(cmyk_pixel : aspose.psd.CmykColorcmyk_icc_stream : io.RawIOBase, rgb_icc_stream : io.RawIOBase) -> aspose.psd.Color:
        '''The conversion from CMYKColor to Color using icc conversion.
        This method is deprecated. Please use more effective :py:func:`aspose.psd.CmykColorHelper.to_argb_icc`.
        
        :param cmyk_pixel: The pixel of CMYKColor type in CMYK format.
        :param cmyk_icc_stream: The stream containing icc cmyk profile.
        :param rgb_icc_stream: The stream containing icc rgb profile.
        :returns: The :py:class:`aspose.psd.Color`.'''
        ...
    
    @staticmethod
    def from_params(cyan : intmagenta : int, yellow : int, black : int) -> aspose.psd.CmykColor:
        '''Creates a :py:class:`aspose.psd.CmykColor` structure from a 32-bit cyan, magenta, yellow and black values.
        This method is deprecated. Please use more effective :py:func:`aspose.psd.CmykColorHelper.from_components`.
        
        :param cyan: The cyan component. Valid values are 0 through 255.
        :param magenta: The magenta component. Valid values are 0 through 255.
        :param yellow: The yellow component. Valid values are 0 through 255.
        :param black: The black component. Valid values are 0 through 255.
        :returns: The :py:class:`aspose.psd.CmykColor`.'''
        ...
    
    @staticmethod
    def to_argb32(cmyk_pixels : List[aspose.psd.CmykColor]) -> List[int]:
        '''The conversion from CMYKColor to 32-bit ARGB Color using icc conversion  with default profiles.
        This method is deprecated. Please use more effective :py:func:`aspose.psd.CmykColorHelper.to_argb32`.
        
        :param cmyk_pixels: The pixels of CMYKColor type in CMYK format.
        :returns: The array of the 32-bit ARGB color.'''
        ...
    
    def to_value(self) -> int:
        '''The to value.
        
        :returns: The :py:class:`int`.'''
        ...
    
    @classmethod
    @property
    def empty(cls) -> aspose.psd.CmykColor:
        '''Gets the empty.'''
        ...
    
    @property
    def c(self) -> byte:
        '''Gets the cyan component value of this :py:class:`aspose.psd.Color` structure.'''
        ...
    
    @property
    def m(self) -> byte:
        '''Gets the magenta component value of this :py:class:`aspose.psd.Color` structure.'''
        ...
    
    @property
    def y(self) -> byte:
        '''Gets the yellow component value of this :py:class:`aspose.psd.Color` structure.'''
        ...
    
    @property
    def k(self) -> byte:
        '''Gets the black component value of this :py:class:`aspose.psd.Color` structure.'''
        ...
    
    @property
    def is_empty(self) -> bool:
        ...
    
    ...

class CmykColorHelper:
    '''Helper methods to work with CMYK color presented as a signed 32-bit integer value.
    Provides the similar API as the :py:class:`aspose.psd.CmykColor` struct.
    It's more lightweight because CMYK color is presented just as Int32 rather than structure with internal fields.
    Please prefer to use static methods of this class when possible instead of the deprecated
    :py:class:`aspose.psd.CmykColor` struct.'''
    
    @overload
    @staticmethod
    def to_cmyk(argb_pixels : List[int]) -> List[int]:
        '''The conversion from ARGB colors to CMYK colors.
        
        :param argb_pixels: The ARGB colors presented as 32-bit integer values.
        :returns: The CMYK colors presented as 32-bit integer values.'''
        ...
    
    @overload
    @staticmethod
    def to_cmyk(argb_pixel : int) -> int:
        '''The conversion from ARGB color to CMYK color.
        
        :param argb_pixel: The ARGB color presented as a 32-bit integer value.
        :returns: The CMYK color presented as a 32-bit integer value.'''
        ...
    
    @overload
    @staticmethod
    def to_cmyk(pixel : aspose.psd.Color) -> int:
        '''The conversion from ARGB color to CMYK color.
        
        :param pixel: The ARGB color.
        :returns: The CMYK color presented as a 32-bit integer value.'''
        ...
    
    @overload
    @staticmethod
    def to_cmyk(pixels : List[aspose.psd.Color]) -> List[int]:
        '''The conversion from ARGB colors to CMYK colors.
        
        :param pixels: The ARGB colors.
        :returns: The CMYK colors presented as 32-bit integer values.'''
        ...
    
    @overload
    @staticmethod
    def to_argb(cmyk_pixels : List[int]) -> List[aspose.psd.Color]:
        '''The conversion from CMYK colors to ARGB colors.
        
        :param cmyk_pixels: The CMYK colors presented as 32-bit integer values.
        :returns: The ARGB colors.'''
        ...
    
    @overload
    @staticmethod
    def to_argb(cmyk_pixel : int) -> aspose.psd.Color:
        '''The conversion from CMYK color to ARGB color.
        
        :param cmyk_pixel: The CMYK color presented as a 32-bit integer value.
        :returns: The ARGB color.'''
        ...
    
    @overload
    @staticmethod
    def to_argb_icc(cmyk_pixels : List[int]) -> List[aspose.psd.Color]:
        '''The conversion from CMYK colors to ARGB colors using Icc conversion with default profiles.
        
        :param cmyk_pixels: The CMYK pixels presented as 32-bit integer values.
        :returns: The ARGB colors.'''
        ...
    
    @overload
    @staticmethod
    def to_argb_icc(cmyk_pixels : List[int]cmyk_icc_stream : io.RawIOBase, rgb_icc_stream : io.RawIOBase) -> List[aspose.psd.Color]:
        '''The conversion from CMYK colors to ARGB colors using Icc conversion with custom profiles.
        
        :param cmyk_pixels: The CMYK colors presented as 32-bit integer values.
        :param cmyk_icc_stream: The stream containing CMYK Icc profile.
        :param rgb_icc_stream: The stream containing RGB Icc profile.
        :returns: The ARGB colors.'''
        ...
    
    @overload
    @staticmethod
    def to_argb_icc(cmyk_pixel : int) -> aspose.psd.Color:
        '''The conversion from CMYK color to ARGB Color using Icc conversion with default profiles.
        
        :param cmyk_pixel: The CMYK color presented as a 32-bit integer value.
        :returns: The ARGB color.'''
        ...
    
    @overload
    @staticmethod
    def to_argb_icc(cmyk_pixel : intcmyk_icc_stream : io.RawIOBase, rgb_icc_stream : io.RawIOBase) -> aspose.psd.Color:
        '''The conversion from CMYK color to ARGB color using Icc conversion with custom profile.
        
        :param cmyk_pixel: The CMYK color presented as a 32-bit integer value.
        :param cmyk_icc_stream: The stream containing CMYK Icc profile.
        :param rgb_icc_stream: The stream containing RGB Icc profile.
        :returns: The ARGB color.'''
        ...
    
    @overload
    @staticmethod
    def to_cmyk_icc(pixels : List[aspose.psd.Color]rgb_icc_stream : io.RawIOBase, cmyk_icc_stream : io.RawIOBase) -> List[int]:
        '''The conversion from ARGB colors to CMYK colors using Icc conversion with custom profiles.
        
        :param pixels: The ARGB colors.
        :param rgb_icc_stream: The stream containing RGB Icc profile.
        :param cmyk_icc_stream: The stream containing CMYK Icc profile.
        :returns: The CMYK colors presented as 32-bit integer values.'''
        ...
    
    @overload
    @staticmethod
    def to_cmyk_icc(pixels : List[aspose.psd.Color]) -> List[int]:
        '''The conversion from ARGB colors to CMYK colors using Icc conversion with default profiles.
        
        :param pixels: The ARGB colors.
        :returns: The CMYK colors presented as 32-bit integer values.'''
        ...
    
    @overload
    @staticmethod
    def to_cmyk_icc(pixel : aspose.psd.Color) -> int:
        '''The conversion from ARGB color to CMYK color using Icc conversion with default profiles.
        
        :param pixel: The ARGB color.
        :returns: The CMYK color presented as a 32-bit integer value.'''
        ...
    
    @overload
    @staticmethod
    def to_cmyk_icc(pixel : aspose.psd.Colorrgb_icc_stream : io.RawIOBase, cmyk_icc_stream : io.RawIOBase) -> int:
        '''The conversion from ARGB color to CMYK color using Icc conversion with custom profiles.
        
        :param pixel: The ARGB color.
        :param rgb_icc_stream: The stream containing RGB Icc profile.
        :param cmyk_icc_stream: The stream containing CMYK Icc profile.
        :returns: The CMYK color presented as a 32-bit integer value.'''
        ...
    
    @staticmethod
    def get_c(cmyk : int) -> int:
        '''Gets the cyan component value.
        
        :param cmyk: The CMYK color presented as a 32-bit integer value.
        :returns: The cyan component value.'''
        ...
    
    @staticmethod
    def get_m(cmyk : int) -> int:
        '''Gets the magenta component value.
        
        :param cmyk: The CMYK color presented as a 32-bit integer value.
        :returns: The magenta component value.'''
        ...
    
    @staticmethod
    def get_y(cmyk : int) -> int:
        '''Gets the yellow component value.
        
        :param cmyk: The CMYK color presented as a 32-bit integer value.
        :returns: The yellow component value.'''
        ...
    
    @staticmethod
    def get_k(cmyk : int) -> int:
        '''Gets the black component value.
        
        :param cmyk: The CMYK color presented as a 32-bit integer value.
        :returns: The black component value.'''
        ...
    
    @staticmethod
    def from_components(cyan : intmagenta : int, yellow : int, black : int) -> int:
        '''Creates CMYK from a 32-bit cyan, magenta, yellow and black values.
        
        :param cyan: The cyan component. Valid values are 0 through 255.
        :param magenta: The magenta component. Valid values are 0 through 255.
        :param yellow: The yellow component. Valid values are 0 through 255.
        :param black: The black component. Valid values are 0 through 255.
        :returns: The CMYK color presented as a 32-bit integer value.'''
        ...
    
    @staticmethod
    def to_cmyk_bytes(argb_pixels : List[int]start_index : int, length : int) -> bytes:
        '''Converts RGB to CMYK.
        
        :param argb_pixels: The RGB colors presented as 32-bit integer values.
        :param start_index: The start index of RGB color.
        :param length: The number of RGB pixels to convert.
        :returns: The CMYK colors presented as a byte array.'''
        ...
    
    @staticmethod
    def to_argb32(cmyk_pixels : List[int]) -> List[int]:
        '''The conversion from CMYK colors to ARGB colors.
        
        :param cmyk_pixels: The CMYK colors presented as 32-bit integer values.
        :returns: The ARGB colors presented as 32-bit integer values.'''
        ...
    
    @staticmethod
    def to_cmyk_icc_bytes(pixels : List[int]start_index : int, length : int, rgb_icc_stream : io.RawIOBase, cmyk_icc_stream : io.RawIOBase) -> bytes:
        '''Converts RGB to CMYK using custom ICC profiles.
        
        :param pixels: The RGB colors presented as 32-bit integer values.
        :param start_index: The start index of RGB color.
        :param length: The number of RGB pixels to convert.
        :param rgb_icc_stream: The RGB profile stream.
        :param cmyk_icc_stream: The CMYK profile stream.
        :returns: The CMYK colors presented as a byte array.'''
        ...
    
    ...

class Color:
    '''The color of the pixel.'''
    
    @overload
    @staticmethod
    def from_argb(argb : int) -> aspose.psd.Color:
        '''Creates a :py:class:`aspose.psd.Color` structure from a 32-bit ARGB value.
        
        :param argb: A value specifying the 32-bit ARGB value.
        :returns: The :py:class:`aspose.psd.Color` structure that this method creates.'''
        ...
    
    @overload
    @staticmethod
    def from_argb(alpha : intred : int, green : int, blue : int) -> aspose.psd.Color:
        '''Creates a :py:class:`aspose.psd.Color` structure from the four ARGB component (alpha, red, green, and blue) values. Although this method allows a 32-bit value to be passed for each component, the value of each component is limited to 8 bits.
        
        :param alpha: The alpha component. Valid values are 0 through 255.
        :param red: The red component. Valid values are 0 through 255.
        :param green: The green component. Valid values are 0 through 255.
        :param blue: The blue component. Valid values are 0 through 255.
        :returns: The :py:class:`aspose.psd.Color` that this method creates.'''
        ...
    
    @overload
    @staticmethod
    def from_argb(alpha : intbase_color : aspose.psd.Color) -> aspose.psd.Color:
        '''Creates a :py:class:`aspose.psd.Color` structure from the specified :py:class:`aspose.psd.Color` structure, but with the new specified alpha value. Although this method allows a 32-bit value to be passed for the alpha value, the value is limited to 8 bits.
        
        :param alpha: The alpha value for the new :py:class:`aspose.psd.Color`. Valid values are 0 through 255.
        :param base_color: The :py:class:`aspose.psd.Color` from which to create the new :py:class:`aspose.psd.Color`.
        :returns: The :py:class:`aspose.psd.Color` that this method creates.'''
        ...
    
    @overload
    @staticmethod
    def from_argb(red : intgreen : int, blue : int) -> aspose.psd.Color:
        '''Creates a :py:class:`aspose.psd.Color` structure from the specified 8-bit color values (red, green, and blue). The alpha value is implicitly 255 (fully opaque). Although this method allows a 32-bit value to be passed for each color component, the value of each component is limited to 8 bits.
        
        :param red: The red component value for the new :py:class:`aspose.psd.Color`. Valid values are 0 through 255.
        :param green: The green component value for the new :py:class:`aspose.psd.Color`. Valid values are 0 through 255.
        :param blue: The blue component value for the new :py:class:`aspose.psd.Color`. Valid values are 0 through 255.
        :returns: The :py:class:`aspose.psd.Color` that this method creates.'''
        ...
    
    @overload
    @staticmethod
    def to_cmyk(pixels : List[aspose.psd.Color]) -> List[aspose.psd.CmykColor]:
        '''The conversion from Color to CMYKColor.
        This method is deprecated. Please use more effective :py:func:`aspose.psd.CmykColorHelper.to_cmyk`.
        
        :param pixels: The pixels of Color type in RGB format.
        :returns: The :py:class:`List[Aspose:PSD:CmykColor]`.'''
        ...
    
    @overload
    @staticmethod
    def to_cmyk(pixel : aspose.psd.Color) -> aspose.psd.CmykColor:
        '''The conversion from Color to CMYKColor.
        This method is deprecated. Please use more effective :py:func:`aspose.psd.CmykColorHelper.to_cmyk`.
        
        :param pixel: The pixel of Color type in RGB format.
        :returns: The :py:class:`Aspose:PSD:CmykColor`.'''
        ...
    
    @overload
    @staticmethod
    def to_cmyk_icc(pixel : aspose.psd.Color) -> aspose.psd.CmykColor:
        '''The conversion from Color to CMYKColor using icc conversion with default profiles.
        This method is deprecated. Please use more effective :py:func:`aspose.psd.CmykColorHelper.to_cmyk_icc`.
        
        :param pixel: The pixel of Color type in RGB format.
        :returns: The :py:class:`aspose.psd.CmykColor`.'''
        ...
    
    @overload
    @staticmethod
    def to_cmyk_icc(pixels : List[aspose.psd.Color]) -> List[aspose.psd.CmykColor]:
        '''The conversion from Color to CMYKColor using icc conversion with default profiles.
        This method is deprecated. Please use more effective :py:func:`aspose.psd.CmykColorHelper.to_cmyk_icc`.
        
        :param pixels: The pixels of Color type in RGB format.
        :returns: The :py:class:`List[aspose.psd.CmykColor]`.'''
        ...
    
    @overload
    @staticmethod
    def to_cmyk_icc(pixels : List[aspose.psd.Color]rgb_icc_stream : io.RawIOBase, cmyk_icc_stream : io.RawIOBase) -> List[aspose.psd.CmykColor]:
        '''The conversion from Color to CMYKColor using icc conversion.
        This method is deprecated. Please use more effective :py:func:`aspose.psd.CmykColorHelper.to_cmyk_icc`.
        
        :param pixels: The pixels of Color type in RGB format.
        :param rgb_icc_stream: The stream containing icc rgb profile.
        :param cmyk_icc_stream: The stream containing icc cmyk profile.
        :returns: The :py:class:`List[Aspose:PSD:CmykColor]`.'''
        ...
    
    @overload
    @staticmethod
    def to_cmyk_icc(pixel : aspose.psd.Colorrgb_icc_stream : io.RawIOBase, cmyk_icc_stream : io.RawIOBase) -> aspose.psd.CmykColor:
        '''The conversion from Color to CMYKColor using icc conversion with default profiles.
        This method is deprecated. Please use more effective :py:func:`aspose.psd.CmykColorHelper.to_cmyk_icc`.
        
        :param pixel: The pixel of Color type in RGB format.
        :param rgb_icc_stream: The stream containing icc rgb profile.
        :param cmyk_icc_stream: The stream containing icc cmyk profile.
        :returns: The :py:class:`List[Aspose:PSD:CmykColor]`.'''
        ...
    
    @staticmethod
    def from_known_color(color : aspose.psd.KnownColor) -> aspose.psd.Color:
        '''Creates a :py:class:`aspose.psd.Color` structure from the specified predefined color.
        
        :param color: An element of the :py:class:`aspose.psd.KnownColor` enumeration.
        :returns: The :py:class:`aspose.psd.Color` that this method creates.'''
        ...
    
    @staticmethod
    def from_name(name : str) -> aspose.psd.Color:
        '''Creates a :py:class:`aspose.psd.Color` structure from the specified name of a predefined color.
        
        :param name: A string that is the name of a predefined color. Valid names are the same as the names of the elements of the :py:class:`aspose.psd.KnownColor` enumeration.
        :returns: The :py:class:`aspose.psd.Color` that this method creates.'''
        ...
    
    def get_brightness(self) -> float:
        '''Gets the hue-saturation-brightness (HSB) brightness value for this :py:class:`aspose.psd.Color` structure.
        
        :returns: The brightness of this :py:class:`aspose.psd.Color`. The brightness ranges from 0.0 through 1.0, where 0.0 represents black and 1.0 represents white.'''
        ...
    
    def get_hue(self) -> float:
        '''Gets the hue-saturation-brightness (HSB) hue value, in degrees, for this :py:class:`aspose.psd.Color` structure.
        
        :returns: The hue, in degrees, of this :py:class:`aspose.psd.Color`. The hue is measured in degrees, ranging from 0.0 through 360.0, in HSB color space.'''
        ...
    
    def get_saturation(self) -> float:
        '''Gets the hue-saturation-brightness (HSB) saturation value for this :py:class:`aspose.psd.Color` structure.
        
        :returns: The saturation of this :py:class:`aspose.psd.Color`. The saturation ranges from 0.0 through 1.0, where 0.0 is grayscale and 1.0 is the most saturated.'''
        ...
    
    def to_argb(self) -> int:
        '''Gets the 32-bit ARGB value of this :py:class:`aspose.psd.Color` structure.
        
        :returns: The 32-bit ARGB value of this :py:class:`aspose.psd.Color`.'''
        ...
    
    def to_known_color(self) -> aspose.psd.KnownColor:
        '''Gets the :py:class:`aspose.psd.KnownColor` value of this :py:class:`aspose.psd.Color` structure.
        
        :returns: An element of the :py:class:`aspose.psd.KnownColor` enumeration, if the :py:class:`aspose.psd.Color` is created from a predefined color by using either the :py:func:`aspose.psd.Color.from_name` method or the :py:func:`aspose.psd.Color.from_known_color` method; otherwise, 0.'''
        ...
    
    @classmethod
    @property
    def empty(cls) -> aspose.psd.Color:
        '''Gets an empty :py:class:`aspose.psd.Color`.'''
        ...
    
    @classmethod
    @property
    def transparent(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def alice_blue(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def antique_white(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def aqua(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def aquamarine(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def azure(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def beige(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def bisque(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def black(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def blanched_almond(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def blue(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def blue_violet(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def brown(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def burly_wood(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def cadet_blue(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def chartreuse(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def chocolate(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def coral(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def cornflower_blue(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def cornsilk(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def crimson(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def cyan(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def dark_blue(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def dark_cyan(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def dark_goldenrod(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def dark_gray(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def dark_green(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def dark_khaki(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def dark_magenta(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def dark_olive_green(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def dark_orange(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def dark_orchid(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def dark_red(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def dark_salmon(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def dark_sea_green(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def dark_slate_blue(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def dark_slate_gray(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def dark_turquoise(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def dark_violet(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def deep_pink(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def deep_sky_blue(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def dim_gray(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def dodger_blue(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def firebrick(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def floral_white(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def forest_green(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def fuchsia(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def gainsboro(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def ghost_white(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def gold(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def goldenrod(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def gray(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def green(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def green_yellow(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def honeydew(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def hot_pink(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def indian_red(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def indigo(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def ivory(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def khaki(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def lavender(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def lavender_blush(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def lawn_green(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def lemon_chiffon(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def light_blue(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def light_coral(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def light_cyan(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def light_goldenrod_yellow(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def light_green(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def light_gray(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def light_pink(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def light_salmon(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def light_sea_green(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def light_sky_blue(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def light_slate_gray(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def light_steel_blue(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def light_yellow(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def lime(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def lime_green(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def linen(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def magenta(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def maroon(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def medium_aquamarine(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def medium_blue(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def medium_orchid(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def medium_purple(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def medium_sea_green(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def medium_slate_blue(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def medium_spring_green(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def medium_turquoise(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def medium_violet_red(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def midnight_blue(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def mint_cream(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def misty_rose(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def moccasin(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def navajo_white(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def navy(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def old_lace(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def olive(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def olive_drab(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def orange(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def orange_red(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def orchid(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def pale_goldenrod(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def pale_green(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def pale_turquoise(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def pale_violet_red(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def papaya_whip(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def peach_puff(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def peru(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def pink(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def plum(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def powder_blue(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def purple(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def red(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def rosy_brown(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def royal_blue(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def saddle_brown(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def salmon(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def sandy_brown(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def sea_green(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def sea_shell(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def sienna(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def silver(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def sky_blue(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def slate_blue(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def slate_gray(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def snow(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def spring_green(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def steel_blue(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def tan(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def teal(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def thistle(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def tomato(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def turquoise(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def violet(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def wheat(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def white(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def white_smoke(cls) -> aspose.psd.Color:
        ...
    
    @classmethod
    @property
    def yellow(cls) -> aspose.psd.Color:
        '''Gets a system-defined color.'''
        ...
    
    @classmethod
    @property
    def yellow_green(cls) -> aspose.psd.Color:
        ...
    
    @property
    def r(self) -> byte:
        '''Gets the red component value of this :py:class:`aspose.psd.Color` structure.'''
        ...
    
    @property
    def g(self) -> byte:
        '''Gets the green component value of this :py:class:`aspose.psd.Color` structure.'''
        ...
    
    @property
    def b(self) -> byte:
        '''Gets the blue component value of this :py:class:`aspose.psd.Color` structure.'''
        ...
    
    @property
    def a(self) -> byte:
        '''Gets the alpha component value of this :py:class:`aspose.psd.Color` structure.'''
        ...
    
    @property
    def is_known_color(self) -> bool:
        ...
    
    @property
    def is_empty(self) -> bool:
        ...
    
    @property
    def is_named_color(self) -> bool:
        ...
    
    @property
    def name(self) -> str:
        '''Gets the name of this :py:class:`aspose.psd.Color`.'''
        ...
    
    ...

class ColorBlend:
    '''Defines arrays of colors and positions used for interpolating color blending in a multicolor gradient. This class cannot be inherited.'''
    
    @property
    def colors(self) -> List[aspose.psd.Color]:
        '''Gets an array of colors that represents the colors to use at corresponding positions along a gradient.'''
        ...
    
    @colors.setter
    def colors(self, value : List[aspose.psd.Color]):
        '''Sets an array of colors that represents the colors to use at corresponding positions along a gradient.'''
        ...
    
    @property
    def positions(self) -> List[float]:
        '''Gets the positions along a gradient line.'''
        ...
    
    @positions.setter
    def positions(self, value : List[float]):
        '''Sets the positions along a gradient line.'''
        ...
    
    ...

class ColorMap:
    '''Defines a map for converting colors. Several methods of the :py:class:`aspose.psd.ImageAttributes` class adjust image colors by using a color-remap table, which is an array of :py:class:`aspose.psd.ColorMap` structures. Not inheritable.'''
    
    @property
    def old_color(self) -> aspose.psd.Color:
        ...
    
    @old_color.setter
    def old_color(self, value : aspose.psd.Color):
        ...
    
    @property
    def new_color(self) -> aspose.psd.Color:
        ...
    
    @new_color.setter
    def new_color(self, value : aspose.psd.Color):
        ...
    
    ...

class ColorMatrix:
    '''Defines a 5 x 5 matrix that contains the coordinates for the RGBA space. Several methods of the :py:class:`aspose.psd.ImageAttributes` class adjust image colors by using a color matrix. This class cannot be inherited.'''
    
    def get_matrix(self) -> List[List[float]]:
        '''Gets the matrix values.
        
        :returns: The matrix values array.'''
        ...
    
    @property
    def matrix00(self) -> float:
        '''Gets the element at the 0 (zero) row and 0 column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @matrix00.setter
    def matrix00(self, value : float):
        '''Sets the element at the 0 (zero) row and 0 column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @property
    def matrix01(self) -> float:
        '''Gets the element at the 0 (zero) row and first column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @matrix01.setter
    def matrix01(self, value : float):
        '''Sets the element at the 0 (zero) row and first column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @property
    def matrix02(self) -> float:
        '''Gets the element at the 0 (zero) row and second column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @matrix02.setter
    def matrix02(self, value : float):
        '''Sets the element at the 0 (zero) row and second column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @property
    def matrix03(self) -> float:
        '''Gets the element at the 0 (zero) row and third column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @matrix03.setter
    def matrix03(self, value : float):
        '''Sets the element at the 0 (zero) row and third column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @property
    def matrix04(self) -> float:
        '''Gets the element at the 0 (zero) row and fourth column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @matrix04.setter
    def matrix04(self, value : float):
        '''Sets the element at the 0 (zero) row and fourth column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @property
    def matrix10(self) -> float:
        '''Gets the element at the first row and 0 (zero) column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @matrix10.setter
    def matrix10(self, value : float):
        '''Sets the element at the first row and 0 (zero) column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @property
    def matrix11(self) -> float:
        '''Gets the element at the first row and first column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @matrix11.setter
    def matrix11(self, value : float):
        '''Sets the element at the first row and first column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @property
    def matrix12(self) -> float:
        '''Gets the element at the first row and second column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @matrix12.setter
    def matrix12(self, value : float):
        '''Sets the element at the first row and second column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @property
    def matrix13(self) -> float:
        '''Gets the element at the first row and third column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @matrix13.setter
    def matrix13(self, value : float):
        '''Sets the element at the first row and third column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @property
    def matrix14(self) -> float:
        '''Gets the element at the first row and fourth column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @matrix14.setter
    def matrix14(self, value : float):
        '''Sets the element at the first row and fourth column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @property
    def matrix20(self) -> float:
        '''Gets the element at the second row and 0 (zero) column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @matrix20.setter
    def matrix20(self, value : float):
        '''Sets the element at the second row and 0 (zero) column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @property
    def matrix21(self) -> float:
        '''Gets the element at the second row and first column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @matrix21.setter
    def matrix21(self, value : float):
        '''Sets the element at the second row and first column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @property
    def matrix22(self) -> float:
        '''Gets the element at the second row and second column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @matrix22.setter
    def matrix22(self, value : float):
        '''Sets the element at the second row and second column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @property
    def matrix23(self) -> float:
        '''Gets the element at the second row and third column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @matrix23.setter
    def matrix23(self, value : float):
        '''Sets the element at the second row and third column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @property
    def matrix24(self) -> float:
        '''Gets the element at the second row and fourth column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @matrix24.setter
    def matrix24(self, value : float):
        '''Sets the element at the second row and fourth column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @property
    def matrix30(self) -> float:
        '''Gets the element at the third row and 0 (zero) column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @matrix30.setter
    def matrix30(self, value : float):
        '''Sets the element at the third row and 0 (zero) column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @property
    def matrix31(self) -> float:
        '''Gets the element at the third row and first column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @matrix31.setter
    def matrix31(self, value : float):
        '''Sets the element at the third row and first column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @property
    def matrix32(self) -> float:
        '''Gets the element at the third row and second column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @matrix32.setter
    def matrix32(self, value : float):
        '''Sets the element at the third row and second column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @property
    def matrix33(self) -> float:
        '''Gets the element at the third row and third column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @matrix33.setter
    def matrix33(self, value : float):
        '''Sets the element at the third row and third column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @property
    def matrix34(self) -> float:
        '''Gets the element at the third row and fourth column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @matrix34.setter
    def matrix34(self, value : float):
        '''Sets the element at the third row and fourth column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @property
    def matrix40(self) -> float:
        '''Gets the element at the fourth row and 0 (zero) column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @matrix40.setter
    def matrix40(self, value : float):
        '''Sets the element at the fourth row and 0 (zero) column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @property
    def matrix41(self) -> float:
        '''Gets the element at the fourth row and first column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @matrix41.setter
    def matrix41(self, value : float):
        '''Sets the element at the fourth row and first column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @property
    def matrix42(self) -> float:
        '''Gets the element at the fourth row and second column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @matrix42.setter
    def matrix42(self, value : float):
        '''Sets the element at the fourth row and second column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @property
    def matrix43(self) -> float:
        '''Gets the element at the fourth row and third column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @matrix43.setter
    def matrix43(self, value : float):
        '''Sets the element at the fourth row and third column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @property
    def matrix44(self) -> float:
        '''Gets the element at the fourth row and fourth column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @matrix44.setter
    def matrix44(self, value : float):
        '''Sets the element at the fourth row and fourth column of this :py:class:`aspose.psd.ColorMatrix`.'''
        ...
    
    @classmethod
    @property
    def MATRIX_DIMENSION_ELEMENTS_COUNT(cls) -> int:
        ...
    
    @classmethod
    @property
    def MATRIX_DIMENSIONS_COUNT(cls) -> int:
        ...
    
    @classmethod
    @property
    def MATRIX_TOTAL_ELEMENTS_COUNT(cls) -> int:
        ...
    
    ...

class ColorPalette(IColorPalette):
    '''Defines an array of colors that make up a color palette. The colors are 32-bit ARGB colors. Not inheritable.'''
    
    @overload
    @staticmethod
    def copy_palette(color_palette : aspose.psd.IColorPaletteuse_compact_palette : bool) -> aspose.psd.ColorPalette:
        '''Copies the palette.
        
        :param color_palette: The color palette.
        :param use_compact_palette: Indicating whether compact palette.
        :returns: The newly created and copied palette or null if null palette passed.'''
        ...
    
    @overload
    @staticmethod
    def copy_palette(color_palette : aspose.psd.IColorPalette) -> aspose.psd.ColorPalette:
        '''Copies the palette.
        
        :param color_palette: The color palette.
        :returns: The newly created and copied palette or null if null palette passed.'''
        ...
    
    @overload
    def get_nearest_color_index(self, argb_32_color : int) -> int:
        '''Gets the index of the nearest color.
        
        :param argb_32_color: The 32-bit ARGB color.
        :returns: The index of the nearest color.'''
        ...
    
    @overload
    def get_nearest_color_index(self, color : aspose.psd.Color) -> int:
        '''Gets the index of the nearest color.
        
        :param color: The color.
        :returns: The index of the nearest color.'''
        ...
    
    def get_argb_32_color(self, index : int) -> int:
        '''Gets the 32-bit ARGB palette color by index.
        
        :param index: The 32-bit ARGB palette color index.
        :returns: The color palette entry specified by the ``index``.'''
        ...
    
    def get_color(self, index : int) -> aspose.psd.Color:
        '''Gets the palette color by index.
        
        :param index: The palette color index.
        :returns: The color palette entry specified by the ``index``.'''
        ...
    
    @property
    def entries_count(self) -> int:
        ...
    
    @property
    def argb_32_entries(self) -> List[int]:
        ...
    
    @property
    def entries(self) -> List[aspose.psd.Color]:
        '''Gets an array of :py:class:`aspose.psd.Color` structures.'''
        ...
    
    @property
    def is_compact_palette(self) -> bool:
        ...
    
    ...

class ColorPaletteHelper:
    '''Helper class for color palettes manipulation.'''
    
    @overload
    @staticmethod
    def get_close_image_palette(image : aspose.psd.RasterImageentries_count : int) -> aspose.psd.IColorPalette:
        '''Gets color palette from raster image (palletizes image) in case the image does not have one. In case palette exists it will be used instead performing calculations.
        
        :param image: The raster image.
        :param entries_count: The desired entries count.
        :returns: The color palette which starts with the most frequent colors from the ``image`` and contains ``entriesCount`` entries.'''
        ...
    
    @overload
    @staticmethod
    def get_close_image_palette(image : aspose.psd.RasterImagedest_bounds : aspose.psd.Rectangle, entries_count : int) -> aspose.psd.IColorPalette:
        '''Gets color palette from raster image (palletizes image) in case the image does not have one. In case palette exists it will be used instead performing calculations.
        
        :param image: The raster image.
        :param dest_bounds: The destination image bounds.
        :param entries_count: The desired entries count.
        :returns: The color palette which starts with the most frequent colors from the ``image`` and contains ``entriesCount`` entries.'''
        ...
    
    @overload
    @staticmethod
    def get_close_image_palette(image : aspose.psd.RasterImagedest_bounds : aspose.psd.Rectangle, entries_count : int, use_image_palette : bool) -> aspose.psd.IColorPalette:
        '''Gets color palette from raster image (palletizes image) in case the image does not have one. In case palette exists it will be used instead performing calculations.
        
        :param image: The raster image.
        :param dest_bounds: The destination image bounds.
        :param entries_count: The desired entries count.
        :param use_image_palette: If set, it will use its own image palette if available
        :returns: The color palette which starts with the most frequent colors from the ``image`` and contains ``entriesCount`` entries.'''
        ...
    
    @staticmethod
    def create_monochrome() -> aspose.psd.IColorPalette:
        '''Creates a monochrome color palette containing 2 colors only.
        
        :returns: Color palette for monochrome images.'''
        ...
    
    @staticmethod
    def create_4_bit() -> aspose.psd.IColorPalette:
        '''Creates the 4 bit color palette.
        
        :returns: The 4 bit color palette.'''
        ...
    
    @staticmethod
    def create_4_bit_grayscale(min_is_white : bool) -> aspose.psd.IColorPalette:
        '''Creates the 4 bit grayscale palette.
        
        :param min_is_white: if set to ``true`` the palette starts with white color, otherwise it starts with black color.
        :returns: The 4 bit grayscale palette.'''
        ...
    
    @staticmethod
    def create_8_bit() -> aspose.psd.IColorPalette:
        '''Creates the 8 bit color palette.
        
        :returns: The 8 bit color palette.'''
        ...
    
    @staticmethod
    def create_8_bit_grayscale(min_is_white : bool) -> aspose.psd.IColorPalette:
        '''Creates the 8 bit grayscale palette.
        
        :param min_is_white: if set to ``true`` the palette starts with white color, otherwise it starts with black color.
        :returns: The 8 bit grayscale palette.'''
        ...
    
    @staticmethod
    def get_uniform_color_palette(image : aspose.psd.RasterImage) -> aspose.psd.ColorPalette:
        '''Get uniform 256 color palette.
        
        :param image: The image.
        :returns: The :py:class:`aspose.psd.ColorPalette`.'''
        ...
    
    @staticmethod
    def get_downscale_palette(image : aspose.psd.RasterImage) -> aspose.psd.ColorPalette:
        '''Get 256 color palette, composed from upper bits of initial image color values.
        
        :param image: The image.
        :returns: The :py:class:`aspose.psd.ColorPalette`.'''
        ...
    
    @staticmethod
    def has_transparent_colors(palette : aspose.psd.IColorPalette) -> bool:
        '''Determines whether the specified palette has transparent colors.
        
        :param palette: The palette.
        :returns: ``true`` if the specified palette has transparent colors; otherwise, ``false``.'''
        ...
    
    ...

class ColorTranslator:
    '''Translates colors to and from GDI+ Color structures. This class cannot be inherited.'''
    
    @staticmethod
    def from_html(html_color : str) -> aspose.psd.Color:
        '''Takes color from the HTML color.
        
        :param html_color: HTML color.
        :returns: The color.'''
        ...
    
    @staticmethod
    def from_ole(ole_color : int) -> aspose.psd.Color:
        '''Takes color from the OLE color.
        
        :param ole_color: OLE color.
        :returns: The color.'''
        ...
    
    @staticmethod
    def from_win32(win_32_color : int) -> aspose.psd.Color:
        '''Takes color from the HTML color.
        
        :param win_32_color: Win32 color.
        :returns: The color.'''
        ...
    
    @staticmethod
    def to_html(c : aspose.psd.Color) -> str:
        '''Creates HTML color  from the color.
        
        :param c: The color class.
        :returns: The html string color.'''
        ...
    
    @staticmethod
    def to_ole(c : aspose.psd.Color) -> int:
        '''Translates OLE color to color.
        
        :param c: The color.
        :returns: The OLE color.'''
        ...
    
    @staticmethod
    def to_win32(c : aspose.psd.Color) -> int:
        '''Translates the color to win32 color.
        
        :param c: The color.
        :returns: The win32 color.'''
        ...
    
    ...

class CustomLineCap:
    '''Encapsulates a custom user-defined line cap.'''
    
    def set_stroke_caps(self, start_cap : aspose.psd.LineCap, end_cap : aspose.psd.LineCap):
        '''Sets the caps used to start and end lines that make up this custom cap.
        
        :param start_cap: The :py:class:`aspose.psd.LineCap` enumeration used at the beginning of a line within this cap.
        :param end_cap: The :py:class:`aspose.psd.LineCap` enumeration used at the end of a line within this cap.'''
        ...
    
    def get_stroke_caps(self, start_cap : Any, end_cap : Any):
        '''Gets the caps used to start and end lines that make up this custom cap.
        
        :param start_cap: The :py:class:`aspose.psd.LineCap` enumeration used at the beginning of a line within this cap.
        :param end_cap: The :py:class:`aspose.psd.LineCap` enumeration used at the end of a line within this cap.'''
        ...
    
    @property
    def fill_path(self) -> aspose.psd.GraphicsPath:
        ...
    
    @fill_path.setter
    def fill_path(self, value : aspose.psd.GraphicsPath):
        ...
    
    @property
    def stroke_path(self) -> aspose.psd.GraphicsPath:
        ...
    
    @stroke_path.setter
    def stroke_path(self, value : aspose.psd.GraphicsPath):
        ...
    
    @property
    def stroke_join(self) -> aspose.psd.LineJoin:
        ...
    
    @stroke_join.setter
    def stroke_join(self, value : aspose.psd.LineJoin):
        ...
    
    @property
    def base_cap(self) -> aspose.psd.LineCap:
        ...
    
    @base_cap.setter
    def base_cap(self, value : aspose.psd.LineCap):
        ...
    
    @property
    def base_inset(self) -> float:
        ...
    
    @base_inset.setter
    def base_inset(self, value : float):
        ...
    
    @property
    def width_scale(self) -> float:
        ...
    
    @width_scale.setter
    def width_scale(self, value : float):
        ...
    
    ...

class DataStreamSupporter(DisposableObject):
    '''The data stream container.'''
    
    @overload
    def save(self):
        '''Saves the object's data to the current :py:class:`aspose.psd.DataStreamSupporter`.'''
        ...
    
    @overload
    def save(self, stream : io.RawIOBase):
        '''Saves the object's data to the specified stream.
        
        :param stream: The stream to save the object's data to.'''
        ...
    
    @overload
    def save(self, file_path : str):
        '''Saves the object's data to the specified file location.
        
        :param file_path: The file path to save the object's data to.'''
        ...
    
    @overload
    def save(self, file_path : str, over_write : bool):
        '''Saves the object's data to the specified file location.
        
        :param file_path: The file path to save the object's data to.
        :param over_write: if set to ``true`` over write the file contents, otherwise append will occur.'''
        ...
    
    def cache_data(self):
        '''Caches the data and ensures no additional data loading will be performed from the underlying :py:attr:`aspose.psd.DataStreamSupporter.data_stream_container`.'''
        ...
    
    @property
    def disposed(self) -> bool:
        '''Gets a value indicating whether this instance is disposed.'''
        ...
    
    @property
    def data_stream_container(self) -> aspose.psd.StreamContainer:
        ...
    
    @property
    def is_cached(self) -> bool:
        ...
    
    ...

class DisposableObject:
    '''Represents disposable object.'''
    
    @property
    def disposed(self) -> bool:
        '''Gets a value indicating whether this instance is disposed.'''
        ...
    
    ...

class Figure(ObjectWithBounds):
    '''The figure. A container for shapes.'''
    
    @overload
    def get_bounds(self, matrix : aspose.psd.Matrix) -> aspose.psd.RectangleF:
        '''Gets the object's bounds.
        
        :param matrix: The matrix to apply before bounds will be calculated.
        :returns: The estimated object's bounds.'''
        ...
    
    @overload
    def get_bounds(self, matrix : aspose.psd.Matrix, pen : aspose.psd.Pen) -> aspose.psd.RectangleF:
        '''Gets the object's bounds.
        
        :param matrix: The matrix to apply before bounds will be calculated.
        :param pen: The pen to use for object. This can influence the object's bounds size.
        :returns: The estimated object's bounds.'''
        ...
    
    def transform(self, transform : aspose.psd.Matrix):
        '''Applies the specified transformation to the shape.
        
        :param transform: The transformation to apply.'''
        ...
    
    def add_shape(self, shape : aspose.psd.Shape):
        '''Adds a shape to the figure.
        
        :param shape: The shape to add.'''
        ...
    
    def add_shapes(self, shapes : List[aspose.psd.Shape]):
        '''Adds a range of shapes to the figure.
        
        :param shapes: The shapes to add.'''
        ...
    
    def remove_shape(self, shape : aspose.psd.Shape):
        '''Removes a shape from the figure.
        
        :param shape: The shape to remove.'''
        ...
    
    def remove_shapes(self, shapes : List[aspose.psd.Shape]):
        '''Removes a range of shapes from the figure.
        
        :param shapes: The shapes range to remove.'''
        ...
    
    def reverse(self):
        '''Reverses this figure shapes order and shapes point order.'''
        ...
    
    @property
    def bounds(self) -> aspose.psd.RectangleF:
        '''Gets the object's bounds.'''
        ...
    
    @property
    def shapes(self) -> List[aspose.psd.Shape]:
        '''Gets the figure shapes.'''
        ...
    
    @property
    def is_closed(self) -> bool:
        ...
    
    @is_closed.setter
    def is_closed(self, value : bool):
        ...
    
    @property
    def segments(self) -> List[aspose.psd.ShapeSegment]:
        '''Gets the whole figure segments.'''
        ...
    
    ...

class FileStreamContainer(StreamContainer):
    '''Helper for file stream processing.'''
    
    @overload
    def write(self, bytes : bytes):
        '''Writes all of the specified bytes to the stream.
        
        :param bytes: The bytes to write.'''
        ...
    
    @overload
    def write(self, buffer : bytes, offset : int, count : int):
        '''Writes a sequence of bytes to the current stream and advances the current position within this stream by the number of bytes written.
        
        :param buffer: An array of bytes. This method copies ``count`` bytes from ``buffer`` to the current stream.
        :param offset: The zero-based byte offset in ``buffer`` at which to begin copying bytes to the current stream.
        :param count: The number of bytes to be written to the current stream.'''
        ...
    
    @overload
    def read(self, bytes : bytes) -> int:
        '''Reads bytes to fill the specified bytes buffer.
        
        :param bytes: The bytes to fill.
        :returns: The number of bytes read. This value can be less than the number of bytes in the buffer if there is not enough bytes in the stream.'''
        ...
    
    @overload
    def read(self, buffer : bytes, offset : int, count : int) -> int:
        '''Reads a sequence of bytes from the current stream and advances the position within the stream by the number of bytes read.
        
        :param buffer: An array of bytes. When this method returns, the buffer contains the specified byte array with the values between ``offset`` and (``offset`` + ``count`` - 1) replaced by the bytes read from the current source.
        :param offset: The zero-based byte offset in ``buffer`` at which to begin storing the data read from the current stream.
        :param count: The maximum number of bytes to be read from the current stream.
        :returns: The total number of bytes read into the buffer. This can be less than the number of bytes requested if that many bytes are not currently available, or zero (0) if the end of the stream has been reached.'''
        ...
    
    @overload
    def to_bytes(self) -> bytes:
        '''Converts the stream data to the :py:class:`int` array.
        
        :returns: The stream data converted to the :py:class:`int` array.'''
        ...
    
    @overload
    def to_bytes(self, position : int, bytes_count : int) -> bytes:
        '''Converts the stream data to the :py:class:`int` array.
        
        :param position: The position to start reading bytes from.
        :param bytes_count: The bytes count to read.
        :returns: The stream data converted to the :py:class:`int` array.'''
        ...
    
    @overload
    def save(self, destination_stream : io.RawIOBase):
        '''Saves (copies) the stream's data to the specified stream. Uses default buffer size :py:attr:`aspose.psd.StreamContainer.READ_WRITE_BYTES_COUNT` and stream :py:attr:`aspose.psd.StreamContainer.length` value.
        
        :param destination_stream: The stream to save the data to.'''
        ...
    
    @overload
    def save(self, destination_stream : io.RawIOBase, buffer_size : int):
        '''Saves (copies) all the stream's data to the specified stream. Uses stream :py:attr:`aspose.psd.StreamContainer.length` value.
        
        :param destination_stream: The stream to save the data to.
        :param buffer_size: The buffer.'''
        ...
    
    @overload
    def save(self, destination_stream : io.RawIOBase, buffer_size : int, length : int):
        '''Saves (copies) the stream's data to the specified stream.
        
        :param destination_stream: The stream to save the data to.
        :param buffer_size: The buffer size. By default :py:attr:`aspose.psd.StreamContainer.READ_WRITE_BYTES_COUNT` value is used.
        :param length: The stream data length to copy. By default the length is set to :py:attr:`aspose.psd.StreamContainer.length` value.'''
        ...
    
    @overload
    def save(self, file_path : str):
        '''Saves (copies) the stream's data to the specified stream. Uses default buffer size :py:attr:`aspose.psd.StreamContainer.READ_WRITE_BYTES_COUNT` and stream :py:attr:`aspose.psd.StreamContainer.length` value.
        
        :param file_path: The file path to save the stream data to.'''
        ...
    
    @overload
    def save(self, file_path : str, buffer_size : int):
        '''Saves (copies) the stream's data to the specified stream. Uses stream :py:attr:`aspose.psd.StreamContainer.length` value.
        
        :param file_path: The file path to save the stream data to.
        :param buffer_size: The buffer size. By default :py:attr:`aspose.psd.StreamContainer.READ_WRITE_BYTES_COUNT` value is used.'''
        ...
    
    @overload
    def save(self, file_path : str, buffer_size : int, length : int):
        '''Saves (copies) the stream's data to the specified stream.
        
        :param file_path: The file path to save the stream data to.
        :param buffer_size: The buffer size. By default :py:attr:`aspose.psd.StreamContainer.READ_WRITE_BYTES_COUNT` value is used.
        :param length: The stream data length to copy. By default the length is set to :py:attr:`aspose.psd.StreamContainer.length` value.'''
        ...
    
    @overload
    def write_to(self, stream_container : aspose.psd.StreamContainer):
        '''Copies the contained data to another :py:class:`aspose.psd.StreamContainer`.
        
        :param stream_container: The stream container to copy to.'''
        ...
    
    @overload
    def write_to(self, stream_container : aspose.psd.StreamContainer, length : int):
        '''Copies the contained data to another :py:class:`aspose.psd.StreamContainer`.
        
        :param stream_container: The stream container to copy to.
        :param length: The bytes count to write.'''
        ...
    
    def flush(self):
        '''Clears all buffers for this stream and causes any buffered data to be written to the underlying device.'''
        ...
    
    def write_byte(self, value : byte):
        '''Writes a byte to the current position in the stream and advances the position within the stream by one byte.
        
        :param value: The byte to write to the stream.'''
        ...
    
    def read_byte(self) -> int:
        '''Reads a byte from the stream and advances the position within the stream by one byte, or returns -1 if at the end of the stream.
        
        :returns: The unsigned byte cast to an Int32, or -1 if at the end of the stream.'''
        ...
    
    def seek(self, offset : int, origin : aspose.psd.SeekOrigin) -> int:
        '''Sets the position within the current stream.
        
        :param offset: A byte offset relative to the ``origin`` parameter. This value represents offset from the starting stream position passed in the StreamContainer constructor.
        :param origin: A value of type :py:class:`System.IO.SeekOrigin` indicating the reference point used to obtain the new position.
        :returns: The new position within the current stream.'''
        ...
    
    def seek_begin(self):
        '''Sets the stream position to the beginning of the stream. This value represents offset from the starting stream position passed in the StreamContainer constructor.'''
        ...
    
    @staticmethod
    def create_file_stream(file_location : stris_temporal : bool) -> aspose.psd.FileStreamContainer:
        '''Creates a new file stream.
        
        :param file_location: The file location.
        :param is_temporal: If set to ``true`` the file stream container is temporal.
        :returns: The file stream container.'''
        ...
    
    @staticmethod
    def open_file_stream(file_location : str) -> aspose.psd.FileStreamContainer:
        '''Opens an existing file stream. If file stream does not exist the appropriate exception is thrown.
        
        :param file_location: The file location.
        :returns: The file stream container.'''
        ...
    
    @property
    def disposed(self) -> bool:
        '''Gets a value indicating whether this instance is disposed.'''
        ...
    
    @property
    def sync_root(self) -> any:
        ...
    
    @property
    def position(self) -> int:
        '''Gets the current position within the stream. This value represents offset from the starting stream position passed in the StreamContainer constructor.'''
        ...
    
    @position.setter
    def position(self, value : int):
        '''Sets the current position within the stream. This value represents offset from the starting stream position passed in the StreamContainer constructor.'''
        ...
    
    @property
    def stream(self) -> io.RawIOBase:
        '''Gets the data stream.'''
        ...
    
    @property
    def is_stream_disposed_on_close(self) -> bool:
        ...
    
    @property
    def length(self) -> int:
        '''Gets the stream length in bytes. This value is less than the :py:attr:`io.RawIOBase.Length` by the starting stream position passed in the StreamContainer constructor.'''
        ...
    
    @length.setter
    def length(self, value : int):
        '''Sets the stream length in bytes. This value is less than the :py:attr:`io.RawIOBase.Length` by the starting stream position passed in the StreamContainer constructor.'''
        ...
    
    @property
    def can_read(self) -> bool:
        ...
    
    @property
    def can_seek(self) -> bool:
        ...
    
    @property
    def can_write(self) -> bool:
        ...
    
    @classmethod
    @property
    def READ_WRITE_BYTES_COUNT(cls) -> int:
        ...
    
    @property
    def is_temporal(self) -> bool:
        ...
    
    @is_temporal.setter
    def is_temporal(self, value : bool):
        ...
    
    @property
    def is_created(self) -> bool:
        ...
    
    @property
    def file_path(self) -> str:
        ...
    
    ...

class Font:
    '''Defines a particular format for text, including font face, size, and style attributes. This class cannot be inherited.'''
    
    def deep_clone(self) -> aspose.psd.Font:
        '''Creates an exact deep copy of this :py:class:`aspose.psd.Font`.
        
        :returns: The :py:class:`aspose.psd.Font` this method creates.'''
        ...
    
    @property
    def bold(self) -> bool:
        '''Gets a value indicating whether this :py:class:`aspose.psd.Font` is bold.'''
        ...
    
    @property
    def character_set(self) -> aspose.psd.CharacterSet:
        ...
    
    @property
    def italic(self) -> bool:
        '''Gets a value indicating whether this :py:class:`aspose.psd.Font` is italic.'''
        ...
    
    @property
    def name(self) -> str:
        '''Gets the face name of this :py:class:`aspose.psd.Font`.'''
        ...
    
    @property
    def strikeout(self) -> bool:
        '''Gets a value indicating whether this :py:class:`aspose.psd.Font` specifies a horizontal line through the font.'''
        ...
    
    @property
    def underline(self) -> bool:
        '''Gets a value indicating whether this :py:class:`aspose.psd.Font` is underlined.'''
        ...
    
    @property
    def style(self) -> aspose.psd.FontStyle:
        '''Gets style information for this :py:class:`aspose.psd.Font`.'''
        ...
    
    @property
    def size(self) -> float:
        '''Gets the em-size of this :py:class:`aspose.psd.Font` measured in the units specified by the :py:attr:`aspose.psd.Font.unit` property.'''
        ...
    
    @property
    def unit(self) -> aspose.psd.GraphicsUnit:
        '''Gets the unit of measure for this :py:class:`aspose.psd.Font`.'''
        ...
    
    ...

class FontSettings:
    '''General PSD vector formats renderer font settings.'''
    
    @staticmethod
    def get_fonts_folders() -> List[str]:
        '''Gets a copy of the array that contains the list of folders where Aspose.Words looks for TrueType fonts.
        
        :returns: A copy of the current font locations.'''
        ...
    
    @staticmethod
    def get_default_fonts_folders() -> List[str]:
        '''Gets the default fonts folders.
        
        :returns: Returns system folder'''
        ...
    
    @staticmethod
    def set_fonts_folder(font_folder : str):
        '''This is a shortcut to :py:func:`aspose.psd.FontSettings.set_fonts_folders` for setting only one font directory.
        There are no checks performed on the fonts folder.
        
        :param font_folder: The font folder.'''
        ...
    
    @staticmethod
    def set_fonts_folders(fonts_folders : List[str]recursive : bool):
        '''Sets the folders where TrueType fonts are loaded from and clears all loaded fonts.
        There are no checks performed on the fonts folders.
        
        :param fonts_folders: The fonts folders.
        :param recursive: if set to ``true`` [recursive].'''
        ...
    
    @staticmethod
    def reset():
        '''Resets the fonts folder and default font name to the system default.'''
        ...
    
    @staticmethod
    def update_fonts():
        '''Updates fonts cache for PSD files that contain text layers. This method guarantees that fonts from folder fontsFolder using
        method FontSettings.SetFontsFolder(fontsFolder) or after reset fonts using FontSettings.Reset() will be taken into consideration when processing PSD files. Please use this method each time when
        FontSettings.SetFontsFolder(fontsFolder) or FontSettings.Reset() called for PSD images. Without calling this Method there is no guarantee that fonts will be updated.'''
        ...
    
    @staticmethod
    def get_adobe_font_name(font_family_name : str) -> str:
        '''Gets the adobe font name by font family name.
        
        :param font_family_name: The font family name.
        :returns: The adobe font name by font family name.'''
        ...
    
    @staticmethod
    def set_allowed_fonts(font_list : List[str]):
        '''Restricts font using by list of fonts. Please check real font names before restriction
        Set Allowed font list to Null to remove restrictrions
        
        :param font_list: The font list.'''
        ...
    
    @staticmethod
    def is_font_allowed(font_name : str) -> bool:
        '''Determines whether [is font allowed] [the specified font name].
        
        :param font_name: Name of the font.
        :returns: ``true`` if [is font allowed] [the specified font name]; otherwise, ``false``.'''
        ...
    
    @staticmethod
    def get_replacement_font(font_name : str) -> str:
        '''Gets the most suitable replacement font.
        If all replacements are not allowed then will returned first allowed and available font.
        If there are no available fonts then will be returned font from argument
        
        :param font_name: Name of the font.
        :returns: The name of replaced font'''
        ...
    
    @staticmethod
    def get_font_replacements(font_name : str) -> List[str]:
        '''Gets the font replacements array by the font name
        
        :param font_name: Name of the font.
        :returns: Array of names of replacements for provided fonts'''
        ...
    
    @staticmethod
    def set_font_replacements(font_to_replace : strfont_names : List[str]):
        '''Sets the font replacement list. If font is not allowed then will be find replacement.
        The first one font in list will be used first. If it retricted too, then will be selected next font from list.
        If font has not replacements or all replacements are not allowed then will be used first allowed font from allowed font list.
        If there are no allowed and available fonts then library will try use system default font even if it is not allowed.
        
        :param font_to_replace: The font to replace.
        :param font_names: The replacement font names in order of similarity.'''
        ...
    
    @staticmethod
    def clear_font_replacements():
        '''Clears the all fonts replacements'''
        ...
    
    @staticmethod
    def remove_font_cache_file():
        '''Removes of the font cache file.'''
        ...
    
    @classmethod
    @property
    def get_system_alternative_font(cls) -> bool:
        ...
    
    @classmethod
    @get_system_alternative_font.setter
    def get_system_alternative_font(cls, value : bool):
        ...
    
    @classmethod
    @property
    def default_font_name(cls) -> str:
        ...
    
    @classmethod
    @default_font_name.setter
    def default_font_name(cls, value : str):
        ...
    
    ...

class Graphics:
    '''Represents the graphics according to the graphics engine used in the current assembly.'''
    
    @overload
    def multiply_transform(self, matrix : aspose.psd.Matrix):
        '''Multiplies the :py:class:`aspose.psd.Matrix` that represents the local geometric transform of this :py:class:`aspose.psd.Graphics` by the specified :py:class:`aspose.psd.Matrix` by prepending the specified :py:class:`aspose.psd.Matrix`.
        
        :param matrix: The :py:class:`aspose.psd.Matrix` by which to multiply the geometric transform.'''
        ...
    
    @overload
    def multiply_transform(self, matrix : aspose.psd.Matrix, order : aspose.psd.MatrixOrder):
        '''Multiplies the :py:class:`aspose.psd.Matrix` that represents the local geometric transform of this :py:class:`aspose.psd.Graphics` by the specified :py:class:`aspose.psd.Matrix` in the specified order.
        
        :param matrix: The :py:class:`aspose.psd.Matrix` by which to multiply the geometric transform.
        :param order: A :py:class:`aspose.psd.MatrixOrder` that specifies in which order to multiply the two matrices.'''
        ...
    
    @overload
    def translate_transform(self, dx : float, dy : float):
        '''Translates the local geometric transform by the specified dimensions. This method prepends the translation to the transform.
        
        :param dx: The value of the translation in x.
        :param dy: The value of the translation in y.'''
        ...
    
    @overload
    def translate_transform(self, dx : float, dy : float, order : aspose.psd.MatrixOrder):
        '''Translates the local geometric transform by the specified dimensions in the specified order.
        
        :param dx: The value of the translation in x.
        :param dy: The value of the translation in y.
        :param order: The order (prepend or append) in which to apply the translation.'''
        ...
    
    @overload
    def scale_transform(self, sx : float, sy : float):
        '''Scales the local geometric transform by the specified amounts. This method prepends the scaling matrix to the transform.
        
        :param sx: The amount by which to scale the transform in the x-axis direction.
        :param sy: The amount by which to scale the transform in the y-axis direction.'''
        ...
    
    @overload
    def scale_transform(self, sx : float, sy : float, order : aspose.psd.MatrixOrder):
        '''Scales the local geometric transform by the specified amounts in the specified order.
        
        :param sx: The amount by which to scale the transform in the x-axis direction.
        :param sy: The amount by which to scale the transform in the y-axis direction.
        :param order: A :py:class:`aspose.psd.MatrixOrder` that specifies whether to append or prepend the scaling matrix.'''
        ...
    
    @overload
    def rotate_transform(self, angle : float):
        '''Rotates the local geometric transform by the specified amount. This method prepends the rotation to the transform.
        
        :param angle: The angle of rotation.'''
        ...
    
    @overload
    def rotate_transform(self, angle : float, order : aspose.psd.MatrixOrder):
        '''Rotates the local geometric transform by the specified amount in the specified order.
        
        :param angle: The angle of rotation.
        :param order: A :py:class:`aspose.psd.MatrixOrder` that specifies whether to append or prepend the rotation matrix.'''
        ...
    
    @overload
    def draw_line(self, pen : aspose.psd.Pen, point1 : aspose.psd.Point, point2 : aspose.psd.Point):
        '''Draws a line connecting two :py:class:`aspose.psd.Point` structures.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the line.
        :param point1: :py:class:`aspose.psd.Point` structure that represents the first point to connect.
        :param point2: :py:class:`aspose.psd.Point` structure that represents the second point to connect.'''
        ...
    
    @overload
    def draw_line(self, pen : aspose.psd.Pen, point1 : aspose.psd.PointF, point2 : aspose.psd.PointF):
        '''Draws a line connecting two :py:class:`aspose.psd.PointF` structures.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the line.
        :param point1: :py:class:`aspose.psd.PointF` structure that represents the first point to connect.
        :param point2: :py:class:`aspose.psd.PointF` structure that represents the second point to connect.'''
        ...
    
    @overload
    def draw_line(self, pen : aspose.psd.Pen, x1 : int, y1 : int, x2 : int, y2 : int):
        '''Draws a line connecting the two points specified by the coordinate pairs.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the line.
        :param x1: The x-coordinate of the first point.
        :param y1: The y-coordinate of the first point.
        :param x2: The x-coordinate of the second point.
        :param y2: The y-coordinate of the second point.'''
        ...
    
    @overload
    def draw_line(self, pen : aspose.psd.Pen, x1 : float, y1 : float, x2 : float, y2 : float):
        '''Draws a line connecting the two points specified by the coordinate pairs.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the line.
        :param x1: The x-coordinate of the first point.
        :param y1: The y-coordinate of the first point.
        :param x2: The x-coordinate of the second point.
        :param y2: The y-coordinate of the second point.'''
        ...
    
    @overload
    def draw_lines(self, pen : aspose.psd.Pen, points : List[aspose.psd.Point]):
        '''Draws a series of line segments that connect an array of :py:class:`aspose.psd.Point` structures.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the line segments.
        :param points: Array of :py:class:`aspose.psd.Point` structures that represent the points to connect.'''
        ...
    
    @overload
    def draw_lines(self, pen : aspose.psd.Pen, points : List[aspose.psd.PointF]):
        '''Draws a series of line segments that connect an array of :py:class:`aspose.psd.PointF` structures.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the line segments.
        :param points: Array of :py:class:`aspose.psd.PointF` structures that represent the points to connect.'''
        ...
    
    @overload
    def fill_rectangle(self, brush : aspose.psd.Brush, rect : aspose.psd.Rectangle):
        '''Fills the interior of a rectangle specified by a :py:class:`aspose.psd.Rectangle` structure.
        
        :param brush: :py:class:`aspose.psd.Brush` that determines the characteristics of the fill.
        :param rect: :py:class:`aspose.psd.Rectangle` structure that represents the rectangle to fill.'''
        ...
    
    @overload
    def fill_rectangle(self, brush : aspose.psd.Brush, rect : aspose.psd.RectangleF):
        '''Fills the interior of a rectangle specified by a :py:class:`aspose.psd.RectangleF` structure.
        
        :param brush: :py:class:`aspose.psd.Brush` that determines the characteristics of the fill.
        :param rect: :py:class:`aspose.psd.RectangleF` structure that represents the rectangle to fill.'''
        ...
    
    @overload
    def fill_rectangle(self, brush : aspose.psd.Brush, x : float, y : float, width : float, height : float):
        '''Fills the interior of a rectangle specified by a pair of coordinates, a width and a height.
        
        :param brush: :py:class:`aspose.psd.Brush` that determines the characteristics of the fill.
        :param x: The x-coordinate of the upper-left corner of the rectangle to fill.
        :param y: The y-coordinate of the upper-left corner of the rectangle to fill.
        :param width: Width of the rectangle to fill.
        :param height: Height of the rectangle to fill.'''
        ...
    
    @overload
    def fill_rectangle(self, brush : aspose.psd.Brush, x : int, y : int, width : int, height : int):
        '''Fills the interior of a rectangle specified by a pair of coordinates, a width and a height.
        
        :param brush: :py:class:`aspose.psd.Brush` that determines the characteristics of the fill.
        :param x: The x-coordinate of the upper-left corner of the rectangle to fill.
        :param y: The y-coordinate of the upper-left corner of the rectangle to fill.
        :param width: Width of the rectangle to fill.
        :param height: Height of the rectangle to fill.'''
        ...
    
    @overload
    def fill_rectangles(self, brush : aspose.psd.Brush, rects : List[aspose.psd.Rectangle]):
        '''Fills the interiors of a series of rectangles specified by :py:class:`aspose.psd.Rectangle` structures.
        
        :param brush: :py:class:`aspose.psd.Brush` that determines the characteristics of the fill.
        :param rects: Array of :py:class:`aspose.psd.Rectangle` structures that represent the rectangles to fill.'''
        ...
    
    @overload
    def fill_rectangles(self, brush : aspose.psd.Brush, rects : List[aspose.psd.RectangleF]):
        '''Fills the interiors of a series of rectangles specified by :py:class:`aspose.psd.RectangleF` structures.
        
        :param brush: :py:class:`aspose.psd.Brush` that determines the characteristics of the fill.
        :param rects: Array of :py:class:`aspose.psd.Rectangle` structures that represent the rectangles to fill.'''
        ...
    
    @overload
    def draw_rectangle(self, pen : aspose.psd.Pen, rect : aspose.psd.RectangleF):
        '''Draws a rectangle specified by a :py:class:`aspose.psd.RectangleF` structure.
        
        :param pen: A :py:class:`aspose.psd.Pen` that determines the color, width, and style of the rectangle.
        :param rect: A :py:class:`aspose.psd.RectangleF` structure that represents the rectangle to draw.'''
        ...
    
    @overload
    def draw_rectangle(self, pen : aspose.psd.Pen, rect : aspose.psd.Rectangle):
        '''Draws a rectangle specified by a :py:class:`aspose.psd.Rectangle` structure.
        
        :param pen: A :py:class:`aspose.psd.Pen` that determines the color, width, and style of the rectangle.
        :param rect: A :py:class:`aspose.psd.Rectangle` structure that represents the rectangle to draw.'''
        ...
    
    @overload
    def draw_rectangle(self, pen : aspose.psd.Pen, x : float, y : float, width : float, height : float):
        '''Draws a rectangle specified by a coordinate pair, a width, and a height.
        
        :param pen: A :py:class:`aspose.psd.Pen` that determines the color, width, and style of the rectangle.
        :param x: The x-coordinate of the upper-left corner of the rectangle to draw.
        :param y: The y-coordinate of the upper-left corner of the rectangle to draw.
        :param width: The width of the rectangle to draw.
        :param height: The height of the rectangle to draw.'''
        ...
    
    @overload
    def draw_rectangle(self, pen : aspose.psd.Pen, x : int, y : int, width : int, height : int):
        '''Draws a rectangle specified by a coordinate pair, a width, and a height.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the rectangle.
        :param x: The x-coordinate of the upper-left corner of the rectangle to draw.
        :param y: The y-coordinate of the upper-left corner of the rectangle to draw.
        :param width: Width of the rectangle to draw.
        :param height: Height of the rectangle to draw.'''
        ...
    
    @overload
    def draw_rectangles(self, pen : aspose.psd.Pen, rects : List[aspose.psd.RectangleF]):
        '''Draws a series of rectangles specified by :py:class:`aspose.psd.RectangleF` structures.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the outlines of the rectangles.
        :param rects: Array of :py:class:`aspose.psd.RectangleF` structures that represent the rectangles to draw.'''
        ...
    
    @overload
    def draw_rectangles(self, pen : aspose.psd.Pen, rects : List[aspose.psd.Rectangle]):
        '''Draws a series of rectangles specified by :py:class:`aspose.psd.Rectangle` structures.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the outlines of the rectangles.
        :param rects: Array of :py:class:`aspose.psd.Rectangle` structures that represent the rectangles to draw.'''
        ...
    
    @overload
    def draw_ellipse(self, pen : aspose.psd.Pen, rect : aspose.psd.RectangleF):
        '''Draws an ellipse defined by a bounding :py:class:`aspose.psd.RectangleF`.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the ellipse.
        :param rect: :py:class:`aspose.psd.RectangleF` structure that defines the boundaries of the ellipse.'''
        ...
    
    @overload
    def draw_ellipse(self, pen : aspose.psd.Pen, x : float, y : float, width : float, height : float):
        '''Draws an ellipse defined by a bounding rectangle specified by a pair of coordinates, a height, and a width.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the ellipse.
        :param x: The x-coordinate of the upper-left corner of the bounding rectangle that defines the ellipse.
        :param y: The y-coordinate of the upper-left corner of the bounding rectangle that defines the ellipse.
        :param width: Width of the bounding rectangle that defines the ellipse.
        :param height: Height of the bounding rectangle that defines the ellipse.'''
        ...
    
    @overload
    def draw_ellipse(self, pen : aspose.psd.Pen, rect : aspose.psd.Rectangle):
        '''Draws an ellipse specified by a bounding :py:class:`aspose.psd.Rectangle` structure.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the ellipse.
        :param rect: :py:class:`aspose.psd.Rectangle` structure that defines the boundaries of the ellipse.'''
        ...
    
    @overload
    def draw_ellipse(self, pen : aspose.psd.Pen, x : int, y : int, width : int, height : int):
        '''Draws an ellipse defined by a bounding rectangle specified by a pair of coordinates, a height, and a width.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the ellipse.
        :param x: The x-coordinate of the upper-left corner of the bounding rectangle that defines the ellipse.
        :param y: The y-coordinate of the upper-left corner of the bounding rectangle that defines the ellipse.
        :param width: Width of the bounding rectangle that defines the ellipse.
        :param height: Height of the bounding rectangle that defines the ellipse.'''
        ...
    
    @overload
    def draw_polygon(self, pen : aspose.psd.Pen, points : List[aspose.psd.PointF]):
        '''Draws a polygon defined by an array of :py:class:`aspose.psd.PointF` structures.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the polygon.
        :param points: Array of :py:class:`aspose.psd.PointF` structures that represent the vertices of the polygon.'''
        ...
    
    @overload
    def draw_polygon(self, pen : aspose.psd.Pen, points : List[aspose.psd.Point]):
        '''Draws a polygon defined by an array of :py:class:`aspose.psd.Point` structures.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the polygon.
        :param points: Array of :py:class:`aspose.psd.Point` structures that represent the vertices of the polygon.'''
        ...
    
    @overload
    def draw_image(self, source_image : aspose.psd.Image, point : aspose.psd.PointF):
        '''Draws the specified :py:attr:`aspose.psd.Graphics.image`, using its original physical size, at the specified location.
        
        :param source_image: The image to draw with.
        :param point: :py:class:`aspose.psd.PointF` structure that represents the upper-left corner of the drawn image.'''
        ...
    
    @overload
    def draw_image(self, source_image : aspose.psd.Image, x : float, y : float):
        '''Draws the specified :py:attr:`aspose.psd.Graphics.image`, using its original physical size, at the specified location.
        
        :param source_image: The image to draw with.
        :param x: The x-coordinate of the upper-left corner of the drawn image.
        :param y: The y-coordinate of the upper-left corner of the drawn image.'''
        ...
    
    @overload
    def draw_image(self, source_image : aspose.psd.Image, rect : aspose.psd.RectangleF):
        '''Draws the specified :py:attr:`aspose.psd.Graphics.image` at the specified location and with the specified size.
        
        :param source_image: The image to draw with.
        :param rect: :py:class:`aspose.psd.RectangleF` structure that specifies the location and size of the drawn image.'''
        ...
    
    @overload
    def draw_image(self, source_image : aspose.psd.Image, rect_destination : aspose.psd.Rectangle, graphics_unit : aspose.psd.GraphicsUnit):
        '''Draws the specified :py:attr:`aspose.psd.Graphics.image` at the specified location and with the specified size.
        
        :param source_image: The image to draw with.
        :param rect_destination: The destination rectangle.
        :param graphics_unit: The graphics unit.'''
        ...
    
    @overload
    def draw_image(self, source_image : aspose.psd.Image, rect_destination : aspose.psd.RectangleF, graphics_unit : aspose.psd.GraphicsUnit):
        '''Draws the specified :py:attr:`aspose.psd.Graphics.image` at the specified location and with the specified size.
        
        :param source_image: The image to draw with.
        :param rect_destination: The destination rectangle.
        :param graphics_unit: The graphics unit.'''
        ...
    
    @overload
    def draw_image(self, source_image : aspose.psd.Image, rect_destination : aspose.psd.Rectangle, graphics_unit : aspose.psd.GraphicsUnit, image_attributes : aspose.psd.ImageAttributes):
        '''Draws the specified :py:attr:`aspose.psd.Graphics.image` at the specified location and with the specified size.
        
        :param source_image: The image to draw with.
        :param rect_destination: The destination rectangle.
        :param graphics_unit: The graphics unit.
        :param image_attributes: The image attributes.'''
        ...
    
    @overload
    def draw_image(self, source_image : aspose.psd.Image, rect_destination : aspose.psd.RectangleF, graphics_unit : aspose.psd.GraphicsUnit, image_attributes : aspose.psd.ImageAttributes):
        '''Draws the specified :py:attr:`aspose.psd.Graphics.image` at the specified location and with the specified size.
        
        :param source_image: The image to draw with.
        :param rect_destination: The destination rectangle to draw in.
        :param graphics_unit: The graphics unit.
        :param image_attributes: The image attributes.'''
        ...
    
    @overload
    def draw_image(self, source_image : aspose.psd.Image, rect_source : aspose.psd.Rectangle, rect_destination : aspose.psd.Rectangle, graphics_unit : aspose.psd.GraphicsUnit):
        '''Draws the specified :py:attr:`aspose.psd.Graphics.image` at the specified location and with the specified size.
        
        :param source_image: The image to draw with.
        :param rect_source: The rect source.
        :param rect_destination: The rect destination.
        :param graphics_unit: The graphics unit.'''
        ...
    
    @overload
    def draw_image(self, source_image : aspose.psd.Image, rect_source : aspose.psd.RectangleF, rect_destination : aspose.psd.RectangleF, graphics_unit : aspose.psd.GraphicsUnit):
        '''Draws the specified :py:attr:`aspose.psd.Graphics.image` at the specified location and with the specified size.
        
        :param source_image: The image to draw with.
        :param rect_source: The rect source.
        :param rect_destination: The rect destination.
        :param graphics_unit: The graphics unit.'''
        ...
    
    @overload
    def draw_image(self, source_image : aspose.psd.Image, rect_source : aspose.psd.Rectangle, rect_destination : aspose.psd.Rectangle, graphics_unit : aspose.psd.GraphicsUnit, image_attributes : aspose.psd.ImageAttributes):
        '''Draws the specified :py:attr:`aspose.psd.Graphics.image` at the specified location and with the specified size.
        
        :param source_image: The image to draw with.
        :param rect_source: The rect source.
        :param rect_destination: The rect destination.
        :param graphics_unit: The graphics unit.
        :param image_attributes: The image attributes.'''
        ...
    
    @overload
    def draw_image(self, source_image : aspose.psd.Image, rect_source : aspose.psd.RectangleF, rect_destination : aspose.psd.RectangleF, graphics_unit : aspose.psd.GraphicsUnit, image_attributes : aspose.psd.ImageAttributes):
        '''Draws the specified :py:attr:`aspose.psd.Graphics.image` at the specified location and with the specified size.
        
        :param source_image: The image to draw with.
        :param rect_source: The source rectangle.
        :param rect_destination: The destination rectangle.
        :param graphics_unit: The graphics unit to use.
        :param image_attributes: The image attributes to use.'''
        ...
    
    @overload
    def draw_image(self, image : aspose.psd.Image, dest_points : List[aspose.psd.Point]):
        '''Draws the specified portion of the specified ``image`` at the specified location and with the specified size.
        
        :param image: The image to draw.
        :param dest_points: Array of three PointF structures that define a parallelogram.'''
        ...
    
    @overload
    def draw_image(self, image : aspose.psd.Image, dest_points : List[aspose.psd.Point], src_rect : aspose.psd.Rectangle):
        '''Draws the specified portion of the specified ``image`` at the specified location and with the specified size.
        
        :param image: The image to draw.
        :param dest_points: Array of three PointF structures that define a parallelogram.
        :param src_rect: The source rectangle.'''
        ...
    
    @overload
    def draw_image(self, image : aspose.psd.Image, dest_points : List[aspose.psd.Point], src_rect : aspose.psd.Rectangle, src_unit : aspose.psd.GraphicsUnit):
        '''Draws the specified portion of the specified ``image`` at the specified location and with the specified size.
        
        :param image: The image to draw.
        :param dest_points: Array of three PointF structures that define a parallelogram.
        :param src_rect: The source rectangle.
        :param src_unit: The units of measure.'''
        ...
    
    @overload
    def draw_image(self, image : aspose.psd.Image, dest_points : List[aspose.psd.Point], src_rect : aspose.psd.Rectangle, src_unit : aspose.psd.GraphicsUnit, image_attributes : aspose.psd.ImageAttributes):
        '''Draws the specified portion of the specified ``image`` at the specified location and with the specified size.
        
        :param image: The image to draw.
        :param dest_points: Array of three PointF structures that define a parallelogram.
        :param src_rect: The source rectangle.
        :param src_unit: The units of measure.
        :param image_attributes: The image attributes.'''
        ...
    
    @overload
    def draw_image(self, image : aspose.psd.Image, dest_points : List[aspose.psd.PointF]):
        '''Draws the specified portion of the specified ``image`` at the specified location and with the specified size.
        
        :param image: The image to draw.
        :param dest_points: Array of three PointF structures that define a parallelogram.'''
        ...
    
    @overload
    def draw_image(self, image : aspose.psd.Image, dest_points : List[aspose.psd.PointF], src_rect : aspose.psd.RectangleF):
        '''Draws the specified portion of the specified ``image`` at the specified location and with the specified size.
        
        :param image: The image to draw.
        :param dest_points: Array of three PointF structures that define a parallelogram.
        :param src_rect: The source rectangle.'''
        ...
    
    @overload
    def draw_image(self, image : aspose.psd.Image, dest_points : List[aspose.psd.PointF], src_rect : aspose.psd.RectangleF, src_unit : aspose.psd.GraphicsUnit):
        '''Draws the specified portion of the specified ``image`` at the specified location and with the specified size.
        
        :param image: The image to draw.
        :param dest_points: Array of three PointF structures that define a parallelogram.
        :param src_rect: The source rectangle.
        :param src_unit: The units of measure.'''
        ...
    
    @overload
    def draw_image(self, image : aspose.psd.Image, dest_points : List[aspose.psd.PointF], src_rect : aspose.psd.RectangleF, src_unit : aspose.psd.GraphicsUnit, image_attributes : aspose.psd.ImageAttributes):
        '''Draws the specified portion of the specified ``image`` at the specified location and with the specified size.
        
        :param image: The image to draw.
        :param dest_points: Array of three PointF structures that define a parallelogram.
        :param src_rect: The source rectangle.
        :param src_unit: The units of measure.
        :param image_attributes: The image attributes.'''
        ...
    
    @overload
    def draw_image(self, source_image : aspose.psd.Image, x : float, y : float, width : float, height : float):
        '''Draws the specified :py:attr:`aspose.psd.Graphics.image` at the specified location and with the specified size.
        
        :param source_image: The image to draw with.
        :param x: The x-coordinate of the upper-left corner of the drawn image.
        :param y: The y-coordinate of the upper-left corner of the drawn image.
        :param width: Width of the drawn image.
        :param height: Height of the drawn image.'''
        ...
    
    @overload
    def draw_image(self, source_image : aspose.psd.Image, point : aspose.psd.Point):
        '''Draws the specified :py:attr:`aspose.psd.Graphics.image`, using its original physical size, at the specified location.
        
        :param source_image: The image to draw with.
        :param point: :py:class:`aspose.psd.Point` structure that represents the location of the upper-left corner of the drawn image.'''
        ...
    
    @overload
    def draw_image(self, source_image : aspose.psd.Image, x : int, y : int):
        '''Draws the specified image, using its original physical size, at the location specified by a coordinate pair.
        
        :param source_image: The image to draw with.
        :param x: The x-coordinate of the upper-left corner of the drawn image.
        :param y: The y-coordinate of the upper-left corner of the drawn image.'''
        ...
    
    @overload
    def draw_image(self, source_image : aspose.psd.Image, rect : aspose.psd.Rectangle):
        '''Draws the specified :py:attr:`aspose.psd.Graphics.image` at the specified location and with the specified size.
        
        :param source_image: The image to draw with.
        :param rect: :py:class:`aspose.psd.Rectangle` structure that specifies the location and size of the drawn image.'''
        ...
    
    @overload
    def draw_image(self, source_image : aspose.psd.Image, x : int, y : int, width : int, height : int):
        '''Draws the specified :py:attr:`aspose.psd.Graphics.image` at the specified location and with the specified size.
        
        :param source_image: The image to draw with.
        :param x: The x-coordinate of the upper-left corner of the drawn image.
        :param y: The y-coordinate of the upper-left corner of the drawn image.
        :param width: Width of the drawn image.
        :param height: Height of the drawn image.'''
        ...
    
    @overload
    def draw_image_unscaled(self, source_image : aspose.psd.Image, point : aspose.psd.Point):
        '''Draws a specified image using its original physical size at a specified location.
        
        :param source_image: The image to draw with.
        :param point: :py:class:`aspose.psd.Point` structure that specifies the upper-left corner of the drawn image.'''
        ...
    
    @overload
    def draw_image_unscaled(self, source_image : aspose.psd.Image, x : int, y : int):
        '''Draws the specified image using its original physical size at the location specified by a coordinate pair.
        
        :param source_image: The image to draw with.
        :param x: The x-coordinate of the upper-left corner of the drawn image.
        :param y: The y-coordinate of the upper-left corner of the drawn image.'''
        ...
    
    @overload
    def draw_image_unscaled(self, source_image : aspose.psd.Image, rect : aspose.psd.Rectangle):
        '''Draws a specified image using its original physical size at a specified location.
        
        :param source_image: The image to draw with.
        :param rect: :py:class:`aspose.psd.Rectangle` that specifies the upper-left corner of the drawn image. The X and Y properties of the rectangle specify the upper-left corner. The Width and Height properties are ignored.'''
        ...
    
    @overload
    def draw_image_unscaled(self, source_image : aspose.psd.Image, x : int, y : int, width : int, height : int):
        '''Draws a specified image using its original physical size at a specified location.
        
        :param source_image: The image to draw with.
        :param x: The x-coordinate of the upper-left corner of the drawn image.
        :param y: The y-coordinate of the upper-left corner of the drawn image.
        :param width: The parameter is not used.
        :param height: The parameter is not used.'''
        ...
    
    @overload
    def draw_arc(self, pen : aspose.psd.Pen, x : float, y : float, width : float, height : float, start_angle : float, sweep_angle : float):
        '''Draws an arc representing a portion of an ellipse specified by a pair of coordinates, a width, and a height.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the arc.
        :param x: The x-coordinate of the upper-left corner of the rectangle that defines the ellipse.
        :param y: The y-coordinate of the upper-left corner of the rectangle that defines the ellipse.
        :param width: Width of the rectangle that defines the ellipse.
        :param height: Height of the rectangle that defines the ellipse.
        :param start_angle: Angle in degrees measured clockwise from the x-axis to the starting point of the arc.
        :param sweep_angle: Angle in degrees measured clockwise from the ``startAngle`` parameter to ending point of the arc.'''
        ...
    
    @overload
    def draw_arc(self, pen : aspose.psd.Pen, rect : aspose.psd.RectangleF, start_angle : float, sweep_angle : float):
        '''Draws an arc representing a portion of an ellipse specified by a :py:class:`aspose.psd.RectangleF` structure.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the arc.
        :param rect: :py:class:`aspose.psd.RectangleF` structure that defines the boundaries of the ellipse.
        :param start_angle: Angle in degrees measured clockwise from the x-axis to the starting point of the arc.
        :param sweep_angle: Angle in degrees measured clockwise from the ``startAngle`` parameter to ending point of the arc.'''
        ...
    
    @overload
    def draw_arc(self, pen : aspose.psd.Pen, x : int, y : int, width : int, height : int, start_angle : int, sweep_angle : int):
        '''Draws an arc representing a portion of an ellipse specified by a pair of coordinates, a width, and a height.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the arc.
        :param x: The x-coordinate of the upper-left corner of the rectangle that defines the ellipse.
        :param y: The y-coordinate of the upper-left corner of the rectangle that defines the ellipse.
        :param width: Width of the rectangle that defines the ellipse.
        :param height: Height of the rectangle that defines the ellipse.
        :param start_angle: Angle in degrees measured clockwise from the x-axis to the starting point of the arc.
        :param sweep_angle: Angle in degrees measured clockwise from the ``startAngle`` parameter to ending point of the arc.'''
        ...
    
    @overload
    def draw_arc(self, pen : aspose.psd.Pen, rect : aspose.psd.Rectangle, start_angle : float, sweep_angle : float):
        '''Draws an arc representing a portion of an ellipse specified by a :py:class:`aspose.psd.Rectangle` structure.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the arc.
        :param rect: :py:class:`aspose.psd.RectangleF` structure that defines the boundaries of the ellipse.
        :param start_angle: Angle in degrees measured clockwise from the x-axis to the starting point of the arc.
        :param sweep_angle: Angle in degrees measured clockwise from the ``startAngle`` parameter to ending point of the arc.'''
        ...
    
    @overload
    def draw_pie(self, pen : aspose.psd.Pen, rect : aspose.psd.RectangleF, start_angle : float, sweep_angle : float):
        '''Draws a pie shape defined by an ellipse specified by a :py:class:`aspose.psd.RectangleF` structure and two radial lines.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the pie shape.
        :param rect: :py:class:`aspose.psd.RectangleF` structure that represents the bounding rectangle that defines the ellipse from which the pie shape comes.
        :param start_angle: Angle measured in degrees clockwise from the x-axis to the first side of the pie shape.
        :param sweep_angle: Angle measured in degrees clockwise from the ``startAngle`` parameter to the second side of the pie shape.'''
        ...
    
    @overload
    def draw_pie(self, pen : aspose.psd.Pen, x : float, y : float, width : float, height : float, start_angle : float, sweep_angle : float):
        '''Draws a pie shape defined by an ellipse specified by a coordinate pair, a width, a height, and two radial lines.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the pie shape.
        :param x: The x-coordinate of the upper-left corner of the bounding rectangle that defines the ellipse from which the pie shape comes.
        :param y: The y-coordinate of the upper-left corner of the bounding rectangle that defines the ellipse from which the pie shape comes.
        :param width: Width of the bounding rectangle that defines the ellipse from which the pie shape comes.
        :param height: Height of the bounding rectangle that defines the ellipse from which the pie shape comes.
        :param start_angle: Angle measured in degrees clockwise from the x-axis to the first side of the pie shape.
        :param sweep_angle: Angle measured in degrees clockwise from the ``startAngle`` parameter to the second side of the pie shape.'''
        ...
    
    @overload
    def draw_pie(self, pen : aspose.psd.Pen, rect : aspose.psd.Rectangle, start_angle : float, sweep_angle : float):
        '''Draws a pie shape defined by an ellipse specified by a :py:class:`aspose.psd.Rectangle` structure and two radial lines.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the pie shape.
        :param rect: :py:class:`aspose.psd.Rectangle` structure that represents the bounding rectangle that defines the ellipse from which the pie shape comes.
        :param start_angle: Angle measured in degrees clockwise from the x-axis to the first side of the pie shape.
        :param sweep_angle: Angle measured in degrees clockwise from the ``startAngle`` parameter to the second side of the pie shape.'''
        ...
    
    @overload
    def draw_pie(self, pen : aspose.psd.Pen, x : int, y : int, width : int, height : int, start_angle : int, sweep_angle : int):
        '''Draws a pie shape defined by an ellipse specified by a coordinate pair, a width, a height, and two radial lines.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the pie shape.
        :param x: The x-coordinate of the upper-left corner of the bounding rectangle that defines the ellipse from which the pie shape comes.
        :param y: The y-coordinate of the upper-left corner of the bounding rectangle that defines the ellipse from which the pie shape comes.
        :param width: Width of the bounding rectangle that defines the ellipse from which the pie shape comes.
        :param height: Height of the bounding rectangle that defines the ellipse from which the pie shape comes.
        :param start_angle: Angle measured in degrees clockwise from the x-axis to the first side of the pie shape.
        :param sweep_angle: Angle measured in degrees clockwise from the ``startAngle`` parameter to the second side of the pie shape.'''
        ...
    
    @overload
    def draw_curve(self, pen : aspose.psd.Pen, points : List[aspose.psd.PointF]):
        '''Draws a cardinal spline through a specified array of :py:class:`aspose.psd.PointF` structures. This method uses a default tension of 0.5.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and height of the curve.
        :param points: Array of :py:class:`aspose.psd.PointF` structures that define the spline.'''
        ...
    
    @overload
    def draw_curve(self, pen : aspose.psd.Pen, points : List[aspose.psd.PointF], tension : float):
        '''Draws a cardinal spline through a specified array of :py:class:`aspose.psd.PointF` structures using a specified tension.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and height of the curve.
        :param points: Array of :py:class:`aspose.psd.PointF` structures that represent the points that define the curve.
        :param tension: Value greater than or equal to 0.0F that specifies the tension of the curve.'''
        ...
    
    @overload
    def draw_curve(self, pen : aspose.psd.Pen, points : List[aspose.psd.PointF], offset : int, number_of_segments : int):
        '''Draws a cardinal spline through a specified array of :py:class:`aspose.psd.PointF` structures. The drawing begins offset from the beginning of the array.
        This method uses a default tension of 0.5.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and height of the curve.
        :param points: Array of :py:class:`aspose.psd.PointF` structures that define the spline.
        :param offset: Offset from the first element in the array of the ``points`` parameter to the starting point in the curve.
        :param number_of_segments: Number of segments after the starting point to include in the curve.'''
        ...
    
    @overload
    def draw_curve(self, pen : aspose.psd.Pen, points : List[aspose.psd.PointF], offset : int, number_of_segments : int, tension : float):
        '''Draws a cardinal spline through a specified array of :py:class:`aspose.psd.PointF` structures using a specified tension. The drawing begins offset from the beginning of the array.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and height of the curve.
        :param points: Array of :py:class:`aspose.psd.PointF` structures that define the spline.
        :param offset: Offset from the first element in the array of the ``points`` parameter to the starting point in the curve.
        :param number_of_segments: Number of segments after the starting point to include in the curve.
        :param tension: Value greater than or equal to 0.0F that specifies the tension of the curve.'''
        ...
    
    @overload
    def draw_curve(self, pen : aspose.psd.Pen, points : List[aspose.psd.Point]):
        '''Draws a cardinal spline through a specified array of :py:class:`aspose.psd.Point` structures.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and height of the curve.
        :param points: Array of :py:class:`aspose.psd.Point` structures that define the spline.'''
        ...
    
    @overload
    def draw_curve(self, pen : aspose.psd.Pen, points : List[aspose.psd.Point], tension : float):
        '''Draws a cardinal spline through a specified array of :py:class:`aspose.psd.Point` structures using a specified tension.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and height of the curve.
        :param points: Array of :py:class:`aspose.psd.Point` structures that define the spline.
        :param tension: Value greater than or equal to 0.0F that specifies the tension of the curve.'''
        ...
    
    @overload
    def draw_curve(self, pen : aspose.psd.Pen, points : List[aspose.psd.Point], offset : int, number_of_segments : int, tension : float):
        '''Draws a cardinal spline through a specified array of :py:class:`aspose.psd.Point` structures using a specified tension.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and height of the curve.
        :param points: Array of :py:class:`aspose.psd.Point` structures that define the spline.
        :param offset: Offset from the first element in the array of the ``points`` parameter to the starting point in the curve.
        :param number_of_segments: Number of segments after the starting point to include in the curve.
        :param tension: Value greater than or equal to 0.0F that specifies the tension of the curve.'''
        ...
    
    @overload
    def draw_closed_curve(self, pen : aspose.psd.Pen, points : List[aspose.psd.PointF]):
        '''Draws a closed cardinal spline defined by an array of :py:class:`aspose.psd.PointF` structures. This method uses a default tension of 0.5 and :py:attr:`aspose.psd.FillMode.ALTERNATE` fill mode.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and height of the curve.
        :param points: Array of :py:class:`aspose.psd.PointF` structures that define the spline.'''
        ...
    
    @overload
    def draw_closed_curve(self, pen : aspose.psd.Pen, points : List[aspose.psd.PointF], tension : float):
        '''Draws a closed cardinal spline defined by an array of :py:class:`aspose.psd.PointF` structures using a specified tension. This method uses a default :py:attr:`aspose.psd.FillMode.ALTERNATE` fill mode.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and height of the curve.
        :param points: Array of :py:class:`aspose.psd.PointF` structures that define the spline.
        :param tension: Value greater than or equal to 0.0F that specifies the tension of the curve.'''
        ...
    
    @overload
    def draw_closed_curve(self, pen : aspose.psd.Pen, points : List[aspose.psd.Point]):
        '''Draws a closed cardinal spline defined by an array of :py:class:`aspose.psd.Point` structures. This method uses a default tension of 0.5 and :py:attr:`aspose.psd.FillMode.ALTERNATE` fill mode.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and height of the curve.
        :param points: Array of :py:class:`aspose.psd.Point` structures that define the spline.'''
        ...
    
    @overload
    def draw_closed_curve(self, pen : aspose.psd.Pen, points : List[aspose.psd.Point], tension : float):
        '''Draws a closed cardinal spline defined by an array of :py:class:`aspose.psd.Point` structures using a specified tension. This method uses a default :py:attr:`aspose.psd.FillMode.ALTERNATE` fill mode.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and height of the curve.
        :param points: Array of :py:class:`aspose.psd.Point` structures that define the spline.
        :param tension: Value greater than or equal to 0.0F that specifies the tension of the curve.'''
        ...
    
    @overload
    def draw_bezier(self, pen : aspose.psd.Pen, x1 : float, y1 : float, x2 : float, y2 : float, x3 : float, y3 : float, x4 : float, y4 : float):
        '''Draws a Bézier spline defined by four ordered pairs of coordinates that represent points.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the curve.
        :param x1: The x-coordinate of the starting point of the curve.
        :param y1: The y-coordinate of the starting point of the curve.
        :param x2: The x-coordinate of the first control point of the curve.
        :param y2: The y-coordinate of the first control point of the curve.
        :param x3: The x-coordinate of the second control point of the curve.
        :param y3: The y-coordinate of the second control point of the curve.
        :param x4: The x-coordinate of the ending point of the curve.
        :param y4: The y-coordinate of the ending point of the curve.'''
        ...
    
    @overload
    def draw_bezier(self, pen : aspose.psd.Pen, pt1 : aspose.psd.PointF, pt2 : aspose.psd.PointF, pt3 : aspose.psd.PointF, pt4 : aspose.psd.PointF):
        '''Draws a Bézier spline defined by four :py:class:`aspose.psd.PointF` structures.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the curve.
        :param pt1: :py:class:`aspose.psd.PointF` structure that represents the starting point of the curve.
        :param pt2: :py:class:`aspose.psd.PointF` structure that represents the first control point for the curve.
        :param pt3: :py:class:`aspose.psd.PointF` structure that represents the second control point for the curve.
        :param pt4: :py:class:`aspose.psd.PointF` structure that represents the ending point of the curve.'''
        ...
    
    @overload
    def draw_bezier(self, pen : aspose.psd.Pen, pt1 : aspose.psd.Point, pt2 : aspose.psd.Point, pt3 : aspose.psd.Point, pt4 : aspose.psd.Point):
        '''Draws a Bézier spline defined by four :py:class:`aspose.psd.Point` structures.
        
        :param pen: :py:class:`aspose.psd.Pen` structure that determines the color, width, and style of the curve.
        :param pt1: :py:class:`aspose.psd.Point` structure that represents the starting point of the curve.
        :param pt2: :py:class:`aspose.psd.Point` structure that represents the first control point for the curve.
        :param pt3: :py:class:`aspose.psd.Point` structure that represents the second control point for the curve.
        :param pt4: :py:class:`aspose.psd.Point` structure that represents the ending point of the curve.'''
        ...
    
    @overload
    def draw_beziers(self, pen : aspose.psd.Pen, points : List[aspose.psd.Point]):
        '''Draws a series of Bézier splines from an array of :py:class:`aspose.psd.Point` structures.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the curve.
        :param points: Array of :py:class:`aspose.psd.Point` structures that represent the points that determine the curve.'''
        ...
    
    @overload
    def draw_beziers(self, pen : aspose.psd.Pen, points : List[aspose.psd.PointF]):
        '''Draws a series of Bézier splines from an array of :py:class:`aspose.psd.PointF` structures.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the curve.
        :param points: Array of :py:class:`aspose.psd.PointF` structures that represent the points that determine the curve.'''
        ...
    
    @overload
    def draw_string(self, s : str, font : aspose.psd.Font, brush : aspose.psd.Brush, x : float, y : float):
        '''Draws the specified text string at the specified location with the specified :py:class:`aspose.psd.Brush` and :py:class:`aspose.psd.Font` objects.
        
        :param s: String to draw.
        :param font: :py:class:`aspose.psd.Font` that defines the text format of the string.
        :param brush: :py:class:`aspose.psd.Brush` that determines the color and texture of the drawn text.
        :param x: The x-coordinate of the upper-left corner of the drawn text.
        :param y: The y-coordinate of the upper-left corner of the drawn text.'''
        ...
    
    @overload
    def draw_string(self, s : str, font : aspose.psd.Font, brush : aspose.psd.Brush, point : aspose.psd.PointF):
        '''Draws the specified text string at the specified location with the specified :py:class:`aspose.psd.Brush` and :py:class:`aspose.psd.Font` objects.
        
        :param s: String to draw.
        :param font: :py:class:`aspose.psd.Font` that defines the text format of the string.
        :param brush: :py:class:`aspose.psd.Brush` that determines the color and texture of the drawn text.
        :param point: :py:class:`aspose.psd.PointF` structure that specifies the upper-left corner of the drawn text.'''
        ...
    
    @overload
    def draw_string(self, s : str, font : aspose.psd.Font, brush : aspose.psd.Brush, x : float, y : float, format : aspose.psd.StringFormat):
        '''Draws the specified text string at the specified location with the specified :py:class:`aspose.psd.Brush` and :py:class:`aspose.psd.Font` objects using the formatting attributes of the specified :py:class:`aspose.psd.StringFormat`.
        
        :param s: String to draw.
        :param font: :py:class:`aspose.psd.Font` that defines the text format of the string.
        :param brush: :py:class:`aspose.psd.Brush` that determines the color and texture of the drawn text.
        :param x: The x-coordinate of the upper-left corner of the drawn text.
        :param y: The y-coordinate of the upper-left corner of the drawn text.
        :param format: :py:class:`aspose.psd.StringFormat` that specifies formatting attributes, such as line spacing and alignment, that are applied to the drawn text.'''
        ...
    
    @overload
    def draw_string(self, s : str, font : aspose.psd.Font, brush : aspose.psd.Brush, point : aspose.psd.PointF, format : aspose.psd.StringFormat):
        '''Draws the specified text string at the specified location with the specified :py:class:`aspose.psd.Brush` and :py:class:`aspose.psd.Font` objects using the formatting attributes of the specified :py:class:`aspose.psd.StringFormat`.
        
        :param s: String to draw.
        :param font: :py:class:`aspose.psd.Font` that defines the text format of the string.
        :param brush: :py:class:`aspose.psd.Brush` that determines the color and texture of the drawn text.
        :param point: :py:class:`aspose.psd.PointF` structure that specifies the upper-left corner of the drawn text.
        :param format: :py:class:`aspose.psd.StringFormat` that specifies formatting attributes, such as line spacing and alignment, that are applied to the drawn text.'''
        ...
    
    @overload
    def draw_string(self, s : str, font : aspose.psd.Font, brush : aspose.psd.Brush, layout_rectangle : aspose.psd.RectangleF):
        '''Draws the specified text string in the specified rectangle with the specified :py:class:`aspose.psd.Brush` and :py:class:`aspose.psd.Font` objects.
        
        :param s: String to draw.
        :param font: :py:class:`aspose.psd.Font` that defines the text format of the string.
        :param brush: :py:class:`aspose.psd.Brush` that determines the color and texture of the drawn text.
        :param layout_rectangle: :py:class:`aspose.psd.RectangleF` structure that specifies the location of the drawn text.'''
        ...
    
    @overload
    def draw_string(self, s : str, font : aspose.psd.Font, brush : aspose.psd.Brush, layout_rectangle : aspose.psd.RectangleF, format : aspose.psd.StringFormat):
        '''Draws the specified text string in the specified rectangle with the specified :py:class:`aspose.psd.Brush` and :py:class:`aspose.psd.Font` objects using the formatting attributes of the specified :py:class:`aspose.psd.StringFormat`.
        
        :param s: String to draw.
        :param font: :py:class:`aspose.psd.Font` that defines the text format of the string.
        :param brush: :py:class:`aspose.psd.Brush` that determines the color and texture of the drawn text.
        :param layout_rectangle: :py:class:`aspose.psd.RectangleF` structure that specifies the location of the drawn text.
        :param format: :py:class:`aspose.psd.StringFormat` that specifies formatting attributes, such as line spacing and alignment, that are applied to the drawn text.'''
        ...
    
    @overload
    def fill_ellipse(self, brush : aspose.psd.Brush, rect : aspose.psd.RectangleF):
        '''Fills the interior of an ellipse defined by a bounding rectangle specified by a :py:class:`aspose.psd.RectangleF` structure.
        
        :param brush: :py:class:`aspose.psd.Brush` that determines the characteristics of the fill.
        :param rect: :py:class:`aspose.psd.RectangleF` structure that represents the bounding rectangle that defines the ellipse.'''
        ...
    
    @overload
    def fill_ellipse(self, brush : aspose.psd.Brush, x : float, y : float, width : float, height : float):
        '''Fills the interior of an ellipse defined by a bounding rectangle specified by a pair of coordinates, a width, and a height.
        
        :param brush: :py:class:`aspose.psd.Brush` that determines the characteristics of the fill.
        :param x: The x-coordinate of the upper-left corner of the bounding rectangle that defines the ellipse.
        :param y: The y-coordinate of the upper-left corner of the bounding rectangle that defines the ellipse.
        :param width: Width of the bounding rectangle that defines the ellipse.
        :param height: Height of the bounding rectangle that defines the ellipse.'''
        ...
    
    @overload
    def fill_ellipse(self, brush : aspose.psd.Brush, rect : aspose.psd.Rectangle):
        '''Fills the interior of an ellipse defined by a bounding rectangle specified by a :py:class:`aspose.psd.Rectangle` structure.
        
        :param brush: :py:class:`aspose.psd.Brush` that determines the characteristics of the fill.
        :param rect: :py:class:`aspose.psd.Rectangle` structure that represents the bounding rectangle that defines the ellipse.'''
        ...
    
    @overload
    def fill_ellipse(self, brush : aspose.psd.Brush, x : int, y : int, width : int, height : int):
        '''Fills the interior of an ellipse defined by a bounding rectangle specified by a pair of coordinates, a width, and a height.
        
        :param brush: :py:class:`aspose.psd.Brush` that determines the characteristics of the fill.
        :param x: The x-coordinate of the upper-left corner of the bounding rectangle that defines the ellipse.
        :param y: The y-coordinate of the upper-left corner of the bounding rectangle that defines the ellipse.
        :param width: Width of the bounding rectangle that defines the ellipse.
        :param height: Height of the bounding rectangle that defines the ellipse.'''
        ...
    
    @overload
    def fill_pie(self, brush : aspose.psd.Brush, rect : aspose.psd.Rectangle, start_angle : float, sweep_angle : float):
        '''Fills the interior of a pie section defined by an ellipse specified by a :py:class:`aspose.psd.RectangleF` structure and two radial lines.
        
        :param brush: :py:class:`aspose.psd.Brush` that determines the characteristics of the fill.
        :param rect: :py:class:`aspose.psd.Rectangle` structure that represents the bounding rectangle that defines the ellipse from which the pie section comes.
        :param start_angle: Angle in degrees measured clockwise from the x-axis to the first side of the pie section.
        :param sweep_angle: Angle in degrees measured clockwise from the ``startAngle`` parameter to the second side of the pie section.'''
        ...
    
    @overload
    def fill_pie(self, brush : aspose.psd.Brush, rect : aspose.psd.RectangleF, start_angle : float, sweep_angle : float):
        '''Fills the interior of a pie section defined by an ellipse specified by a :py:class:`aspose.psd.RectangleF` structure and two radial lines.
        
        :param brush: :py:class:`aspose.psd.Brush` that determines the characteristics of the fill.
        :param rect: :py:class:`aspose.psd.RectangleF` structure that represents the bounding rectangle that defines the ellipse from which the pie section comes.
        :param start_angle: Angle in degrees measured clockwise from the x-axis to the first side of the pie section.
        :param sweep_angle: Angle in degrees measured clockwise from the ``startAngle`` parameter to the second side of the pie section.'''
        ...
    
    @overload
    def fill_pie(self, brush : aspose.psd.Brush, x : float, y : float, width : float, height : float, start_angle : float, sweep_angle : float):
        '''Fills the interior of a pie section defined by an ellipse specified by a pair of coordinates, a width, a height, and two radial lines.
        
        :param brush: :py:class:`aspose.psd.Brush` that determines the characteristics of the fill.
        :param x: The x-coordinate of the upper-left corner of the bounding rectangle that defines the ellipse from which the pie section comes.
        :param y: The y-coordinate of the upper-left corner of the bounding rectangle that defines the ellipse from which the pie section comes.
        :param width: Width of the bounding rectangle that defines the ellipse from which the pie section comes.
        :param height: Height of the bounding rectangle that defines the ellipse from which the pie section comes.
        :param start_angle: Angle in degrees measured clockwise from the x-axis to the first side of the pie section.
        :param sweep_angle: Angle in degrees measured clockwise from the ``startAngle`` parameter to the second side of the pie section.'''
        ...
    
    @overload
    def fill_pie(self, brush : aspose.psd.Brush, x : int, y : int, width : int, height : int, start_angle : int, sweep_angle : int):
        '''Fills the interior of a pie section defined by an ellipse specified by a pair of coordinates, a width, a height, and two radial lines.
        
        :param brush: :py:class:`aspose.psd.Brush` that determines the characteristics of the fill.
        :param x: The x-coordinate of the upper-left corner of the bounding rectangle that defines the ellipse from which the pie section comes.
        :param y: The y-coordinate of the upper-left corner of the bounding rectangle that defines the ellipse from which the pie section comes.
        :param width: Width of the bounding rectangle that defines the ellipse from which the pie section comes.
        :param height: Height of the bounding rectangle that defines the ellipse from which the pie section comes.
        :param start_angle: Angle in degrees measured clockwise from the x-axis to the first side of the pie section.
        :param sweep_angle: Angle in degrees measured clockwise from the ``startAngle`` parameter to the second side of the pie section.'''
        ...
    
    @overload
    def fill_polygon(self, brush : aspose.psd.Brush, points : List[aspose.psd.PointF]):
        '''Fills the interior of a polygon defined by an array of points specified by :py:class:`aspose.psd.PointF` structures and :py:attr:`aspose.psd.FillMode.ALTERNATE`.
        
        :param brush: :py:class:`aspose.psd.Brush` that determines the characteristics of the fill.
        :param points: Array of :py:class:`aspose.psd.PointF` structures that represent the vertices of the polygon to fill.'''
        ...
    
    @overload
    def fill_polygon(self, brush : aspose.psd.Brush, points : List[aspose.psd.PointF], fill_mode : aspose.psd.FillMode):
        '''Fills the interior of a polygon defined by an array of points specified by :py:class:`aspose.psd.PointF` structures using the specified fill mode.
        
        :param brush: :py:class:`aspose.psd.Brush` that determines the characteristics of the fill.
        :param points: Array of :py:class:`aspose.psd.PointF` structures that represent the vertices of the polygon to fill.
        :param fill_mode: Member of the :py:class:`aspose.psd.FillMode` enumeration that determines the style of the fill.'''
        ...
    
    @overload
    def fill_polygon(self, brush : aspose.psd.Brush, points : List[aspose.psd.Point]):
        '''Fills the interior of a polygon defined by an array of points specified by :py:class:`aspose.psd.Point` structures and :py:attr:`aspose.psd.FillMode.ALTERNATE`.
        
        :param brush: :py:class:`aspose.psd.Brush` that determines the characteristics of the fill.
        :param points: Array of :py:class:`aspose.psd.Point` structures that represent the vertices of the polygon to fill.'''
        ...
    
    @overload
    def fill_polygon(self, brush : aspose.psd.Brush, points : List[aspose.psd.Point], fill_mode : aspose.psd.FillMode):
        '''Fills the interior of a polygon defined by an array of points specified by :py:class:`aspose.psd.Point` structures using the specified fill mode.
        
        :param brush: :py:class:`aspose.psd.Brush` that determines the characteristics of the fill.
        :param points: Array of :py:class:`aspose.psd.Point` structures that represent the vertices of the polygon to fill.
        :param fill_mode: Member of the :py:class:`aspose.psd.FillMode` enumeration that determines the style of the fill.'''
        ...
    
    @overload
    def fill_closed_curve(self, brush : aspose.psd.Brush, points : List[aspose.psd.PointF]):
        '''Fills the interior of a closed cardinal spline curve defined by an array of :py:class:`aspose.psd.PointF` structures. This method uses a default tension of 0.5 and :py:attr:`aspose.psd.FillMode.ALTERNATE` fill mode.
        
        :param brush: :py:class:`aspose.psd.Brush` that determines the characteristics of the fill.
        :param points: Array of :py:class:`aspose.psd.PointF` structures that define the spline.'''
        ...
    
    @overload
    def fill_closed_curve(self, brush : aspose.psd.Brush, points : List[aspose.psd.PointF], fillmode : aspose.psd.FillMode):
        '''Fills the interior of a closed cardinal spline curve defined by an array of :py:class:`aspose.psd.PointF` structures using the specified fill mode. This method uses a default tension of 0.5.
        
        :param brush: :py:class:`aspose.psd.Brush` that determines the characteristics of the fill.
        :param points: Array of :py:class:`aspose.psd.PointF` structures that define the spline.
        :param fillmode: Member of the :py:class:`aspose.psd.FillMode` enumeration that determines how the curve is filled.'''
        ...
    
    @overload
    def fill_closed_curve(self, brush : aspose.psd.Brush, points : List[aspose.psd.PointF], fillmode : aspose.psd.FillMode, tension : float):
        '''Fills the interior of a closed cardinal spline curve defined by an array of :py:class:`aspose.psd.PointF` structures using the specified fill mode and tension.
        
        :param brush: A :py:class:`aspose.psd.Brush` that determines the characteristics of the fill.
        :param points: Array of :py:class:`aspose.psd.PointF` structures that define the spline.
        :param fillmode: Member of the :py:class:`aspose.psd.FillMode` enumeration that determines how the curve is filled.
        :param tension: Value greater than or equal to 0.0F that specifies the tension of the curve.'''
        ...
    
    @overload
    def fill_closed_curve(self, brush : aspose.psd.Brush, points : List[aspose.psd.Point]):
        '''Fills the interior of a closed cardinal spline curve defined by an array of :py:class:`aspose.psd.Point` structures. This method uses a default tension of 0.5 and :py:attr:`aspose.psd.FillMode.ALTERNATE` fill mode.
        
        :param brush: :py:class:`aspose.psd.Brush` that determines the characteristics of the fill.
        :param points: Array of :py:class:`aspose.psd.Point` structures that define the spline.'''
        ...
    
    @overload
    def fill_closed_curve(self, brush : aspose.psd.Brush, points : List[aspose.psd.Point], fillmode : aspose.psd.FillMode):
        '''Fills the interior of a closed cardinal spline curve defined by an array of :py:class:`aspose.psd.Point` structures using the specified fill mode. This method uses a default tension of 0.5.
        
        :param brush: :py:class:`aspose.psd.Brush` that determines the characteristics of the fill.
        :param points: Array of :py:class:`aspose.psd.Point` structures that define the spline.
        :param fillmode: Member of the :py:class:`aspose.psd.FillMode` enumeration that determines how the curve is filled.'''
        ...
    
    @overload
    def fill_closed_curve(self, brush : aspose.psd.Brush, points : List[aspose.psd.Point], fillmode : aspose.psd.FillMode, tension : float):
        '''Fills the interior of a closed cardinal spline curve defined by an array of :py:class:`aspose.psd.Point` structures using the specified fill mode and tension.
        
        :param brush: :py:class:`aspose.psd.Brush` that determines the characteristics of the fill.
        :param points: Array of :py:class:`aspose.psd.Point` structures that define the spline.
        :param fillmode: Member of the :py:class:`aspose.psd.FillMode` enumeration that determines how the curve is filled.
        :param tension: Value greater than or equal to 0.0F that specifies the tension of the curve.'''
        ...
    
    def reset_transform(self):
        '''Resets the :py:attr:`aspose.psd.Graphics.transform` property to identity.'''
        ...
    
    def begin_update(self):
        '''Starts caching of the following graphics operations. The graphics effects applied afterwards will not be applied immediately instead the EndUpdate will cause applying all the effects at once.'''
        ...
    
    def end_update(self):
        '''Finishes caching of the graphics operations started after BeginUpdate was called. The preceding graphics operations will be applied at once when calling this method.'''
        ...
    
    def clear(self, color : aspose.psd.Color):
        '''Clears the graphics surface using the specified color.
        
        :param color: The color to clear the graphics surface by.'''
        ...
    
    def draw_image_unscaled_and_clipped(self, source_image : aspose.psd.Image, rect : aspose.psd.Rectangle):
        '''Draws the specified image without scaling and clips it, if necessary, to fit in the specified rectangle.
        
        :param source_image: The image to draw with.
        :param rect: The :py:class:`aspose.psd.Rectangle` in which to draw the image.'''
        ...
    
    def draw_path(self, pen : aspose.psd.Pen, path : aspose.psd.GraphicsPath):
        '''Draws a :py:class:`aspose.psd.GraphicsPath`.
        
        :param pen: :py:class:`aspose.psd.Pen` that determines the color, width, and style of the path.
        :param path: :py:class:`aspose.psd.GraphicsPath` to draw.'''
        ...
    
    def fill_path(self, brush : aspose.psd.Brush, path : aspose.psd.GraphicsPath):
        '''Fills the interior of a :py:class:`aspose.psd.GraphicsPath`.
        
        :param brush: :py:class:`aspose.psd.Brush` that determines the characteristics of the fill.
        :param path: :py:class:`aspose.psd.GraphicsPath` that represents the path to fill.'''
        ...
    
    def fill_region(self, brush : aspose.psd.Brush, region : aspose.psd.Region):
        '''Fills the interior of a :py:class:`aspose.psd.Region`.
        
        :param brush: :py:class:`aspose.psd.Brush` that determines the characteristics of the fill.
        :param region: :py:class:`aspose.psd.Region` that represents the area to fill.'''
        ...
    
    @property
    def dpi_x(self) -> float:
        ...
    
    @property
    def dpi_y(self) -> float:
        ...
    
    @property
    def page_unit(self) -> aspose.psd.GraphicsUnit:
        ...
    
    @page_unit.setter
    def page_unit(self, value : aspose.psd.GraphicsUnit):
        ...
    
    @property
    def page_scale(self) -> float:
        ...
    
    @page_scale.setter
    def page_scale(self, value : float):
        ...
    
    @property
    def clip(self) -> aspose.psd.Region:
        '''Gets the clip region.'''
        ...
    
    @clip.setter
    def clip(self, value : aspose.psd.Region):
        '''Sets the clip region.'''
        ...
    
    @property
    def transform(self) -> aspose.psd.Matrix:
        '''Gets a copy of the geometric world transformation for this :py:class:`aspose.psd.Graphics`.'''
        ...
    
    @transform.setter
    def transform(self, value : aspose.psd.Matrix):
        '''Sets a copy of the geometric world transformation for this :py:class:`aspose.psd.Graphics`.'''
        ...
    
    @property
    def is_in_begin_update_call(self) -> bool:
        ...
    
    @property
    def image(self) -> aspose.psd.Image:
        '''Gets the image.'''
        ...
    
    @property
    def compositing_quality(self) -> aspose.psd.CompositingQuality:
        ...
    
    @compositing_quality.setter
    def compositing_quality(self, value : aspose.psd.CompositingQuality):
        ...
    
    @property
    def interpolation_mode(self) -> aspose.psd.InterpolationMode:
        ...
    
    @interpolation_mode.setter
    def interpolation_mode(self, value : aspose.psd.InterpolationMode):
        ...
    
    @property
    def smoothing_mode(self) -> aspose.psd.SmoothingMode:
        ...
    
    @smoothing_mode.setter
    def smoothing_mode(self, value : aspose.psd.SmoothingMode):
        ...
    
    @property
    def text_rendering_hint(self) -> aspose.psd.TextRenderingHint:
        ...
    
    @text_rendering_hint.setter
    def text_rendering_hint(self, value : aspose.psd.TextRenderingHint):
        ...
    
    @property
    def paintable_image_options(self) -> aspose.psd.ImageOptionsBase:
        ...
    
    @paintable_image_options.setter
    def paintable_image_options(self, value : aspose.psd.ImageOptionsBase):
        ...
    
    ...

class GraphicsPath(ObjectWithBounds):
    '''Represents a series of connected lines and curves. This class cannot be inherited.'''
    
    @overload
    def get_bounds(self, matrix : aspose.psd.Matrix) -> aspose.psd.RectangleF:
        '''Gets the object's bounds.
        
        :param matrix: The matrix to apply before bounds will be calculated.
        :returns: The estimated object's bounds.'''
        ...
    
    @overload
    def get_bounds(self, matrix : aspose.psd.Matrix, pen : aspose.psd.Pen) -> aspose.psd.RectangleF:
        '''Gets the object's bounds.
        
        :param matrix: The matrix to apply before bounds will be calculated.
        :param pen: The pen to use for object. This can influence the object's bounds size.
        :returns: The estimated object's bounds.'''
        ...
    
    @overload
    def is_visible(self, x : float, y : float) -> bool:
        '''Indicates whether the specified point is contained within this :py:class:`aspose.psd.GraphicsPath`.
        
        :param x: The x-coordinate of the point to test.
        :param y: The y-coordinate of the point to test.
        :returns: This method returns true if the specified point is contained within this :py:class:`aspose.psd.GraphicsPath`; otherwise, false.'''
        ...
    
    @overload
    def is_visible(self, point : aspose.psd.PointF) -> bool:
        '''Indicates whether the specified point is contained within this :py:class:`aspose.psd.GraphicsPath`.
        
        :param point: A :py:class:`aspose.psd.PointF` that represents the point to test.
        :returns: This method returns true if the specified point is contained within this :py:class:`aspose.psd.GraphicsPath`; otherwise, false.'''
        ...
    
    @overload
    def is_visible(self, x : int, y : int) -> bool:
        '''Indicates whether the specified point is contained within this :py:class:`aspose.psd.GraphicsPath`.
        
        :param x: The x-coordinate of the point to test.
        :param y: The y-coordinate of the point to test.
        :returns: This method returns true if the specified point is contained within this :py:class:`aspose.psd.GraphicsPath`; otherwise, false.'''
        ...
    
    @overload
    def is_visible(self, point : aspose.psd.Point) -> bool:
        '''Indicates whether the specified point is contained within this :py:class:`aspose.psd.GraphicsPath`.
        
        :param point: A :py:class:`aspose.psd.Point` that represents the point to test.
        :returns: This method returns true if the specified point is contained within this :py:class:`aspose.psd.GraphicsPath`; otherwise, false.'''
        ...
    
    @overload
    def is_visible(self, x : float, y : float, graphics : aspose.psd.Graphics) -> bool:
        '''Indicates whether the specified point is contained within this :py:class:`aspose.psd.GraphicsPath` in the visible clip region of the specified :py:class:`aspose.psd.Graphics`.
        
        :param x: The x-coordinate of the point to test.
        :param y: The y-coordinate of the point to test.
        :param graphics: The :py:class:`aspose.psd.Graphics` for which to test visibility.
        :returns: This method returns true if the specified point is contained within this :py:class:`aspose.psd.GraphicsPath`; otherwise, false.'''
        ...
    
    @overload
    def is_visible(self, pt : aspose.psd.PointF, graphics : aspose.psd.Graphics) -> bool:
        '''Indicates whether the specified point is contained within this :py:class:`aspose.psd.GraphicsPath`.
        
        :param pt: A :py:class:`aspose.psd.PointF` that represents the point to test.
        :param graphics: The :py:class:`aspose.psd.Graphics` for which to test visibility.
        :returns: This method returns true if the specified point is contained within this; otherwise, false.'''
        ...
    
    @overload
    def is_visible(self, x : int, y : int, graphics : aspose.psd.Graphics) -> bool:
        '''Indicates whether the specified point is contained within this :py:class:`aspose.psd.GraphicsPath`, using the specified :py:class:`aspose.psd.Graphics`.
        
        :param x: The x-coordinate of the point to test.
        :param y: The y-coordinate of the point to test.
        :param graphics: The :py:class:`aspose.psd.Graphics` for which to test visibility.
        :returns: This method returns true if the specified point is contained within this :py:class:`aspose.psd.GraphicsPath`; otherwise, false.'''
        ...
    
    @overload
    def is_visible(self, pt : aspose.psd.Point, graphics : aspose.psd.Graphics) -> bool:
        '''Indicates whether the specified point is contained within this :py:class:`aspose.psd.GraphicsPath`.
        
        :param pt: A :py:class:`aspose.psd.Point` that represents the point to test.
        :param graphics: The :py:class:`aspose.psd.Graphics` for which to test visibility.
        :returns: This method returns true if the specified point is contained within this :py:class:`aspose.psd.GraphicsPath`; otherwise, false.'''
        ...
    
    @overload
    def is_outline_visible(self, x : float, y : float, pen : aspose.psd.Pen) -> bool:
        '''Indicates whether the specified point is contained within (under) the outline of this :py:class:`aspose.psd.GraphicsPath` when drawn with the specified :py:class:`aspose.psd.Pen`.
        
        :param x: The x-coordinate of the point to test.
        :param y: The y-coordinate of the point to test.
        :param pen: The :py:class:`aspose.psd.Pen` to test.
        :returns: This method returns true if the specified point is contained within the outline of this :py:class:`aspose.psd.GraphicsPath` when drawn with the specified :py:class:`aspose.psd.Pen`; otherwise, false.'''
        ...
    
    @overload
    def is_outline_visible(self, point : aspose.psd.PointF, pen : aspose.psd.Pen) -> bool:
        '''Indicates whether the specified point is contained within (under) the outline of this :py:class:`aspose.psd.GraphicsPath` when drawn with the specified :py:class:`aspose.psd.Pen`.
        
        :param point: A :py:class:`aspose.psd.PointF` that specifies the location to test.
        :param pen: The :py:class:`aspose.psd.Pen` to test.
        :returns: This method returns true if the specified point is contained within the outline of this :py:class:`aspose.psd.GraphicsPath` when drawn with the specified :py:class:`aspose.psd.Pen`; otherwise, false.'''
        ...
    
    @overload
    def is_outline_visible(self, x : float, y : float, pen : aspose.psd.Pen, graphics : aspose.psd.Graphics) -> bool:
        '''Indicates whether the specified point is contained within (under) the outline of this :py:class:`aspose.psd.GraphicsPath` when drawn with the specified :py:class:`aspose.psd.Pen` and using the specified :py:class:`aspose.psd.Graphics`.
        
        :param x: The x-coordinate of the point to test.
        :param y: The y-coordinate of the point to test.
        :param pen: The :py:class:`aspose.psd.Pen` to test.
        :param graphics: The :py:class:`aspose.psd.Graphics` for which to test visibility.
        :returns: This method returns true if the specified point is contained within (under) the outline of this :py:class:`aspose.psd.GraphicsPath` as drawn with the specified :py:class:`aspose.psd.Pen`; otherwise, false.'''
        ...
    
    @overload
    def is_outline_visible(self, pt : aspose.psd.PointF, pen : aspose.psd.Pen, graphics : aspose.psd.Graphics) -> bool:
        '''Indicates whether the specified point is contained within (under) the outline of this :py:class:`aspose.psd.GraphicsPath` when drawn with the specified :py:class:`aspose.psd.Pen` and using the specified :py:class:`aspose.psd.Graphics`.
        
        :param pt: A :py:class:`aspose.psd.PointF` that specifies the location to test.
        :param pen: The :py:class:`aspose.psd.Pen` to test.
        :param graphics: The :py:class:`aspose.psd.Graphics` for which to test visibility.
        :returns: This method returns true if the specified point is contained within (under) the outline of this :py:class:`aspose.psd.GraphicsPath` as drawn with the specified :py:class:`aspose.psd.Pen`; otherwise, false.'''
        ...
    
    @overload
    def is_outline_visible(self, x : int, y : int, pen : aspose.psd.Pen) -> bool:
        '''Indicates whether the specified point is contained within (under) the outline of this :py:class:`aspose.psd.GraphicsPath` when drawn with the specified :py:class:`aspose.psd.Pen`.
        
        :param x: The x-coordinate of the point to test.
        :param y: The y-coordinate of the point to test.
        :param pen: The :py:class:`aspose.psd.Pen` to test.
        :returns: This method returns true if the specified point is contained within the outline of this :py:class:`aspose.psd.GraphicsPath` when drawn with the specified :py:class:`aspose.psd.Pen`; otherwise, false.'''
        ...
    
    @overload
    def is_outline_visible(self, point : aspose.psd.Point, pen : aspose.psd.Pen) -> bool:
        '''Indicates whether the specified point is contained within (under) the outline of this :py:class:`aspose.psd.GraphicsPath` when drawn with the specified :py:class:`aspose.psd.Pen`.
        
        :param point: A :py:class:`aspose.psd.Point` that specifies the location to test.
        :param pen: The :py:class:`aspose.psd.Pen` to test.
        :returns: This method returns true if the specified point is contained within the outline of this :py:class:`aspose.psd.GraphicsPath` when drawn with the specified :py:class:`aspose.psd.Pen`; otherwise, false.'''
        ...
    
    @overload
    def is_outline_visible(self, x : int, y : int, pen : aspose.psd.Pen, graphics : aspose.psd.Graphics) -> bool:
        '''Indicates whether the specified point is contained within (under) the outline of this :py:class:`aspose.psd.GraphicsPath` when drawn with the specified :py:class:`aspose.psd.Pen` and using the specified :py:class:`aspose.psd.Graphics`.
        
        :param x: The x-coordinate of the point to test.
        :param y: The y-coordinate of the point to test.
        :param pen: The :py:class:`aspose.psd.Pen` to test.
        :param graphics: The :py:class:`aspose.psd.Graphics` for which to test visibility.
        :returns: This method returns true if the specified point is contained within the outline of this :py:class:`aspose.psd.GraphicsPath` as drawn with the specified :py:class:`aspose.psd.Pen`; otherwise, false.'''
        ...
    
    @overload
    def is_outline_visible(self, pt : aspose.psd.Point, pen : aspose.psd.Pen, graphics : aspose.psd.Graphics) -> bool:
        '''Indicates whether the specified point is contained within (under) the outline of this :py:class:`aspose.psd.GraphicsPath` when drawn with the specified :py:class:`aspose.psd.Pen` and using the specified :py:class:`aspose.psd.Graphics`.
        
        :param pt: A :py:class:`aspose.psd.Point` that specifies the location to test.
        :param pen: The :py:class:`aspose.psd.Pen` to test.
        :param graphics: The :py:class:`aspose.psd.Graphics` for which to test visibility.
        :returns: This method returns true if the specified point is contained within the outline of this :py:class:`aspose.psd.GraphicsPath` as drawn with the specified :py:class:`aspose.psd.Pen`; otherwise, false.'''
        ...
    
    @overload
    def flatten(self):
        '''Converts each curve in this path into a sequence of connected line segments.'''
        ...
    
    @overload
    def flatten(self, matrix : aspose.psd.Matrix):
        '''Applies the specified transform and then converts each curve in this :py:class:`aspose.psd.GraphicsPath` into a sequence of connected line segments.
        
        :param matrix: A :py:class:`aspose.psd.Matrix` by which to transform this :py:class:`aspose.psd.GraphicsPath` before flattening.'''
        ...
    
    @overload
    def flatten(self, matrix : aspose.psd.Matrix, flatness : float):
        '''Converts each curve in this :py:class:`aspose.psd.GraphicsPath` into a sequence of connected line segments.
        
        :param matrix: A :py:class:`aspose.psd.Matrix` by which to transform this :py:class:`aspose.psd.GraphicsPath` before flattening.
        :param flatness: Specifies the maximum permitted error between the curve and its flattened approximation. A value of 0.25 is the default. Reducing the flatness value will increase the number of line segments in the approximation.'''
        ...
    
    @overload
    def widen(self, pen : aspose.psd.Pen):
        '''Adds an additional outline to the path.
        
        :param pen: A :py:class:`aspose.psd.Pen` that specifies the width between the original outline of the path and the new outline this method creates.'''
        ...
    
    @overload
    def widen(self, pen : aspose.psd.Pen, matrix : aspose.psd.Matrix):
        '''Adds an additional outline to the :py:class:`aspose.psd.GraphicsPath`.
        
        :param pen: A :py:class:`aspose.psd.Pen` that specifies the width between the original outline of the path and the new outline this method creates.
        :param matrix: A :py:class:`aspose.psd.Matrix` that specifies a transform to apply to the path before widening.'''
        ...
    
    @overload
    def widen(self, pen : aspose.psd.Pen, matrix : aspose.psd.Matrix, flatness : float):
        '''Replaces this :py:class:`aspose.psd.GraphicsPath` with curves that enclose the area that is filled when this path is drawn by the specified pen.
        
        :param pen: A :py:class:`aspose.psd.Pen` that specifies the width between the original outline of the path and the new outline this method creates.
        :param matrix: A :py:class:`aspose.psd.Matrix` that specifies a transform to apply to the path before widening.
        :param flatness: A value that specifies the flatness for curves.'''
        ...
    
    @overload
    def warp(self, dest_points : List[aspose.psd.PointF], src_rect : aspose.psd.RectangleF):
        '''Applies a warp transform, defined by a rectangle and a parallelogram, to this :py:class:`aspose.psd.GraphicsPath`.
        
        :param dest_points: An array of :py:class:`aspose.psd.PointF` structures that define a parallelogram to which the rectangle defined by ``srcRect`` is transformed. The array can contain either three or four elements. If the array contains three elements, the lower-right corner of the parallelogram is implied by the first three points.
        :param src_rect: A :py:class:`aspose.psd.RectangleF` that represents the rectangle that is transformed to the parallelogram defined by ``destPoints``.'''
        ...
    
    @overload
    def warp(self, dest_points : List[aspose.psd.PointF], src_rect : aspose.psd.RectangleF, matrix : aspose.psd.Matrix):
        '''Applies a warp transform, defined by a rectangle and a parallelogram, to this :py:class:`aspose.psd.GraphicsPath`.
        
        :param dest_points: An array of :py:class:`aspose.psd.PointF` structures that define a parallelogram to which the rectangle defined by ``srcRect`` is transformed. The array can contain either three or four elements. If the array contains three elements, the lower-right corner of the parallelogram is implied by the first three points.
        :param src_rect: A :py:class:`aspose.psd.RectangleF` that represents the rectangle that is transformed to the parallelogram defined by ``destPoints``.
        :param matrix: A :py:class:`aspose.psd.Matrix` that specifies a geometric transform to apply to the path.'''
        ...
    
    @overload
    def warp(self, dest_points : List[aspose.psd.PointF], src_rect : aspose.psd.RectangleF, matrix : aspose.psd.Matrix, warp_mode : aspose.psd.WarpMode):
        '''Applies a warp transform, defined by a rectangle and a parallelogram, to this :py:class:`aspose.psd.GraphicsPath`.
        
        :param dest_points: An array of :py:class:`aspose.psd.PointF` structures that defines a parallelogram to which the rectangle defined by ``srcRect`` is transformed. The array can contain either three or four elements. If the array contains three elements, the lower-right corner of the parallelogram is implied by the first three points.
        :param src_rect: A :py:class:`aspose.psd.RectangleF` that represents the rectangle that is transformed to the parallelogram defined by ``destPoints``.
        :param matrix: A :py:class:`aspose.psd.Matrix` that specifies a geometric transform to apply to the path.
        :param warp_mode: A :py:class:`aspose.psd.WarpMode` enumeration that specifies whether this warp operation uses perspective or bilinear mode.'''
        ...
    
    @overload
    def warp(self, dest_points : List[aspose.psd.PointF], src_rect : aspose.psd.RectangleF, matrix : aspose.psd.Matrix, warp_mode : aspose.psd.WarpMode, flatness : float):
        '''Applies a warp transform, defined by a rectangle and a parallelogram, to this :py:class:`aspose.psd.GraphicsPath`.
        
        :param dest_points: An array of :py:class:`aspose.psd.PointF` structures that define a parallelogram to which the rectangle defined by ``srcRect`` is transformed. The array can contain either three or four elements. If the array contains three elements, the lower-right corner of the parallelogram is implied by the first three points.
        :param src_rect: A :py:class:`aspose.psd.RectangleF` that represents the rectangle that is transformed to the parallelogram defined by ``destPoints``.
        :param matrix: A :py:class:`aspose.psd.Matrix` that specifies a geometric transform to apply to the path.
        :param warp_mode: A :py:class:`aspose.psd.WarpMode` enumeration that specifies whether this warp operation uses perspective or bilinear mode.
        :param flatness: A value from 0 through 1 that specifies how flat the resulting path is. For more information, see the :py:func:`aspose.psd.GraphicsPath.flatten` methods.'''
        ...
    
    @overload
    def add_path(self, adding_path : aspose.psd.GraphicsPath):
        '''Appends the specified :py:class:`aspose.psd.GraphicsPath` to this path.
        
        :param adding_path: The :py:class:`aspose.psd.GraphicsPath` to add.'''
        ...
    
    @overload
    def add_path(self, adding_path : aspose.psd.GraphicsPath, connect : bool):
        '''Appends the specified :py:class:`aspose.psd.GraphicsPath` to this path.
        
        :param adding_path: The :py:class:`aspose.psd.GraphicsPath` to add.
        :param connect: A Boolean value that specifies whether the first figure in the added path is part of the last figure in this path. A value of true specifies that the first figure in the added path is part of the last figure in this path. A value of false specifies that the first figure in the added path is separate from the last figure in this path.'''
        ...
    
    def transform(self, transform : aspose.psd.Matrix):
        '''Applies the specified transformation to the shape.
        
        :param transform: The transformation to apply.'''
        ...
    
    def reset(self):
        '''Empties the graphics path and sets the :py:class:`aspose.psd.FillMode` to :py:attr:`aspose.psd.FillMode.ALTERNATE`.'''
        ...
    
    def reverse(self):
        '''Reverses the order of figures, shapes, and points in each shape of this :py:class:`aspose.psd.GraphicsPath`.'''
        ...
    
    def add_figure(self, figure : aspose.psd.Figure):
        '''Adds a new figure.
        
        :param figure: The figure to add.'''
        ...
    
    def add_figures(self, figures : List[aspose.psd.Figure]):
        '''Adds new figures.
        
        :param figures: The figures to add.'''
        ...
    
    def remove_figure(self, figure : aspose.psd.Figure):
        '''Removes a figure.
        
        :param figure: The figure to remove.'''
        ...
    
    def remove_figures(self, figures : List[aspose.psd.Figure]):
        '''Removes figures.
        
        :param figures: The figures to remove.'''
        ...
    
    def deep_clone(self) -> aspose.psd.GraphicsPath:
        '''Performs a deep clone of this graphics path.
        
        :returns: A deep clone of the graphics path.'''
        ...
    
    @property
    def bounds(self) -> aspose.psd.RectangleF:
        '''Gets the object's bounds.'''
        ...
    
    @property
    def fill_mode(self) -> aspose.psd.FillMode:
        ...
    
    @fill_mode.setter
    def fill_mode(self, value : aspose.psd.FillMode):
        ...
    
    @property
    def figures(self) -> List[aspose.psd.Figure]:
        '''Gets the path figures.'''
        ...
    
    ...

class IAdvancedBufferProcessor(IBufferProcessor):
    '''The advanced buffer processor.'''
    
    def finish_row(self):
        '''Finishes the row.'''
        ...
    
    def finish_rows(self, rows_count : int):
        '''Finishes the rows.
        
        :param rows_count: The rows count.'''
        ...
    
    def process_buffer(self, buffer : bytes, buffer_length : int):
        '''Processes the buffer.
        
        :param buffer: The buffer to process.
        :param buffer_length: The buffer length to process.'''
        ...
    
    ...

class IBufferProcessor:
    '''The buffer processor.'''
    
    def process_buffer(self, buffer : bytes, buffer_length : int):
        '''Processes the buffer.
        
        :param buffer: The buffer to process.
        :param buffer_length: The buffer length to process.'''
        ...
    
    ...

class IColorConverter:
    '''The color converter.'''
    
    def convert(self, source_format : aspose.psd.PixelDataFormat, data : bytes, offset : int, bit_start : int, samples_count : int, lines_count : int, dest_format : aspose.psd.PixelDataFormat, output_data : bytes, output_offset : int) -> int:
        '''Converts the passed data to the output format.
        
        :param source_format: The source format.
        :param data: The source data.
        :param offset: The offset in bytes where data copying should begin.
        :param bit_start: The bit start. Note this value is not byte aligned value instead this is actual bit where copying should begin.
        :param samples_count: The samples count.
        :param lines_count: The lines count.
        :param dest_format: The destination format.
        :param output_data: The output data.
        :param output_offset: The output offset where data copying should start.
        :returns: The converted bytes count.'''
        ...
    
    ...

class IColorPalette:
    '''The color palette interface.'''
    
    @overload
    def get_nearest_color_index(self, argb_32_color : int) -> int:
        '''Gets the index of the nearest 32-bit ARGB color.
        
        :param argb_32_color: The 32-bit ARGB color.
        :returns: The index of the nearest color.'''
        ...
    
    @overload
    def get_nearest_color_index(self, color : aspose.psd.Color) -> int:
        '''Gets the index of the nearest color.
        
        :param color: The color.
        :returns: The index of the nearest color.'''
        ...
    
    def get_argb_32_color(self, index : int) -> int:
        '''Gets the 32-bit ARGB palette color by index.
        
        :param index: The 32-bit ARGB palette color index.
        :returns: The color palette entry specified by the ``index``.'''
        ...
    
    def get_color(self, index : int) -> aspose.psd.Color:
        '''Gets the palette color by index.
        
        :param index: The palette color index.
        :returns: The color palette entry specified by the ``index``.'''
        ...
    
    @property
    def entries_count(self) -> int:
        ...
    
    @property
    def argb_32_entries(self) -> List[int]:
        ...
    
    @property
    def entries(self) -> List[aspose.psd.Color]:
        '''Gets an array of :py:class:`aspose.psd.Color` structures.'''
        ...
    
    @property
    def is_compact_palette(self) -> bool:
        ...
    
    ...

class IImageCreator:
    '''The image creator.'''
    
    def create(self, stream_container : aspose.psd.StreamContainer, image_options : aspose.psd.ImageOptionsBase, width : int, height : int) -> aspose.psd.Image:
        '''Creates a new image instance with ``imageOptions``.
        
        :param stream_container: The stream container to create image data in.
        :param image_options: The image options.
        :param width: width of new image
        :param height: height of new image
        :returns: A new image instance.'''
        ...
    
    ...

class IImageCreatorDescriptor(IImageDescriptor):
    '''The image creator descriptor specifying the creator properties. The creator descriptor is used to overcome
    the necessity to contain each image creator instance in memory and multithreading issues.'''
    
    def can_create(self, image_options : aspose.psd.ImageOptionsBase) -> bool:
        '''Determines whether image creator can create a new image using the ``imageOptions``.
        
        :param image_options: The image options.
        :returns: ``True`` if image creator created by this descriptor can create image data using the specified ``imageOptions``; otherwise, ``false``.'''
        ...
    
    def create_instance(self) -> aspose.psd.IImageCreator:
        '''Creates a new creator instance.
        
        :returns: A new creator instance.'''
        ...
    
    @property
    def supported_format(self) -> aspose.psd.FileFormat:
        ...
    
    ...

class IImageDescriptor:
    '''The image descriptor. Contains base properties and methods for all other image descriptor types.'''
    
    @property
    def supported_format(self) -> aspose.psd.FileFormat:
        ...
    
    ...

class IImageExporter:
    '''The image exporter. Can export data from internal Aspose.PSD format to a specified data format.'''
    
    @overload
    def export(self, image : aspose.psd.Image, stream : io.RawIOBase, options_base : aspose.psd.ImageOptionsBase):
        '''Exports the specified image data into specified data format.
        
        :param image: The image data to export.
        :param stream: The stream to export data to.
        :param options_base: Options for image export'''
        ...
    
    @overload
    def export(self, image : aspose.psd.Image, stream : io.RawIOBase, options_base : aspose.psd.ImageOptionsBase, bounds_rectangle : aspose.psd.Rectangle):
        '''Exports the specified image data into specified data format.
        
        :param image: The image data to export.
        :param stream: The stream to export data to.
        :param options_base: Options for image export
        :param bounds_rectangle: The bounds rectangle.'''
        ...
    
    ...

class IImageExporterDescriptor(IImageDescriptor):
    '''Represents the image exporter descriptor. The exporter descriptor is used to overcome the necessity to contain each exporter instance
    in memory and multithreading issues.'''
    
    def can_export(self, image : aspose.psd.Image, options_base : aspose.psd.ImageOptionsBase) -> bool:
        '''Determines whether image exporter can export the specified image to the specified image format specified by save options.
        
        :param image: The image to export.
        :param options_base: The options base.
        :returns: ``True`` if exporter created by this descriptor can export the specified image to the specified file format; otherwise, ``false``.'''
        ...
    
    def create_instance(self) -> aspose.psd.IImageExporter:
        '''Creates a new exporter instance.
        
        :returns: A new exporter instance.'''
        ...
    
    @property
    def supported_format(self) -> aspose.psd.FileFormat:
        ...
    
    ...

class IImageLoader:
    '''The image loader.'''
    
    def load(self, stream_container : aspose.psd.StreamContainer, load_options : aspose.psd.LoadOptions) -> aspose.psd.Image:
        '''Opens a new image with ``loadOptions``.
        
        :param stream_container: The stream container.
        :param load_options: The load options.
        :returns: A newly opened image instance.'''
        ...
    
    ...

class IImageLoaderDescriptor(IImageDescriptor):
    '''The image loader descriptor specifying the loader properties. The loader descriptor is used to overcome
    the necessity to contain each image loader instance in memory and multithreading issues.'''
    
    def can_load(self, stream_container : aspose.psd.StreamContainer, load_options : aspose.psd.LoadOptions) -> bool:
        '''Determines whether image loader can read a new image from the specified stream and optionally using the ``loadOptions``.
        
        :param stream_container: The stream container.
        :param load_options: The file format details specified by ``loadOptions``. The ``loadOptions`` may be null.
        :returns: ``true`` if image loader created by this descriptor can read image from stream; otherwise, ``false``.'''
        ...
    
    def create_instance(self) -> aspose.psd.IImageLoader:
        '''Creates a new loader instance.
        
        :returns: A new loader instance.'''
        ...
    
    @property
    def supported_format(self) -> aspose.psd.FileFormat:
        ...
    
    ...

class IIndexedColorConverter:
    '''The color converter for indexed image formats.'''
    
    def fill_indexedto_indexed_map(self, map : bytes, source_format : aspose.psd.PixelDataFormat, dest_format : aspose.psd.PixelDataFormat):
        '''Fills the indexed to indexed image conversion map.
        
        :param map: The conversion map.
        :param source_format: The source format.
        :param dest_format: The destination format.'''
        ...
    
    ...

class IKeyedObject:
    '''Represents interface for objects with keys.'''
    
    @property
    def key(self) -> str:
        '''Gets the object key.'''
        ...
    
    ...

class IObjectWithBounds:
    '''Represents an object with bounds.'''
    
    @property
    def size(self) -> aspose.psd.Size:
        '''Gets the object size.'''
        ...
    
    @property
    def bounds(self) -> aspose.psd.Rectangle:
        '''Gets the object bounds.'''
        ...
    
    @property
    def width(self) -> int:
        '''Gets the object width.'''
        ...
    
    @property
    def height(self) -> int:
        '''Gets the object height.'''
        ...
    
    ...

class IOrderedShape:
    '''Represents an ordered shape. An ordered shape is a continuous set of points having a start point and end point.
    The continuous set of points connected using a specific rule.'''
    
    def reverse(self):
        '''Reverses the order of points for this shape.'''
        ...
    
    @property
    def start_point(self) -> aspose.psd.PointF:
        ...
    
    @property
    def end_point(self) -> aspose.psd.PointF:
        ...
    
    @property
    def is_closed(self) -> bool:
        ...
    
    @is_closed.setter
    def is_closed(self, value : bool):
        ...
    
    ...

class IPartialArgb32PixelLoader:
    '''Conforms to the 32-bit ARGB pixels loaded partially.'''
    
    def process(self, pixels_rectangle : aspose.psd.Rectangle, pixels : List[int], start : aspose.psd.Point, end : aspose.psd.Point):
        '''Processes the loaded pixels.
        
        :param pixels_rectangle: The pixels rectangle.
        :param pixels: The 32-bit ARGB pixels.
        :param start: The start pixels point. If not equal to (left,top) meaning that it is not full rectangle we have.
        :param end: The end pixels point. If not equal to (right,bottom) meaning that it is not full rectangle we have.'''
        ...
    
    ...

class IPartialArgb64PixelLoader(IPartialArgb32PixelLoader):
    '''The 64-bit ARGB pixels loader.'''
    
    def process64(self, pixels_rectangle : aspose.psd.Rectangle, pixels : List[int], start : aspose.psd.Point, end : aspose.psd.Point):
        '''Processes the loaded pixels.
        
        :param pixels_rectangle: The pixels rectangle.
        :param pixels: The 64-bit ARGB pixels.
        :param start: The start pixels point. If not equal to (left,top) meaning that it is not full rectangle we have.
        :param end: The end pixels point. If not equal to (right,bottom) meaning that it is not full rectangle we have.'''
        ...
    
    def process(self, pixels_rectangle : aspose.psd.Rectangle, pixels : List[int], start : aspose.psd.Point, end : aspose.psd.Point):
        '''Processes the loaded pixels.
        
        :param pixels_rectangle: The pixels rectangle.
        :param pixels: The 32-bit ARGB pixels.
        :param start: The start pixels point. If not equal to (left,top) meaning that it is not full rectangle we have.
        :param end: The end pixels point. If not equal to (right,bottom) meaning that it is not full rectangle we have.'''
        ...
    
    ...

class IPartialPixelLoader:
    '''Conforms to the pixels loaded partially.'''
    
    def process(self, pixels_rectangle : aspose.psd.Rectangle, pixels : List[aspose.psd.Color], start : aspose.psd.Point, end : aspose.psd.Point):
        '''Processes the loaded pixels.
        
        :param pixels_rectangle: The pixels rectangle.
        :param pixels: The pixels.
        :param start: The start pixels point. If not equal to (left,top) meaning that it is not full rectangle we have.
        :param end: The end pixels point. If not equal to (right,bottom) meaning that it is not full rectangle we have.'''
        ...
    
    ...

class IPartialRawDataLoader:
    '''The partial data loader.'''
    
    @overload
    def process(self, rectangle : aspose.psd.Rectangle, data : bytes, start : aspose.psd.Point, end : aspose.psd.Point):
        '''Processes the loaded data.
        
        :param rectangle: The data rectangle.
        :param data: The raw data.
        :param start: The start data point. If not equal to (left,top) meaning that it is not full rectangle we have.
        :param end: The end data point. If not equal to (right,bottom) meaning that it is not full rectangle we have.'''
        ...
    
    @overload
    def process(self, rectangle : aspose.psd.Rectangle, data : bytes, start : aspose.psd.Point, end : aspose.psd.Point, load_options : aspose.psd.LoadOptions):
        '''Processes the loaded data.
        
        :param rectangle: The data rectangle.
        :param data: The raw data.
        :param start: The start data point. If not equal to (left,top) meaning that it is not full rectangle we have.
        :param end: The end data point. If not equal to (right,bottom) meaning that it is not full rectangle we have.
        :param load_options: The load options.'''
        ...
    
    ...

class IPsdColorPalette(IColorPalette):
    '''The pasd color palette'''
    
    @overload
    def get_nearest_color_index(self, argb_32_color : int) -> int:
        '''Gets the index of the nearest 32-bit ARGB color.
        
        :param argb_32_color: The 32-bit ARGB color.
        :returns: The index of the nearest color.'''
        ...
    
    @overload
    def get_nearest_color_index(self, color : aspose.psd.Color) -> int:
        '''Gets the index of the nearest color.
        
        :param color: The color.
        :returns: The index of the nearest color.'''
        ...
    
    def get_argb_32_color(self, index : int) -> int:
        '''Gets the 32-bit ARGB palette color by index.
        
        :param index: The 32-bit ARGB palette color index.
        :returns: The color palette entry specified by the ``index``.'''
        ...
    
    def get_color(self, index : int) -> aspose.psd.Color:
        '''Gets the palette color by index.
        
        :param index: The palette color index.
        :returns: The color palette entry specified by the ``index``.'''
        ...
    
    @property
    def transparent_index(self) -> int:
        ...
    
    @property
    def has_transparent_color(self) -> bool:
        ...
    
    @property
    def transparent_color(self) -> aspose.psd.Color:
        ...
    
    @property
    def raw_entries(self) -> bytes:
        ...
    
    @property
    def raw_entries_count(self) -> int:
        ...
    
    @property
    def entries_count(self) -> int:
        ...
    
    @property
    def argb_32_entries(self) -> List[int]:
        ...
    
    @property
    def entries(self) -> List[aspose.psd.Color]:
        '''Gets an array of :py:class:`aspose.psd.Color` structures.'''
        ...
    
    @property
    def is_compact_palette(self) -> bool:
        ...
    
    ...

class IRasterImageArgb32PixelLoader(IRasterImageRawDataLoader):
    '''The raster image 32-bit ARGB pixel loader.'''
    
    def load_partial_argb_32_pixels(self, rectangle : aspose.psd.Rectangle, partial_pixel_loader : aspose.psd.IPartialArgb32PixelLoader):
        '''Loads 32-bit ARGB pixels partially (by blocks).
        
        :param rectangle: The rectangle to load pixels from.
        :param partial_pixel_loader: The partial pixel loader.'''
        ...
    
    def load_raw_data(self, rectangle : aspose.psd.Rectangle, raw_data_settings : aspose.psd.RawDataSettings, raw_data_loader : aspose.psd.IPartialRawDataLoader):
        '''Loads raw data.
        
        :param rectangle: The rectangle to load raw data from.
        :param raw_data_settings: The raw data settings to use for loaded data. Note if data is not in the format specified then data conversion will be performed.
        :param raw_data_loader: The raw data loader.'''
        ...
    
    @property
    def is_raw_data_available(self) -> bool:
        ...
    
    @property
    def raw_data_settings(self) -> aspose.psd.RawDataSettings:
        ...
    
    ...

class IRasterImagePixelLoader(IRasterImageRawDataLoader):
    '''The raster image pixel loader.'''
    
    def load_partial_pixels(self, rectangle : aspose.psd.Rectangle, partial_pixel_loader : aspose.psd.IPartialPixelLoader):
        '''Loads pixels partially (by blocks).
        
        :param rectangle: The rectangle to load pixels from.
        :param partial_pixel_loader: The partial pixel loader.'''
        ...
    
    def load_raw_data(self, rectangle : aspose.psd.Rectangle, raw_data_settings : aspose.psd.RawDataSettings, raw_data_loader : aspose.psd.IPartialRawDataLoader):
        '''Loads raw data.
        
        :param rectangle: The rectangle to load raw data from.
        :param raw_data_settings: The raw data settings to use for loaded data. Note if data is not in the format specified then data conversion will be performed.
        :param raw_data_loader: The raw data loader.'''
        ...
    
    @property
    def is_raw_data_available(self) -> bool:
        ...
    
    @property
    def raw_data_settings(self) -> aspose.psd.RawDataSettings:
        ...
    
    ...

class IRasterImageRawDataLoader:
    '''The raster image raw data loader.'''
    
    def load_raw_data(self, rectangle : aspose.psd.Rectangle, raw_data_settings : aspose.psd.RawDataSettings, raw_data_loader : aspose.psd.IPartialRawDataLoader):
        '''Loads raw data.
        
        :param rectangle: The rectangle to load raw data from.
        :param raw_data_settings: The raw data settings to use for loaded data. Note if data is not in the format specified then data conversion will be performed.
        :param raw_data_loader: The raw data loader.'''
        ...
    
    @property
    def is_raw_data_available(self) -> bool:
        ...
    
    @property
    def raw_data_settings(self) -> aspose.psd.RawDataSettings:
        ...
    
    ...

class Image(DataStreamSupporter):
    '''The image is the base class for all type of images.'''
    
    @overload
    def save(self):
        '''Saves the image data to the underlying stream.'''
        ...
    
    @overload
    def save(self, file_path : str, options : aspose.psd.ImageOptionsBase):
        '''Saves the object's data to the specified file location in the specified file format according to save options.
        
        :param file_path: The file path.
        :param options: The options.'''
        ...
    
    @overload
    def save(self, file_path : str, options : aspose.psd.ImageOptionsBase, bounds_rectangle : aspose.psd.Rectangle):
        '''Saves the object's data to the specified file location in the specified file format according to save options.
        
        :param file_path: The file path.
        :param options: The options.
        :param bounds_rectangle: The destination image bounds rectangle. Set the empty rectangle for use sourse bounds.'''
        ...
    
    @overload
    def save(self, stream : io.RawIOBase, options_base : aspose.psd.ImageOptionsBase):
        '''Saves the image's data to the specified stream in the specified file format according to save options.
        
        :param stream: The stream to save the image's data to.
        :param options_base: The save options.'''
        ...
    
    @overload
    def save(self, stream : io.RawIOBase, options_base : aspose.psd.ImageOptionsBase, bounds_rectangle : aspose.psd.Rectangle):
        '''Saves the image's data to the specified stream in the specified file format according to save options.
        
        :param stream: The stream to save the image's data to.
        :param options_base: The save options.
        :param bounds_rectangle: The destination image bounds rectangle. Set the empty rectangle for use source bounds.'''
        ...
    
    @overload
    def save(self, stream : io.RawIOBase):
        '''Saves the object's data to the specified stream.
        
        :param stream: The stream to save the object's data to.'''
        ...
    
    @overload
    def save(self, file_path : str):
        '''Saves the object's data to the specified file location.
        
        :param file_path: The file path to save the object's data to.'''
        ...
    
    @overload
    def save(self, file_path : str, over_write : bool):
        '''Saves the object's data to the specified file location.
        
        :param file_path: The file path to save the object's data to.
        :param over_write: if set to ``true`` over write the file contents, otherwise append will occur.'''
        ...
    
    @overload
    @staticmethod
    def can_load(file_path : str) -> bool:
        '''Determines whether image can be loaded from the specified file path.
        
        :param file_path: The file path.
        :returns: ``true`` if image can be loaded from the specified file; otherwise, ``false``.'''
        ...
    
    @overload
    @staticmethod
    def can_load(file_path : strload_options : aspose.psd.LoadOptions) -> bool:
        '''Determines whether image can be loaded from the specified file path and optionally using the specified open options.
        
        :param file_path: The file path.
        :param load_options: The load options.
        :returns: ``true`` if image can be loaded from the specified file; otherwise, ``false``.'''
        ...
    
    @overload
    @staticmethod
    def can_load(stream : io.RawIOBase) -> bool:
        '''Determines whether image can be loaded from the specified stream.
        
        :param stream: The stream to load from.
        :returns: ``true`` if image can be loaded from the specified stream; otherwise, ``false``.'''
        ...
    
    @overload
    @staticmethod
    def can_load(stream : io.RawIOBaseload_options : aspose.psd.LoadOptions) -> bool:
        '''Determines whether image can be loaded from the specified stream and optionally using the specified ``loadOptions``.
        
        :param stream: The stream to load from.
        :param load_options: The load options.
        :returns: ``true`` if image can be loaded from the specified stream; otherwise, ``false``.'''
        ...
    
    @overload
    @staticmethod
    def get_file_format(file_path : str) -> aspose.psd.FileFormat:
        '''Gets the file format.
        
        :param file_path: The file path.
        :returns: The determined file format.'''
        ...
    
    @overload
    @staticmethod
    def get_file_format(stream : io.RawIOBase) -> aspose.psd.FileFormat:
        '''Gets the file format.
        
        :param stream: The stream.
        :returns: The determined file format.'''
        ...
    
    @overload
    @staticmethod
    def get_fitting_rectangle(rectangle : aspose.psd.Rectanglewidth : int, height : int) -> aspose.psd.Rectangle:
        '''Gets rectangle which fits the current image.
        
        :param rectangle: The rectangle to get fitting rectangle for.
        :param width: The object width.
        :param height: The object height.
        :returns: The fitting rectangle or exception if no fitting rectangle can be found.'''
        ...
    
    @overload
    @staticmethod
    def get_fitting_rectangle(rectangle : aspose.psd.Rectanglepixels : List[int], width : int, height : int) -> aspose.psd.Rectangle:
        '''Gets rectangle which fits the current image.
        
        :param rectangle: The rectangle to get fitting rectangle for.
        :param pixels: The 32-bit ARGB pixels.
        :param width: The object width.
        :param height: The object height.
        :returns: The fitting rectangle or exception if no fitting rectangle can be found.'''
        ...
    
    @overload
    @staticmethod
    def load(file_path : strload_options : aspose.psd.LoadOptions) -> aspose.psd.Image:
        '''Loads a new image from the specified file.
        
        :param file_path: The file path to load image from.
        :param load_options: The load options.
        :returns: The loaded image.'''
        ...
    
    @overload
    @staticmethod
    def load(file_path : str) -> aspose.psd.Image:
        '''Loads a new image from the specified file.
        
        :param file_path: The file path to load image from.
        :returns: The loaded image.'''
        ...
    
    @overload
    @staticmethod
    def load(stream : io.RawIOBaseload_options : aspose.psd.LoadOptions) -> aspose.psd.Image:
        '''Loads a new image from the specified stream.
        
        :param stream: The stream to load image from.
        :param load_options: The load options.
        :returns: The loaded image.'''
        ...
    
    @overload
    @staticmethod
    def load(stream : io.RawIOBase) -> aspose.psd.Image:
        '''Loads a new image from the specified stream.
        
        :param stream: The stream to load image from.
        :returns: The loaded image.'''
        ...
    
    @overload
    def resize(self, new_width : int, new_height : int):
        '''Resizes the image. The default :py:attr:`aspose.psd.ResizeType.NEAREST_NEIGHBOUR_RESAMPLE` is used.
        
        :param new_width: The new width.
        :param new_height: The new height.'''
        ...
    
    @overload
    def resize(self, new_width : int, new_height : int, resize_type : aspose.psd.ResizeType):
        '''Resizes the image.
        
        :param new_width: The new width.
        :param new_height: The new height.
        :param resize_type: The resize type.'''
        ...
    
    @overload
    def resize(self, new_width : int, new_height : int, settings : aspose.psd.ImageResizeSettings):
        '''Resizes the image.
        
        :param new_width: The new width.
        :param new_height: The new height.
        :param settings: The resize settings.'''
        ...
    
    @overload
    def resize_width_proportionally(self, new_width : int):
        '''Resizes the width proportionally. The default :py:attr:`aspose.psd.ResizeType.NEAREST_NEIGHBOUR_RESAMPLE` is used.
        
        :param new_width: The new width.'''
        ...
    
    @overload
    def resize_width_proportionally(self, new_width : int, resize_type : aspose.psd.ResizeType):
        '''Resizes the width proportionally.
        
        :param new_width: The new width.
        :param resize_type: Type of the resize.'''
        ...
    
    @overload
    def resize_width_proportionally(self, new_width : int, settings : aspose.psd.ImageResizeSettings):
        '''Resizes the width proportionally.
        
        :param new_width: The new width.
        :param settings: The image resize settings.'''
        ...
    
    @overload
    def resize_height_proportionally(self, new_height : int):
        '''Resizes the height proportionally.
        
        :param new_height: The new height.'''
        ...
    
    @overload
    def resize_height_proportionally(self, new_height : int, resize_type : aspose.psd.ResizeType):
        '''Resizes the height proportionally.
        
        :param new_height: The new height.
        :param resize_type: Type of the resize.'''
        ...
    
    @overload
    def resize_height_proportionally(self, new_height : int, settings : aspose.psd.ImageResizeSettings):
        '''Resizes the height proportionally.
        
        :param new_height: The new height.
        :param settings: The image resize settings.'''
        ...
    
    def cache_data(self):
        '''Caches the data and ensures no additional data loading will be performed from the underlying :py:attr:`aspose.psd.DataStreamSupporter.data_stream_container`.'''
        ...
    
    @staticmethod
    def create(image_options : aspose.psd.ImageOptionsBasewidth : int, height : int) -> aspose.psd.Image:
        '''Creates a new image using the specified create options.
        
        :param image_options: The image options.
        :param width: The width.
        :param height: The height.
        :returns: The newly created image.'''
        ...
    
    def can_save(self, options : aspose.psd.ImageOptionsBase) -> bool:
        '''Determines whether image can be saved to the specified file format represented by the passed save options.
        
        :param options: The save options to use.
        :returns: ``true`` if image can be saved to the specified file format represented by the passed save options; otherwise, ``false``.'''
        ...
    
    def get_default_options(self, args : List[any]) -> aspose.psd.ImageOptionsBase:
        '''Gets the default options.
        
        :param args: The arguments.
        :returns: Default options'''
        ...
    
    def get_original_options(self) -> aspose.psd.ImageOptionsBase:
        '''Gets the options based on the original file settings.
        This can be helpful to keep bit-depth and other parameters of the original image unchanged.
        For example, if we load a black-white PNG image with 1 bit per pixel and then save it using the
        :py:func:`aspose.psd.DataStreamSupporter.save` method, the output PNG image with 8-bit per pixel will be produced.
        To avoid it and save PNG image with 1-bit per pixel, use this method to get corresponding saving options and pass them
        to the :py:func:`aspose.psd.Image.save` method as the second parameter.
        
        :returns: The options based on the original file settings.'''
        ...
    
    def rotate_flip(self, rotate_flip_type : aspose.psd.RotateFlipType):
        '''Rotates, flips, or rotates and flips the image.
        
        :param rotate_flip_type: Type of the rotate flip.'''
        ...
    
    def set_palette(self, palette : aspose.psd.IColorPalette, update_colors : bool):
        '''Sets the image palette.
        
        :param palette: The palette to set.
        :param update_colors: if set to ``true`` colors will be updated according to the new palette; otherwise color indexes remain unchanged. Note that unchanged indexes may crash the image on loading if some indexes have no corresponding palette entries.'''
        ...
    
    @staticmethod
    def get_proportional_width(width : intheight : int, new_height : int) -> int:
        '''Gets a proportional width.
        
        :param width: The width.
        :param height: The height.
        :param new_height: The new height.
        :returns: The proportional width.'''
        ...
    
    @staticmethod
    def get_proportional_height(width : intheight : int, new_width : int) -> int:
        '''Gets a proportional height.
        
        :param width: The width.
        :param height: The height.
        :param new_width: The new width.
        :returns: The proportional height.'''
        ...
    
    @property
    def disposed(self) -> bool:
        '''Gets a value indicating whether this instance is disposed.'''
        ...
    
    @property
    def data_stream_container(self) -> aspose.psd.StreamContainer:
        ...
    
    @property
    def is_cached(self) -> bool:
        ...
    
    @property
    def bits_per_pixel(self) -> int:
        ...
    
    @property
    def bounds(self) -> aspose.psd.Rectangle:
        '''Gets the image bounds.'''
        ...
    
    @property
    def container(self) -> aspose.psd.Image:
        '''Gets the :py:class:`aspose.psd.Image` container.'''
        ...
    
    @property
    def height(self) -> int:
        '''Gets the image height.'''
        ...
    
    @property
    def palette(self) -> aspose.psd.IColorPalette:
        '''Gets the color palette. The color palette is not used when pixels are represented directly.'''
        ...
    
    @palette.setter
    def palette(self, value : aspose.psd.IColorPalette):
        '''Sets the color palette. The color palette is not used when pixels are represented directly.'''
        ...
    
    @property
    def use_palette(self) -> bool:
        ...
    
    @property
    def size(self) -> aspose.psd.Size:
        '''Gets the image size.'''
        ...
    
    @property
    def width(self) -> int:
        '''Gets the image width.'''
        ...
    
    @property
    def interrupt_monitor(self) -> aspose.psd.multithreading.InterruptMonitor:
        ...
    
    @interrupt_monitor.setter
    def interrupt_monitor(self, value : aspose.psd.multithreading.InterruptMonitor):
        ...
    
    @property
    def buffer_size_hint(self) -> int:
        ...
    
    @buffer_size_hint.setter
    def buffer_size_hint(self, value : int):
        ...
    
    @property
    def auto_adjust_palette(self) -> bool:
        ...
    
    @auto_adjust_palette.setter
    def auto_adjust_palette(self, value : bool):
        ...
    
    @property
    def has_background_color(self) -> bool:
        ...
    
    @has_background_color.setter
    def has_background_color(self, value : bool):
        ...
    
    @property
    def file_format(self) -> aspose.psd.FileFormat:
        ...
    
    @property
    def background_color(self) -> aspose.psd.Color:
        ...
    
    @background_color.setter
    def background_color(self, value : aspose.psd.Color):
        ...
    
    ...

class ImageAttributes:
    '''An :py:class:`aspose.psd.ImageAttributes` object contains information about how bitmap and metafile colors are manipulated during rendering. An :py:class:`aspose.psd.ImageAttributes` object maintains several color-adjustment settings, including color-adjustment matrices, grayscale-adjustment matrices, gamma-correction values, color-map tables, and color-threshold values. During rendering, colors can be corrected, darkened, lightened, and removed. To apply such manipulations, initialize an :py:class:`aspose.psd.ImageAttributes` object and pass the path of that :py:class:`aspose.psd.ImageAttributes` object (along with the path of an :py:class:`aspose.psd.Image`) to the DrawImage method.'''
    
    @overload
    def set_color_matrix(self, new_color_matrix : aspose.psd.ColorMatrix):
        '''Sets the color-adjustment matrix for the default category.
        
        :param new_color_matrix: The color-adjustment matrix.'''
        ...
    
    @overload
    def set_color_matrix(self, new_color_matrix : aspose.psd.ColorMatrix, flags : aspose.psd.ColorMatrixFlag):
        '''Sets the color-adjustment matrix for the default category.
        
        :param new_color_matrix: The color-adjustment matrix.
        :param flags: An element of :py:class:`aspose.psd.ColorMatrixFlag` that specifies the type of image and color that will be affected by the color-adjustment matrix.'''
        ...
    
    @overload
    def set_color_matrix(self, new_color_matrix : aspose.psd.ColorMatrix, mode : aspose.psd.ColorMatrixFlag, type : aspose.psd.ColorAdjustType):
        '''Sets the color-adjustment matrix for a specified category.
        
        :param new_color_matrix: The color-adjustment matrix.
        :param mode: An element of :py:class:`aspose.psd.ColorMatrixFlag` that specifies the type of image and color that will be affected by the color-adjustment matrix.
        :param type: An element of :py:class:`aspose.psd.ColorAdjustType` that specifies the category for which the color-adjustment matrix is set.'''
        ...
    
    @overload
    def clear_color_matrix(self):
        '''Clears the color-adjustment matrix for the default category.'''
        ...
    
    @overload
    def clear_color_matrix(self, type : aspose.psd.ColorAdjustType):
        '''Clears the color-adjustment matrix for a specified category.
        
        :param type: An element of :py:class:`aspose.psd.ColorAdjustType` that specifies the category for which the color-adjustment matrix is cleared.'''
        ...
    
    @overload
    def set_color_matrices(self, new_color_matrix : aspose.psd.ColorMatrix, gray_matrix : aspose.psd.ColorMatrix):
        '''Sets the color-adjustment matrix and the grayscale-adjustment matrix for the default category.
        
        :param new_color_matrix: The color-adjustment matrix.
        :param gray_matrix: The grayscale-adjustment matrix.'''
        ...
    
    @overload
    def set_color_matrices(self, new_color_matrix : aspose.psd.ColorMatrix, gray_matrix : aspose.psd.ColorMatrix, flags : aspose.psd.ColorMatrixFlag):
        '''Sets the color-adjustment matrix and the grayscale-adjustment matrix for the default category.
        
        :param new_color_matrix: The color-adjustment matrix.
        :param gray_matrix: The grayscale-adjustment matrix.
        :param flags: An element of :py:class:`aspose.psd.ColorMatrixFlag` that specifies the type of image and color that will be affected by the color-adjustment and grayscale-adjustment matrices.'''
        ...
    
    @overload
    def set_color_matrices(self, new_color_matrix : aspose.psd.ColorMatrix, gray_matrix : aspose.psd.ColorMatrix, mode : aspose.psd.ColorMatrixFlag, type : aspose.psd.ColorAdjustType):
        '''Sets the color-adjustment matrix and the grayscale-adjustment matrix for a specified category.
        
        :param new_color_matrix: The color-adjustment matrix.
        :param gray_matrix: The grayscale-adjustment matrix.
        :param mode: An element of :py:class:`aspose.psd.ColorMatrixFlag` that specifies the type of image and color that will be affected by the color-adjustment and grayscale-adjustment matrices.
        :param type: An element of :py:class:`aspose.psd.ColorAdjustType` that specifies the category for which the color-adjustment and grayscale-adjustment matrices are set.'''
        ...
    
    @overload
    def set_threshold(self, threshold : float):
        '''Sets the threshold (transparency range) for the default category.
        
        :param threshold: A real number that specifies the threshold value.'''
        ...
    
    @overload
    def set_threshold(self, threshold : float, type : aspose.psd.ColorAdjustType):
        '''Sets the threshold (transparency range) for a specified category.
        
        :param threshold: A threshold value from 0.0 to 1.0 that is used as a breakpoint to sort colors that will be mapped to either a maximum or a minimum value.
        :param type: An element of :py:class:`aspose.psd.ColorAdjustType` that specifies the category for which the color threshold is set.'''
        ...
    
    @overload
    def clear_threshold(self):
        '''Clears the threshold value for the default category.'''
        ...
    
    @overload
    def clear_threshold(self, type : aspose.psd.ColorAdjustType):
        '''Clears the threshold value for a specified category.
        
        :param type: An element of :py:class:`aspose.psd.ColorAdjustType` that specifies the category for which the threshold is cleared.'''
        ...
    
    @overload
    def set_gamma(self, gamma : float):
        '''Sets the gamma value for the default category.
        
        :param gamma: The gamma correction value.'''
        ...
    
    @overload
    def set_gamma(self, gamma : float, type : aspose.psd.ColorAdjustType):
        '''Sets the gamma value for a specified category.
        
        :param gamma: The gamma correction value.
        :param type: An element of the :py:class:`aspose.psd.ColorAdjustType` enumeration that specifies the category for which the gamma value is set.'''
        ...
    
    @overload
    def clear_gamma(self):
        '''Disables gamma correction for the default category.'''
        ...
    
    @overload
    def clear_gamma(self, type : aspose.psd.ColorAdjustType):
        '''Disables gamma correction for a specified category.
        
        :param type: An element of :py:class:`aspose.psd.ColorAdjustType` that specifies the category for which gamma correction is disabled.'''
        ...
    
    @overload
    def set_no_op(self):
        '''Turns off color adjustment for the default category.'''
        ...
    
    @overload
    def set_no_op(self, type : aspose.psd.ColorAdjustType):
        '''Turns off color adjustment for a specified category.
        
        :param type: An element of :py:class:`aspose.psd.ColorAdjustType` that specifies the category for which color correction is turned off.'''
        ...
    
    @overload
    def clear_no_op(self):
        '''Clears the NoOp setting for the default category.'''
        ...
    
    @overload
    def clear_no_op(self, type : aspose.psd.ColorAdjustType):
        '''Clears the NoOp setting for a specified category.
        
        :param type: An element of :py:class:`aspose.psd.ColorAdjustType` that specifies the category for which the NoOp setting is cleared.'''
        ...
    
    @overload
    def set_color_key(self, color_low : aspose.psd.Color, color_high : aspose.psd.Color):
        '''Sets the color key for the default category.
        
        :param color_low: The low color-key value.
        :param color_high: The high color-key value.'''
        ...
    
    @overload
    def set_color_key(self, color_low : aspose.psd.Color, color_high : aspose.psd.Color, type : aspose.psd.ColorAdjustType):
        '''Sets the color key (transparency range) for a specified category.
        
        :param color_low: The low color-key value.
        :param color_high: The high color-key value.
        :param type: An element of :py:class:`aspose.psd.ColorAdjustType` that specifies the category for which the color key is set.'''
        ...
    
    @overload
    def clear_color_key(self):
        '''Clears the color key (transparency range) for the default category.'''
        ...
    
    @overload
    def clear_color_key(self, type : aspose.psd.ColorAdjustType):
        '''Clears the color key (transparency range) for a specified category.
        
        :param type: An element of :py:class:`aspose.psd.ColorAdjustType` that specifies the category for which the color key is cleared.'''
        ...
    
    @overload
    def set_output_channel(self, flags : aspose.psd.ColorChannelFlag):
        '''Sets the CMYK (cyan-magenta-yellow-black) output channel for the default category.
        
        :param flags: An element of :py:class:`aspose.psd.ColorChannelFlag` that specifies the output channel.'''
        ...
    
    @overload
    def set_output_channel(self, flags : aspose.psd.ColorChannelFlag, type : aspose.psd.ColorAdjustType):
        '''Sets the CMYK (cyan-magenta-yellow-black) output channel for a specified category.
        
        :param flags: An element of :py:class:`aspose.psd.ColorChannelFlag` that specifies the output channel.
        :param type: An element of :py:class:`aspose.psd.ColorAdjustType` that specifies the category for which the output channel is set.'''
        ...
    
    @overload
    def clear_output_channel(self):
        '''Clears the CMYK (cyan-magenta-yellow-black) output channel setting for the default category.'''
        ...
    
    @overload
    def clear_output_channel(self, type : aspose.psd.ColorAdjustType):
        '''Clears the (cyan-magenta-yellow-black) output channel setting for a specified category.
        
        :param type: An element of :py:class:`aspose.psd.ColorAdjustType` that specifies the category for which the output channel setting is cleared.'''
        ...
    
    @overload
    def set_output_channel_color_profile(self, color_profile_filename : str):
        '''Sets the output channel color-profile file for the default category.
        
        :param color_profile_filename: The path name of a color-profile file. If the color-profile file is in the %SystemRoot%\System32\Spool\Drivers\Color directory, this parameter can be the file name. Otherwise, this parameter must be the fully qualified path name.'''
        ...
    
    @overload
    def set_output_channel_color_profile(self, color_profile_filename : str, type : aspose.psd.ColorAdjustType):
        '''Sets the output channel color-profile file for a specified category.
        
        :param color_profile_filename: The path name of a color-profile file. If the color-profile file is in the %SystemRoot%\System32\Spool\Drivers\Color directory, this parameter can be the file name. Otherwise, this parameter must be the fully qualified path name.
        :param type: An element of :py:class:`aspose.psd.ColorAdjustType` that specifies the category for which the output channel color-profile file is set.'''
        ...
    
    @overload
    def clear_output_channel_color_profile(self):
        '''Clears the output channel color profile setting for the default category.'''
        ...
    
    @overload
    def clear_output_channel_color_profile(self, type : aspose.psd.ColorAdjustType):
        '''Clears the output channel color profile setting for a specified category.
        
        :param type: An element of :py:class:`aspose.psd.ColorAdjustType` that specifies the category for which the output channel profile setting is cleared.'''
        ...
    
    @overload
    def set_remap_table(self, map : List[aspose.psd.ColorMap]):
        '''Sets the color-remap table for the default category.
        
        :param map: An array of color pairs of type :py:class:`aspose.psd.ColorMap`. Each color pair contains an existing color (the first value) and the color that it will be mapped to (the second value).'''
        ...
    
    @overload
    def set_remap_table(self, map : List[aspose.psd.ColorMap], type : aspose.psd.ColorAdjustType):
        '''Sets the color-remap table for a specified category.
        
        :param map: An array of color pairs of type :py:class:`aspose.psd.ColorMap`. Each color pair contains an existing color (the first value) and the color that it will be mapped to (the second value).
        :param type: An element of :py:class:`aspose.psd.ColorAdjustType` that specifies the category for which the color-remap table is set.'''
        ...
    
    @overload
    def clear_remap_table(self):
        '''Clears the color-remap table for the default category.'''
        ...
    
    @overload
    def clear_remap_table(self, type : aspose.psd.ColorAdjustType):
        '''Clears the color-remap table for a specified category.
        
        :param type: An element of :py:class:`aspose.psd.ColorAdjustType` that specifies the category for which the remap table is cleared.'''
        ...
    
    @overload
    def set_wrap_mode(self, mode : aspose.psd.WrapMode):
        '''Sets the wrap mode that is used to decide how to tile a texture across a shape, or at shape boundaries. A texture is tiled across a shape to fill it in when the texture is smaller than the shape it is filling.
        
        :param mode: An element of :py:class:`aspose.psd.WrapMode` that specifies how repeated copies of an image are used to tile an area.'''
        ...
    
    @overload
    def set_wrap_mode(self, mode : aspose.psd.WrapMode, color : aspose.psd.Color):
        '''Sets the wrap mode and color used to decide how to tile a texture across a shape, or at shape boundaries. A texture is tiled across a shape to fill it in when the texture is smaller than the shape it is filling.
        
        :param mode: An element of :py:class:`aspose.psd.WrapMode` that specifies how repeated copies of an image are used to tile an area.
        :param color: An :py:class:`aspose.psd.ImageAttributes` object that specifies the color of pixels outside of a rendered image. This color is visible if the mode parameter is set to :py:attr:`aspose.psd.WrapMode.CLAMP` and the source rectangle passed to DrawImage is larger than the image itself.'''
        ...
    
    @overload
    def set_wrap_mode(self, mode : aspose.psd.WrapMode, color : aspose.psd.Color, clamp : bool):
        '''Sets the wrap mode and color used to decide how to tile a texture across a shape, or at shape boundaries. A texture is tiled across a shape to fill it in when the texture is smaller than the shape it is filling.
        
        :param mode: An element of :py:class:`aspose.psd.WrapMode` that specifies how repeated copies of an image are used to tile an area.
        :param color: A color object that specifies the color of pixels outside of a rendered image. This color is visible if the mode parameter is set to :py:attr:`aspose.psd.WrapMode.CLAMP` and the source rectangle passed to DrawImage is larger than the image itself.
        :param clamp: This parameter has no effect. Set it to false.'''
        ...
    
    def set_brush_remap_table(self, map : List[aspose.psd.ColorMap]):
        '''Sets the color-remap table for the brush category.
        
        :param map: An array of :py:class:`aspose.psd.ColorMap` objects.'''
        ...
    
    def clear_brush_remap_table(self):
        '''Clears the brush color-remap table of this :py:class:`aspose.psd.ImageAttributes` object.'''
        ...
    
    ...

class ImageCreatorsRegistry:
    '''Represents the image creators registry.'''
    
    @staticmethod
    def register(image_creator_descriptor : aspose.psd.IImageCreatorDescriptor):
        '''Registers the specified image creator descriptor.
        
        :param image_creator_descriptor: The image creator descriptor.'''
        ...
    
    @staticmethod
    def get_first_supported_descriptor(image_options : aspose.psd.ImageOptionsBase) -> aspose.psd.IImageCreatorDescriptor:
        '''Gets the fist found supported descriptor suitable for the specified.
        
        :param image_options: The image options.
        :returns: The creator descriptor which supports the specified or null if no such descriptor is found.'''
        ...
    
    @staticmethod
    def create_first_supported_creator(image_options : aspose.psd.ImageOptionsBase) -> aspose.psd.IImageCreator:
        '''Creates the first found creator suitable for the specified.
        
        :param image_options: The image options.
        :returns: The creator which supports the specified or null if no such creator is found.'''
        ...
    
    @staticmethod
    def register_creator(creator_descriptor : aspose.psd.IImageCreatorDescriptor):
        '''Registers the creator.
        
        :param creator_descriptor: The creator descriptor to register.'''
        ...
    
    @staticmethod
    def unregister_creator(creator_descriptor : aspose.psd.IImageCreatorDescriptor):
        '''Unregisters the creator.
        
        :param creator_descriptor: The creator descriptor.'''
        ...
    
    @classmethod
    @property
    def registered_formats(cls) -> aspose.psd.FileFormat:
        ...
    
    @classmethod
    @property
    def registered_descriptors(cls) -> List[aspose.psd.IImageCreatorDescriptor]:
        ...
    
    ...

class ImageExportersRegistry:
    '''Represents the image exporters registry.'''
    
    @staticmethod
    def register(image_exporter_descriptor : aspose.psd.IImageExporterDescriptor):
        '''Registers the specified image exporter descriptor.
        
        :param image_exporter_descriptor: The image exporter descriptor.'''
        ...
    
    @staticmethod
    def get_first_supported_descriptor(image : aspose.psd.Imageoptions : aspose.psd.ImageOptionsBase) -> aspose.psd.IImageExporterDescriptor:
        '''Gets the fist found supported descriptor suitable for the specified save options and image.
        
        :param image: The image to export.
        :param options: The options.
        :returns: The exporter descriptor which supports the specified image and save options or null if no such descriptor is found.'''
        ...
    
    @staticmethod
    def create_first_supported_exporter(image : aspose.psd.Imageoptions : aspose.psd.ImageOptionsBase) -> aspose.psd.IImageExporter:
        '''Creates the first found exporter suitable for the specified save options and image.
        
        :param image: The image to export.
        :param options: The save options to use for export.
        :returns: The exporter which supports the specified image and save options or null if no such exporter is found.'''
        ...
    
    @staticmethod
    def register_exporter(exporter_descriptor : aspose.psd.IImageExporterDescriptor):
        '''Registers the exporter.
        
        :param exporter_descriptor: The exporter descriptor to register.'''
        ...
    
    @staticmethod
    def unregister_exporter(exporter_descriptor : aspose.psd.IImageExporterDescriptor):
        '''Unregisters the exporter.
        
        :param exporter_descriptor: The exporter descriptor to unregister.'''
        ...
    
    @classmethod
    @property
    def registered_formats(cls) -> aspose.psd.FileFormat:
        ...
    
    @classmethod
    @property
    def registered_exporter_descriptors(cls) -> List[aspose.psd.IImageExporterDescriptor]:
        ...
    
    ...

class ImageLoadersRegistry:
    '''Represents the image loaders registry.'''
    
    @staticmethod
    def register(image_loader_descriptor : aspose.psd.IImageLoaderDescriptor):
        '''Registers the specified image loader descriptor.
        
        :param image_loader_descriptor: The image loader descriptor.'''
        ...
    
    @staticmethod
    def get_first_supported_descriptor_by_type_name(descriptor_type_name : str) -> aspose.psd.IImageLoaderDescriptor:
        '''Gets the first supported descriptor by its type name.
        
        :param descriptor_type_name: The descriptor type name.
        :returns: The first found loader descriptor or null if not such descriptor is found.'''
        ...
    
    @staticmethod
    def get_first_supported_descriptor_by_file_format(file_format : aspose.psd.FileFormat) -> aspose.psd.IImageLoaderDescriptor:
        '''Gets the first supported file format by its type name.
        
        :param file_format: The supported descriptor file format.
        :returns: The first found loader descriptor or null if not such descriptor is found.'''
        ...
    
    @staticmethod
    def get_first_supported_descriptor(stream : io.RawIOBaseload_options : aspose.psd.LoadOptions) -> aspose.psd.IImageLoaderDescriptor:
        '''Gets the fist found supported descriptor suitable for the specified ``stream`` and optionally the ``loadOptions``.
        
        :param stream: The stream.
        :param load_options: The load options.
        :returns: The loader descriptor which supports the specified ``stream`` and ``loadOptions`` or null if no such descriptor is found.'''
        ...
    
    @staticmethod
    def create_first_supported_loader(stream : io.RawIOBaseload_options : aspose.psd.LoadOptions) -> aspose.psd.IImageLoader:
        '''Creates the first found loader suitable for the specified ``stream`` and optionally the ``loadOptions``.
        
        :param stream: The stream.
        :param load_options: The load options.
        :returns: The loader which supports the specified ``stream`` and ``loadOptions`` or null if no such loader is found.'''
        ...
    
    @staticmethod
    def register_loader(loader_descriptor : aspose.psd.IImageLoaderDescriptor):
        '''Registers the loader.
        
        :param loader_descriptor: The loader descriptor to register.'''
        ...
    
    @staticmethod
    def unregister_loader(loader_descriptor : aspose.psd.IImageLoaderDescriptor):
        '''Unregisters the loader.
        
        :param loader_descriptor: The loader descriptor to unregister.'''
        ...
    
    @classmethod
    @property
    def registered_formats(cls) -> aspose.psd.FileFormat:
        ...
    
    @classmethod
    @property
    def registered_descriptors(cls) -> List[aspose.psd.IImageLoaderDescriptor]:
        ...
    
    ...

class ImageOptionsBase(DisposableObject):
    '''The image base options.'''
    
    def clone(self) -> aspose.psd.ImageOptionsBase:
        '''Clones this instance.
        
        :returns: Returns shallow copy of this instance'''
        ...
    
    @property
    def disposed(self) -> bool:
        '''Gets a value indicating whether this instance is disposed.'''
        ...
    
    @property
    def default_replacement_font(self) -> str:
        ...
    
    @default_replacement_font.setter
    def default_replacement_font(self, value : str):
        ...
    
    @property
    def xmp_data(self) -> aspose.psd.xmp.XmpPacketWrapper:
        ...
    
    @xmp_data.setter
    def xmp_data(self, value : aspose.psd.xmp.XmpPacketWrapper):
        ...
    
    @property
    def source(self) -> aspose.psd.Source:
        '''Gets the source to create image in.'''
        ...
    
    @source.setter
    def source(self, value : aspose.psd.Source):
        '''Sets the source to create image in.'''
        ...
    
    @property
    def palette(self) -> aspose.psd.IColorPalette:
        '''Gets the color palette.'''
        ...
    
    @palette.setter
    def palette(self, value : aspose.psd.IColorPalette):
        '''Sets the color palette.'''
        ...
    
    @property
    def resolution_settings(self) -> aspose.psd.ResolutionSetting:
        ...
    
    @resolution_settings.setter
    def resolution_settings(self, value : aspose.psd.ResolutionSetting):
        ...
    
    @property
    def vector_rasterization_options(self) -> aspose.psd.imageoptions.VectorRasterizationOptions:
        ...
    
    @vector_rasterization_options.setter
    def vector_rasterization_options(self, value : aspose.psd.imageoptions.VectorRasterizationOptions):
        ...
    
    @property
    def buffer_size_hint(self) -> int:
        ...
    
    @buffer_size_hint.setter
    def buffer_size_hint(self, value : int):
        ...
    
    @property
    def multi_page_options(self) -> aspose.psd.imageoptions.MultiPageOptions:
        ...
    
    @multi_page_options.setter
    def multi_page_options(self, value : aspose.psd.imageoptions.MultiPageOptions):
        ...
    
    @property
    def full_frame(self) -> bool:
        ...
    
    @full_frame.setter
    def full_frame(self, value : bool):
        ...
    
    ...

class ImageResizeSettings:
    '''Image resize settings class'''
    
    @property
    def entries_count(self) -> int:
        ...
    
    @entries_count.setter
    def entries_count(self, value : int):
        ...
    
    @property
    def mode(self) -> aspose.psd.ResizeType:
        '''Gets the interpolation mode.'''
        ...
    
    @mode.setter
    def mode(self, value : aspose.psd.ResizeType):
        '''Sets the interpolation mode.'''
        ...
    
    @property
    def filter_type(self) -> aspose.psd.ImageFilterType:
        ...
    
    @filter_type.setter
    def filter_type(self, value : aspose.psd.ImageFilterType):
        ...
    
    @property
    def color_quantization_method(self) -> aspose.psd.ColorQuantizationMethod:
        ...
    
    @color_quantization_method.setter
    def color_quantization_method(self, value : aspose.psd.ColorQuantizationMethod):
        ...
    
    @property
    def color_compare_method(self) -> aspose.psd.ColorCompareMethod:
        ...
    
    @color_compare_method.setter
    def color_compare_method(self, value : aspose.psd.ColorCompareMethod):
        ...
    
    ...

class IntRange:
    '''Class for representing sequence of elements'''
    
    def get_array_one_item_from_index(self, index : int) -> List[int]:
        '''Returns one item array from specified index
        
        :param index: The range index.
        :returns: The array of :py:class:`int`'''
        ...
    
    @staticmethod
    def get_range(start : intcount : int, delta : int) -> Iterable[int]:
        '''Gets the count range of int elements starting at start
        
        :param start: The start.
        :param count: The count.
        :param delta: The delta.
        :returns: Array of items'''
        ...
    
    @property
    def range(self) -> List[int]:
        '''Gets the range.'''
        ...
    
    @range.setter
    def range(self, value : List[int]):
        '''Sets the range.'''
        ...
    
    ...

class License:
    '''Provides methods to license the component.'''
    
    @overload
    def set_license(self, license_name : str):
        '''Licenses the component.'''
        ...
    
    @overload
    def set_license(self, stream : io.RawIOBase):
        '''Licenses the component.
        
        :param stream: A stream that contains the license.'''
        ...
    
    ...

class LoadOptions:
    '''Represents the loading options.'''
    
    @property
    def data_recovery_mode(self) -> aspose.psd.DataRecoveryMode:
        ...
    
    @data_recovery_mode.setter
    def data_recovery_mode(self, value : aspose.psd.DataRecoveryMode):
        ...
    
    @property
    def data_background_color(self) -> aspose.psd.Color:
        ...
    
    @data_background_color.setter
    def data_background_color(self, value : aspose.psd.Color):
        ...
    
    @property
    def use_icc_profile_conversion(self) -> bool:
        ...
    
    @use_icc_profile_conversion.setter
    def use_icc_profile_conversion(self, value : bool):
        ...
    
    @property
    def buffer_size_hint(self) -> int:
        ...
    
    @buffer_size_hint.setter
    def buffer_size_hint(self, value : int):
        ...
    
    ...

class Matrix:
    '''Replaces the GDI+ Matrix.'''
    
    @overload
    def scale(self, scale_x : float, scale_y : float, order : aspose.psd.MatrixOrder):
        '''Applies the specified scale vector (scaleX and scaleY) to this :py:class:`aspose.psd.Matrix` using the specified order.
        
        :param scale_x: The scale X.
        :param scale_y: The scale Y.
        :param order: The order.'''
        ...
    
    @overload
    def scale(self, sx : float, sy : float):
        '''Applies the specified scale vector (scaleX and scaleY) to this Matrix using (default) Prepend order.
        
        :param sx: The sx. The sx. The sx.
        :param sy: The sy. The sy. The sy.'''
        ...
    
    @overload
    def translate(self, offset_x : float, offset_y : float, order : aspose.psd.MatrixOrder):
        '''Applies the specified translation vector to this Matrix in the specified order.
        
        :param offset_x: The offset X.
        :param offset_y: The offset Y.
        :param order: The order.'''
        ...
    
    @overload
    def translate(self, tx : float, ty : float):
        '''Applies the specified translation vector to this :py:class:`aspose.psd.Matrix` using (default) Prepend order.
        
        :param tx: The tx. The tx. The tx.
        :param ty: The ty. The ty. The ty.'''
        ...
    
    @overload
    def multiply(self, tx : aspose.psd.Matrix, order : aspose.psd.MatrixOrder):
        '''Multiplies this Matrix by the matrix specified in the matrix parameter, and in the order specified in the order parameter.
        
        :param tx: The tx. The tx. The tx.
        :param order: The order. The order. The order.'''
        ...
    
    @overload
    def multiply(self, tx : aspose.psd.Matrix):
        '''Multiplies this Matrix by the matrix specified in the matrix parameter using (default) Prepend order.
        
        :param tx: The matrix to multiply with.'''
        ...
    
    @overload
    def rotate(self, angle : float, order : aspose.psd.MatrixOrder):
        '''Applies a clockwise rotation of an amount specified in the angle parameter, around the origin (zero x and y coordinates) for this Matrix in the specified order.
        
        :param angle: The rotate angle.
        :param order: The matrix order.'''
        ...
    
    @overload
    def rotate(self, angle : float):
        '''Applies a clockwise rotation of an amount specified in the angle parameter, around the origin (zero x and y coordinates) for this Matrix in the default (Prepend) order.
        
        :param angle: The rotate angle.'''
        ...
    
    @overload
    def rotate_at(self, angle : float, point : aspose.psd.PointF, order : aspose.psd.MatrixOrder):
        '''Applies a clockwise rotation about the specified point to this Matrix in the specified order.
        
        :param angle: The angle.
        :param point: The point.
        :param order: The order.'''
        ...
    
    @overload
    def rotate_at(self, angle : float, point : aspose.psd.PointF):
        '''Applies a clockwise rotation about the specified point to this Matrix in the default (Prepend) order.
        
        :param angle: The angle.
        :param point: The point.'''
        ...
    
    def get_elements(self) -> List[float]:
        '''Gets the copy of matrix elements.
        
        :returns: A matrix elements copy.'''
        ...
    
    def transform_points(self, points : List[aspose.psd.PointF]):
        '''Applies the geometric transform represented by this :py:class:`aspose.psd.Matrix` to a specified array of points.
        
        :param points: The points.'''
        ...
    
    def reset(self):
        '''Resets this Matrix to have the elements of the identity matrix.'''
        ...
    
    @staticmethod
    def equals(a : aspose.psd.Matrixb : aspose.psd.Matrix) -> bool:
        '''Determines whether two matrixes are equal.
        
        :param a: The first matrix to compare.
        :param b: The second matrix to compare.
        :returns: True if matrixes are equal.'''
        ...
    
    @property
    def elements(self) -> List[float]:
        '''Gets an array of floating-point values that represents the elements of this :py:class:`aspose.psd.Matrix`.'''
        ...
    
    @property
    def m11(self) -> float:
        '''Gets the matrix element at first row first column. Represents scale along X axis.'''
        ...
    
    @property
    def m12(self) -> float:
        '''Gets the matrix element at first row second column. Represents shear along Y axis.'''
        ...
    
    @property
    def m21(self) -> float:
        '''Gets the matrix element at second row first column. Represents shear along X axis.'''
        ...
    
    @property
    def m22(self) -> float:
        '''Gets the matrix element at second row second column. Represents scale along Y axis.'''
        ...
    
    @property
    def m31(self) -> float:
        '''Gets the matrix element at third row first column. Represents translation along X axis.'''
        ...
    
    @property
    def m32(self) -> float:
        '''Gets the matrix element at third row first column. Represents translation along Y axis.'''
        ...
    
    @classmethod
    @property
    def TYPE_IDENTITY(cls) -> int:
        ...
    
    @classmethod
    @property
    def TYPE_TRANSLATION(cls) -> int:
        ...
    
    @classmethod
    @property
    def TYPE_UNIFORM_SCALE(cls) -> int:
        ...
    
    @classmethod
    @property
    def TYPE_GENERAL_SCALE(cls) -> int:
        ...
    
    @classmethod
    @property
    def TYPE_MASK_SCALE(cls) -> int:
        ...
    
    @classmethod
    @property
    def TYPE_FLIP(cls) -> int:
        ...
    
    @classmethod
    @property
    def TYPE_QUADRANT_ROTATION(cls) -> int:
        ...
    
    @classmethod
    @property
    def TYPE_GENERAL_ROTATION(cls) -> int:
        ...
    
    @classmethod
    @property
    def TYPE_MASK_ROTATION(cls) -> int:
        ...
    
    @classmethod
    @property
    def TYPE_GENERAL_TRANSFORM(cls) -> int:
        ...
    
    ...

class Metered:
    '''Provides methods to set metered key.'''
    
    def set_metered_key(self, public_key : str, private_key : str):
        '''Sets metered public and private key.
        If you purchase metered license, when start application, this API should be called, normally, this is enough.
        However, if always fail to upload consumption data and exceed 24 hours, the license will be set to evaluation status,
        to avoid such case, you should regularly check the license status, if it is evaluation status, call this API again.
        
        :param public_key: public key
        :param private_key: private key'''
        ...
    
    @staticmethod
    def get_consumption_quantity() -> float:
        '''Gets consumption file size
        
        :returns: consumption quantity'''
        ...
    
    @staticmethod
    def get_consumption_credit() -> float:
        '''Gets consumption credit
        
        :returns: consumption quantity'''
        ...
    
    def get_product_name(self) -> str:
        '''Gets the name of the product.
        
        :returns: Name of Licensed product'''
        ...
    
    @staticmethod
    def is_metered_licensed() -> bool:
        '''Check whether metered is licensed
        
        :returns: True or false'''
        ...
    
    ...

class NonGenericDictionary:
    '''Represents a non generic dictionary.'''
    
    def remove(self, key : any):
        '''Removes the element with the specified key from the
        :py:class:`dict` object.
        
        :param key: The key of the element to remove.'''
        ...
    
    def add(self, key : any, value : any):
        '''Adds an element with the provided key and value to the
        :py:class:`dict` object.
        
        :param key: The
        :py:class:`any` to use as the key of the element to add.
        :param value: The
        :py:class:`any` to use as the value of the element to add.'''
        ...
    
    def clear(self):
        '''Removes all elements from the
        :py:class:`dict` object.'''
        ...
    
    @property
    def is_fixed_size(self) -> bool:
        ...
    
    @property
    def is_read_only(self) -> bool:
        ...
    
    @property
    def keys(self) -> list:
        '''Gets an
        :py:class:`list` object containing the keys of the
        :py:class:`dict` object.'''
        ...
    
    @property
    def values(self) -> list:
        '''Gets an
        :py:class:`list` object containing the values in the
        :py:class:`dict` object.'''
        ...
    
    ...

class NonGenericList:
    '''Non generic list of objects'''
    
    ...

class ObjectWithBounds:
    '''The object having bounds.'''
    
    @overload
    def get_bounds(self, matrix : aspose.psd.Matrix) -> aspose.psd.RectangleF:
        '''Gets the object's bounds.
        
        :param matrix: The matrix to apply before bounds will be calculated.
        :returns: The estimated object's bounds.'''
        ...
    
    @overload
    def get_bounds(self, matrix : aspose.psd.Matrix, pen : aspose.psd.Pen) -> aspose.psd.RectangleF:
        '''Gets the object's bounds.
        
        :param matrix: The matrix to apply before bounds will be calculated.
        :param pen: The pen to use for object. This can influence the object's bounds size.
        :returns: The estimated object's bounds.'''
        ...
    
    def transform(self, transform : aspose.psd.Matrix):
        '''Applies the specified transformation to the shape.
        
        :param transform: The transformation to apply.'''
        ...
    
    @property
    def bounds(self) -> aspose.psd.RectangleF:
        '''Gets the object's bounds.'''
        ...
    
    ...

class OpenTypeFontsCache:
    '''Cache for OpenType fonts that are installed in the system.'''
    
    @staticmethod
    def update_cache():
        ''''''
        ...
    
    ...

class Pen(TransparencySupporter):
    '''Defines an object used to draw lines, curves and figures.'''
    
    @overload
    def multiply_transform(self, matrix : aspose.psd.Matrix):
        '''Multiplies the transformation matrix for this :py:class:`aspose.psd.Pen` by the specified :py:class:`aspose.psd.Matrix`.
        
        :param matrix: The :py:class:`aspose.psd.Matrix` object by which to multiply the transformation matrix.'''
        ...
    
    @overload
    def multiply_transform(self, matrix : aspose.psd.Matrix, order : aspose.psd.MatrixOrder):
        '''Multiplies the transformation matrix for this :py:class:`aspose.psd.Pen` by the specified :py:class:`aspose.psd.Matrix` in the specified order.
        
        :param matrix: The :py:class:`aspose.psd.Matrix` by which to multiply the transformation matrix.
        :param order: The order in which to perform the multiplication operation.'''
        ...
    
    @overload
    def translate_transform(self, dx : float, dy : float):
        '''Translates the local geometric transformation by the specified dimensions. This method prepends the translation to the transformation.
        
        :param dx: The value of the translation in x.
        :param dy: The value of the translation in y.'''
        ...
    
    @overload
    def translate_transform(self, dx : float, dy : float, order : aspose.psd.MatrixOrder):
        '''Translates the local geometric transformation by the specified dimensions in the specified order.
        
        :param dx: The value of the translation in x.
        :param dy: The value of the translation in y.
        :param order: The order (prepend or append) in which to apply the translation.'''
        ...
    
    @overload
    def scale_transform(self, sx : float, sy : float):
        '''Scales the local geometric transformation by the specified factors. This method prepends the scaling matrix to the transformation.
        
        :param sx: The factor by which to scale the transformation in the x-axis direction.
        :param sy: The factor by which to scale the transformation in the y-axis direction.'''
        ...
    
    @overload
    def scale_transform(self, sx : float, sy : float, order : aspose.psd.MatrixOrder):
        '''Scales the local geometric transformation by the specified factors in the specified order.
        
        :param sx: The factor by which to scale the transformation in the x-axis direction.
        :param sy: The factor by which to scale the transformation in the y-axis direction.
        :param order: A :py:class:`aspose.psd.MatrixOrder` that specifies whether to append or prepend the scaling matrix.'''
        ...
    
    @overload
    def rotate_transform(self, angle : float):
        '''Rotates the local geometric transformation by the specified angle. This method prepends the rotation to the transformation.
        
        :param angle: The angle of rotation.'''
        ...
    
    @overload
    def rotate_transform(self, angle : float, order : aspose.psd.MatrixOrder):
        '''Rotates the local geometric transformation by the specified angle in the specified order.
        
        :param angle: The angle of rotation.
        :param order: A :py:class:`aspose.psd.MatrixOrder` that specifies whether to append or prepend the rotation matrix.'''
        ...
    
    def set_line_cap(self, start_cap : aspose.psd.LineCap, end_cap : aspose.psd.LineCap, dash_cap : aspose.psd.DashCap):
        '''Sets the values that determine the style of cap used to end lines drawn by this :py:class:`aspose.psd.Pen`.
        
        :param start_cap: A :py:class:`aspose.psd.LineCap` that represents the cap style to use at the beginning of lines drawn with this :py:class:`aspose.psd.Pen`.
        :param end_cap: A :py:class:`aspose.psd.LineCap` that represents the cap style to use at the end of lines drawn with this :py:class:`aspose.psd.Pen`.
        :param dash_cap: A :py:class:`aspose.psd.LineCap` that represents the cap style to use at the beginning or end of dashed lines drawn with this :py:class:`aspose.psd.Pen`.'''
        ...
    
    def reset_transform(self):
        '''Resets the geometric transformation matrix for this :py:class:`aspose.psd.Pen` to identity.'''
        ...
    
    @property
    def opacity(self) -> float:
        '''Gets the object's opacity. The value should be between 0 and 1. Value of 0 means that object is fully visible, value of 1 means the object is fully opaque.'''
        ...
    
    @opacity.setter
    def opacity(self, value : float):
        '''Sets the object's opacity. The value should be between 0 and 1. Value of 0 means that object is fully visible, value of 1 means the object is fully opaque.'''
        ...
    
    @property
    def width(self) -> float:
        '''Gets the width of this :py:class:`aspose.psd.Pen`, in units of the Graphics object used for drawing.'''
        ...
    
    @width.setter
    def width(self, value : float):
        '''Sets the width of this :py:class:`aspose.psd.Pen`, in units of the Graphics object used for drawing.'''
        ...
    
    @property
    def start_cap(self) -> aspose.psd.LineCap:
        ...
    
    @start_cap.setter
    def start_cap(self, value : aspose.psd.LineCap):
        ...
    
    @property
    def end_cap(self) -> aspose.psd.LineCap:
        ...
    
    @end_cap.setter
    def end_cap(self, value : aspose.psd.LineCap):
        ...
    
    @property
    def dash_cap(self) -> aspose.psd.DashCap:
        ...
    
    @dash_cap.setter
    def dash_cap(self, value : aspose.psd.DashCap):
        ...
    
    @property
    def line_join(self) -> aspose.psd.LineJoin:
        ...
    
    @line_join.setter
    def line_join(self, value : aspose.psd.LineJoin):
        ...
    
    @property
    def custom_start_cap(self) -> aspose.psd.CustomLineCap:
        ...
    
    @custom_start_cap.setter
    def custom_start_cap(self, value : aspose.psd.CustomLineCap):
        ...
    
    @property
    def custom_end_cap(self) -> aspose.psd.CustomLineCap:
        ...
    
    @custom_end_cap.setter
    def custom_end_cap(self, value : aspose.psd.CustomLineCap):
        ...
    
    @property
    def miter_limit(self) -> float:
        ...
    
    @miter_limit.setter
    def miter_limit(self, value : float):
        ...
    
    @property
    def alignment(self) -> aspose.psd.PenAlignment:
        '''Gets the alignment for this :py:class:`aspose.psd.Pen`.'''
        ...
    
    @alignment.setter
    def alignment(self, value : aspose.psd.PenAlignment):
        '''Sets the alignment for this :py:class:`aspose.psd.Pen`.'''
        ...
    
    @property
    def transform(self) -> aspose.psd.Matrix:
        '''Gets a copy of the geometric transformation for this :py:class:`aspose.psd.Pen`.'''
        ...
    
    @transform.setter
    def transform(self, value : aspose.psd.Matrix):
        '''Sets a copy of the geometric transformation for this :py:class:`aspose.psd.Pen`.'''
        ...
    
    @property
    def pen_type(self) -> aspose.psd.PenType:
        ...
    
    @property
    def color(self) -> aspose.psd.Color:
        '''Gets the color of this :py:class:`aspose.psd.Pen`.'''
        ...
    
    @color.setter
    def color(self, value : aspose.psd.Color):
        '''Sets the color of this :py:class:`aspose.psd.Pen`.'''
        ...
    
    @property
    def brush(self) -> aspose.psd.Brush:
        '''Gets the :py:attr:`aspose.psd.Pen.brush` that determines attributes of this :py:class:`aspose.psd.Pen`.'''
        ...
    
    @brush.setter
    def brush(self, value : aspose.psd.Brush):
        '''Sets the :py:attr:`aspose.psd.Pen.brush` that determines attributes of this :py:class:`aspose.psd.Pen`.'''
        ...
    
    @property
    def dash_style(self) -> aspose.psd.DashStyle:
        ...
    
    @dash_style.setter
    def dash_style(self, value : aspose.psd.DashStyle):
        ...
    
    @property
    def dash_offset(self) -> float:
        ...
    
    @dash_offset.setter
    def dash_offset(self, value : float):
        ...
    
    @property
    def dash_pattern(self) -> List[float]:
        ...
    
    @dash_pattern.setter
    def dash_pattern(self, value : List[float]):
        ...
    
    @property
    def compound_array(self) -> List[float]:
        ...
    
    @compound_array.setter
    def compound_array(self, value : List[float]):
        ...
    
    ...

class PixelDataFormat:
    '''The pixel data format. This is an immutable object.'''
    
    @overload
    @staticmethod
    def get_grayscale_alpha(bits_per_sample : int) -> aspose.psd.PixelDataFormat:
        '''Gets GrayscaleAlpha color with a specified number of bits per sample.
        
        :param bits_per_sample: The number of bits per sample.
        :returns: The GrayscaleAlpha color.'''
        ...
    
    @overload
    @staticmethod
    def get_grayscale_alpha(bits_per_sample : intalpha_channel_bits : int) -> aspose.psd.PixelDataFormat:
        '''Gets GrayscaleAlpha color with a specified number of bits per sample.
        
        :param bits_per_sample: The number of bits per sample.
        :param alpha_channel_bits: The number of bits per sample in the alpha channel.
        :returns: The GrayscaleAlpha color.'''
        ...
    
    @overload
    @staticmethod
    def get_rgb(bits_per_sample : int) -> aspose.psd.PixelDataFormat:
        '''Gets RGB color with a specified number of bits per sample.
        
        :param bits_per_sample: The number of bits per sample.
        :returns: The RGB color.'''
        ...
    
    @overload
    @staticmethod
    def get_rgb(bits_per_red_channel : intbits_per_green_channel : int, bits_per_blue_channel : int) -> aspose.psd.PixelDataFormat:
        '''Gets RGB color with a specified number of bits per sample.
        
        :param bits_per_red_channel: The number of bits per Red channel.
        :param bits_per_green_channel: The number of bits per Green channel.
        :param bits_per_blue_channel: The number of bits per Blue channel.
        :returns: The RGB color.'''
        ...
    
    @overload
    @staticmethod
    def get_rgba(bits_per_sample : int) -> aspose.psd.PixelDataFormat:
        '''Gets RGBA color with a specified number of bits per sample.
        
        :param bits_per_sample: The number of bits per sample.
        :returns: The RGBA color.'''
        ...
    
    @overload
    @staticmethod
    def get_rgba(bits_per_red_channel : intbits_per_green_channel : int, bits_per_blue_channel : int, bits_per_alpha_channel : int) -> aspose.psd.PixelDataFormat:
        '''Gets RGBA color with a specified number of bits per sample.
        
        :param bits_per_red_channel: The number of bits per Red channel.
        :param bits_per_green_channel: The number of bits per Green channel.
        :param bits_per_blue_channel: The number of bits per Blue channel.
        :param bits_per_alpha_channel: The number of bits per Alpha channel.
        :returns: The RGBA color.'''
        ...
    
    @overload
    @staticmethod
    def get_y_cb_cr(bits_per_sample : int) -> aspose.psd.PixelDataFormat:
        '''Gets YCbCr color with a specified number of bits per sample.
        
        :param bits_per_sample: The number of bits per sample.
        :returns: The YCbCr color.'''
        ...
    
    @overload
    @staticmethod
    def get_y_cb_cr(bits_per_y : intbits_per_cb : int, bits_per_cr : int) -> aspose.psd.PixelDataFormat:
        '''Gets YCbCr color with a specified number of bits per sample.
        
        :param bits_per_y: The number of bits per Y channel.
        :param bits_per_cb: The number of bits per Cb channel.
        :param bits_per_cr: The number of bits per Cr channel.
        :returns: The YCbCr color.'''
        ...
    
    @overload
    @staticmethod
    def get_cmyk(bits_per_sample : int) -> aspose.psd.PixelDataFormat:
        '''Gets CMYK color with a specified number of bits per sample.
        
        :param bits_per_sample: The number of bits per sample.
        :returns: The CMYK color.'''
        ...
    
    @overload
    @staticmethod
    def get_cmyk(bits_per_cyan_channel : intbits_per_magenta_channel : int, bits_per_yellow_channel : int, bits_per_key_channel : int) -> aspose.psd.PixelDataFormat:
        '''Gets CMYK color with a specified number of bits per sample.
        
        :param bits_per_cyan_channel: The number of bits per Cyan channel.
        :param bits_per_magenta_channel: The number of bits per Magenta channel.
        :param bits_per_yellow_channel: The number of bits per Yellow channel.
        :param bits_per_key_channel: The number of bits per Key channel.
        :returns: The CMYK color.'''
        ...
    
    @staticmethod
    def get_grayscale(bits_per_sample : int) -> aspose.psd.PixelDataFormat:
        '''Gets Grayscale color with a specified number of bits per sample.
        
        :param bits_per_sample: The number of bits per sample.
        :returns: The Grayscale color.'''
        ...
    
    @staticmethod
    def get_rgb_indexed(bits_per_sample : int) -> aspose.psd.PixelDataFormat:
        '''Gets BGRA indexed color with a specified number of bits per sample.
        
        :param bits_per_sample: The number of bits per sample.
        :returns: The BGRA color.'''
        ...
    
    @staticmethod
    def get_bgra(bits_per_sample : int) -> aspose.psd.PixelDataFormat:
        '''Gets BGRA color with a specified number of bits per sample.
        
        :param bits_per_sample: The number of bits per sample.
        :returns: The BGRA color.'''
        ...
    
    @staticmethod
    def get_bgr(bits_per_sample : int) -> aspose.psd.PixelDataFormat:
        '''Gets BGR color with a specified number of bits per sample.
        
        :param bits_per_sample: The number of bits per sample.
        :returns: The BGR color.'''
        ...
    
    @staticmethod
    def get_cmyka(bits_per_cyan_channel : intbits_per_magenta_channel : int, bits_per_yellow_channel : int, bits_per_key_channel : int, bits_per_alpha_channel : int) -> aspose.psd.PixelDataFormat:
        '''Gets CMYKA color with a specified number of bits per sample.
        
        :param bits_per_cyan_channel: The number of bits per Cyan channel.
        :param bits_per_magenta_channel: The number of bits per Magenta channel.
        :param bits_per_yellow_channel: The number of bits per Yellow channel.
        :param bits_per_key_channel: The number of bits per Key channel.
        :param bits_per_alpha_channel: The number of bits per Alpha channel.
        :returns: The CMYK color.'''
        ...
    
    @staticmethod
    def get_ycck(bits_per_sample : int) -> aspose.psd.PixelDataFormat:
        '''Gets YCCK color with a specified number of bits per sample.
        
        :param bits_per_sample: The number of bits per sample.
        :returns: The YCCK color.'''
        ...
    
    @staticmethod
    def get_cie_lab(bits_per_l : intbits_per_a : int, bits_per_b : int) -> aspose.psd.PixelDataFormat:
        '''Gets CIE Lab color with a specified number of bits per sample.
        
        :param bits_per_l: The number of bits per L channel.
        :param bits_per_a: The number of bits per A channel.
        :param bits_per_b: The number of bits per B channel.
        :returns: The CIE Lab color.'''
        ...
    
    @classmethod
    @property
    def rgb_32_bpp(cls) -> aspose.psd.PixelDataFormat:
        ...
    
    @classmethod
    @property
    def cmyk(cls) -> aspose.psd.PixelDataFormat:
        '''Gets the :py:class:`aspose.psd.PixelDataFormat` defined for 32 bits per pixel with 8 bits for each of the cyan, magenta, yellow and black.'''
        ...
    
    @classmethod
    @property
    def cmyka(cls) -> aspose.psd.PixelDataFormat:
        '''Gets the acmyk.'''
        ...
    
    @classmethod
    @property
    def rgb_24_bpp(cls) -> aspose.psd.PixelDataFormat:
        ...
    
    @classmethod
    @property
    def rgb_16_bpp_555(cls) -> aspose.psd.PixelDataFormat:
        ...
    
    @classmethod
    @property
    def rgb_16_bpp_565(cls) -> aspose.psd.PixelDataFormat:
        ...
    
    @classmethod
    @property
    def rgb_indexed_8_bpp(cls) -> aspose.psd.PixelDataFormat:
        ...
    
    @classmethod
    @property
    def rgb_indexed_4_bpp(cls) -> aspose.psd.PixelDataFormat:
        ...
    
    @classmethod
    @property
    def rgb_indexed_2_bpp(cls) -> aspose.psd.PixelDataFormat:
        ...
    
    @classmethod
    @property
    def rgb_indexed_1_bpp(cls) -> aspose.psd.PixelDataFormat:
        ...
    
    @classmethod
    @property
    def y_cb_cr(cls) -> aspose.psd.PixelDataFormat:
        ...
    
    @classmethod
    @property
    def grayscale(cls) -> aspose.psd.PixelDataFormat:
        '''Gets the :py:class:`aspose.psd.PixelDataFormat` defined for 8 bits per pixel with 8 bits representing grayscale intensity in the 0-255 interval.'''
        ...
    
    @classmethod
    @property
    def ycck(cls) -> aspose.psd.PixelDataFormat:
        '''Gets the :py:class:`aspose.psd.PixelDataFormat` defined for 32 bits per pixel with 8 bits for each of the luma, blue-difference, red-difference and black chroma components.'''
        ...
    
    @classmethod
    @property
    def rgba_32_bpp(cls) -> aspose.psd.PixelDataFormat:
        ...
    
    @classmethod
    @property
    def rgba_64_bpp(cls) -> aspose.psd.PixelDataFormat:
        ...
    
    @classmethod
    @property
    def rgb_24_bpp_png(cls) -> aspose.psd.PixelDataFormat:
        ...
    
    @classmethod
    @property
    def grayscale_alpha(cls) -> aspose.psd.PixelDataFormat:
        ...
    
    @property
    def pixel_format(self) -> aspose.psd.PixelFormat:
        ...
    
    @property
    def bits_per_pixel(self) -> int:
        ...
    
    @property
    def channels_count(self) -> int:
        ...
    
    @property
    def channel_bits(self) -> List[int]:
        ...
    
    @property
    def caption(self) -> str:
        '''Gets the pixel data format caption.'''
        ...
    
    ...

class PixelsData:
    '''The class to store image pixels data and its bounds.'''
    
    @property
    def bounds(self) -> aspose.psd.Rectangle:
        '''Gets the bounds of pixels data.'''
        ...
    
    @bounds.setter
    def bounds(self, value : aspose.psd.Rectangle):
        '''Sets the bounds of pixels data.'''
        ...
    
    @property
    def pixels(self) -> List[int]:
        '''Gets the pixels data.'''
        ...
    
    @pixels.setter
    def pixels(self, value : List[int]):
        '''Sets the pixels data.'''
        ...
    
    ...

class PluginLicenseException:
    '''Exception for Plugin License'''
    
    ...

class Point:
    '''Represents an ordered pair of integer x- and y-coordinates that defines a point in a two-dimensional plane.'''
    
    @overload
    def offset(self, point : aspose.psd.Point):
        '''Translates this :py:class:`aspose.psd.Point` by the specified :py:class:`aspose.psd.Point`.
        
        :param point: The :py:class:`aspose.psd.Point` used to offset this :py:class:`aspose.psd.Point`.'''
        ...
    
    @overload
    def offset(self, dx : int, dy : int):
        '''Translates this :py:class:`aspose.psd.Point` by the specified amount.
        
        :param dx: The amount to offset the x-coordinate.
        :param dy: The amount to offset the y-coordinate.'''
        ...
    
    @staticmethod
    def add(point : aspose.psd.Pointsize : aspose.psd.Size) -> aspose.psd.Point:
        '''Adds the specified :py:class:`aspose.psd.Size` to the specified :py:class:`aspose.psd.Point`.
        
        :param point: The :py:class:`aspose.psd.Point` to add to.
        :param size: The :py:class:`aspose.psd.Size` to add to the ``point``.
        :returns: The :py:class:`aspose.psd.Point` that is the result of the addition operation.'''
        ...
    
    @staticmethod
    def subtract(point : aspose.psd.Pointsize : aspose.psd.Size) -> aspose.psd.Point:
        '''Returns the result of subtracting specified :py:class:`aspose.psd.Size` from the specified :py:class:`aspose.psd.Point`.
        
        :param point: The :py:class:`aspose.psd.Point` to be subtracted from.
        :param size: The :py:class:`aspose.psd.Size` to subtract from the ``point``.
        :returns: The :py:class:`aspose.psd.Point` that is the result of the subtraction operation.'''
        ...
    
    @staticmethod
    def ceiling(point : aspose.psd.PointF) -> aspose.psd.Point:
        '''Converts the specified :py:class:`aspose.psd.PointF` to a :py:class:`aspose.psd.Point` by rounding the values of the :py:class:`aspose.psd.PointF` to the next higher integer values.
        
        :param point: The :py:class:`aspose.psd.PointF` to convert.
        :returns: The :py:class:`aspose.psd.Point` this method converts to.'''
        ...
    
    @staticmethod
    def round(point : aspose.psd.PointF) -> aspose.psd.Point:
        '''Converts the specified :py:class:`aspose.psd.PointF` to a :py:class:`aspose.psd.Point` object by rounding the :py:class:`aspose.psd.Point` values to the nearest integer.
        
        :param point: The :py:class:`aspose.psd.PointF` to convert.
        :returns: The :py:class:`aspose.psd.Point` this method converts to.'''
        ...
    
    @staticmethod
    def truncate(point : aspose.psd.PointF) -> aspose.psd.Point:
        '''Converts the specified :py:class:`aspose.psd.PointF` to a :py:class:`aspose.psd.Point` by truncating the values of the :py:class:`aspose.psd.Point`.
        
        :param point: The :py:class:`aspose.psd.PointF` to convert.
        :returns: The :py:class:`aspose.psd.Point` this method converts to.'''
        ...
    
    @classmethod
    @property
    def empty(cls) -> aspose.psd.Point:
        '''Gets a new instance of the :py:class:`aspose.psd.Point` structure that has :py:attr:`aspose.psd.Point.x` and :py:attr:`aspose.psd.Point.y` values set to zero.'''
        ...
    
    @property
    def is_empty(self) -> bool:
        ...
    
    @property
    def x(self) -> int:
        '''Gets the x-coordinate of this :py:class:`aspose.psd.Point`.'''
        ...
    
    @x.setter
    def x(self, value : int):
        '''Sets the x-coordinate of this :py:class:`aspose.psd.Point`.'''
        ...
    
    @property
    def y(self) -> int:
        '''Gets the y-coordinate of this :py:class:`aspose.psd.Point`.'''
        ...
    
    @y.setter
    def y(self, value : int):
        '''Sets the y-coordinate of this :py:class:`aspose.psd.Point`.'''
        ...
    
    ...

class PointF:
    '''Represents an ordered pair of floating-point x- and y-coordinates that defines a point in a two-dimensional plane.'''
    
    @overload
    @staticmethod
    def add(point : aspose.psd.PointFsize : aspose.psd.Size) -> aspose.psd.PointF:
        '''Translates a given :py:class:`aspose.psd.PointF` by the specified :py:class:`aspose.psd.Size`.
        
        :param point: The :py:class:`aspose.psd.PointF` to translate.
        :param size: The :py:class:`aspose.psd.Size` that specifies the numbers to add to the coordinates of ``point``.
        :returns: The translated :py:class:`aspose.psd.PointF`.'''
        ...
    
    @overload
    @staticmethod
    def add(point : aspose.psd.PointFsize : aspose.psd.SizeF) -> aspose.psd.PointF:
        '''Translates a given :py:class:`aspose.psd.PointF` by a specified :py:class:`aspose.psd.SizeF`.
        
        :param point: The :py:class:`aspose.psd.PointF` to translate.
        :param size: The :py:class:`aspose.psd.SizeF` that specifies the numbers to add to the coordinates of ``point``.
        :returns: The translated :py:class:`aspose.psd.PointF`.'''
        ...
    
    @overload
    @staticmethod
    def subtract(point : aspose.psd.PointFsize : aspose.psd.Size) -> aspose.psd.PointF:
        '''Translates a :py:class:`aspose.psd.PointF` by the negative of a specified size.
        
        :param point: The :py:class:`aspose.psd.PointF` to translate.
        :param size: The :py:class:`aspose.psd.Size` that specifies the numbers to subtract from the coordinates of ``point``.
        :returns: The translated :py:class:`aspose.psd.PointF`.'''
        ...
    
    @overload
    @staticmethod
    def subtract(point : aspose.psd.PointFsize : aspose.psd.SizeF) -> aspose.psd.PointF:
        '''Translates a :py:class:`aspose.psd.PointF` by the negative of a specified size.
        
        :param point: The :py:class:`aspose.psd.PointF` to translate.
        :param size: The :py:class:`aspose.psd.SizeF` that specifies the numbers to subtract from the coordinates of ``point``.
        :returns: The translated :py:class:`aspose.psd.PointF`.'''
        ...
    
    @classmethod
    @property
    def empty(cls) -> aspose.psd.PointF:
        '''Gets a new instance of the :py:class:`aspose.psd.PointF` structure that has :py:attr:`aspose.psd.PointF.x` and :py:attr:`aspose.psd.PointF.y` values set to zero.'''
        ...
    
    @property
    def is_empty(self) -> bool:
        ...
    
    @property
    def x(self) -> float:
        '''Gets the x-coordinate of this :py:class:`aspose.psd.PointF`.'''
        ...
    
    @x.setter
    def x(self, value : float):
        '''Sets the x-coordinate of this :py:class:`aspose.psd.PointF`.'''
        ...
    
    @property
    def y(self) -> float:
        '''Gets the y-coordinate of this :py:class:`aspose.psd.PointF`.'''
        ...
    
    @y.setter
    def y(self, value : float):
        '''Sets the y-coordinate of this :py:class:`aspose.psd.PointF`.'''
        ...
    
    ...

class RasterCachedImage(RasterImage):
    '''Represents a raster image supporting raster graphics operations. This image caches pixel data when required.'''
    
    @overload
    def save(self, stream : io.RawIOBase, options_base : aspose.psd.ImageOptionsBase, bounds_rectangle : aspose.psd.Rectangle):
        '''Saves the image's data to the specified stream in the specified file format according to save options.
        
        :param stream: The stream to save the image's data to.
        :param options_base: The save options.
        :param bounds_rectangle: The destination image bounds rectangle. Set the empty rectangle for use source bounds.'''
        ...
    
    @overload
    def save(self):
        '''Saves the image data to the underlying stream.'''
        ...
    
    @overload
    def save(self, file_path : str, options : aspose.psd.ImageOptionsBase):
        '''Saves the object's data to the specified file location in the specified file format according to save options.
        
        :param file_path: The file path.
        :param options: The options.'''
        ...
    
    @overload
    def save(self, file_path : str, options : aspose.psd.ImageOptionsBase, bounds_rectangle : aspose.psd.Rectangle):
        '''Saves the object's data to the specified file location in the specified file format according to save options.
        
        :param file_path: The file path.
        :param options: The options.
        :param bounds_rectangle: The destination image bounds rectangle. Set the empty rectangle for use sourse bounds.'''
        ...
    
    @overload
    def save(self, stream : io.RawIOBase, options_base : aspose.psd.ImageOptionsBase):
        '''Saves the image's data to the specified stream in the specified file format according to save options.
        
        :param stream: The stream to save the image's data to.
        :param options_base: The save options.'''
        ...
    
    @overload
    def save(self, stream : io.RawIOBase):
        '''Saves the object's data to the specified stream.
        
        :param stream: The stream to save the object's data to.'''
        ...
    
    @overload
    def save(self, file_path : str):
        '''Saves the object's data to the specified file location.
        
        :param file_path: The file path to save the object's data to.'''
        ...
    
    @overload
    def save(self, file_path : str, over_write : bool):
        '''Saves the object's data to the specified file location.
        
        :param file_path: The file path to save the object's data to.
        :param over_write: if set to ``true`` over write the file contents, otherwise append will occur.'''
        ...
    
    @overload
    @staticmethod
    def can_load(file_path : str) -> bool:
        '''Determines whether image can be loaded from the specified file path.
        
        :param file_path: The file path.
        :returns: ``true`` if image can be loaded from the specified file; otherwise, ``false``.'''
        ...
    
    @overload
    @staticmethod
    def can_load(file_path : strload_options : aspose.psd.LoadOptions) -> bool:
        '''Determines whether image can be loaded from the specified file path and optionally using the specified open options.
        
        :param file_path: The file path.
        :param load_options: The load options.
        :returns: ``true`` if image can be loaded from the specified file; otherwise, ``false``.'''
        ...
    
    @overload
    @staticmethod
    def can_load(stream : io.RawIOBase) -> bool:
        '''Determines whether image can be loaded from the specified stream.
        
        :param stream: The stream to load from.
        :returns: ``true`` if image can be loaded from the specified stream; otherwise, ``false``.'''
        ...
    
    @overload
    @staticmethod
    def can_load(stream : io.RawIOBaseload_options : aspose.psd.LoadOptions) -> bool:
        '''Determines whether image can be loaded from the specified stream and optionally using the specified ``loadOptions``.
        
        :param stream: The stream to load from.
        :param load_options: The load options.
        :returns: ``true`` if image can be loaded from the specified stream; otherwise, ``false``.'''
        ...
    
    @overload
    @staticmethod
    def get_file_format(file_path : str) -> aspose.psd.FileFormat:
        '''Gets the file format.
        
        :param file_path: The file path.
        :returns: The determined file format.'''
        ...
    
    @overload
    @staticmethod
    def get_file_format(stream : io.RawIOBase) -> aspose.psd.FileFormat:
        '''Gets the file format.
        
        :param stream: The stream.
        :returns: The determined file format.'''
        ...
    
    @overload
    @staticmethod
    def get_fitting_rectangle(rectangle : aspose.psd.Rectanglewidth : int, height : int) -> aspose.psd.Rectangle:
        '''Gets rectangle which fits the current image.
        
        :param rectangle: The rectangle to get fitting rectangle for.
        :param width: The object width.
        :param height: The object height.
        :returns: The fitting rectangle or exception if no fitting rectangle can be found.'''
        ...
    
    @overload
    @staticmethod
    def get_fitting_rectangle(rectangle : aspose.psd.Rectanglepixels : List[int], width : int, height : int) -> aspose.psd.Rectangle:
        '''Gets rectangle which fits the current image.
        
        :param rectangle: The rectangle to get fitting rectangle for.
        :param pixels: The 32-bit ARGB pixels.
        :param width: The object width.
        :param height: The object height.
        :returns: The fitting rectangle or exception if no fitting rectangle can be found.'''
        ...
    
    @overload
    @staticmethod
    def load(file_path : strload_options : aspose.psd.LoadOptions) -> aspose.psd.Image:
        '''Loads a new image from the specified file.
        
        :param file_path: The file path to load image from.
        :param load_options: The load options.
        :returns: The loaded image.'''
        ...
    
    @overload
    @staticmethod
    def load(file_path : str) -> aspose.psd.Image:
        '''Loads a new image from the specified file.
        
        :param file_path: The file path to load image from.
        :returns: The loaded image.'''
        ...
    
    @overload
    @staticmethod
    def load(stream : io.RawIOBaseload_options : aspose.psd.LoadOptions) -> aspose.psd.Image:
        '''Loads a new image from the specified stream.
        
        :param stream: The stream to load image from.
        :param load_options: The load options.
        :returns: The loaded image.'''
        ...
    
    @overload
    @staticmethod
    def load(stream : io.RawIOBase) -> aspose.psd.Image:
        '''Loads a new image from the specified stream.
        
        :param stream: The stream to load image from.
        :returns: The loaded image.'''
        ...
    
    @overload
    def resize(self, new_width : int, new_height : int, resize_type : aspose.psd.ResizeType):
        '''Resizes the image.
        
        :param new_width: The new width.
        :param new_height: The new height.
        :param resize_type: The resize type.'''
        ...
    
    @overload
    def resize(self, new_width : int, new_height : int, settings : aspose.psd.ImageResizeSettings):
        '''Resizes the image.
        
        :param new_width: The new width.
        :param new_height: The new height.
        :param settings: The resize settings.'''
        ...
    
    @overload
    def resize(self, new_width : int, new_height : int):
        '''Resizes the image. The default :py:attr:`aspose.psd.ResizeType.NEAREST_NEIGHBOUR_RESAMPLE` is used.
        
        :param new_width: The new width.
        :param new_height: The new height.'''
        ...
    
    @overload
    def resize_width_proportionally(self, new_width : int):
        '''Resizes the width proportionally. The default :py:attr:`aspose.psd.ResizeType.NEAREST_NEIGHBOUR_RESAMPLE` is used.
        
        :param new_width: The new width.'''
        ...
    
    @overload
    def resize_width_proportionally(self, new_width : int, resize_type : aspose.psd.ResizeType):
        '''Resizes the width proportionally.
        
        :param new_width: The new width.
        :param resize_type: Type of the resize.'''
        ...
    
    @overload
    def resize_width_proportionally(self, new_width : int, settings : aspose.psd.ImageResizeSettings):
        '''Resizes the width proportionally.
        
        :param new_width: The new width.
        :param settings: The image resize settings.'''
        ...
    
    @overload
    def resize_height_proportionally(self, new_height : int):
        '''Resizes the height proportionally.
        
        :param new_height: The new height.'''
        ...
    
    @overload
    def resize_height_proportionally(self, new_height : int, resize_type : aspose.psd.ResizeType):
        '''Resizes the height proportionally.
        
        :param new_height: The new height.
        :param resize_type: Type of the resize.'''
        ...
    
    @overload
    def resize_height_proportionally(self, new_height : int, settings : aspose.psd.ImageResizeSettings):
        '''Resizes the height proportionally.
        
        :param new_height: The new height.
        :param settings: The image resize settings.'''
        ...
    
    @overload
    def dither(self, dithering_method : aspose.psd.DitheringMethod, bits_count : int, custom_palette : aspose.psd.IColorPalette):
        '''Performs dithering on the current image.
        
        :param dithering_method: The dithering method.
        :param bits_count: The final bits count for dithering.
        :param custom_palette: The custom palette for dithering.'''
        ...
    
    @overload
    def dither(self, dithering_method : aspose.psd.DitheringMethod, bits_count : int):
        '''Performs dithering on the current image.
        
        :param dithering_method: The dithering method.
        :param bits_count: The final bits count for dithering.'''
        ...
    
    @overload
    def get_default_raw_data(self, rectangle : aspose.psd.Rectangle, partial_raw_data_loader : aspose.psd.IPartialRawDataLoader, raw_data_settings : aspose.psd.RawDataSettings):
        '''Gets the default raw data array using partial pixel loader.
        
        :param rectangle: The rectangle to get pixels for.
        :param partial_raw_data_loader: The partial raw data loader.
        :param raw_data_settings: The raw data settings.'''
        ...
    
    @overload
    def get_default_raw_data(self, rectangle : aspose.psd.Rectangle, raw_data_settings : aspose.psd.RawDataSettings) -> bytes:
        '''Gets the default raw data array.
        
        :param rectangle: The rectangle to get raw data for.
        :param raw_data_settings: The raw data settings.
        :returns: The default raw data array.'''
        ...
    
    @overload
    def load_raw_data(self, rectangle : aspose.psd.Rectangle, raw_data_settings : aspose.psd.RawDataSettings, raw_data_loader : aspose.psd.IPartialRawDataLoader):
        '''Loads raw data.
        
        :param rectangle: The rectangle to load raw data from.
        :param raw_data_settings: The raw data settings to use for loaded data. Note if data is not in the format specified then data conversion will be performed.
        :param raw_data_loader: The raw data loader.'''
        ...
    
    @overload
    def load_raw_data(self, rectangle : aspose.psd.Rectangle, dest_image_bounds : aspose.psd.Rectangle, raw_data_settings : aspose.psd.RawDataSettings, raw_data_loader : aspose.psd.IPartialRawDataLoader):
        '''Loads raw data.
        
        :param rectangle: The rectangle to load raw data from.
        :param dest_image_bounds: The dest image bounds.
        :param raw_data_settings: The raw data settings to use for loaded data. Note if data is not in the format specified then data conversion will be performed.
        :param raw_data_loader: The raw data loader.'''
        ...
    
    @overload
    def crop(self, rectangle : aspose.psd.Rectangle):
        '''Cropping the image.
        
        :param rectangle: The rectangle.'''
        ...
    
    @overload
    def crop(self, left_shift : int, right_shift : int, top_shift : int, bottom_shift : int):
        ...
    
    @overload
    def binarize_bradley(self, brightness_difference : float, window_size : int):
        '''Binarization of an image using Bradley's adaptive thresholding algorithm using the integral image thresholding
        
        :param brightness_difference: The brightness difference between pixel and the average of an s x s window of pixels centered around this pixel.
        :param window_size: The size of s x s window of pixels centered around this pixel'''
        ...
    
    @overload
    def binarize_bradley(self, brightness_difference : float):
        '''Binarization of an image using Bradley's adaptive thresholding algorithm using the integral image thresholding
        
        :param brightness_difference: The brightness difference between pixel and the average of an s x s window of pixels centered around this pixel.'''
        ...
    
    @overload
    def adjust_gamma(self, gamma_red : float, gamma_green : float, gamma_blue : float):
        '''Gamma-correction of an image.
        
        :param gamma_red: Gamma for red channel coefficient
        :param gamma_green: Gamma for green channel coefficient
        :param gamma_blue: Gamma for blue channel coefficient'''
        ...
    
    @overload
    def adjust_gamma(self, gamma : float):
        '''Gamma-correction of an image.
        
        :param gamma: Gamma for red, green and blue channels coefficient'''
        ...
    
    @overload
    def rotate(self, angle : float, resize_proportionally : bool, background_color : aspose.psd.Color):
        '''Rotate image around the center.
        
        :param angle: The rotate angle in degrees. Positive values will rotate clockwise.
        :param resize_proportionally: if set to ``true`` you will have your image size changed according to rotated rectangle (corner points) projections in other case that leaves dimensions untouched and only internal image contents are rotated.
        :param background_color: Color of the background.'''
        ...
    
    @overload
    def rotate(self, angle : float):
        ...
    
    @overload
    def normalize_angle(self):
        ...
    
    @overload
    def normalize_angle(self, resize_proportionally : bool, background_color : aspose.psd.Color):
        ...
    
    @overload
    def replace_color(self, old_color : aspose.psd.Color, old_color_diff : byte, new_color : aspose.psd.Color):
        ...
    
    @overload
    def replace_color(self, old_color_argb : int, old_color_diff : byte, new_color_argb : int):
        ...
    
    @overload
    def replace_non_transparent_colors(self, new_color : aspose.psd.Color):
        ...
    
    @overload
    def replace_non_transparent_colors(self, new_color_argb : int):
        ...
    
    def cache_data(self):
        '''Caches the data and ensures no additional data loading will be performed from the underlying :py:attr:`aspose.psd.DataStreamSupporter.data_stream_container`.'''
        ...
    
    @staticmethod
    def create(image_options : aspose.psd.ImageOptionsBasewidth : int, height : int) -> aspose.psd.Image:
        '''Creates a new image using the specified create options.
        
        :param image_options: The image options.
        :param width: The width.
        :param height: The height.
        :returns: The newly created image.'''
        ...
    
    def can_save(self, options : aspose.psd.ImageOptionsBase) -> bool:
        '''Determines whether image can be saved to the specified file format represented by the passed save options.
        
        :param options: The save options to use.
        :returns: ``true`` if image can be saved to the specified file format represented by the passed save options; otherwise, ``false``.'''
        ...
    
    def get_default_options(self, args : List[any]) -> aspose.psd.ImageOptionsBase:
        '''Gets the default options.
        
        :param args: The arguments.
        :returns: Default options'''
        ...
    
    def get_original_options(self) -> aspose.psd.ImageOptionsBase:
        '''Gets the options based on the original file settings.
        This can be helpful to keep bit-depth and other parameters of the original image unchanged.
        For example, if we load a black-white PNG image with 1 bit per pixel and then save it using the
        :py:func:`aspose.psd.DataStreamSupporter.save` method, the output PNG image with 8-bit per pixel will be produced.
        To avoid it and save PNG image with 1-bit per pixel, use this method to get corresponding saving options and pass them
        to the :py:func:`aspose.psd.Image.save` method as the second parameter.
        
        :returns: The options based on the original file settings.'''
        ...
    
    def rotate_flip(self, rotate_flip_type : aspose.psd.RotateFlipType):
        '''Rotates, flips, or rotates and flips the image.
        
        :param rotate_flip_type: The rotate flip type.'''
        ...
    
    def set_palette(self, palette : aspose.psd.IColorPalette, update_colors : bool):
        '''Sets the image palette.
        
        :param palette: The palette to set.
        :param update_colors: if set to ``true`` colors will be updated according to the new palette; otherwise color indexes remain unchanged. Note that unchanged indexes may crash the image on loading if some indexes have no corresponding palette entries.'''
        ...
    
    @staticmethod
    def get_proportional_width(width : intheight : int, new_height : int) -> int:
        '''Gets a proportional width.
        
        :param width: The width.
        :param height: The height.
        :param new_height: The new height.
        :returns: The proportional width.'''
        ...
    
    @staticmethod
    def get_proportional_height(width : intheight : int, new_width : int) -> int:
        '''Gets a proportional height.
        
        :param width: The width.
        :param height: The height.
        :param new_width: The new width.
        :returns: The proportional height.'''
        ...
    
    def get_modify_date(self, use_default : bool) -> DateTime:
        '''Gets the date and time the resource image was last modified.
        
        :param use_default: if set to ``true`` uses the information from FileInfo as default value.
        :returns: The date and time the resource image was last modified.'''
        ...
    
    def get_default_pixels(self, rectangle : aspose.psd.Rectangle, partial_pixel_loader : aspose.psd.IPartialArgb32PixelLoader):
        '''Gets the default pixels array using partial pixel loader.
        
        :param rectangle: The rectangle to get pixels for.
        :param partial_pixel_loader: The partial pixel loader.'''
        ...
    
    def get_default_argb_32_pixels(self, rectangle : aspose.psd.Rectangle) -> List[int]:
        '''Gets the default 32-bit ARGB pixels array.
        
        :param rectangle: The rectangle to get pixels for.
        :returns: The default pixels array.'''
        ...
    
    def get_argb_32_pixel(self, x : int, y : int) -> int:
        '''Gets an image 32-bit ARGB pixel.
        
        :param x: The pixel x location.
        :param y: The pixel y location.
        :returns: The 32-bit ARGB pixel for the specified location.'''
        ...
    
    def get_pixel(self, x : int, y : int) -> aspose.psd.Color:
        '''Gets an image pixel.
        
        :param x: The pixel x location.
        :param y: The pixel y location.
        :returns: The pixel color for the specified location.'''
        ...
    
    def set_argb_32_pixel(self, x : int, y : int, argb_32_color : int):
        '''Sets an image 32-bit ARGB pixel for the specified position.
        
        :param x: The pixel x location.
        :param y: The pixel y location.
        :param argb_32_color: The 32-bit ARGB pixel for the specified position.'''
        ...
    
    def set_pixel(self, x : int, y : int, color : aspose.psd.Color):
        '''Sets an image pixel for the specified position.
        
        :param x: The pixel x location.
        :param y: The pixel y location.
        :param color: The pixel color for the specified position.'''
        ...
    
    def read_scan_line(self, scan_line_index : int) -> List[aspose.psd.Color]:
        '''Reads the whole scan line by the specified scan line index.
        
        :param scan_line_index: Zero based index of the scan line.
        :returns: The scan line pixel color values array.'''
        ...
    
    def read_argb_32_scan_line(self, scan_line_index : int) -> List[int]:
        '''Reads the whole scan line by the specified scan line index.
        
        :param scan_line_index: Zero based index of the scan line.
        :returns: The scan line 32-bit ARGB color values array.'''
        ...
    
    def write_scan_line(self, scan_line_index : int, pixels : List[aspose.psd.Color]):
        '''Writes the whole scan line to the specified scan line index.
        
        :param scan_line_index: Zero based index of the scan line.
        :param pixels: The pixel colors array to write.'''
        ...
    
    def write_argb_32_scan_line(self, scan_line_index : int, argb_32_pixels : List[int]):
        '''Writes the whole scan line to the specified scan line index.
        
        :param scan_line_index: Zero based index of the scan line.
        :param argb_32_pixels: The 32-bit ARGB colors array to write.'''
        ...
    
    def load_partial_argb_32_pixels(self, rectangle : aspose.psd.Rectangle, partial_pixel_loader : aspose.psd.IPartialArgb32PixelLoader):
        '''Loads 32-bit ARGB pixels partially by packs.
        
        :param rectangle: The desired rectangle.
        :param partial_pixel_loader: The 32-bit ARGB pixel loader.'''
        ...
    
    def load_partial_pixels(self, desired_rectangle : aspose.psd.Rectangle, pixel_loader : aspose.psd.IPartialPixelLoader):
        '''Loads pixels partially by packs.
        
        :param desired_rectangle: The desired rectangle.
        :param pixel_loader: The pixel loader.'''
        ...
    
    def load_argb_32_pixels(self, rectangle : aspose.psd.Rectangle) -> List[int]:
        '''Loads 32-bit ARGB pixels.
        
        :param rectangle: The rectangle to load pixels from.
        :returns: The loaded 32-bit ARGB pixels array.'''
        ...
    
    def load_argb_64_pixels(self, rectangle : aspose.psd.Rectangle) -> List[int]:
        '''Loads 64-bit ARGB pixels.
        
        :param rectangle: The rectangle to load pixels from.
        :returns: The loaded 64-bit ARGB pixels array.'''
        ...
    
    def load_pixels(self, rectangle : aspose.psd.Rectangle) -> List[aspose.psd.Color]:
        '''Loads pixels.
        
        :param rectangle: The rectangle to load pixels from.
        :returns: The loaded pixels array.'''
        ...
    
    def load_cmyk_pixels(self, rectangle : aspose.psd.Rectangle) -> List[aspose.psd.CmykColor]:
        '''Loads pixels in CMYK format.
        This method is deprecated. Please use more effective the :py:func:`aspose.psd.RasterImage.load_cmyk_32_pixels` method.
        
        :param rectangle: The rectangle to load pixels from.
        :returns: The loaded CMYK pixels array.'''
        ...
    
    def load_cmyk_32_pixels(self, rectangle : aspose.psd.Rectangle) -> List[int]:
        '''Loads pixels in CMYK format.
        
        :param rectangle: The rectangle to load pixels from.
        :returns: The loaded CMYK pixels presentes as 32-bit inateger values.'''
        ...
    
    def save_raw_data(self, data : bytes, data_offset : int, rectangle : aspose.psd.Rectangle, raw_data_settings : aspose.psd.RawDataSettings):
        '''Saves the raw data.
        
        :param data: The raw data.
        :param data_offset: The starting raw data offset.
        :param rectangle: The raw data rectangle.
        :param raw_data_settings: The raw data settings the data is in.'''
        ...
    
    def save_argb_32_pixels(self, rectangle : aspose.psd.Rectangle, pixels : List[int]):
        '''Saves the 32-bit ARGB pixels.
        
        :param rectangle: The rectangle to save pixels to.
        :param pixels: The 32-bit ARGB pixels array.'''
        ...
    
    def save_pixels(self, rectangle : aspose.psd.Rectangle, pixels : List[aspose.psd.Color]):
        '''Saves the pixels.
        
        :param rectangle: The rectangle to save pixels to.
        :param pixels: The pixels array.'''
        ...
    
    def to_bitmap(self) -> aspose.pydrawing.Bitmap:
        ...
    
    def save_cmyk_pixels(self, rectangle : aspose.psd.Rectangle, pixels : List[aspose.psd.CmykColor]):
        ...
    
    def save_cmyk_32_pixels(self, rectangle : aspose.psd.Rectangle, pixels : List[int]):
        ...
    
    def set_resolution(self, dpi_x : float, dpi_y : float):
        ...
    
    def binarize_fixed(self, threshold : byte):
        '''Binarization of an image with predefined threshold
        
        :param threshold: Threshold value. If corresponding gray value of a pixel is greater than threshold, a value of 255 will be assigned to it, 0 otherwise.'''
        ...
    
    def binarize_otsu(self):
        '''Binarization of an image with Otsu thresholding'''
        ...
    
    def grayscale(self):
        '''Transformation of an image to its grayscale representation'''
        ...
    
    def adjust_brightness(self, brightness : int):
        '''Adjust of a brightness for image.
        
        :param brightness: Brightness value.'''
        ...
    
    def adjust_contrast(self, contrast : float):
        '''Image contrasting
        
        :param contrast: Contrast value (in range [-100; 100])'''
        ...
    
    def get_skew_angle(self) -> float:
        ...
    
    def filter(self, rectangle : aspose.psd.Rectangle, options : aspose.psd.imagefilters.filteroptions.FilterOptionsBase):
        ...
    
    @property
    def disposed(self) -> bool:
        '''Gets a value indicating whether this instance is disposed.'''
        ...
    
    @property
    def data_stream_container(self) -> aspose.psd.StreamContainer:
        ...
    
    @property
    def is_cached(self) -> bool:
        ...
    
    @property
    def bits_per_pixel(self) -> int:
        ...
    
    @property
    def bounds(self) -> aspose.psd.Rectangle:
        '''Gets the image bounds.'''
        ...
    
    @property
    def container(self) -> aspose.psd.Image:
        '''Gets the :py:class:`aspose.psd.Image` container.'''
        ...
    
    @property
    def height(self) -> int:
        '''Gets the image height.'''
        ...
    
    @property
    def palette(self) -> aspose.psd.IColorPalette:
        '''Gets the color palette. The color palette is not used when pixels are represented directly.'''
        ...
    
    @palette.setter
    def palette(self, value : aspose.psd.IColorPalette):
        '''Sets the color palette. The color palette is not used when pixels are represented directly.'''
        ...
    
    @property
    def use_palette(self) -> bool:
        ...
    
    @property
    def size(self) -> aspose.psd.Size:
        '''Gets the image size.'''
        ...
    
    @property
    def width(self) -> int:
        '''Gets the image width.'''
        ...
    
    @property
    def interrupt_monitor(self) -> aspose.psd.multithreading.InterruptMonitor:
        ...
    
    @interrupt_monitor.setter
    def interrupt_monitor(self, value : aspose.psd.multithreading.InterruptMonitor):
        ...
    
    @property
    def buffer_size_hint(self) -> int:
        ...
    
    @buffer_size_hint.setter
    def buffer_size_hint(self, value : int):
        ...
    
    @property
    def auto_adjust_palette(self) -> bool:
        ...
    
    @auto_adjust_palette.setter
    def auto_adjust_palette(self, value : bool):
        ...
    
    @property
    def has_background_color(self) -> bool:
        ...
    
    @has_background_color.setter
    def has_background_color(self, value : bool):
        ...
    
    @property
    def file_format(self) -> aspose.psd.FileFormat:
        ...
    
    @property
    def background_color(self) -> aspose.psd.Color:
        ...
    
    @background_color.setter
    def background_color(self, value : aspose.psd.Color):
        ...
    
    @property
    def premultiply_components(self) -> bool:
        ...
    
    @premultiply_components.setter
    def premultiply_components(self, value : bool):
        ...
    
    @property
    def use_raw_data(self) -> bool:
        ...
    
    @use_raw_data.setter
    def use_raw_data(self, value : bool):
        ...
    
    @property
    def update_xmp_data(self) -> bool:
        ...
    
    @update_xmp_data.setter
    def update_xmp_data(self, value : bool):
        ...
    
    @property
    def xmp_data(self) -> aspose.psd.xmp.XmpPacketWrapper:
        ...
    
    @xmp_data.setter
    def xmp_data(self, value : aspose.psd.xmp.XmpPacketWrapper):
        ...
    
    @property
    def raw_indexed_color_converter(self) -> aspose.psd.IIndexedColorConverter:
        ...
    
    @raw_indexed_color_converter.setter
    def raw_indexed_color_converter(self, value : aspose.psd.IIndexedColorConverter):
        ...
    
    @property
    def raw_custom_color_converter(self) -> aspose.psd.IColorConverter:
        ...
    
    @raw_custom_color_converter.setter
    def raw_custom_color_converter(self, value : aspose.psd.IColorConverter):
        ...
    
    @property
    def raw_fallback_index(self) -> int:
        ...
    
    @raw_fallback_index.setter
    def raw_fallback_index(self, value : int):
        ...
    
    @property
    def raw_data_settings(self) -> aspose.psd.RawDataSettings:
        ...
    
    @property
    def raw_data_format(self) -> aspose.psd.PixelDataFormat:
        ...
    
    @property
    def raw_line_size(self) -> int:
        ...
    
    @property
    def is_raw_data_available(self) -> bool:
        ...
    
    @property
    def horizontal_resolution(self) -> float:
        ...
    
    @horizontal_resolution.setter
    def horizontal_resolution(self, value : float):
        ...
    
    @property
    def vertical_resolution(self) -> float:
        ...
    
    @vertical_resolution.setter
    def vertical_resolution(self, value : float):
        ...
    
    @property
    def has_transparent_color(self) -> bool:
        ...
    
    @has_transparent_color.setter
    def has_transparent_color(self, value : bool):
        ...
    
    @property
    def has_alpha(self) -> bool:
        ...
    
    @property
    def transparent_color(self) -> aspose.psd.Color:
        ...
    
    @transparent_color.setter
    def transparent_color(self, value : aspose.psd.Color):
        ...
    
    @property
    def image_opacity(self) -> float:
        ...
    
    ...

class RasterImage(Image):
    '''Represents a raster image supporting raster graphics operations.'''
    
    @overload
    def save(self, stream : io.RawIOBase, options_base : aspose.psd.ImageOptionsBase, bounds_rectangle : aspose.psd.Rectangle):
        '''Saves the image's data to the specified stream in the specified file format according to save options.
        
        :param stream: The stream to save the image's data to.
        :param options_base: The save options.
        :param bounds_rectangle: The destination image bounds rectangle. Set the empty rectangle for use source bounds.'''
        ...
    
    @overload
    def save(self):
        '''Saves the image data to the underlying stream.'''
        ...
    
    @overload
    def save(self, file_path : str, options : aspose.psd.ImageOptionsBase):
        '''Saves the object's data to the specified file location in the specified file format according to save options.
        
        :param file_path: The file path.
        :param options: The options.'''
        ...
    
    @overload
    def save(self, file_path : str, options : aspose.psd.ImageOptionsBase, bounds_rectangle : aspose.psd.Rectangle):
        '''Saves the object's data to the specified file location in the specified file format according to save options.
        
        :param file_path: The file path.
        :param options: The options.
        :param bounds_rectangle: The destination image bounds rectangle. Set the empty rectangle for use sourse bounds.'''
        ...
    
    @overload
    def save(self, stream : io.RawIOBase, options_base : aspose.psd.ImageOptionsBase):
        '''Saves the image's data to the specified stream in the specified file format according to save options.
        
        :param stream: The stream to save the image's data to.
        :param options_base: The save options.'''
        ...
    
    @overload
    def save(self, stream : io.RawIOBase):
        '''Saves the object's data to the specified stream.
        
        :param stream: The stream to save the object's data to.'''
        ...
    
    @overload
    def save(self, file_path : str):
        '''Saves the object's data to the specified file location.
        
        :param file_path: The file path to save the object's data to.'''
        ...
    
    @overload
    def save(self, file_path : str, over_write : bool):
        '''Saves the object's data to the specified file location.
        
        :param file_path: The file path to save the object's data to.
        :param over_write: if set to ``true`` over write the file contents, otherwise append will occur.'''
        ...
    
    @overload
    @staticmethod
    def can_load(file_path : str) -> bool:
        '''Determines whether image can be loaded from the specified file path.
        
        :param file_path: The file path.
        :returns: ``true`` if image can be loaded from the specified file; otherwise, ``false``.'''
        ...
    
    @overload
    @staticmethod
    def can_load(file_path : strload_options : aspose.psd.LoadOptions) -> bool:
        '''Determines whether image can be loaded from the specified file path and optionally using the specified open options.
        
        :param file_path: The file path.
        :param load_options: The load options.
        :returns: ``true`` if image can be loaded from the specified file; otherwise, ``false``.'''
        ...
    
    @overload
    @staticmethod
    def can_load(stream : io.RawIOBase) -> bool:
        '''Determines whether image can be loaded from the specified stream.
        
        :param stream: The stream to load from.
        :returns: ``true`` if image can be loaded from the specified stream; otherwise, ``false``.'''
        ...
    
    @overload
    @staticmethod
    def can_load(stream : io.RawIOBaseload_options : aspose.psd.LoadOptions) -> bool:
        '''Determines whether image can be loaded from the specified stream and optionally using the specified ``loadOptions``.
        
        :param stream: The stream to load from.
        :param load_options: The load options.
        :returns: ``true`` if image can be loaded from the specified stream; otherwise, ``false``.'''
        ...
    
    @overload
    @staticmethod
    def get_file_format(file_path : str) -> aspose.psd.FileFormat:
        '''Gets the file format.
        
        :param file_path: The file path.
        :returns: The determined file format.'''
        ...
    
    @overload
    @staticmethod
    def get_file_format(stream : io.RawIOBase) -> aspose.psd.FileFormat:
        '''Gets the file format.
        
        :param stream: The stream.
        :returns: The determined file format.'''
        ...
    
    @overload
    @staticmethod
    def get_fitting_rectangle(rectangle : aspose.psd.Rectanglewidth : int, height : int) -> aspose.psd.Rectangle:
        '''Gets rectangle which fits the current image.
        
        :param rectangle: The rectangle to get fitting rectangle for.
        :param width: The object width.
        :param height: The object height.
        :returns: The fitting rectangle or exception if no fitting rectangle can be found.'''
        ...
    
    @overload
    @staticmethod
    def get_fitting_rectangle(rectangle : aspose.psd.Rectanglepixels : List[int], width : int, height : int) -> aspose.psd.Rectangle:
        '''Gets rectangle which fits the current image.
        
        :param rectangle: The rectangle to get fitting rectangle for.
        :param pixels: The 32-bit ARGB pixels.
        :param width: The object width.
        :param height: The object height.
        :returns: The fitting rectangle or exception if no fitting rectangle can be found.'''
        ...
    
    @overload
    @staticmethod
    def load(file_path : strload_options : aspose.psd.LoadOptions) -> aspose.psd.Image:
        '''Loads a new image from the specified file.
        
        :param file_path: The file path to load image from.
        :param load_options: The load options.
        :returns: The loaded image.'''
        ...
    
    @overload
    @staticmethod
    def load(file_path : str) -> aspose.psd.Image:
        '''Loads a new image from the specified file.
        
        :param file_path: The file path to load image from.
        :returns: The loaded image.'''
        ...
    
    @overload
    @staticmethod
    def load(stream : io.RawIOBaseload_options : aspose.psd.LoadOptions) -> aspose.psd.Image:
        '''Loads a new image from the specified stream.
        
        :param stream: The stream to load image from.
        :param load_options: The load options.
        :returns: The loaded image.'''
        ...
    
    @overload
    @staticmethod
    def load(stream : io.RawIOBase) -> aspose.psd.Image:
        '''Loads a new image from the specified stream.
        
        :param stream: The stream to load image from.
        :returns: The loaded image.'''
        ...
    
    @overload
    def resize(self, new_width : int, new_height : int, resize_type : aspose.psd.ResizeType):
        '''Resizes the image.
        
        :param new_width: The new width.
        :param new_height: The new height.
        :param resize_type: The resize type.'''
        ...
    
    @overload
    def resize(self, new_width : int, new_height : int, settings : aspose.psd.ImageResizeSettings):
        '''Resizes the image.
        
        :param new_width: The new width.
        :param new_height: The new height.
        :param settings: The resize settings.'''
        ...
    
    @overload
    def resize(self, new_width : int, new_height : int):
        '''Resizes the image. The default :py:attr:`aspose.psd.ResizeType.NEAREST_NEIGHBOUR_RESAMPLE` is used.
        
        :param new_width: The new width.
        :param new_height: The new height.'''
        ...
    
    @overload
    def resize_width_proportionally(self, new_width : int):
        '''Resizes the width proportionally. The default :py:attr:`aspose.psd.ResizeType.NEAREST_NEIGHBOUR_RESAMPLE` is used.
        
        :param new_width: The new width.'''
        ...
    
    @overload
    def resize_width_proportionally(self, new_width : int, resize_type : aspose.psd.ResizeType):
        '''Resizes the width proportionally.
        
        :param new_width: The new width.
        :param resize_type: Type of the resize.'''
        ...
    
    @overload
    def resize_width_proportionally(self, new_width : int, settings : aspose.psd.ImageResizeSettings):
        '''Resizes the width proportionally.
        
        :param new_width: The new width.
        :param settings: The image resize settings.'''
        ...
    
    @overload
    def resize_height_proportionally(self, new_height : int):
        '''Resizes the height proportionally.
        
        :param new_height: The new height.'''
        ...
    
    @overload
    def resize_height_proportionally(self, new_height : int, resize_type : aspose.psd.ResizeType):
        '''Resizes the height proportionally.
        
        :param new_height: The new height.
        :param resize_type: Type of the resize.'''
        ...
    
    @overload
    def resize_height_proportionally(self, new_height : int, settings : aspose.psd.ImageResizeSettings):
        '''Resizes the height proportionally.
        
        :param new_height: The new height.
        :param settings: The image resize settings.'''
        ...
    
    @overload
    def dither(self, dithering_method : aspose.psd.DitheringMethod, bits_count : int):
        '''Performs dithering on the current image.
        
        :param dithering_method: The dithering method.
        :param bits_count: The final bits count for dithering.'''
        ...
    
    @overload
    def dither(self, dithering_method : aspose.psd.DitheringMethod, bits_count : int, custom_palette : aspose.psd.IColorPalette):
        '''Performs dithering on the current image.
        
        :param dithering_method: The dithering method.
        :param bits_count: The final bits count for dithering.
        :param custom_palette: The custom palette for dithering.'''
        ...
    
    @overload
    def get_default_raw_data(self, rectangle : aspose.psd.Rectangle, partial_raw_data_loader : aspose.psd.IPartialRawDataLoader, raw_data_settings : aspose.psd.RawDataSettings):
        '''Gets the default raw data array using partial pixel loader.
        
        :param rectangle: The rectangle to get pixels for.
        :param partial_raw_data_loader: The partial raw data loader.
        :param raw_data_settings: The raw data settings.'''
        ...
    
    @overload
    def get_default_raw_data(self, rectangle : aspose.psd.Rectangle, raw_data_settings : aspose.psd.RawDataSettings) -> bytes:
        '''Gets the default raw data array.
        
        :param rectangle: The rectangle to get raw data for.
        :param raw_data_settings: The raw data settings.
        :returns: The default raw data array.'''
        ...
    
    @overload
    def load_raw_data(self, rectangle : aspose.psd.Rectangle, raw_data_settings : aspose.psd.RawDataSettings, raw_data_loader : aspose.psd.IPartialRawDataLoader):
        '''Loads raw data.
        
        :param rectangle: The rectangle to load raw data from.
        :param raw_data_settings: The raw data settings to use for loaded data. Note if data is not in the format specified then data conversion will be performed.
        :param raw_data_loader: The raw data loader.'''
        ...
    
    @overload
    def load_raw_data(self, rectangle : aspose.psd.Rectangle, dest_image_bounds : aspose.psd.Rectangle, raw_data_settings : aspose.psd.RawDataSettings, raw_data_loader : aspose.psd.IPartialRawDataLoader):
        '''Loads raw data.
        
        :param rectangle: The rectangle to load raw data from.
        :param dest_image_bounds: The dest image bounds.
        :param raw_data_settings: The raw data settings to use for loaded data. Note if data is not in the format specified then data conversion will be performed.
        :param raw_data_loader: The raw data loader.'''
        ...
    
    @overload
    def crop(self, rectangle : aspose.psd.Rectangle):
        ...
    
    @overload
    def crop(self, left_shift : int, right_shift : int, top_shift : int, bottom_shift : int):
        ...
    
    @overload
    def binarize_bradley(self, brightness_difference : float):
        ...
    
    @overload
    def binarize_bradley(self, brightness_difference : float, window_size : int):
        ...
    
    @overload
    def adjust_gamma(self, gamma_red : float, gamma_green : float, gamma_blue : float):
        ...
    
    @overload
    def adjust_gamma(self, gamma : float):
        ...
    
    @overload
    def rotate(self, angle : float, resize_proportionally : bool, background_color : aspose.psd.Color):
        ...
    
    @overload
    def rotate(self, angle : float):
        ...
    
    @overload
    def normalize_angle(self):
        ...
    
    @overload
    def normalize_angle(self, resize_proportionally : bool, background_color : aspose.psd.Color):
        ...
    
    @overload
    def replace_color(self, old_color : aspose.psd.Color, old_color_diff : byte, new_color : aspose.psd.Color):
        ...
    
    @overload
    def replace_color(self, old_color_argb : int, old_color_diff : byte, new_color_argb : int):
        ...
    
    @overload
    def replace_non_transparent_colors(self, new_color : aspose.psd.Color):
        ...
    
    @overload
    def replace_non_transparent_colors(self, new_color_argb : int):
        ...
    
    def cache_data(self):
        '''Caches the data and ensures no additional data loading will be performed from the underlying :py:attr:`aspose.psd.DataStreamSupporter.data_stream_container`.'''
        ...
    
    @staticmethod
    def create(image_options : aspose.psd.ImageOptionsBasewidth : int, height : int) -> aspose.psd.Image:
        '''Creates a new image using the specified create options.
        
        :param image_options: The image options.
        :param width: The width.
        :param height: The height.
        :returns: The newly created image.'''
        ...
    
    def can_save(self, options : aspose.psd.ImageOptionsBase) -> bool:
        '''Determines whether image can be saved to the specified file format represented by the passed save options.
        
        :param options: The save options to use.
        :returns: ``true`` if image can be saved to the specified file format represented by the passed save options; otherwise, ``false``.'''
        ...
    
    def get_default_options(self, args : List[any]) -> aspose.psd.ImageOptionsBase:
        '''Gets the default options.
        
        :param args: The arguments.
        :returns: Default options'''
        ...
    
    def get_original_options(self) -> aspose.psd.ImageOptionsBase:
        '''Gets the options based on the original file settings.
        This can be helpful to keep bit-depth and other parameters of the original image unchanged.
        For example, if we load a black-white PNG image with 1 bit per pixel and then save it using the
        :py:func:`aspose.psd.DataStreamSupporter.save` method, the output PNG image with 8-bit per pixel will be produced.
        To avoid it and save PNG image with 1-bit per pixel, use this method to get corresponding saving options and pass them
        to the :py:func:`aspose.psd.Image.save` method as the second parameter.
        
        :returns: The options based on the original file settings.'''
        ...
    
    def rotate_flip(self, rotate_flip_type : aspose.psd.RotateFlipType):
        '''Rotates, flips, or rotates and flips the image.
        
        :param rotate_flip_type: Type of the rotate flip.'''
        ...
    
    def set_palette(self, palette : aspose.psd.IColorPalette, update_colors : bool):
        '''Sets the image palette.
        
        :param palette: The palette to set.
        :param update_colors: if set to ``true`` colors will be updated according to the new palette; otherwise color indexes remain unchanged. Note that unchanged indexes may crash the image on loading if some indexes have no corresponding palette entries.'''
        ...
    
    @staticmethod
    def get_proportional_width(width : intheight : int, new_height : int) -> int:
        '''Gets a proportional width.
        
        :param width: The width.
        :param height: The height.
        :param new_height: The new height.
        :returns: The proportional width.'''
        ...
    
    @staticmethod
    def get_proportional_height(width : intheight : int, new_width : int) -> int:
        '''Gets a proportional height.
        
        :param width: The width.
        :param height: The height.
        :param new_width: The new width.
        :returns: The proportional height.'''
        ...
    
    def get_modify_date(self, use_default : bool) -> DateTime:
        '''Gets the date and time the resource image was last modified.
        
        :param use_default: if set to ``true`` uses the information from FileInfo as default value.
        :returns: The date and time the resource image was last modified.'''
        ...
    
    def get_default_pixels(self, rectangle : aspose.psd.Rectangle, partial_pixel_loader : aspose.psd.IPartialArgb32PixelLoader):
        '''Gets the default pixels array using partial pixel loader.
        
        :param rectangle: The rectangle to get pixels for.
        :param partial_pixel_loader: The partial pixel loader.'''
        ...
    
    def get_default_argb_32_pixels(self, rectangle : aspose.psd.Rectangle) -> List[int]:
        '''Gets the default 32-bit ARGB pixels array.
        
        :param rectangle: The rectangle to get pixels for.
        :returns: The default pixels array.'''
        ...
    
    def get_argb_32_pixel(self, x : int, y : int) -> int:
        '''Gets an image 32-bit ARGB pixel.
        
        :param x: The pixel x location.
        :param y: The pixel y location.
        :returns: The 32-bit ARGB pixel for the specified location.'''
        ...
    
    def get_pixel(self, x : int, y : int) -> aspose.psd.Color:
        '''Gets an image pixel.
        
        :param x: The pixel x location.
        :param y: The pixel y location.
        :returns: The pixel color for the specified location.'''
        ...
    
    def set_argb_32_pixel(self, x : int, y : int, argb_32_color : int):
        '''Sets an image 32-bit ARGB pixel for the specified position.
        
        :param x: The pixel x location.
        :param y: The pixel y location.
        :param argb_32_color: The 32-bit ARGB pixel for the specified position.'''
        ...
    
    def set_pixel(self, x : int, y : int, color : aspose.psd.Color):
        '''Sets an image pixel for the specified position.
        
        :param x: The pixel x location.
        :param y: The pixel y location.
        :param color: The pixel color for the specified position.'''
        ...
    
    def read_scan_line(self, scan_line_index : int) -> List[aspose.psd.Color]:
        '''Reads the whole scan line by the specified scan line index.
        
        :param scan_line_index: Zero based index of the scan line.
        :returns: The scan line pixel color values array.'''
        ...
    
    def read_argb_32_scan_line(self, scan_line_index : int) -> List[int]:
        '''Reads the whole scan line by the specified scan line index.
        
        :param scan_line_index: Zero based index of the scan line.
        :returns: The scan line 32-bit ARGB color values array.'''
        ...
    
    def write_scan_line(self, scan_line_index : int, pixels : List[aspose.psd.Color]):
        '''Writes the whole scan line to the specified scan line index.
        
        :param scan_line_index: Zero based index of the scan line.
        :param pixels: The pixel colors array to write.'''
        ...
    
    def write_argb_32_scan_line(self, scan_line_index : int, argb_32_pixels : List[int]):
        '''Writes the whole scan line to the specified scan line index.
        
        :param scan_line_index: Zero based index of the scan line.
        :param argb_32_pixels: The 32-bit ARGB colors array to write.'''
        ...
    
    def load_partial_argb_32_pixels(self, rectangle : aspose.psd.Rectangle, partial_pixel_loader : aspose.psd.IPartialArgb32PixelLoader):
        '''Loads 32-bit ARGB pixels partially by packs.
        
        :param rectangle: The desired rectangle.
        :param partial_pixel_loader: The 32-bit ARGB pixel loader.'''
        ...
    
    def load_partial_pixels(self, desired_rectangle : aspose.psd.Rectangle, pixel_loader : aspose.psd.IPartialPixelLoader):
        '''Loads pixels partially by packs.
        
        :param desired_rectangle: The desired rectangle.
        :param pixel_loader: The pixel loader.'''
        ...
    
    def load_argb_32_pixels(self, rectangle : aspose.psd.Rectangle) -> List[int]:
        '''Loads 32-bit ARGB pixels.
        
        :param rectangle: The rectangle to load pixels from.
        :returns: The loaded 32-bit ARGB pixels array.'''
        ...
    
    def load_argb_64_pixels(self, rectangle : aspose.psd.Rectangle) -> List[int]:
        '''Loads 64-bit ARGB pixels.
        
        :param rectangle: The rectangle to load pixels from.
        :returns: The loaded 64-bit ARGB pixels array.'''
        ...
    
    def load_pixels(self, rectangle : aspose.psd.Rectangle) -> List[aspose.psd.Color]:
        '''Loads pixels.
        
        :param rectangle: The rectangle to load pixels from.
        :returns: The loaded pixels array.'''
        ...
    
    def load_cmyk_pixels(self, rectangle : aspose.psd.Rectangle) -> List[aspose.psd.CmykColor]:
        '''Loads pixels in CMYK format.
        This method is deprecated. Please use more effective the :py:func:`aspose.psd.RasterImage.load_cmyk_32_pixels` method.
        
        :param rectangle: The rectangle to load pixels from.
        :returns: The loaded CMYK pixels array.'''
        ...
    
    def load_cmyk_32_pixels(self, rectangle : aspose.psd.Rectangle) -> List[int]:
        '''Loads pixels in CMYK format.
        
        :param rectangle: The rectangle to load pixels from.
        :returns: The loaded CMYK pixels presentes as 32-bit inateger values.'''
        ...
    
    def save_raw_data(self, data : bytes, data_offset : int, rectangle : aspose.psd.Rectangle, raw_data_settings : aspose.psd.RawDataSettings):
        '''Saves the raw data.
        
        :param data: The raw data.
        :param data_offset: The starting raw data offset.
        :param rectangle: The raw data rectangle.
        :param raw_data_settings: The raw data settings the data is in.'''
        ...
    
    def save_argb_32_pixels(self, rectangle : aspose.psd.Rectangle, pixels : List[int]):
        '''Saves the 32-bit ARGB pixels.
        
        :param rectangle: The rectangle to save pixels to.
        :param pixels: The 32-bit ARGB pixels array.'''
        ...
    
    def save_pixels(self, rectangle : aspose.psd.Rectangle, pixels : List[aspose.psd.Color]):
        '''Saves the pixels.
        
        :param rectangle: The rectangle to save pixels to.
        :param pixels: The pixels array.'''
        ...
    
    def to_bitmap(self) -> aspose.pydrawing.Bitmap:
        ...
    
    def save_cmyk_pixels(self, rectangle : aspose.psd.Rectangle, pixels : List[aspose.psd.CmykColor]):
        ...
    
    def save_cmyk_32_pixels(self, rectangle : aspose.psd.Rectangle, pixels : List[int]):
        ...
    
    def set_resolution(self, dpi_x : float, dpi_y : float):
        ...
    
    def binarize_fixed(self, threshold : byte):
        ...
    
    def binarize_otsu(self):
        ...
    
    def grayscale(self):
        ...
    
    def adjust_brightness(self, brightness : int):
        ...
    
    def adjust_contrast(self, contrast : float):
        ...
    
    def get_skew_angle(self) -> float:
        ...
    
    def filter(self, rectangle : aspose.psd.Rectangle, options : aspose.psd.imagefilters.filteroptions.FilterOptionsBase):
        ...
    
    @property
    def disposed(self) -> bool:
        '''Gets a value indicating whether this instance is disposed.'''
        ...
    
    @property
    def data_stream_container(self) -> aspose.psd.StreamContainer:
        ...
    
    @property
    def is_cached(self) -> bool:
        ...
    
    @property
    def bits_per_pixel(self) -> int:
        ...
    
    @property
    def bounds(self) -> aspose.psd.Rectangle:
        '''Gets the image bounds.'''
        ...
    
    @property
    def container(self) -> aspose.psd.Image:
        '''Gets the :py:class:`aspose.psd.Image` container.'''
        ...
    
    @property
    def height(self) -> int:
        '''Gets the image height.'''
        ...
    
    @property
    def palette(self) -> aspose.psd.IColorPalette:
        '''Gets the color palette. The color palette is not used when pixels are represented directly.'''
        ...
    
    @palette.setter
    def palette(self, value : aspose.psd.IColorPalette):
        '''Sets the color palette. The color palette is not used when pixels are represented directly.'''
        ...
    
    @property
    def use_palette(self) -> bool:
        ...
    
    @property
    def size(self) -> aspose.psd.Size:
        '''Gets the image size.'''
        ...
    
    @property
    def width(self) -> int:
        '''Gets the image width.'''
        ...
    
    @property
    def interrupt_monitor(self) -> aspose.psd.multithreading.InterruptMonitor:
        ...
    
    @interrupt_monitor.setter
    def interrupt_monitor(self, value : aspose.psd.multithreading.InterruptMonitor):
        ...
    
    @property
    def buffer_size_hint(self) -> int:
        ...
    
    @buffer_size_hint.setter
    def buffer_size_hint(self, value : int):
        ...
    
    @property
    def auto_adjust_palette(self) -> bool:
        ...
    
    @auto_adjust_palette.setter
    def auto_adjust_palette(self, value : bool):
        ...
    
    @property
    def has_background_color(self) -> bool:
        ...
    
    @has_background_color.setter
    def has_background_color(self, value : bool):
        ...
    
    @property
    def file_format(self) -> aspose.psd.FileFormat:
        ...
    
    @property
    def background_color(self) -> aspose.psd.Color:
        ...
    
    @background_color.setter
    def background_color(self, value : aspose.psd.Color):
        ...
    
    @property
    def premultiply_components(self) -> bool:
        ...
    
    @premultiply_components.setter
    def premultiply_components(self, value : bool):
        ...
    
    @property
    def use_raw_data(self) -> bool:
        ...
    
    @use_raw_data.setter
    def use_raw_data(self, value : bool):
        ...
    
    @property
    def update_xmp_data(self) -> bool:
        ...
    
    @update_xmp_data.setter
    def update_xmp_data(self, value : bool):
        ...
    
    @property
    def xmp_data(self) -> aspose.psd.xmp.XmpPacketWrapper:
        ...
    
    @xmp_data.setter
    def xmp_data(self, value : aspose.psd.xmp.XmpPacketWrapper):
        ...
    
    @property
    def raw_indexed_color_converter(self) -> aspose.psd.IIndexedColorConverter:
        ...
    
    @raw_indexed_color_converter.setter
    def raw_indexed_color_converter(self, value : aspose.psd.IIndexedColorConverter):
        ...
    
    @property
    def raw_custom_color_converter(self) -> aspose.psd.IColorConverter:
        ...
    
    @raw_custom_color_converter.setter
    def raw_custom_color_converter(self, value : aspose.psd.IColorConverter):
        ...
    
    @property
    def raw_fallback_index(self) -> int:
        ...
    
    @raw_fallback_index.setter
    def raw_fallback_index(self, value : int):
        ...
    
    @property
    def raw_data_settings(self) -> aspose.psd.RawDataSettings:
        ...
    
    @property
    def raw_data_format(self) -> aspose.psd.PixelDataFormat:
        ...
    
    @property
    def raw_line_size(self) -> int:
        ...
    
    @property
    def is_raw_data_available(self) -> bool:
        ...
    
    @property
    def horizontal_resolution(self) -> float:
        ...
    
    @horizontal_resolution.setter
    def horizontal_resolution(self, value : float):
        ...
    
    @property
    def vertical_resolution(self) -> float:
        ...
    
    @vertical_resolution.setter
    def vertical_resolution(self, value : float):
        ...
    
    @property
    def has_transparent_color(self) -> bool:
        ...
    
    @has_transparent_color.setter
    def has_transparent_color(self, value : bool):
        ...
    
    @property
    def has_alpha(self) -> bool:
        ...
    
    @property
    def transparent_color(self) -> aspose.psd.Color:
        ...
    
    @transparent_color.setter
    def transparent_color(self, value : aspose.psd.Color):
        ...
    
    @property
    def image_opacity(self) -> float:
        ...
    
    ...

class RawDataSettings:
    '''The raw data settings'''
    
    @property
    def pixel_data_format(self) -> aspose.psd.PixelDataFormat:
        ...
    
    @pixel_data_format.setter
    def pixel_data_format(self, value : aspose.psd.PixelDataFormat):
        ...
    
    @property
    def color_palette(self) -> aspose.psd.IColorPalette:
        ...
    
    @color_palette.setter
    def color_palette(self, value : aspose.psd.IColorPalette):
        ...
    
    @property
    def dithering_method(self) -> aspose.psd.DitheringMethods:
        ...
    
    @dithering_method.setter
    def dithering_method(self, value : aspose.psd.DitheringMethods):
        ...
    
    @property
    def indexed_color_converter(self) -> aspose.psd.IIndexedColorConverter:
        ...
    
    @indexed_color_converter.setter
    def indexed_color_converter(self, value : aspose.psd.IIndexedColorConverter):
        ...
    
    @property
    def custom_color_converter(self) -> aspose.psd.IColorConverter:
        ...
    
    @custom_color_converter.setter
    def custom_color_converter(self, value : aspose.psd.IColorConverter):
        ...
    
    @property
    def fallback_index(self) -> int:
        ...
    
    @fallback_index.setter
    def fallback_index(self, value : int):
        ...
    
    @property
    def line_size(self) -> int:
        ...
    
    @line_size.setter
    def line_size(self, value : int):
        ...
    
    ...

class Rectangle:
    '''Stores a set of four integers that represent the location and size of a rectangle.'''
    
    @overload
    @staticmethod
    def inflate(rect : aspose.psd.Rectanglex : int, y : int) -> aspose.psd.Rectangle:
        '''Creates and returns an inflated copy of the specified :py:class:`aspose.psd.Rectangle` structure. The copy is inflated by the specified amount. The original :py:class:`aspose.psd.Rectangle` structure remains unmodified.
        
        :param rect: The :py:class:`aspose.psd.Rectangle` with which to start. This rectangle is not modified.
        :param x: The amount to inflate this :py:class:`aspose.psd.Rectangle` horizontally.
        :param y: The amount to inflate this :py:class:`aspose.psd.Rectangle` vertically.
        :returns: The inflated :py:class:`aspose.psd.Rectangle`.'''
        ...
    
    @overload
    def inflate(self, width : int, height : int):
        '''Inflates this :py:class:`aspose.psd.Rectangle` by the specified amount.
        
        :param width: The amount to inflate this :py:class:`aspose.psd.Rectangle` horizontally.
        :param height: The amount to inflate this :py:class:`aspose.psd.Rectangle` vertically.'''
        ...
    
    @overload
    def inflate(self, size : aspose.psd.Size):
        '''Inflates this :py:class:`aspose.psd.Rectangle` by the specified amount.
        
        :param size: The amount to inflate this rectangle.'''
        ...
    
    @overload
    @staticmethod
    def intersect(a : aspose.psd.Rectangleb : aspose.psd.Rectangle) -> aspose.psd.Rectangle:
        '''Returns a third :py:class:`aspose.psd.Rectangle` structure that represents the intersection of two other :py:class:`aspose.psd.Rectangle` structures. If there is no intersection, an empty :py:class:`aspose.psd.Rectangle` is returned.
        
        :param a: A first rectangle to intersect.
        :param b: A second rectangle to intersect.
        :returns: A :py:class:`aspose.psd.Rectangle` that represents the intersection of ``a`` and ``b``.'''
        ...
    
    @overload
    def intersect(self, rect : aspose.psd.Rectangle):
        '''Replaces this :py:class:`aspose.psd.Rectangle` with the intersection of itself and the specified :py:class:`aspose.psd.Rectangle`.
        
        :param rect: The :py:class:`aspose.psd.Rectangle` with which to intersect.'''
        ...
    
    @overload
    def contains(self, x : int, y : int) -> bool:
        '''Determines if the specified point is contained within this :py:class:`aspose.psd.Rectangle` structure.
        
        :param x: The x-coordinate of the point to test.
        :param y: The y-coordinate of the point to test.
        :returns: This method returns true if the point defined by ``x`` and ``y`` is contained within this :py:class:`aspose.psd.Rectangle` structure; otherwise false.'''
        ...
    
    @overload
    def contains(self, point : aspose.psd.Point) -> bool:
        '''Determines if the specified point is contained within this :py:class:`aspose.psd.Rectangle` structure.
        
        :param point: The :py:class:`aspose.psd.Point` to test.
        :returns: This method returns true if the point represented by ``point`` is contained within this :py:class:`aspose.psd.Rectangle` structure; otherwise false.'''
        ...
    
    @overload
    def contains(self, rect : aspose.psd.Rectangle) -> bool:
        '''Determines if the rectangular region represented by ``rect`` is entirely contained within this :py:class:`aspose.psd.Rectangle` structure.
        
        :param rect: The :py:class:`aspose.psd.Rectangle` to test.
        :returns: This method returns true if the rectangular region represented by ``rect`` is entirely contained within this :py:class:`aspose.psd.Rectangle` structure; otherwise false.'''
        ...
    
    @overload
    def offset(self, pos : aspose.psd.Point):
        '''Adjusts the location of this rectangle by the specified amount.
        
        :param pos: Amount to offset the location.'''
        ...
    
    @overload
    def offset(self, x : int, y : int):
        '''Adjusts the location of this rectangle by the specified amount.
        
        :param x: The horizontal offset.
        :param y: The vertical offset.'''
        ...
    
    @staticmethod
    def from_points(point1 : aspose.psd.Pointpoint2 : aspose.psd.Point) -> aspose.psd.Rectangle:
        '''Creates a new :py:class:`aspose.psd.Rectangle` from two points specified. Two verticales of the created :py:class:`aspose.psd.Rectangle` will be equal to the passed ``point1`` and ``point2``. These would be typically the opposite vertices.
        
        :param point1: The first :py:class:`aspose.psd.Point` for the new rectangle.
        :param point2: The second :py:class:`aspose.psd.Point` for the new rectangle.
        :returns: A newly created :py:class:`aspose.psd.Rectangle`.'''
        ...
    
    @staticmethod
    def ceiling(value : aspose.psd.RectangleF) -> aspose.psd.Rectangle:
        '''Converts the specified :py:class:`aspose.psd.RectangleF` structure to a :py:class:`aspose.psd.Rectangle` structure by rounding the :py:class:`aspose.psd.RectangleF` values to the next higher integer values.
        
        :param value: The :py:class:`aspose.psd.RectangleF` structure to be converted.
        :returns: Returns a :py:class:`aspose.psd.Rectangle`.'''
        ...
    
    @staticmethod
    def truncate(value : aspose.psd.RectangleF) -> aspose.psd.Rectangle:
        '''Converts the specified :py:class:`aspose.psd.RectangleF` to a :py:class:`aspose.psd.Rectangle` by truncating the :py:class:`aspose.psd.RectangleF` values.
        
        :param value: The :py:class:`aspose.psd.RectangleF` to be converted.
        :returns: A new :py:class:`aspose.psd.Rectangle`.'''
        ...
    
    @staticmethod
    def round(value : aspose.psd.RectangleF) -> aspose.psd.Rectangle:
        '''Converts the specified :py:class:`aspose.psd.RectangleF` to a :py:class:`aspose.psd.Rectangle` by rounding the :py:class:`aspose.psd.RectangleF` values to the nearest integer values.
        
        :param value: The :py:class:`aspose.psd.RectangleF` to be converted.
        :returns: A new :py:class:`aspose.psd.Rectangle`.'''
        ...
    
    @staticmethod
    def union(a : aspose.psd.Rectangleb : aspose.psd.Rectangle) -> aspose.psd.Rectangle:
        '''Gets a :py:class:`aspose.psd.Rectangle` structure that contains the union of two :py:class:`aspose.psd.Rectangle` structures.
        
        :param a: A first rectangle to union.
        :param b: A second rectangle to union.
        :returns: A :py:class:`aspose.psd.Rectangle` structure that bounds the union of the two :py:class:`aspose.psd.Rectangle` structures.'''
        ...
    
    @staticmethod
    def from_left_top_right_bottom(left : inttop : int, right : int, bottom : int) -> aspose.psd.Rectangle:
        '''Creates a :py:class:`aspose.psd.Rectangle` structure with the specified edge locations.
        
        :param left: The x-coordinate of the upper-left corner of this :py:class:`aspose.psd.Rectangle` structure.
        :param top: The y-coordinate of the upper-left corner of this :py:class:`aspose.psd.Rectangle` structure.
        :param right: The x-coordinate of the lower-right corner of this :py:class:`aspose.psd.Rectangle` structure.
        :param bottom: The y-coordinate of the lower-right corner of this :py:class:`aspose.psd.Rectangle` structure.
        :returns: The new :py:class:`aspose.psd.Rectangle` that this method creates.'''
        ...
    
    def intersects_with(self, rect : aspose.psd.Rectangle) -> bool:
        '''Determines if this rectangle intersects with ``rect``.
        
        :param rect: The rectangle to test.
        :returns: This method returns true if there is any intersection, otherwise false.'''
        ...
    
    def normalize(self):
        '''Normalizes the rectangle by making it's width and height positive, left less than right and top less than bottom.'''
        ...
    
    @classmethod
    @property
    def empty(cls) -> aspose.psd.Rectangle:
        '''Gets a new instance of the :py:class:`aspose.psd.Rectangle` structure that has :py:attr:`aspose.psd.Rectangle.x`, :py:attr:`aspose.psd.Rectangle.y`, :py:attr:`aspose.psd.Rectangle.width` and :py:attr:`aspose.psd.Rectangle.height` values set to zero.'''
        ...
    
    @property
    def location(self) -> aspose.psd.Point:
        '''Gets the coordinates of the upper-left corner of this :py:class:`aspose.psd.Rectangle` structure.'''
        ...
    
    @location.setter
    def location(self, value : aspose.psd.Point):
        '''Sets the coordinates of the upper-left corner of this :py:class:`aspose.psd.Rectangle` structure.'''
        ...
    
    @property
    def size(self) -> aspose.psd.Size:
        '''Gets the size of this :py:class:`aspose.psd.Rectangle`.'''
        ...
    
    @size.setter
    def size(self, value : aspose.psd.Size):
        '''Sets the size of this :py:class:`aspose.psd.Rectangle`.'''
        ...
    
    @property
    def x(self) -> int:
        '''Gets the x-coordinate of the upper-left corner of this :py:class:`aspose.psd.Rectangle` structure.'''
        ...
    
    @x.setter
    def x(self, value : int):
        '''Sets the x-coordinate of the upper-left corner of this :py:class:`aspose.psd.Rectangle` structure.'''
        ...
    
    @property
    def y(self) -> int:
        '''Gets the y-coordinate of the upper-left corner of this :py:class:`aspose.psd.Rectangle` structure.'''
        ...
    
    @y.setter
    def y(self, value : int):
        '''Sets the y-coordinate of the upper-left corner of this :py:class:`aspose.psd.Rectangle` structure.'''
        ...
    
    @property
    def width(self) -> int:
        '''Gets the width of this :py:class:`aspose.psd.Rectangle` structure.'''
        ...
    
    @width.setter
    def width(self, value : int):
        '''Sets the width of this :py:class:`aspose.psd.Rectangle` structure.'''
        ...
    
    @property
    def height(self) -> int:
        '''Gets the height of this :py:class:`aspose.psd.Rectangle` structure.'''
        ...
    
    @height.setter
    def height(self, value : int):
        '''Sets the height of this :py:class:`aspose.psd.Rectangle` structure.'''
        ...
    
    @property
    def left(self) -> int:
        '''Gets the x-coordinate of the left edge of this :py:class:`aspose.psd.Rectangle` structure.'''
        ...
    
    @left.setter
    def left(self, value : int):
        '''Sets the x-coordinate of the left edge of this :py:class:`aspose.psd.Rectangle` structure.'''
        ...
    
    @property
    def top(self) -> int:
        '''Gets the y-coordinate of the top edge of this :py:class:`aspose.psd.Rectangle` structure.'''
        ...
    
    @top.setter
    def top(self, value : int):
        '''Sets the y-coordinate of the top edge of this :py:class:`aspose.psd.Rectangle` structure.'''
        ...
    
    @property
    def right(self) -> int:
        '''Gets the x-coordinate that is the sum of :py:attr:`aspose.psd.Rectangle.x` and :py:attr:`aspose.psd.Rectangle.width` property values of this :py:class:`aspose.psd.Rectangle` structure.'''
        ...
    
    @right.setter
    def right(self, value : int):
        '''Sets the x-coordinate that is the sum of :py:attr:`aspose.psd.Rectangle.x` and :py:attr:`aspose.psd.Rectangle.width` property values of this :py:class:`aspose.psd.Rectangle` structure.'''
        ...
    
    @property
    def bottom(self) -> int:
        '''Gets the y-coordinate that is the sum of the :py:attr:`aspose.psd.Rectangle.y` and :py:attr:`aspose.psd.Rectangle.height` property values of this :py:class:`aspose.psd.Rectangle` structure.'''
        ...
    
    @bottom.setter
    def bottom(self, value : int):
        '''Sets the y-coordinate that is the sum of the :py:attr:`aspose.psd.Rectangle.y` and :py:attr:`aspose.psd.Rectangle.height` property values of this :py:class:`aspose.psd.Rectangle` structure.'''
        ...
    
    @property
    def is_empty(self) -> bool:
        ...
    
    ...

class RectangleF:
    '''Stores a set of four floating-point numbers that represent the location and size of a rectangle.'''
    
    @overload
    @staticmethod
    def inflate(rect : aspose.psd.RectangleFx : float, y : float) -> aspose.psd.RectangleF:
        '''Creates and returns an inflated copy of the specified :py:class:`aspose.psd.RectangleF` structure. The copy is inflated by the specified amount. The original rectangle remains unmodified.
        
        :param rect: The :py:class:`aspose.psd.RectangleF` to be copied. This rectangle is not modified.
        :param x: The amount to inflate the copy of the rectangle horizontally.
        :param y: The amount to inflate the copy of the rectangle vertically.
        :returns: The inflated :py:class:`aspose.psd.RectangleF`.'''
        ...
    
    @overload
    def inflate(self, x : float, y : float):
        '''Inflates this :py:class:`aspose.psd.RectangleF` structure by the specified amount.
        
        :param x: The amount to inflate this :py:class:`aspose.psd.RectangleF` structure horizontally.
        :param y: The amount to inflate this :py:class:`aspose.psd.RectangleF` structure vertically.'''
        ...
    
    @overload
    def inflate(self, size : aspose.psd.SizeF):
        '''Inflates this :py:class:`aspose.psd.RectangleF` by the specified amount.
        
        :param size: The amount to inflate this rectangle.'''
        ...
    
    @overload
    @staticmethod
    def intersect(a : aspose.psd.RectangleFb : aspose.psd.RectangleF) -> aspose.psd.RectangleF:
        '''Returns a :py:class:`aspose.psd.RectangleF` structure that represents the intersection of two rectangles. If there is no intersection, and empty :py:class:`aspose.psd.RectangleF` is returned.
        
        :param a: A first rectangle to intersect.
        :param b: A second rectangle to intersect.
        :returns: A third :py:class:`aspose.psd.RectangleF` structure the size of which represents the overlapped area of the two specified rectangles.'''
        ...
    
    @overload
    def intersect(self, rect : aspose.psd.RectangleF):
        '''Replaces this :py:class:`aspose.psd.RectangleF` structure with the intersection of itself and the specified :py:class:`aspose.psd.RectangleF` structure.
        
        :param rect: The rectangle to intersect.'''
        ...
    
    @overload
    def contains(self, x : float, y : float) -> bool:
        '''Determines if the specified point is contained within this :py:class:`aspose.psd.RectangleF` structure.
        
        :param x: The x-coordinate of the point to test.
        :param y: The y-coordinate of the point to test.
        :returns: This method returns true if the point defined by ``x`` and ``y`` is contained within this :py:class:`aspose.psd.RectangleF` structure; otherwise false.'''
        ...
    
    @overload
    def contains(self, point : aspose.psd.PointF) -> bool:
        '''Determines if the specified point is contained within this :py:class:`aspose.psd.RectangleF` structure.
        
        :param point: The :py:class:`aspose.psd.PointF` to test.
        :returns: This method returns true if the point represented by the ``point`` parameter is contained within this :py:class:`aspose.psd.RectangleF` structure; otherwise false.'''
        ...
    
    @overload
    def contains(self, rect : aspose.psd.RectangleF) -> bool:
        '''Determines if the rectangular region represented by ``rect`` is entirely contained within this :py:class:`aspose.psd.RectangleF` structure.
        
        :param rect: The :py:class:`aspose.psd.RectangleF` to test.
        :returns: This method returns true if the rectangular region represented by ``rect`` is entirely contained within the rectangular region represented by this :py:class:`aspose.psd.RectangleF`; otherwise false.'''
        ...
    
    @overload
    def offset(self, pos : aspose.psd.PointF):
        '''Adjusts the location of this rectangle by the specified amount.
        
        :param pos: The amount to offset the location.'''
        ...
    
    @overload
    def offset(self, x : float, y : float):
        '''Adjusts the location of this rectangle by the specified amount.
        
        :param x: The amount to offset the location horizontally.
        :param y: The amount to offset the location vertically.'''
        ...
    
    @staticmethod
    def from_points(point1 : aspose.psd.PointFpoint2 : aspose.psd.PointF) -> aspose.psd.RectangleF:
        '''Creates a new :py:class:`aspose.psd.Rectangle` from two points specified. Two verticles of the created :py:class:`aspose.psd.Rectangle` will be equal to the passed ``point1`` and ``point2``. These would be typically the opposite vertices.
        
        :param point1: The first :py:class:`aspose.psd.Point` for the new rectangle.
        :param point2: The second :py:class:`aspose.psd.Point` for the new rectangle.
        :returns: A newly created :py:class:`aspose.psd.Rectangle`.'''
        ...
    
    @staticmethod
    def union(a : aspose.psd.RectangleFb : aspose.psd.RectangleF) -> aspose.psd.RectangleF:
        '''Creates the smallest possible third rectangle that can contain both of two rectangles that form a union.
        
        :param a: A first rectangle to union.
        :param b: A second rectangle to union.
        :returns: A third :py:class:`aspose.psd.RectangleF` structure that contains both of the two rectangles that form the union.'''
        ...
    
    @staticmethod
    def from_left_top_right_bottom(left : floattop : float, right : float, bottom : float) -> aspose.psd.RectangleF:
        '''Creates a :py:class:`aspose.psd.RectangleF` structure with upper-left corner and lower-right corner at the specified locations.
        
        :param left: The x-coordinate of the upper-left corner of the rectangular region.
        :param top: The y-coordinate of the upper-left corner of the rectangular region.
        :param right: The x-coordinate of the lower-right corner of the rectangular region.
        :param bottom: The y-coordinate of the lower-right corner of the rectangular region.
        :returns: The new :py:class:`aspose.psd.RectangleF` that this method creates.'''
        ...
    
    def normalize(self):
        '''Normalizes the rectangle by making it's width and height positive, left less than right and top less than bottom.'''
        ...
    
    def intersects_with(self, rect : aspose.psd.RectangleF) -> bool:
        '''Determines if this rectangle intersects with ``rect``.
        
        :param rect: The rectangle to test.
        :returns: This method returns true if there is any intersection.'''
        ...
    
    @classmethod
    @property
    def empty(cls) -> aspose.psd.RectangleF:
        '''Gets a new instance of the :py:class:`aspose.psd.RectangleF` structure that has :py:attr:`aspose.psd.RectangleF.x`, :py:attr:`aspose.psd.RectangleF.y`, :py:attr:`aspose.psd.RectangleF.width` and :py:attr:`aspose.psd.RectangleF.height` values set to zero.'''
        ...
    
    @property
    def location(self) -> aspose.psd.PointF:
        '''Gets the coordinates of the upper-left corner of this :py:class:`aspose.psd.RectangleF` structure.'''
        ...
    
    @location.setter
    def location(self, value : aspose.psd.PointF):
        '''Sets the coordinates of the upper-left corner of this :py:class:`aspose.psd.RectangleF` structure.'''
        ...
    
    @property
    def size(self) -> aspose.psd.SizeF:
        '''Gets the size of this :py:class:`aspose.psd.RectangleF`.'''
        ...
    
    @size.setter
    def size(self, value : aspose.psd.SizeF):
        '''Sets the size of this :py:class:`aspose.psd.RectangleF`.'''
        ...
    
    @property
    def x(self) -> float:
        '''Gets the x-coordinate of the upper-left corner of this :py:class:`aspose.psd.RectangleF` structure.'''
        ...
    
    @x.setter
    def x(self, value : float):
        '''Sets the x-coordinate of the upper-left corner of this :py:class:`aspose.psd.RectangleF` structure.'''
        ...
    
    @property
    def y(self) -> float:
        '''Gets the y-coordinate of the upper-left corner of this :py:class:`aspose.psd.RectangleF` structure.'''
        ...
    
    @y.setter
    def y(self, value : float):
        '''Sets the y-coordinate of the upper-left corner of this :py:class:`aspose.psd.RectangleF` structure.'''
        ...
    
    @property
    def width(self) -> float:
        '''Gets the width of this :py:class:`aspose.psd.RectangleF` structure.'''
        ...
    
    @width.setter
    def width(self, value : float):
        '''Sets the width of this :py:class:`aspose.psd.RectangleF` structure.'''
        ...
    
    @property
    def height(self) -> float:
        '''Gets the height of this :py:class:`aspose.psd.RectangleF` structure.'''
        ...
    
    @height.setter
    def height(self, value : float):
        '''Sets the height of this :py:class:`aspose.psd.RectangleF` structure.'''
        ...
    
    @property
    def left(self) -> float:
        '''Gets the x-coordinate of the left edge of this :py:class:`aspose.psd.RectangleF` structure.'''
        ...
    
    @left.setter
    def left(self, value : float):
        '''Sets the x-coordinate of the left edge of this :py:class:`aspose.psd.RectangleF` structure.'''
        ...
    
    @property
    def top(self) -> float:
        '''Gets the y-coordinate of the top edge of this :py:class:`aspose.psd.RectangleF` structure.'''
        ...
    
    @top.setter
    def top(self, value : float):
        '''Sets the y-coordinate of the top edge of this :py:class:`aspose.psd.RectangleF` structure.'''
        ...
    
    @property
    def right(self) -> float:
        '''Gets the x-coordinate that is the sum of :py:attr:`aspose.psd.RectangleF.x` and :py:attr:`aspose.psd.RectangleF.width` of this :py:class:`aspose.psd.RectangleF` structure.'''
        ...
    
    @right.setter
    def right(self, value : float):
        '''Sets the x-coordinate that is the sum of :py:attr:`aspose.psd.RectangleF.x` and :py:attr:`aspose.psd.RectangleF.width` of this :py:class:`aspose.psd.RectangleF` structure.'''
        ...
    
    @property
    def bottom(self) -> float:
        '''Gets the y-coordinate that is the sum of :py:attr:`aspose.psd.RectangleF.y` and :py:attr:`aspose.psd.RectangleF.height` of this :py:class:`aspose.psd.RectangleF` structure.'''
        ...
    
    @bottom.setter
    def bottom(self, value : float):
        '''Sets the y-coordinate that is the sum of :py:attr:`aspose.psd.RectangleF.y` and :py:attr:`aspose.psd.RectangleF.height` of this :py:class:`aspose.psd.RectangleF` structure.'''
        ...
    
    @property
    def is_empty(self) -> bool:
        ...
    
    ...

class Region:
    '''Describes the interior of a graphics shape composed of rectangles and paths. This class cannot be inherited.'''
    
    @overload
    def intersect(self, rect : aspose.psd.RectangleF):
        '''Updates this :py:class:`aspose.psd.Region` to the intersection of itself with the specified :py:class:`aspose.psd.RectangleF` structure.
        
        :param rect: The :py:class:`aspose.psd.RectangleF` structure to intersect with this :py:class:`aspose.psd.Region`.'''
        ...
    
    @overload
    def intersect(self, rect : aspose.psd.Rectangle):
        '''Updates this :py:class:`aspose.psd.Region` to the intersection of itself with the specified :py:class:`aspose.psd.Rectangle` structure.
        
        :param rect: The :py:class:`aspose.psd.Rectangle` structure to intersect with this :py:class:`aspose.psd.Region`.'''
        ...
    
    @overload
    def intersect(self, path : aspose.psd.GraphicsPath):
        '''Updates this :py:class:`aspose.psd.Region` to the intersection of itself with the specified :py:class:`aspose.psd.GraphicsPath`.
        
        :param path: The :py:class:`aspose.psd.GraphicsPath` to intersect with this :py:class:`aspose.psd.Region`.'''
        ...
    
    @overload
    def intersect(self, region : aspose.psd.Region):
        '''Updates this :py:class:`aspose.psd.Region` to the intersection of itself with the specified :py:class:`aspose.psd.Region`.
        
        :param region: The :py:class:`aspose.psd.Region` to intersect with this :py:class:`aspose.psd.Region`.'''
        ...
    
    @overload
    def union(self, rect : aspose.psd.RectangleF):
        '''Updates this :py:class:`aspose.psd.Region` to the union of itself and the specified :py:class:`aspose.psd.RectangleF` structure.
        
        :param rect: The :py:class:`aspose.psd.RectangleF` structure to unite with this :py:class:`aspose.psd.Region`.'''
        ...
    
    @overload
    def union(self, rect : aspose.psd.Rectangle):
        '''Updates this :py:class:`aspose.psd.Region` to the union of itself and the specified :py:class:`aspose.psd.Rectangle` structure.
        
        :param rect: The :py:class:`aspose.psd.Rectangle` structure to unite with this :py:class:`aspose.psd.Region`.'''
        ...
    
    @overload
    def union(self, path : aspose.psd.GraphicsPath):
        '''Updates this :py:class:`aspose.psd.Region` to the union of itself and the specified :py:class:`aspose.psd.GraphicsPath`.
        
        :param path: The :py:class:`aspose.psd.GraphicsPath` to unite with this :py:class:`aspose.psd.Region`.'''
        ...
    
    @overload
    def union(self, region : aspose.psd.Region):
        '''Updates this :py:class:`aspose.psd.Region` to the union of itself and the specified :py:class:`aspose.psd.Region`.
        
        :param region: The :py:class:`aspose.psd.Region` to unite with this :py:class:`aspose.psd.Region`.'''
        ...
    
    @overload
    def xor(self, rect : aspose.psd.RectangleF):
        '''Updates this :py:class:`aspose.psd.Region` to the union minus the intersection of itself with the specified :py:class:`aspose.psd.RectangleF` structure.
        
        :param rect: The :py:class:`aspose.psd.RectangleF` structure to xor with this :py:class:`aspose.psd.Region`.'''
        ...
    
    @overload
    def xor(self, rect : aspose.psd.Rectangle):
        '''Updates this :py:class:`aspose.psd.Region` to the union minus the intersection of itself with the specified :py:class:`aspose.psd.Rectangle` structure.
        
        :param rect: The :py:class:`aspose.psd.Rectangle` structure to xor with this :py:class:`aspose.psd.Region`.'''
        ...
    
    @overload
    def xor(self, path : aspose.psd.GraphicsPath):
        '''Updates this :py:class:`aspose.psd.Region` to the union minus the intersection of itself with the specified :py:class:`aspose.psd.GraphicsPath`.
        
        :param path: The :py:class:`aspose.psd.GraphicsPath` to xor with this :py:class:`aspose.psd.Region`.'''
        ...
    
    @overload
    def xor(self, region : aspose.psd.Region):
        '''Updates this :py:class:`aspose.psd.Region` to the union minus the intersection of itself with the specified :py:class:`aspose.psd.Region`.
        
        :param region: The :py:class:`aspose.psd.Region` to xor with this :py:class:`aspose.psd.Region`.'''
        ...
    
    @overload
    def exclude(self, rect : aspose.psd.RectangleF):
        '''Updates this :py:class:`aspose.psd.Region` to contain only the portion of its interior that does not intersect with the specified :py:class:`aspose.psd.RectangleF` structure.
        
        :param rect: The :py:class:`aspose.psd.RectangleF` structure to exclude from this :py:class:`aspose.psd.Region`.'''
        ...
    
    @overload
    def exclude(self, rect : aspose.psd.Rectangle):
        '''Updates this :py:class:`aspose.psd.Region` to contain only the portion of its interior that does not intersect with the specified :py:class:`aspose.psd.Rectangle` structure.
        
        :param rect: The :py:class:`aspose.psd.Rectangle` structure to exclude from this :py:class:`aspose.psd.Region`.'''
        ...
    
    @overload
    def exclude(self, path : aspose.psd.GraphicsPath):
        '''Updates this :py:class:`aspose.psd.Region` to contain only the portion of its interior that does not intersect with the specified :py:class:`aspose.psd.GraphicsPath`.
        
        :param path: The :py:class:`aspose.psd.GraphicsPath` to exclude from this :py:class:`aspose.psd.Region`.'''
        ...
    
    @overload
    def exclude(self, region : aspose.psd.Region):
        '''Updates this :py:class:`aspose.psd.Region` to contain only the portion of its interior that does not intersect with the specified :py:class:`aspose.psd.Region`.
        
        :param region: The :py:class:`aspose.psd.Region` to exclude from this :py:class:`aspose.psd.Region`.'''
        ...
    
    @overload
    def complement(self, rect : aspose.psd.RectangleF):
        '''Updates this :py:class:`aspose.psd.Region` to contain the portion of the specified :py:class:`aspose.psd.RectangleF` structure that does not intersect with this :py:class:`aspose.psd.Region`.
        
        :param rect: The :py:class:`aspose.psd.RectangleF` structure to complement this :py:class:`aspose.psd.Region`.'''
        ...
    
    @overload
    def complement(self, rect : aspose.psd.Rectangle):
        '''Updates this :py:class:`aspose.psd.Region` to contain the portion of the specified :py:class:`aspose.psd.Rectangle` structure that does not intersect with this :py:class:`aspose.psd.Region`.
        
        :param rect: The :py:class:`aspose.psd.Rectangle` structure to complement this :py:class:`aspose.psd.Region`.'''
        ...
    
    @overload
    def complement(self, path : aspose.psd.GraphicsPath):
        '''Updates this :py:class:`aspose.psd.Region` to contain the portion of the specified :py:class:`aspose.psd.GraphicsPath` that does not intersect with this :py:class:`aspose.psd.Region`.
        
        :param path: The :py:class:`aspose.psd.GraphicsPath` to complement this :py:class:`aspose.psd.Region`.'''
        ...
    
    @overload
    def complement(self, region : aspose.psd.Region):
        '''Updates this :py:class:`aspose.psd.Region` to contain the portion of the specified :py:class:`aspose.psd.Region` that does not intersect with this :py:class:`aspose.psd.Region`.
        
        :param region: The :py:class:`aspose.psd.Region` object to complement this :py:class:`aspose.psd.Region` object.'''
        ...
    
    @overload
    def translate(self, dx : float, dy : float):
        '''Offsets the coordinates of this :py:class:`aspose.psd.Region` by the specified amount.
        
        :param dx: The amount to offset this :py:class:`aspose.psd.Region` horizontally.
        :param dy: The amount to offset this :py:class:`aspose.psd.Region` vertically.'''
        ...
    
    @overload
    def translate(self, dx : int, dy : int):
        '''Offsets the coordinates of this :py:class:`aspose.psd.Region` by the specified amount.
        
        :param dx: The amount to offset this :py:class:`aspose.psd.Region` horizontally.
        :param dy: The amount to offset this :py:class:`aspose.psd.Region` vertically.'''
        ...
    
    @overload
    def is_visible(self, x : float, y : float) -> bool:
        '''Tests whether the specified point is contained within this :py:class:`aspose.psd.Region`.
        
        :param x: The x-coordinate of the point to test.
        :param y: The y-coordinate of the point to test.
        :returns: True when the specified point is contained within this :py:class:`aspose.psd.Region`; otherwise, false.'''
        ...
    
    @overload
    def is_visible(self, point : aspose.psd.PointF) -> bool:
        '''Tests whether the specified :py:class:`aspose.psd.PointF` structure is contained within this :py:class:`aspose.psd.Region`.
        
        :param point: The :py:class:`aspose.psd.PointF` structure to test.
        :returns: true when ``point`` is contained within this :py:class:`aspose.psd.Region`; otherwise, false.'''
        ...
    
    @overload
    def is_visible(self, x : float, y : float, g : aspose.psd.Graphics) -> bool:
        '''Tests whether the specified point is contained within this :py:class:`aspose.psd.Region` when drawn using the specified :py:class:`aspose.psd.Graphics`.
        
        :param x: The x-coordinate of the point to test.
        :param y: The y-coordinate of the point to test.
        :param g: A :py:class:`aspose.psd.Graphics` that represents a graphics context.
        :returns: True when the specified point is contained within this :py:class:`aspose.psd.Region`; otherwise, false.'''
        ...
    
    @overload
    def is_visible(self, point : aspose.psd.PointF, g : aspose.psd.Graphics) -> bool:
        '''Tests whether the specified :py:class:`aspose.psd.PointF` structure is contained within this :py:class:`aspose.psd.Region` when drawn using the specified :py:class:`aspose.psd.Graphics`.
        
        :param point: The :py:class:`aspose.psd.PointF` structure to test.
        :param g: A :py:class:`aspose.psd.Graphics` that represents a graphics context.
        :returns: true when ``point`` is contained within this :py:class:`aspose.psd.Region`; otherwise, false.'''
        ...
    
    @overload
    def is_visible(self, x : float, y : float, width : float, height : float) -> bool:
        '''Tests whether any portion of the specified rectangle is contained within this :py:class:`aspose.psd.Region`.
        
        :param x: The x-coordinate of the upper-left corner of the rectangle to test.
        :param y: The y-coordinate of the upper-left corner of the rectangle to test.
        :param width: The width of the rectangle to test.
        :param height: The height of the rectangle to test.
        :returns: true when any portion of the specified rectangle is contained within this :py:class:`aspose.psd.Region` object; otherwise, false.'''
        ...
    
    @overload
    def is_visible(self, rect : aspose.psd.RectangleF) -> bool:
        '''Tests whether any portion of the specified :py:class:`aspose.psd.RectangleF` structure is contained within this :py:class:`aspose.psd.Region`.
        
        :param rect: The :py:class:`aspose.psd.RectangleF` structure to test.
        :returns: true when any portion of ``rect`` is contained within this :py:class:`aspose.psd.Region`; otherwise, false.'''
        ...
    
    @overload
    def is_visible(self, x : float, y : float, width : float, height : float, g : aspose.psd.Graphics) -> bool:
        '''Tests whether any portion of the specified rectangle is contained within this :py:class:`aspose.psd.Region` when drawn using the specified :py:class:`aspose.psd.Graphics`.
        
        :param x: The x-coordinate of the upper-left corner of the rectangle to test.
        :param y: The y-coordinate of the upper-left corner of the rectangle to test.
        :param width: The width of the rectangle to test.
        :param height: The height of the rectangle to test.
        :param g: A :py:class:`aspose.psd.Graphics` that represents a graphics context.
        :returns: true when any portion of the specified rectangle is contained within this :py:class:`aspose.psd.Region`; otherwise, false.'''
        ...
    
    @overload
    def is_visible(self, rect : aspose.psd.RectangleF, g : aspose.psd.Graphics) -> bool:
        '''Tests whether any portion of the specified :py:class:`aspose.psd.RectangleF` structure is contained within this :py:class:`aspose.psd.Region` when drawn using the specified :py:class:`aspose.psd.Graphics`.
        
        :param rect: The :py:class:`aspose.psd.RectangleF` structure to test.
        :param g: A :py:class:`aspose.psd.Graphics` that represents a graphics context.
        :returns: true when ``rect`` is contained within this :py:class:`aspose.psd.Region`; otherwise, false.'''
        ...
    
    @overload
    def is_visible(self, x : int, y : int, g : aspose.psd.Graphics) -> bool:
        '''Tests whether the specified point is contained within this :py:class:`aspose.psd.Region` object when drawn using the specified :py:class:`aspose.psd.Graphics` object.
        
        :param x: The x-coordinate of the point to test.
        :param y: The y-coordinate of the point to test.
        :param g: A :py:class:`aspose.psd.Graphics` that represents a graphics context.
        :returns: true when the specified point is contained within this :py:class:`aspose.psd.Region`; otherwise, false.'''
        ...
    
    @overload
    def is_visible(self, point : aspose.psd.Point) -> bool:
        '''Tests whether the specified :py:class:`aspose.psd.Point` structure is contained within this :py:class:`aspose.psd.Region`.
        
        :param point: The :py:class:`aspose.psd.Point` structure to test.
        :returns: true when ``point`` is contained within this :py:class:`aspose.psd.Region`; otherwise, false.'''
        ...
    
    @overload
    def is_visible(self, point : aspose.psd.Point, g : aspose.psd.Graphics) -> bool:
        '''Tests whether the specified :py:class:`aspose.psd.Point` structure is contained within this :py:class:`aspose.psd.Region` when drawn using the specified :py:class:`aspose.psd.Graphics`.
        
        :param point: The :py:class:`aspose.psd.Point` structure to test.
        :param g: A :py:class:`aspose.psd.Graphics` that represents a graphics context.
        :returns: true when ``point`` is contained within this :py:class:`aspose.psd.Region`; otherwise, false.'''
        ...
    
    @overload
    def is_visible(self, x : int, y : int, width : int, height : int) -> bool:
        '''Tests whether any portion of the specified rectangle is contained within this :py:class:`aspose.psd.Region`.
        
        :param x: The x-coordinate of the upper-left corner of the rectangle to test.
        :param y: The y-coordinate of the upper-left corner of the rectangle to test.
        :param width: The width of the rectangle to test.
        :param height: The height of the rectangle to test.
        :returns: true when any portion of the specified rectangle is contained within this :py:class:`aspose.psd.Region`; otherwise, false.'''
        ...
    
    @overload
    def is_visible(self, rect : aspose.psd.Rectangle) -> bool:
        '''Tests whether any portion of the specified :py:class:`aspose.psd.Rectangle` structure is contained within this :py:class:`aspose.psd.Region`.
        
        :param rect: The :py:class:`aspose.psd.Rectangle` structure to test.
        :returns: This method returns true when any portion of ``rect`` is contained within this :py:class:`aspose.psd.Region`; otherwise, false.'''
        ...
    
    @overload
    def is_visible(self, x : int, y : int, width : int, height : int, g : aspose.psd.Graphics) -> bool:
        '''Tests whether any portion of the specified rectangle is contained within this :py:class:`aspose.psd.Region` when drawn using the specified :py:class:`aspose.psd.Graphics`.
        
        :param x: The x-coordinate of the upper-left corner of the rectangle to test.
        :param y: The y-coordinate of the upper-left corner of the rectangle to test.
        :param width: The width of the rectangle to test.
        :param height: The height of the rectangle to test.
        :param g: A :py:class:`aspose.psd.Graphics` that represents a graphics context.
        :returns: true when any portion of the specified rectangle is contained within this :py:class:`aspose.psd.Region`; otherwise, false.'''
        ...
    
    @overload
    def is_visible(self, rect : aspose.psd.Rectangle, g : aspose.psd.Graphics) -> bool:
        '''Tests whether any portion of the specified :py:class:`aspose.psd.Rectangle` structure is contained within this :py:class:`aspose.psd.Region` when drawn using the specified :py:class:`aspose.psd.Graphics`.
        
        :param rect: The :py:class:`aspose.psd.Rectangle` structure to test.
        :param g: A :py:class:`aspose.psd.Graphics` that represents a graphics context.
        :returns: true when any portion of the ``rect`` is contained within this :py:class:`aspose.psd.Region`; otherwise, false.'''
        ...
    
    def deep_clone(self) -> aspose.psd.Region:
        '''Creates an exact deep copy of this :py:class:`aspose.psd.Region`.
        
        :returns: The :py:class:`aspose.psd.Region` that this method creates.'''
        ...
    
    def make_infinite(self):
        '''Initializes this :py:class:`aspose.psd.Region` object to an infinite interior.'''
        ...
    
    def make_empty(self):
        '''Initializes this :py:class:`aspose.psd.Region` to an empty interior.'''
        ...
    
    def transform(self, matrix : aspose.psd.Matrix):
        '''Transforms this :py:class:`aspose.psd.Region` by the specified :py:class:`aspose.psd.Matrix`.
        
        :param matrix: The :py:class:`aspose.psd.Matrix` by which to transform this :py:class:`aspose.psd.Region`.'''
        ...
    
    def is_empty(self, g : aspose.psd.Graphics) -> bool:
        '''Tests whether this :py:class:`aspose.psd.Region` has an empty interior on the specified drawing surface.
        
        :param g: A :py:class:`aspose.psd.Graphics` that represents a drawing surface.
        :returns: true if the interior of this :py:class:`aspose.psd.Region` is empty when the transformation associated with ``g`` is applied; otherwise, false.'''
        ...
    
    def is_infinite(self, g : aspose.psd.Graphics) -> bool:
        '''Tests whether this :py:class:`aspose.psd.Region` has an infinite interior on the specified drawing surface.
        
        :param g: A :py:class:`aspose.psd.Graphics` that represents a drawing surface.
        :returns: true if the interior of this :py:class:`aspose.psd.Region` is infinite when the transformation associated with ``g`` is applied; otherwise, false.'''
        ...
    
    def equals(self, region : aspose.psd.Region, g : aspose.psd.Graphics) -> bool:
        '''Tests whether the specified :py:class:`aspose.psd.Region` is identical to this :py:class:`aspose.psd.Region` on the specified drawing surface.
        
        :param region: The :py:class:`aspose.psd.Region` to test.
        :param g: A :py:class:`aspose.psd.Graphics` that represents a drawing surface.
        :returns: True if the interior of region is identical to the interior of this region when the transformation associated with the ``g`` parameter is applied; otherwise, false.'''
        ...
    
    ...

class ResolutionSetting:
    '''The resolution setting for image save options.'''
    
    @property
    def horizontal_resolution(self) -> float:
        ...
    
    @horizontal_resolution.setter
    def horizontal_resolution(self, value : float):
        ...
    
    @property
    def vertical_resolution(self) -> float:
        ...
    
    @vertical_resolution.setter
    def vertical_resolution(self, value : float):
        ...
    
    ...

class Shape(ObjectWithBounds):
    '''The shape. A continuous set of points connected using a specific rule.'''
    
    @overload
    def get_bounds(self, matrix : aspose.psd.Matrix) -> aspose.psd.RectangleF:
        '''Gets the object's bounds.
        
        :param matrix: The matrix to apply before bounds will be calculated.
        :returns: The estimated object's bounds.'''
        ...
    
    @overload
    def get_bounds(self, matrix : aspose.psd.Matrix, pen : aspose.psd.Pen) -> aspose.psd.RectangleF:
        '''Gets the object's bounds.
        
        :param matrix: The matrix to apply before bounds will be calculated.
        :param pen: The pen to use for object. This can influence the object's bounds size.
        :returns: The estimated object's bounds.'''
        ...
    
    def transform(self, transform : aspose.psd.Matrix):
        '''Applies the specified transformation to the shape.
        
        :param transform: The transformation to apply.'''
        ...
    
    @property
    def bounds(self) -> aspose.psd.RectangleF:
        '''Gets the object's bounds.'''
        ...
    
    @property
    def center(self) -> aspose.psd.PointF:
        '''Gets the shape's center.'''
        ...
    
    @property
    def segments(self) -> List[aspose.psd.ShapeSegment]:
        '''Gets the shape segments.'''
        ...
    
    @property
    def has_segments(self) -> bool:
        ...
    
    ...

class ShapeSegment:
    '''Represents a shape segment. A segment is a line or curve connecting two points.'''
    
    @property
    def start_point(self) -> aspose.psd.PointF:
        ...
    
    @property
    def end_point(self) -> aspose.psd.PointF:
        ...
    
    ...

class Size:
    '''Represents size.'''
    
    @staticmethod
    def add(size1 : aspose.psd.Sizesize2 : aspose.psd.Size) -> aspose.psd.Size:
        '''Adds the width and height of one :py:class:`aspose.psd.Size` structure to the width and height of another :py:class:`aspose.psd.Size` structure.
        
        :param size1: The first :py:class:`aspose.psd.Size` to add.
        :param size2: The second :py:class:`aspose.psd.Size` to add.
        :returns: A :py:class:`aspose.psd.Size` structure that is the result of the addition operation.'''
        ...
    
    @staticmethod
    def ceiling(size : aspose.psd.SizeF) -> aspose.psd.Size:
        '''Converts the specified :py:class:`aspose.psd.SizeF` structure to a :py:class:`aspose.psd.Size` structure by rounding the values of the :py:class:`aspose.psd.Size` structure to the next higher integer values.
        
        :param size: The :py:class:`aspose.psd.SizeF` structure to convert.
        :returns: The :py:class:`aspose.psd.Size` structure this method converts to.'''
        ...
    
    @staticmethod
    def subtract(size1 : aspose.psd.Sizesize2 : aspose.psd.Size) -> aspose.psd.Size:
        '''Subtracts the width and height of one :py:class:`aspose.psd.Size` structure from the width and height of another :py:class:`aspose.psd.Size` structure.
        
        :param size1: The :py:class:`aspose.psd.Size` structure on the left side of the subtraction operator.
        :param size2: The :py:class:`aspose.psd.Size` structure on the right side of the subtraction operator.
        :returns: The :py:class:`aspose.psd.Size` that is a result of the subtraction operation.'''
        ...
    
    @staticmethod
    def truncate(size : aspose.psd.SizeF) -> aspose.psd.Size:
        '''Converts the specified :py:class:`aspose.psd.SizeF` structure to a :py:class:`aspose.psd.Size` structure by truncating the values of the :py:class:`aspose.psd.SizeF` structure to the next lower integer values.
        
        :param size: The :py:class:`aspose.psd.SizeF` structure to convert.
        :returns: The :py:class:`aspose.psd.Size` structure this method converts to.'''
        ...
    
    @staticmethod
    def round(size : aspose.psd.SizeF) -> aspose.psd.Size:
        '''Converts the specified :py:class:`aspose.psd.SizeF` structure to a :py:class:`aspose.psd.Size` structure by rounding the values of the :py:class:`aspose.psd.SizeF` structure to the nearest integer values.
        
        :param size: The :py:class:`aspose.psd.SizeF` structure to convert.
        :returns: The :py:class:`aspose.psd.Size` structure this method converts to.'''
        ...
    
    @classmethod
    @property
    def empty(cls) -> aspose.psd.Size:
        '''Gets a new instance of the :py:class:`aspose.psd.Size` structure that has :py:attr:`aspose.psd.Size.width` and :py:attr:`aspose.psd.Size.height` values set to zero.'''
        ...
    
    @property
    def is_empty(self) -> bool:
        ...
    
    @property
    def width(self) -> int:
        '''Gets the horizontal component of this :py:class:`aspose.psd.Size`.'''
        ...
    
    @width.setter
    def width(self, value : int):
        '''Sets the horizontal component of this :py:class:`aspose.psd.Size`.'''
        ...
    
    @property
    def height(self) -> int:
        '''Gets the vertical component of this :py:class:`aspose.psd.Size`.'''
        ...
    
    @height.setter
    def height(self, value : int):
        '''Sets the vertical component of this :py:class:`aspose.psd.Size`.'''
        ...
    
    ...

class SizeF:
    '''Stores an ordered pair of floating-point numbers, typically the width and height of a rectangle.'''
    
    @staticmethod
    def add(size1 : aspose.psd.SizeFsize2 : aspose.psd.SizeF) -> aspose.psd.SizeF:
        '''Adds the width and height of one :py:class:`aspose.psd.SizeF` structure to the width and height of another :py:class:`aspose.psd.SizeF` structure.
        
        :param size1: The first :py:class:`aspose.psd.SizeF` to add.
        :param size2: The second :py:class:`aspose.psd.SizeF` to add.
        :returns: A :py:class:`aspose.psd.SizeF` structure that is the result of the addition operation.'''
        ...
    
    @staticmethod
    def subtract(size1 : aspose.psd.SizeFsize2 : aspose.psd.SizeF) -> aspose.psd.SizeF:
        '''Subtracts the width and height of one :py:class:`aspose.psd.SizeF` structure from the width and height of another :py:class:`aspose.psd.SizeF` structure.
        
        :param size1: The :py:class:`aspose.psd.SizeF` structure on the left side of the subtraction operator.
        :param size2: The :py:class:`aspose.psd.SizeF` structure on the right side of the subtraction operator.
        :returns: The :py:class:`aspose.psd.SizeF` that is a result of the subtraction operation.'''
        ...
    
    def to_point_f(self) -> aspose.psd.PointF:
        '''Converts a :py:class:`aspose.psd.SizeF` to a :py:class:`aspose.psd.PointF`.
        
        :returns: Returns a :py:class:`aspose.psd.PointF` structure.'''
        ...
    
    def to_size(self) -> aspose.psd.Size:
        '''Converts a :py:class:`aspose.psd.SizeF` to a :py:class:`aspose.psd.Size` structure with truncated size values.
        
        :returns: Returns a :py:class:`aspose.psd.Size` structure.'''
        ...
    
    @classmethod
    @property
    def empty(cls) -> aspose.psd.SizeF:
        '''Gets a new instance of the :py:class:`aspose.psd.SizeF` structure that has :py:attr:`aspose.psd.SizeF.width` and :py:attr:`aspose.psd.SizeF.height` values set to zero.'''
        ...
    
    @property
    def is_empty(self) -> bool:
        ...
    
    @property
    def width(self) -> float:
        '''Gets the horizontal component of this :py:class:`aspose.psd.SizeF`.'''
        ...
    
    @width.setter
    def width(self, value : float):
        '''Sets the horizontal component of this :py:class:`aspose.psd.SizeF`.'''
        ...
    
    @property
    def height(self) -> float:
        '''Gets the vertical component of this :py:class:`aspose.psd.SizeF`.'''
        ...
    
    @height.setter
    def height(self, value : float):
        '''Sets the vertical component of this :py:class:`aspose.psd.SizeF`.'''
        ...
    
    ...

class Source:
    '''The source is used to contain all relevant information for an object pipe.'''
    
    def get_stream_container(self) -> aspose.psd.StreamContainer:
        '''Gets the stream container.
        
        :returns: the stream container.'''
        ...
    
    ...

class SplitStreamContainer(StreamContainer):
    '''Represents split stream container which contains the stream and provides stream processing routines.'''
    
    @overload
    def write(self, bytes : bytes):
        '''Writes all of the specified bytes to the stream.
        
        :param bytes: The bytes to write.'''
        ...
    
    @overload
    def write(self, buffer : bytes, offset : int, count : int):
        '''Writes a sequence of bytes to the current stream and advances the current position within this stream by the number of bytes written.
        
        :param buffer: An array of bytes. This method copies ``count`` bytes from ``buffer`` to the current stream.
        :param offset: The zero-based byte offset in ``buffer`` at which to begin copying bytes to the current stream.
        :param count: The number of bytes to be written to the current stream.'''
        ...
    
    @overload
    def read(self, bytes : bytes) -> int:
        '''Reads bytes to fill the specified bytes buffer.
        
        :param bytes: The bytes to fill.
        :returns: The number of bytes read. This value can be less than the number of bytes in the buffer if there is not enough bytes in the stream.'''
        ...
    
    @overload
    def read(self, buffer : bytes, offset : int, count : int) -> int:
        '''Reads a sequence of bytes from the current stream and advances the position within the stream by the number of bytes read.
        
        :param buffer: An array of bytes. When this method returns, the buffer contains the specified byte array with the values between ``offset`` and (``offset`` + ``count`` - 1) replaced by the bytes read from the current source.
        :param offset: The zero-based byte offset in ``buffer`` at which to begin storing the data read from the current stream.
        :param count: The maximum number of bytes to be read from the current stream.
        :returns: The total number of bytes read into the buffer. This can be less than the number of bytes requested if that many bytes are not currently available, or zero (0) if the end of the stream has been reached.'''
        ...
    
    @overload
    def to_bytes(self) -> bytes:
        '''Converts the stream data to the :py:class:`int` array.
        
        :returns: The stream data converted to the :py:class:`int` array.'''
        ...
    
    @overload
    def to_bytes(self, position : int, bytes_count : int) -> bytes:
        '''Converts the stream data to the :py:class:`int` array.
        
        :param position: The position to start reading bytes from.
        :param bytes_count: The bytes count to read.
        :returns: The stream data converted to the :py:class:`int` array.'''
        ...
    
    @overload
    def save(self, destination_stream : io.RawIOBase, buffer_size : int, length : int):
        '''Saves (copies) the stream's data to the specified stream.
        
        :param destination_stream: The stream to save the data to.
        :param buffer_size: The buffer size. By default :py:class:`ReadWriteBytesCount` value is used.
        :param length: The stream data length to copy. By default the length is set to :py:attr:`aspose.psd.SplitStreamContainer.length` value.'''
        ...
    
    @overload
    def save(self, destination_stream : io.RawIOBase):
        '''Saves (copies) the stream's data to the specified stream. Uses default buffer size :py:attr:`aspose.psd.StreamContainer.READ_WRITE_BYTES_COUNT` and stream :py:attr:`aspose.psd.StreamContainer.length` value.
        
        :param destination_stream: The stream to save the data to.'''
        ...
    
    @overload
    def save(self, destination_stream : io.RawIOBase, buffer_size : int):
        '''Saves (copies) all the stream's data to the specified stream. Uses stream :py:attr:`aspose.psd.StreamContainer.length` value.
        
        :param destination_stream: The stream to save the data to.
        :param buffer_size: The buffer.'''
        ...
    
    @overload
    def save(self, file_path : str):
        '''Saves (copies) the stream's data to the specified stream. Uses default buffer size :py:attr:`aspose.psd.StreamContainer.READ_WRITE_BYTES_COUNT` and stream :py:attr:`aspose.psd.StreamContainer.length` value.
        
        :param file_path: The file path to save the stream data to.'''
        ...
    
    @overload
    def save(self, file_path : str, buffer_size : int):
        '''Saves (copies) the stream's data to the specified stream. Uses stream :py:attr:`aspose.psd.StreamContainer.length` value.
        
        :param file_path: The file path to save the stream data to.
        :param buffer_size: The buffer size. By default :py:attr:`aspose.psd.StreamContainer.READ_WRITE_BYTES_COUNT` value is used.'''
        ...
    
    @overload
    def save(self, file_path : str, buffer_size : int, length : int):
        '''Saves (copies) the stream's data to the specified stream.
        
        :param file_path: The file path to save the stream data to.
        :param buffer_size: The buffer size. By default :py:attr:`aspose.psd.StreamContainer.READ_WRITE_BYTES_COUNT` value is used.
        :param length: The stream data length to copy. By default the length is set to :py:attr:`aspose.psd.StreamContainer.length` value.'''
        ...
    
    @overload
    def write_to(self, stream_container : aspose.psd.StreamContainer):
        '''Copies the contained data to another :py:class:`aspose.psd.StreamContainer`.
        
        :param stream_container: The stream container to copy to.'''
        ...
    
    @overload
    def write_to(self, stream_container : aspose.psd.StreamContainer, length : int):
        '''Copies the contained data to another :py:class:`aspose.psd.StreamContainer`.
        
        :param stream_container: The stream container to copy to.
        :param length: The bytes count to write.'''
        ...
    
    def flush(self):
        '''Clears all buffers for this stream and causes any buffered data to be written to the underlying device.'''
        ...
    
    def write_byte(self, value : byte):
        '''Writes a byte to the current position in the stream and advances the position within the stream by one byte.
        
        :param value: The byte to write to the stream.'''
        ...
    
    def read_byte(self) -> int:
        '''Reads a byte from the stream and advances the position within the stream by one byte, or returns -1 if at the end of the stream.
        
        :returns: The unsigned byte cast to an Int32, or -1 if at the end of the stream.'''
        ...
    
    def seek(self, offset : int, origin : aspose.psd.SeekOrigin) -> int:
        '''Sets the position within the current stream.
        
        :param offset: A byte offset relative to the ``origin`` parameter. This value represents offset from the starting stream position passed in the StreamContainer constructor.
        :param origin: A value of type :py:class:`System.IO.SeekOrigin` indicating the reference point used to obtain the new position.
        :returns: The new position within the current stream.'''
        ...
    
    def seek_begin(self):
        '''Sets the stream position to the beginning of the stream. This value represents offset from the starting stream position passed in the StreamContainer constructor.'''
        ...
    
    def insert(self, position : int, stream : aspose.psd.StreamContainer, dispose_stream : bool):
        '''Inserts the stream container into specified position.
        
        :param position: The position to insert to.
        :param stream: The stream container to insert.
        :param dispose_stream: if set to ``true`` disposes stream.'''
        ...
    
    @property
    def disposed(self) -> bool:
        '''Gets a value indicating whether this instance is disposed.'''
        ...
    
    @property
    def sync_root(self) -> any:
        ...
    
    @property
    def position(self) -> int:
        '''Gets the current position within the stream. This value represents offset from the starting stream position passed in the StreamContainer constructor.'''
        ...
    
    @position.setter
    def position(self, value : int):
        '''Sets the current position within the stream. This value represents offset from the starting stream position passed in the StreamContainer constructor.'''
        ...
    
    @property
    def stream(self) -> io.RawIOBase:
        '''Gets the data stream.'''
        ...
    
    @property
    def is_stream_disposed_on_close(self) -> bool:
        ...
    
    @property
    def length(self) -> int:
        '''Gets the stream length in bytes. This value is less than the :py:attr:`io.RawIOBase.Length` by the starting stream position passed in the StreamContainer constructor.'''
        ...
    
    @length.setter
    def length(self, value : int):
        '''Sets the stream length in bytes. This value is less than the :py:attr:`io.RawIOBase.Length` by the starting stream position passed in the StreamContainer constructor.'''
        ...
    
    @property
    def can_read(self) -> bool:
        ...
    
    @property
    def can_seek(self) -> bool:
        ...
    
    @property
    def can_write(self) -> bool:
        ...
    
    @classmethod
    @property
    def READ_WRITE_BYTES_COUNT(cls) -> int:
        ...
    
    ...

class StreamContainer(DisposableObject):
    '''Represents stream container which contains the stream and provides stream processing routines.'''
    
    @overload
    def write(self, bytes : bytes):
        '''Writes all of the specified bytes to the stream.
        
        :param bytes: The bytes to write.'''
        ...
    
    @overload
    def write(self, buffer : bytes, offset : int, count : int):
        '''Writes a sequence of bytes to the current stream and advances the current position within this stream by the number of bytes written.
        
        :param buffer: An array of bytes. This method copies ``count`` bytes from ``buffer`` to the current stream.
        :param offset: The zero-based byte offset in ``buffer`` at which to begin copying bytes to the current stream.
        :param count: The number of bytes to be written to the current stream.'''
        ...
    
    @overload
    def read(self, bytes : bytes) -> int:
        '''Reads bytes to fill the specified bytes buffer.
        
        :param bytes: The bytes to fill.
        :returns: The number of bytes read. This value can be less than the number of bytes in the buffer if there is not enough bytes in the stream.'''
        ...
    
    @overload
    def read(self, buffer : bytes, offset : int, count : int) -> int:
        '''Reads a sequence of bytes from the current stream and advances the position within the stream by the number of bytes read.
        
        :param buffer: An array of bytes. When this method returns, the buffer contains the specified byte array with the values between ``offset`` and (``offset`` + ``count`` - 1) replaced by the bytes read from the current source.
        :param offset: The zero-based byte offset in ``buffer`` at which to begin storing the data read from the current stream.
        :param count: The maximum number of bytes to be read from the current stream.
        :returns: The total number of bytes read into the buffer. This can be less than the number of bytes requested if that many bytes are not currently available, or zero (0) if the end of the stream has been reached.'''
        ...
    
    @overload
    def to_bytes(self) -> bytes:
        '''Converts the stream data to the :py:class:`int` array.
        
        :returns: The stream data converted to the :py:class:`int` array.'''
        ...
    
    @overload
    def to_bytes(self, position : int, bytes_count : int) -> bytes:
        '''Converts the stream data to the :py:class:`int` array.
        
        :param position: The position to start reading bytes from.
        :param bytes_count: The bytes count to read.
        :returns: The stream data converted to the :py:class:`int` array.'''
        ...
    
    @overload
    def save(self, destination_stream : io.RawIOBase):
        '''Saves (copies) the stream's data to the specified stream. Uses default buffer size :py:attr:`aspose.psd.StreamContainer.READ_WRITE_BYTES_COUNT` and stream :py:attr:`aspose.psd.StreamContainer.length` value.
        
        :param destination_stream: The stream to save the data to.'''
        ...
    
    @overload
    def save(self, destination_stream : io.RawIOBase, buffer_size : int):
        '''Saves (copies) all the stream's data to the specified stream. Uses stream :py:attr:`aspose.psd.StreamContainer.length` value.
        
        :param destination_stream: The stream to save the data to.
        :param buffer_size: The buffer.'''
        ...
    
    @overload
    def save(self, destination_stream : io.RawIOBase, buffer_size : int, length : int):
        '''Saves (copies) the stream's data to the specified stream.
        
        :param destination_stream: The stream to save the data to.
        :param buffer_size: The buffer size. By default :py:attr:`aspose.psd.StreamContainer.READ_WRITE_BYTES_COUNT` value is used.
        :param length: The stream data length to copy. By default the length is set to :py:attr:`aspose.psd.StreamContainer.length` value.'''
        ...
    
    @overload
    def save(self, file_path : str):
        '''Saves (copies) the stream's data to the specified stream. Uses default buffer size :py:attr:`aspose.psd.StreamContainer.READ_WRITE_BYTES_COUNT` and stream :py:attr:`aspose.psd.StreamContainer.length` value.
        
        :param file_path: The file path to save the stream data to.'''
        ...
    
    @overload
    def save(self, file_path : str, buffer_size : int):
        '''Saves (copies) the stream's data to the specified stream. Uses stream :py:attr:`aspose.psd.StreamContainer.length` value.
        
        :param file_path: The file path to save the stream data to.
        :param buffer_size: The buffer size. By default :py:attr:`aspose.psd.StreamContainer.READ_WRITE_BYTES_COUNT` value is used.'''
        ...
    
    @overload
    def save(self, file_path : str, buffer_size : int, length : int):
        '''Saves (copies) the stream's data to the specified stream.
        
        :param file_path: The file path to save the stream data to.
        :param buffer_size: The buffer size. By default :py:attr:`aspose.psd.StreamContainer.READ_WRITE_BYTES_COUNT` value is used.
        :param length: The stream data length to copy. By default the length is set to :py:attr:`aspose.psd.StreamContainer.length` value.'''
        ...
    
    @overload
    def write_to(self, stream_container : aspose.psd.StreamContainer):
        '''Copies the contained data to another :py:class:`aspose.psd.StreamContainer`.
        
        :param stream_container: The stream container to copy to.'''
        ...
    
    @overload
    def write_to(self, stream_container : aspose.psd.StreamContainer, length : int):
        '''Copies the contained data to another :py:class:`aspose.psd.StreamContainer`.
        
        :param stream_container: The stream container to copy to.
        :param length: The bytes count to write.'''
        ...
    
    def flush(self):
        '''Clears all buffers for this stream and causes any buffered data to be written to the underlying device.'''
        ...
    
    def write_byte(self, value : byte):
        '''Writes a byte to the current position in the stream and advances the position within the stream by one byte.
        
        :param value: The byte to write to the stream.'''
        ...
    
    def read_byte(self) -> int:
        '''Reads a byte from the stream and advances the position within the stream by one byte, or returns -1 if at the end of the stream.
        
        :returns: The unsigned byte cast to an Int32, or -1 if at the end of the stream.'''
        ...
    
    def seek(self, offset : int, origin : aspose.psd.SeekOrigin) -> int:
        '''Sets the position within the current stream.
        
        :param offset: A byte offset relative to the ``origin`` parameter. This value represents offset from the starting stream position passed in the StreamContainer constructor.
        :param origin: A value of type :py:class:`System.IO.SeekOrigin` indicating the reference point used to obtain the new position.
        :returns: The new position within the current stream.'''
        ...
    
    def seek_begin(self):
        '''Sets the stream position to the beginning of the stream. This value represents offset from the starting stream position passed in the StreamContainer constructor.'''
        ...
    
    @property
    def disposed(self) -> bool:
        '''Gets a value indicating whether this instance is disposed.'''
        ...
    
    @property
    def sync_root(self) -> any:
        ...
    
    @property
    def position(self) -> int:
        '''Gets the current position within the stream. This value represents offset from the starting stream position passed in the StreamContainer constructor.'''
        ...
    
    @position.setter
    def position(self, value : int):
        '''Sets the current position within the stream. This value represents offset from the starting stream position passed in the StreamContainer constructor.'''
        ...
    
    @property
    def stream(self) -> io.RawIOBase:
        '''Gets the data stream.'''
        ...
    
    @property
    def is_stream_disposed_on_close(self) -> bool:
        ...
    
    @property
    def length(self) -> int:
        '''Gets the stream length in bytes. This value is less than the :py:attr:`io.RawIOBase.Length` by the starting stream position passed in the StreamContainer constructor.'''
        ...
    
    @length.setter
    def length(self, value : int):
        '''Sets the stream length in bytes. This value is less than the :py:attr:`io.RawIOBase.Length` by the starting stream position passed in the StreamContainer constructor.'''
        ...
    
    @property
    def can_read(self) -> bool:
        ...
    
    @property
    def can_seek(self) -> bool:
        ...
    
    @property
    def can_write(self) -> bool:
        ...
    
    @classmethod
    @property
    def READ_WRITE_BYTES_COUNT(cls) -> int:
        ...
    
    ...

class StringFormat(DisposableObject):
    '''Encapsulates text layout information (such as alignment, orientation and tab stops) display manipulations (such as ellipsis insertion and national digit substitution) and OpenType features. This class cannot be inherited.'''
    
    def deep_clone(self) -> aspose.psd.StringFormat:
        '''Creates a deep clone of this :py:class:`aspose.psd.StringFormat` object.
        
        :returns: The deep clone of the current :py:class:`aspose.psd.StringFormat`.'''
        ...
    
    def set_tab_stops(self, first_tab_offset : float, tab_stops : List[float]):
        '''Sets tab stops for this :py:class:`aspose.psd.StringFormat` object.
        
        :param first_tab_offset: The number of spaces between the beginning of a line of text and the first tab stop.
        :param tab_stops: An array of distances between tab stops in the units specified by the :py:attr:`aspose.psd.Graphics.page_unit` property.'''
        ...
    
    @property
    def disposed(self) -> bool:
        '''Gets a value indicating whether this instance is disposed.'''
        ...
    
    @classmethod
    @property
    def generic_default(cls) -> aspose.psd.StringFormat:
        ...
    
    @classmethod
    @property
    def generic_typographic(cls) -> aspose.psd.StringFormat:
        ...
    
    @property
    def format_flags(self) -> aspose.psd.StringFormatFlags:
        ...
    
    @format_flags.setter
    def format_flags(self, value : aspose.psd.StringFormatFlags):
        ...
    
    @property
    def alignment(self) -> aspose.psd.StringAlignment:
        '''Gets text alignment information on the vertical plane.'''
        ...
    
    @alignment.setter
    def alignment(self, value : aspose.psd.StringAlignment):
        '''Sets text alignment information on the vertical plane.'''
        ...
    
    @property
    def line_alignment(self) -> aspose.psd.StringAlignment:
        ...
    
    @line_alignment.setter
    def line_alignment(self, value : aspose.psd.StringAlignment):
        ...
    
    @property
    def hotkey_prefix(self) -> aspose.psd.HotkeyPrefix:
        ...
    
    @hotkey_prefix.setter
    def hotkey_prefix(self, value : aspose.psd.HotkeyPrefix):
        ...
    
    @property
    def trimming(self) -> aspose.psd.StringTrimming:
        '''Gets the :py:class:`aspose.psd.StringTrimming` enumeration for this :py:class:`aspose.psd.StringFormat` object.'''
        ...
    
    @trimming.setter
    def trimming(self, value : aspose.psd.StringTrimming):
        '''Sets the :py:class:`aspose.psd.StringTrimming` enumeration for this :py:class:`aspose.psd.StringFormat` object.'''
        ...
    
    @property
    def digit_substitution_method(self) -> aspose.psd.StringDigitSubstitute:
        ...
    
    @digit_substitution_method.setter
    def digit_substitution_method(self, value : aspose.psd.StringDigitSubstitute):
        ...
    
    @property
    def digit_substitution_language(self) -> int:
        ...
    
    @digit_substitution_language.setter
    def digit_substitution_language(self, value : int):
        ...
    
    @property
    def first_tab_offset(self) -> float:
        ...
    
    @property
    def tab_stops(self) -> List[float]:
        ...
    
    @property
    def custom_char_ident(self) -> aspose.psd.PointF:
        ...
    
    @custom_char_ident.setter
    def custom_char_ident(self, value : aspose.psd.PointF):
        ...
    
    ...

class TransparencySupporter:
    '''The object supporting transparency.'''
    
    @property
    def opacity(self) -> float:
        '''Gets the object's opacity. The value should be between 0 and 1. Value of 0 means that object is fully visible, value of 1 means the object is fully opaque.'''
        ...
    
    @opacity.setter
    def opacity(self, value : float):
        '''Sets the object's opacity. The value should be between 0 and 1. Value of 0 means that object is fully visible, value of 1 means the object is fully opaque.'''
        ...
    
    ...

class VectorImage(Image):
    '''The vector image is the base class for all type of vector images.'''
    
    @overload
    def save(self):
        '''Saves the image data to the underlying stream.'''
        ...
    
    @overload
    def save(self, file_path : str, options : aspose.psd.ImageOptionsBase):
        '''Saves the object's data to the specified file location in the specified file format according to save options.
        
        :param file_path: The file path.
        :param options: The options.'''
        ...
    
    @overload
    def save(self, file_path : str, options : aspose.psd.ImageOptionsBase, bounds_rectangle : aspose.psd.Rectangle):
        '''Saves the object's data to the specified file location in the specified file format according to save options.
        
        :param file_path: The file path.
        :param options: The options.
        :param bounds_rectangle: The destination image bounds rectangle. Set the empty rectangle for use sourse bounds.'''
        ...
    
    @overload
    def save(self, stream : io.RawIOBase, options_base : aspose.psd.ImageOptionsBase):
        '''Saves the image's data to the specified stream in the specified file format according to save options.
        
        :param stream: The stream to save the image's data to.
        :param options_base: The save options.'''
        ...
    
    @overload
    def save(self, stream : io.RawIOBase, options_base : aspose.psd.ImageOptionsBase, bounds_rectangle : aspose.psd.Rectangle):
        '''Saves the image's data to the specified stream in the specified file format according to save options.
        
        :param stream: The stream to save the image's data to.
        :param options_base: The save options.
        :param bounds_rectangle: The destination image bounds rectangle. Set the empty rectangle for use source bounds.'''
        ...
    
    @overload
    def save(self, stream : io.RawIOBase):
        '''Saves the object's data to the specified stream.
        
        :param stream: The stream to save the object's data to.'''
        ...
    
    @overload
    def save(self, file_path : str):
        '''Saves the object's data to the specified file location.
        
        :param file_path: The file path to save the object's data to.'''
        ...
    
    @overload
    def save(self, file_path : str, over_write : bool):
        '''Saves the object's data to the specified file location.
        
        :param file_path: The file path to save the object's data to.
        :param over_write: if set to ``true`` over write the file contents, otherwise append will occur.'''
        ...
    
    @overload
    @staticmethod
    def can_load(file_path : str) -> bool:
        '''Determines whether image can be loaded from the specified file path.
        
        :param file_path: The file path.
        :returns: ``true`` if image can be loaded from the specified file; otherwise, ``false``.'''
        ...
    
    @overload
    @staticmethod
    def can_load(file_path : strload_options : aspose.psd.LoadOptions) -> bool:
        '''Determines whether image can be loaded from the specified file path and optionally using the specified open options.
        
        :param file_path: The file path.
        :param load_options: The load options.
        :returns: ``true`` if image can be loaded from the specified file; otherwise, ``false``.'''
        ...
    
    @overload
    @staticmethod
    def can_load(stream : io.RawIOBase) -> bool:
        '''Determines whether image can be loaded from the specified stream.
        
        :param stream: The stream to load from.
        :returns: ``true`` if image can be loaded from the specified stream; otherwise, ``false``.'''
        ...
    
    @overload
    @staticmethod
    def can_load(stream : io.RawIOBaseload_options : aspose.psd.LoadOptions) -> bool:
        '''Determines whether image can be loaded from the specified stream and optionally using the specified ``loadOptions``.
        
        :param stream: The stream to load from.
        :param load_options: The load options.
        :returns: ``true`` if image can be loaded from the specified stream; otherwise, ``false``.'''
        ...
    
    @overload
    @staticmethod
    def get_file_format(file_path : str) -> aspose.psd.FileFormat:
        '''Gets the file format.
        
        :param file_path: The file path.
        :returns: The determined file format.'''
        ...
    
    @overload
    @staticmethod
    def get_file_format(stream : io.RawIOBase) -> aspose.psd.FileFormat:
        '''Gets the file format.
        
        :param stream: The stream.
        :returns: The determined file format.'''
        ...
    
    @overload
    @staticmethod
    def get_fitting_rectangle(rectangle : aspose.psd.Rectanglewidth : int, height : int) -> aspose.psd.Rectangle:
        '''Gets rectangle which fits the current image.
        
        :param rectangle: The rectangle to get fitting rectangle for.
        :param width: The object width.
        :param height: The object height.
        :returns: The fitting rectangle or exception if no fitting rectangle can be found.'''
        ...
    
    @overload
    @staticmethod
    def get_fitting_rectangle(rectangle : aspose.psd.Rectanglepixels : List[int], width : int, height : int) -> aspose.psd.Rectangle:
        '''Gets rectangle which fits the current image.
        
        :param rectangle: The rectangle to get fitting rectangle for.
        :param pixels: The 32-bit ARGB pixels.
        :param width: The object width.
        :param height: The object height.
        :returns: The fitting rectangle or exception if no fitting rectangle can be found.'''
        ...
    
    @overload
    @staticmethod
    def load(file_path : strload_options : aspose.psd.LoadOptions) -> aspose.psd.Image:
        '''Loads a new image from the specified file.
        
        :param file_path: The file path to load image from.
        :param load_options: The load options.
        :returns: The loaded image.'''
        ...
    
    @overload
    @staticmethod
    def load(file_path : str) -> aspose.psd.Image:
        '''Loads a new image from the specified file.
        
        :param file_path: The file path to load image from.
        :returns: The loaded image.'''
        ...
    
    @overload
    @staticmethod
    def load(stream : io.RawIOBaseload_options : aspose.psd.LoadOptions) -> aspose.psd.Image:
        '''Loads a new image from the specified stream.
        
        :param stream: The stream to load image from.
        :param load_options: The load options.
        :returns: The loaded image.'''
        ...
    
    @overload
    @staticmethod
    def load(stream : io.RawIOBase) -> aspose.psd.Image:
        '''Loads a new image from the specified stream.
        
        :param stream: The stream to load image from.
        :returns: The loaded image.'''
        ...
    
    @overload
    def resize(self, new_width : int, new_height : int):
        '''Resizes the image. The default :py:attr:`aspose.psd.ResizeType.NEAREST_NEIGHBOUR_RESAMPLE` is used.
        
        :param new_width: The new width.
        :param new_height: The new height.'''
        ...
    
    @overload
    def resize(self, new_width : int, new_height : int, resize_type : aspose.psd.ResizeType):
        '''Resizes the image.
        
        :param new_width: The new width.
        :param new_height: The new height.
        :param resize_type: The resize type.'''
        ...
    
    @overload
    def resize(self, new_width : int, new_height : int, settings : aspose.psd.ImageResizeSettings):
        '''Resizes the image.
        
        :param new_width: The new width.
        :param new_height: The new height.
        :param settings: The resize settings.'''
        ...
    
    @overload
    def resize_width_proportionally(self, new_width : int):
        '''Resizes the width proportionally. The default :py:attr:`aspose.psd.ResizeType.NEAREST_NEIGHBOUR_RESAMPLE` is used.
        
        :param new_width: The new width.'''
        ...
    
    @overload
    def resize_width_proportionally(self, new_width : int, resize_type : aspose.psd.ResizeType):
        '''Resizes the width proportionally.
        
        :param new_width: The new width.
        :param resize_type: Type of the resize.'''
        ...
    
    @overload
    def resize_width_proportionally(self, new_width : int, settings : aspose.psd.ImageResizeSettings):
        '''Resizes the width proportionally.
        
        :param new_width: The new width.
        :param settings: The image resize settings.'''
        ...
    
    @overload
    def resize_height_proportionally(self, new_height : int):
        '''Resizes the height proportionally.
        
        :param new_height: The new height.'''
        ...
    
    @overload
    def resize_height_proportionally(self, new_height : int, resize_type : aspose.psd.ResizeType):
        '''Resizes the height proportionally.
        
        :param new_height: The new height.
        :param resize_type: Type of the resize.'''
        ...
    
    @overload
    def resize_height_proportionally(self, new_height : int, settings : aspose.psd.ImageResizeSettings):
        '''Resizes the height proportionally.
        
        :param new_height: The new height.
        :param settings: The image resize settings.'''
        ...
    
    def cache_data(self):
        '''Caches the data and ensures no additional data loading will be performed from the underlying :py:attr:`aspose.psd.DataStreamSupporter.data_stream_container`.'''
        ...
    
    @staticmethod
    def create(image_options : aspose.psd.ImageOptionsBasewidth : int, height : int) -> aspose.psd.Image:
        '''Creates a new image using the specified create options.
        
        :param image_options: The image options.
        :param width: The width.
        :param height: The height.
        :returns: The newly created image.'''
        ...
    
    def can_save(self, options : aspose.psd.ImageOptionsBase) -> bool:
        '''Determines whether image can be saved to the specified file format represented by the passed save options.
        
        :param options: The save options to use.
        :returns: ``true`` if image can be saved to the specified file format represented by the passed save options; otherwise, ``false``.'''
        ...
    
    def get_default_options(self, args : List[any]) -> aspose.psd.ImageOptionsBase:
        '''Gets the default options.
        
        :param args: The arguments.
        :returns: Default options'''
        ...
    
    def get_original_options(self) -> aspose.psd.ImageOptionsBase:
        '''Gets the options based on the original file settings.
        This can be helpful to keep bit-depth and other parameters of the original image unchanged.
        For example, if we load a black-white PNG image with 1 bit per pixel and then save it using the
        :py:func:`aspose.psd.DataStreamSupporter.save` method, the output PNG image with 8-bit per pixel will be produced.
        To avoid it and save PNG image with 1-bit per pixel, use this method to get corresponding saving options and pass them
        to the :py:func:`aspose.psd.Image.save` method as the second parameter.
        
        :returns: The options based on the original file settings.'''
        ...
    
    def rotate_flip(self, rotate_flip_type : aspose.psd.RotateFlipType):
        '''Rotates, flips, or rotates and flips the image.
        
        :param rotate_flip_type: Type of the rotate flip.'''
        ...
    
    def set_palette(self, palette : aspose.psd.IColorPalette, update_colors : bool):
        '''Sets the image palette.
        
        :param palette: The palette to set.
        :param update_colors: if set to ``true`` colors will be updated according to the new palette; otherwise color indexes remain unchanged. Note that unchanged indexes may crash the image on loading if some indexes have no corresponding palette entries.'''
        ...
    
    @staticmethod
    def get_proportional_width(width : intheight : int, new_height : int) -> int:
        '''Gets a proportional width.
        
        :param width: The width.
        :param height: The height.
        :param new_height: The new height.
        :returns: The proportional width.'''
        ...
    
    @staticmethod
    def get_proportional_height(width : intheight : int, new_width : int) -> int:
        '''Gets a proportional height.
        
        :param width: The width.
        :param height: The height.
        :param new_width: The new width.
        :returns: The proportional height.'''
        ...
    
    @property
    def disposed(self) -> bool:
        '''Gets a value indicating whether this instance is disposed.'''
        ...
    
    @property
    def data_stream_container(self) -> aspose.psd.StreamContainer:
        ...
    
    @property
    def is_cached(self) -> bool:
        ...
    
    @property
    def bits_per_pixel(self) -> int:
        ...
    
    @property
    def bounds(self) -> aspose.psd.Rectangle:
        '''Gets the image bounds.'''
        ...
    
    @property
    def container(self) -> aspose.psd.Image:
        '''Gets the :py:class:`aspose.psd.Image` container.'''
        ...
    
    @property
    def height(self) -> int:
        '''Gets the image height.'''
        ...
    
    @property
    def palette(self) -> aspose.psd.IColorPalette:
        '''Gets the color palette. The color palette is not used when pixels are represented directly.'''
        ...
    
    @palette.setter
    def palette(self, value : aspose.psd.IColorPalette):
        '''Sets the color palette. The color palette is not used when pixels are represented directly.'''
        ...
    
    @property
    def use_palette(self) -> bool:
        ...
    
    @property
    def size(self) -> aspose.psd.Size:
        '''Gets the image size.'''
        ...
    
    @property
    def width(self) -> int:
        '''Gets the image width.'''
        ...
    
    @property
    def interrupt_monitor(self) -> aspose.psd.multithreading.InterruptMonitor:
        ...
    
    @interrupt_monitor.setter
    def interrupt_monitor(self, value : aspose.psd.multithreading.InterruptMonitor):
        ...
    
    @property
    def buffer_size_hint(self) -> int:
        ...
    
    @buffer_size_hint.setter
    def buffer_size_hint(self, value : int):
        ...
    
    @property
    def auto_adjust_palette(self) -> bool:
        ...
    
    @auto_adjust_palette.setter
    def auto_adjust_palette(self, value : bool):
        ...
    
    @property
    def has_background_color(self) -> bool:
        ...
    
    @has_background_color.setter
    def has_background_color(self, value : bool):
        ...
    
    @property
    def file_format(self) -> aspose.psd.FileFormat:
        ...
    
    @property
    def background_color(self) -> aspose.psd.Color:
        ...
    
    @background_color.setter
    def background_color(self, value : aspose.psd.Color):
        ...
    
    @property
    def size_f(self) -> aspose.psd.SizeF:
        ...
    
    @property
    def width_f(self) -> float:
        ...
    
    @property
    def height_f(self) -> float:
        ...
    
    ...

class CacheType:
    '''Specifies the cache type to use.'''
    
    @classmethod
    @property
    def AUTO(cls) -> CacheType:
        '''Specifies auto cache type. The auto cache scheme will try to cache in-memory first then on disk.'''
        ...
    
    @classmethod
    @property
    def CACHE_ON_DISK_ONLY(cls) -> CacheType:
        '''The disk cache only.'''
        ...
    
    @classmethod
    @property
    def CACHE_IN_MEMORY_ONLY(cls) -> CacheType:
        '''The in-memory cache only.'''
        ...
    
    ...

class CharacterSet:
    '''Represents the character set used.'''
    
    @classmethod
    @property
    def ANSI(cls) -> CharacterSet:
        '''1252 Latin 1, 1250 Latin 2, 1256 Arabic character sets'''
        ...
    
    @classmethod
    @property
    def DEFAULT(cls) -> CharacterSet:
        '''The default character set.'''
        ...
    
    @classmethod
    @property
    def SYMBOL(cls) -> CharacterSet:
        '''The symbol character set'''
        ...
    
    @classmethod
    @property
    def SHIFTJIS(cls) -> CharacterSet:
        '''DBCS, 932 Japanese character set.'''
        ...
    
    @classmethod
    @property
    def HANGEUL(cls) -> CharacterSet:
        '''DBCS, 949 Korean character set.'''
        ...
    
    @classmethod
    @property
    def HANGUL(cls) -> CharacterSet:
        '''DBCS, 949 Korean character set.'''
        ...
    
    @classmethod
    @property
    def GB2312(cls) -> CharacterSet:
        '''DBCS, 936 Simplified Chinese character set.'''
        ...
    
    @classmethod
    @property
    def CHINESE_BIG5(cls) -> CharacterSet:
        '''DBCS, 950 Traditional Chinese character set.'''
        ...
    
    @classmethod
    @property
    def OEM(cls) -> CharacterSet:
        '''437 MS-DOS Latin 1, 852 MS-DOS Latin 2, 864 MS-DOS Arabic character sets.'''
        ...
    
    @classmethod
    @property
    def JOHAB(cls) -> CharacterSet:
        '''DBCS, 1361 Korean character set.'''
        ...
    
    @classmethod
    @property
    def HEBREW(cls) -> CharacterSet:
        '''1255 Hebrew character set.'''
        ...
    
    @classmethod
    @property
    def ARABIC(cls) -> CharacterSet:
        '''1256 Arabic character set.'''
        ...
    
    @classmethod
    @property
    def GREEK(cls) -> CharacterSet:
        '''1253 Greek character set.'''
        ...
    
    @classmethod
    @property
    def TURKISH(cls) -> CharacterSet:
        '''1254 Turkish character set.'''
        ...
    
    @classmethod
    @property
    def VIETNAMESE(cls) -> CharacterSet:
        '''1258 Vietnamese character set.'''
        ...
    
    @classmethod
    @property
    def THAI(cls) -> CharacterSet:
        '''874 Thai character set.'''
        ...
    
    @classmethod
    @property
    def EASTEUROPE(cls) -> CharacterSet:
        '''1250 Latin 2, Central Europe character set.'''
        ...
    
    @classmethod
    @property
    def RUSSIAN(cls) -> CharacterSet:
        '''1251 Cyrillic (Slavic) character set.'''
        ...
    
    @classmethod
    @property
    def MAC(cls) -> CharacterSet:
        '''10000 Mac Roman, 10029 Mac Central Europe, 10007 Mac Cyrillic character sets.'''
        ...
    
    @classmethod
    @property
    def BALTIC(cls) -> CharacterSet:
        '''1257 Baltic Rim character set.'''
        ...
    
    ...

class ColorAdjustType:
    '''Specifies which objects use color adjustment information.'''
    
    @classmethod
    @property
    def DEFAULT(cls) -> ColorAdjustType:
        '''Color adjustment information that is used by all GDI+ objects that do not have their own color adjustment information.'''
        ...
    
    @classmethod
    @property
    def BITMAP(cls) -> ColorAdjustType:
        '''Color adjustment information for Bitmap objects.'''
        ...
    
    @classmethod
    @property
    def BRUSH(cls) -> ColorAdjustType:
        '''Color adjustment information for Brush objects.'''
        ...
    
    @classmethod
    @property
    def PEN(cls) -> ColorAdjustType:
        '''Color adjustment information for Pen objects.'''
        ...
    
    @classmethod
    @property
    def TEXT(cls) -> ColorAdjustType:
        '''Color adjustment information for text.'''
        ...
    
    @classmethod
    @property
    def COUNT(cls) -> ColorAdjustType:
        '''The number of types specified.'''
        ...
    
    @classmethod
    @property
    def ANY(cls) -> ColorAdjustType:
        '''The number of types specified.'''
        ...
    
    ...

class ColorChannelFlag:
    '''Specifies individual channels in the CMYK (cyan, magenta, yellow, black) color space. This enumeration is used by the SetOutputChannel methods.'''
    
    @classmethod
    @property
    def COLOR_CHANNEL_C(cls) -> ColorChannelFlag:
        '''The cyan color channel.'''
        ...
    
    @classmethod
    @property
    def COLOR_CHANNEL_M(cls) -> ColorChannelFlag:
        '''The magenta color channel.'''
        ...
    
    @classmethod
    @property
    def COLOR_CHANNEL_Y(cls) -> ColorChannelFlag:
        '''The yellow color channel.'''
        ...
    
    @classmethod
    @property
    def COLOR_CHANNEL_K(cls) -> ColorChannelFlag:
        '''The black color channel.'''
        ...
    
    @classmethod
    @property
    def COLOR_CHANNEL_LAST(cls) -> ColorChannelFlag:
        '''The last selected channel should be used.'''
        ...
    
    ...

class ColorCompareMethod:
    '''Color comparison method to adjust to nearest neighbor'''
    
    @classmethod
    @property
    def EUCLIDIAN(cls) -> ColorCompareMethod:
        '''The euclidian method'''
        ...
    
    ...

class ColorMatrixFlag:
    '''Specifies the types of images and colors that will be affected by the color and grayscale adjustment settings of an :py:class:`aspose.psd.ImageAttributes`.'''
    
    @classmethod
    @property
    def DEFAULT(cls) -> ColorMatrixFlag:
        '''All color values, including gray shades, are adjusted by the same color-adjustment matrix.'''
        ...
    
    @classmethod
    @property
    def SKIP_GRAYS(cls) -> ColorMatrixFlag:
        '''All colors are adjusted, but gray shades are not adjusted. A gray shade is any color that has the same value for its red, green, and blue components.'''
        ...
    
    @classmethod
    @property
    def ALT_GRAYS(cls) -> ColorMatrixFlag:
        '''Only gray shades are adjusted.'''
        ...
    
    ...

class ColorQuantizationMethod:
    '''Colors quantization  methods'''
    
    @classmethod
    @property
    def NONE(cls) -> ColorQuantizationMethod:
        '''Nothing color quantization method is used'''
        ...
    
    @classmethod
    @property
    def POPULARITY(cls) -> ColorQuantizationMethod:
        '''The popularity method'''
        ...
    
    ...

class CompositingQuality:
    '''Specifies the quality level to use during compositing.'''
    
    @classmethod
    @property
    def INVALID(cls) -> CompositingQuality:
        '''Invalid quality.'''
        ...
    
    @classmethod
    @property
    def DEFAULT(cls) -> CompositingQuality:
        '''Default quality.'''
        ...
    
    @classmethod
    @property
    def HIGH_SPEED(cls) -> CompositingQuality:
        '''High speed, low quality.'''
        ...
    
    @classmethod
    @property
    def HIGH_QUALITY(cls) -> CompositingQuality:
        '''High quality, low speed compositing.'''
        ...
    
    @classmethod
    @property
    def GAMMA_CORRECTED(cls) -> CompositingQuality:
        '''Gamma correction is used.'''
        ...
    
    @classmethod
    @property
    def ASSUME_LINEAR(cls) -> CompositingQuality:
        '''Assume linear values.'''
        ...
    
    ...

class DashCap:
    '''Specifies the type of graphic shape to use on both ends of each dash in a dashed line.'''
    
    @classmethod
    @property
    def FLAT(cls) -> DashCap:
        '''Specifies a square cap that squares off both ends of each dash.'''
        ...
    
    @classmethod
    @property
    def ROUND(cls) -> DashCap:
        '''Specifies a circular cap that rounds off both ends of each dash.'''
        ...
    
    @classmethod
    @property
    def TRIANGLE(cls) -> DashCap:
        '''Specifies a triangular cap that points both ends of each dash.'''
        ...
    
    ...

class DashStyle:
    '''Specifies the style of dashed lines drawn with a :py:class:`aspose.psd.Pen` object.'''
    
    @classmethod
    @property
    def SOLID(cls) -> DashStyle:
        '''Specifies a solid line.'''
        ...
    
    @classmethod
    @property
    def DASH(cls) -> DashStyle:
        '''Specifies a line consisting of dashes.'''
        ...
    
    @classmethod
    @property
    def DOT(cls) -> DashStyle:
        '''Specifies a line consisting of dots.'''
        ...
    
    @classmethod
    @property
    def DASH_DOT(cls) -> DashStyle:
        '''Specifies a line consisting of a repeating pattern of dash-dot.'''
        ...
    
    @classmethod
    @property
    def DASH_DOT_DOT(cls) -> DashStyle:
        '''Specifies a line consisting of a repeating pattern of dash-dot-dot.'''
        ...
    
    @classmethod
    @property
    def CUSTOM(cls) -> DashStyle:
        '''Specifies a user-defined custom dash style.'''
        ...
    
    ...

class DataRecoveryMode:
    '''The data recovery mode.'''
    
    @classmethod
    @property
    def NONE(cls) -> DataRecoveryMode:
        '''No data recovery is implied. Whenever the file format has some corrupted data the appropriate exception is thrown.'''
        ...
    
    @classmethod
    @property
    def CONSISTENT_RECOVER(cls) -> DataRecoveryMode:
        '''The consistent recovery mode tries to recover all data as long as corruption does not break the file format and allows correct further processing.'''
        ...
    
    @classmethod
    @property
    def MAXIMAL_RECOVER(cls) -> DataRecoveryMode:
        '''The maximal recovery mode recovers all data even if the file format has corrupted structure and further processing may yield unattended effects.'''
        ...
    
    ...

class DitheringMethod:
    '''Dithering method.'''
    
    @classmethod
    @property
    def THRESHOLD_DITHERING(cls) -> DitheringMethod:
        '''Threshold dithering. Simplest and fastest dithering algorithm.'''
        ...
    
    @classmethod
    @property
    def FLOYD_STEINBERG_DITHERING(cls) -> DitheringMethod:
        '''The Floyd-Steinberg dithering. A more complex dithering algorithm, uses nearest neighbors intensity values.'''
        ...
    
    ...

class DitheringMethods:
    '''The dithering methods used to control color conversion.'''
    
    @classmethod
    @property
    def PALETTE_IGNORE(cls) -> DitheringMethods:
        '''The palette is ignored'''
        ...
    
    @classmethod
    @property
    def PALETTE_CONVERSION(cls) -> DitheringMethods:
        '''The palette is not ignored and wise color conversion should be applied.'''
        ...
    
    @classmethod
    @property
    def CUSTOM_CONVERTER(cls) -> DitheringMethods:
        '''The custom converter.'''
        ...
    
    ...

class FileFormat:
    '''One of supported PSD file formats.'''
    
    @classmethod
    @property
    def UNDEFINED(cls) -> FileFormat:
        '''Undefined file format.'''
        ...
    
    @classmethod
    @property
    def CUSTOM(cls) -> FileFormat:
        '''Custom file format.'''
        ...
    
    @classmethod
    @property
    def BMP(cls) -> FileFormat:
        '''Bmp (Dib) file format.'''
        ...
    
    @classmethod
    @property
    def GIF(cls) -> FileFormat:
        '''Gif file format.'''
        ...
    
    @classmethod
    @property
    def JPEG(cls) -> FileFormat:
        '''Jpeg file format.'''
        ...
    
    @classmethod
    @property
    def PNG(cls) -> FileFormat:
        '''Png file format.'''
        ...
    
    @classmethod
    @property
    def TIFF(cls) -> FileFormat:
        '''Tiff file format.'''
        ...
    
    @classmethod
    @property
    def PSD(cls) -> FileFormat:
        '''Psd file format.'''
        ...
    
    @classmethod
    @property
    def JPEG2000(cls) -> FileFormat:
        '''Jpeg2000 file format'''
        ...
    
    @classmethod
    @property
    def DJVU(cls) -> FileFormat:
        '''Djvu file format'''
        ...
    
    @classmethod
    @property
    def WEBP(cls) -> FileFormat:
        '''The webp file format'''
        ...
    
    @classmethod
    @property
    def EMF(cls) -> FileFormat:
        '''The Emf/Emf+ file format'''
        ...
    
    @classmethod
    @property
    def DICOM(cls) -> FileFormat:
        '''The dicom format'''
        ...
    
    @classmethod
    @property
    def SVG(cls) -> FileFormat:
        '''SVG file format'''
        ...
    
    @classmethod
    @property
    def WMF(cls) -> FileFormat:
        '''The Wmf file format'''
        ...
    
    @classmethod
    @property
    def DNG(cls) -> FileFormat:
        '''The DNG file format'''
        ...
    
    @classmethod
    @property
    def ODG(cls) -> FileFormat:
        '''The Open document graphic format'''
        ...
    
    @classmethod
    @property
    def CDR(cls) -> FileFormat:
        '''The CDR file format'''
        ...
    
    @classmethod
    @property
    def CMX(cls) -> FileFormat:
        '''The CMX file format'''
        ...
    
    @classmethod
    @property
    def OTG(cls) -> FileFormat:
        '''The otg file format'''
        ...
    
    @classmethod
    @property
    def AI(cls) -> FileFormat:
        '''The Adobe Illustrator format'''
        ...
    
    @classmethod
    @property
    def HTML_5_CANVAS(cls) -> FileFormat:
        '''The Html5 Canvas format'''
        ...
    
    @classmethod
    @property
    def EPS(cls) -> FileFormat:
        '''The Encapsulated PostScript format'''
        ...
    
    @classmethod
    @property
    def APNG(cls) -> FileFormat:
        '''The animated Png file format.'''
        ...
    
    @classmethod
    @property
    def TGA(cls) -> FileFormat:
        '''The Truevision TGA file format.'''
        ...
    
    ...

class FillMode:
    '''Specifies how the interior of a closed path is filled.'''
    
    @classmethod
    @property
    def ALTERNATE(cls) -> FillMode:
        '''Specifies the alternate fill mode.'''
        ...
    
    @classmethod
    @property
    def WINDING(cls) -> FillMode:
        '''Specifies the winding fill mode.'''
        ...
    
    ...

class FontStyle:
    '''Specifies style information applied to text.'''
    
    @classmethod
    @property
    def REGULAR(cls) -> FontStyle:
        '''Normal text.'''
        ...
    
    @classmethod
    @property
    def BOLD(cls) -> FontStyle:
        '''Bold text.'''
        ...
    
    @classmethod
    @property
    def ITALIC(cls) -> FontStyle:
        '''Italic text.'''
        ...
    
    @classmethod
    @property
    def UNDERLINE(cls) -> FontStyle:
        '''Underlined text.'''
        ...
    
    @classmethod
    @property
    def STRIKEOUT(cls) -> FontStyle:
        '''Text with a line through the middle.'''
        ...
    
    ...

class GraphicsUnit:
    '''Specifies the unit of measure for the given data.'''
    
    @classmethod
    @property
    def WORLD(cls) -> GraphicsUnit:
        '''Specifies the world coordinate system unit as the unit of measure.'''
        ...
    
    @classmethod
    @property
    def DISPLAY(cls) -> GraphicsUnit:
        '''Specifies the unit of measure of the display device. Typically pixels for video displays, and 1/100 inch for printers.'''
        ...
    
    @classmethod
    @property
    def PIXEL(cls) -> GraphicsUnit:
        '''Specifies a device pixel as the unit of measure.'''
        ...
    
    @classmethod
    @property
    def POINT(cls) -> GraphicsUnit:
        '''Specifies a printer's point (1/72 inch) as the unit of measure.'''
        ...
    
    @classmethod
    @property
    def INCH(cls) -> GraphicsUnit:
        '''Specifies the inch as the unit of measure.'''
        ...
    
    @classmethod
    @property
    def DOCUMENT(cls) -> GraphicsUnit:
        '''Specifies the document unit (1/300 inch) as the unit of measure.'''
        ...
    
    @classmethod
    @property
    def MILLIMETER(cls) -> GraphicsUnit:
        '''Specifies the millimeter as the unit of measure.'''
        ...
    
    ...

class HatchStyle:
    '''Specifies the different patterns available for :py:class:`aspose.psd.brushes.HatchBrush` objects.'''
    
    @classmethod
    @property
    def HORIZONTAL(cls) -> HatchStyle:
        '''A pattern of horizontal lines.'''
        ...
    
    @classmethod
    @property
    def MIN(cls) -> HatchStyle:
        '''Specifies hatch style Horizontal.'''
        ...
    
    @classmethod
    @property
    def VERTICAL(cls) -> HatchStyle:
        '''A pattern of vertical lines.'''
        ...
    
    @classmethod
    @property
    def FORWARD_DIAGONAL(cls) -> HatchStyle:
        '''A pattern of lines on a diagonal from upper left to lower right.'''
        ...
    
    @classmethod
    @property
    def BACKWARD_DIAGONAL(cls) -> HatchStyle:
        '''A pattern of lines on a diagonal from upper right to lower left.'''
        ...
    
    @classmethod
    @property
    def CROSS(cls) -> HatchStyle:
        '''Specifies horizontal and vertical lines that cross.'''
        ...
    
    @classmethod
    @property
    def LARGE_GRID(cls) -> HatchStyle:
        '''Specifies the hatch style Cross.'''
        ...
    
    @classmethod
    @property
    def MAX(cls) -> HatchStyle:
        '''Specifies hatch style SolidDiamond.'''
        ...
    
    @classmethod
    @property
    def DIAGONAL_CROSS(cls) -> HatchStyle:
        '''A pattern of crisscross diagonal lines.'''
        ...
    
    @classmethod
    @property
    def PERCENT05(cls) -> HatchStyle:
        '''Specifies a 5-percent hatch. The ratio of foreground color to background color is 5:95.'''
        ...
    
    @classmethod
    @property
    def PERCENT10(cls) -> HatchStyle:
        '''Specifies a 10-percent hatch. The ratio of foreground color to background color is 10:90.'''
        ...
    
    @classmethod
    @property
    def PERCENT20(cls) -> HatchStyle:
        '''Specifies a 20-percent hatch. The ratio of foreground color to background color is 20:80.'''
        ...
    
    @classmethod
    @property
    def PERCENT25(cls) -> HatchStyle:
        '''Specifies a 25-percent hatch. The ratio of foreground color to background color is 25:75.'''
        ...
    
    @classmethod
    @property
    def PERCENT30(cls) -> HatchStyle:
        '''Specifies a 30-percent hatch. The ratio of foreground color to background color is 30:70.'''
        ...
    
    @classmethod
    @property
    def PERCENT40(cls) -> HatchStyle:
        '''Specifies a 40-percent hatch. The ratio of foreground color to background color is 40:60.'''
        ...
    
    @classmethod
    @property
    def PERCENT50(cls) -> HatchStyle:
        '''Specifies a 50-percent hatch. The ratio of foreground color to background color is 50:50.'''
        ...
    
    @classmethod
    @property
    def PERCENT60(cls) -> HatchStyle:
        '''Specifies a 60-percent hatch. The ratio of foreground color to background color is 60:40.'''
        ...
    
    @classmethod
    @property
    def PERCENT70(cls) -> HatchStyle:
        '''Specifies a 70-percent hatch. The ratio of foreground color to background color is 70:30.'''
        ...
    
    @classmethod
    @property
    def PERCENT75(cls) -> HatchStyle:
        '''Specifies a 75-percent hatch. The ratio of foreground color to background color is 75:25.'''
        ...
    
    @classmethod
    @property
    def PERCENT80(cls) -> HatchStyle:
        '''Specifies a 80-percent hatch. The ratio of foreground color to background color is 80:100.'''
        ...
    
    @classmethod
    @property
    def PERCENT90(cls) -> HatchStyle:
        '''Specifies a 90-percent hatch. The ratio of foreground color to background color is 90:10.'''
        ...
    
    @classmethod
    @property
    def LIGHT_DOWNWARD_DIAGONAL(cls) -> HatchStyle:
        '''Specifies diagonal lines that slant to the right from top points to bottom points and are spaced 50 percent closer together than ForwardDiagonal, but are not antialiased.'''
        ...
    
    @classmethod
    @property
    def LIGHT_UPWARD_DIAGONAL(cls) -> HatchStyle:
        '''Specifies diagonal lines that slant to the left from top points to bottom points and are spaced 50 percent closer together than BackwardDiagonal, but they are not antialiased.'''
        ...
    
    @classmethod
    @property
    def DARK_DOWNWARD_DIAGONAL(cls) -> HatchStyle:
        '''Specifies diagonal lines that slant to the right from top points to bottom points, are spaced 50 percent closer together than, and are twice the width of ForwardDiagonal. This hatch pattern is not antialiased.'''
        ...
    
    @classmethod
    @property
    def DARK_UPWARD_DIAGONAL(cls) -> HatchStyle:
        '''Specifies diagonal lines that slant to the left from top points to bottom points, are spaced 50 percent closer together than BackwardDiagonal, and are twice its width, but the lines are not antialiased.'''
        ...
    
    @classmethod
    @property
    def WIDE_DOWNWARD_DIAGONAL(cls) -> HatchStyle:
        '''Specifies diagonal lines that slant to the right from top points to bottom points, have the same spacing as hatch style ForwardDiagonal, and are triple its width, but are not antialiased.'''
        ...
    
    @classmethod
    @property
    def WIDE_UPWARD_DIAGONAL(cls) -> HatchStyle:
        '''Specifies diagonal lines that slant to the left from top points to bottom points, have the same spacing as hatch style BackwardDiagonal, and are triple its width, but are not antialiased.'''
        ...
    
    @classmethod
    @property
    def LIGHT_VERTICAL(cls) -> HatchStyle:
        '''Specifies vertical lines that are spaced 50 percent closer together than Vertical.'''
        ...
    
    @classmethod
    @property
    def LIGHT_HORIZONTAL(cls) -> HatchStyle:
        '''Specifies horizontal lines that are spaced 50 percent closer together than Horizontal.'''
        ...
    
    @classmethod
    @property
    def NARROW_VERTICAL(cls) -> HatchStyle:
        '''Specifies vertical lines that are spaced 75 percent closer together than hatch style Vertical (or 25 percent closer together than LightVertical).'''
        ...
    
    @classmethod
    @property
    def NARROW_HORIZONTAL(cls) -> HatchStyle:
        '''Specifies horizontal lines that are spaced 75 percent closer together than hatch style Horizontal (or 25 percent closer together than LightHorizontal).'''
        ...
    
    @classmethod
    @property
    def DARK_VERTICAL(cls) -> HatchStyle:
        '''Specifies vertical lines that are spaced 50 percent closer together than Vertical and are twice its width.'''
        ...
    
    @classmethod
    @property
    def DARK_HORIZONTAL(cls) -> HatchStyle:
        '''Specifies horizontal lines that are spaced 50 percent closer together than Horizontal and are twice the width of Horizontal.'''
        ...
    
    @classmethod
    @property
    def DASHED_DOWNWARD_DIAGONAL(cls) -> HatchStyle:
        '''Specifies dashed diagonal lines, that slant to the right from top points to bottom points.'''
        ...
    
    @classmethod
    @property
    def DASHED_UPWARD_DIAGONAL(cls) -> HatchStyle:
        '''Specifies dashed diagonal lines, that slant to the left from top points to bottom points.'''
        ...
    
    @classmethod
    @property
    def DASHED_HORIZONTAL(cls) -> HatchStyle:
        '''Specifies dashed horizontal lines.'''
        ...
    
    @classmethod
    @property
    def DASHED_VERTICAL(cls) -> HatchStyle:
        '''Specifies dashed vertical lines.'''
        ...
    
    @classmethod
    @property
    def SMALL_CONFETTI(cls) -> HatchStyle:
        '''Specifies a hatch that has the appearance of confetti.'''
        ...
    
    @classmethod
    @property
    def LARGE_CONFETTI(cls) -> HatchStyle:
        '''Specifies a hatch that has the appearance of confetti, and is composed of larger pieces than SmallConfetti.'''
        ...
    
    @classmethod
    @property
    def ZIG_ZAG(cls) -> HatchStyle:
        '''Specifies horizontal lines that are composed of zigzags.'''
        ...
    
    @classmethod
    @property
    def WAVE(cls) -> HatchStyle:
        '''Specifies horizontal lines that are composed of tildes.'''
        ...
    
    @classmethod
    @property
    def DIAGONAL_BRICK(cls) -> HatchStyle:
        '''Specifies a hatch that has the appearance of layered bricks that slant to the left from top points to bottom points.'''
        ...
    
    @classmethod
    @property
    def HORIZONTAL_BRICK(cls) -> HatchStyle:
        '''Specifies a hatch that has the appearance of horizontally layered bricks.'''
        ...
    
    @classmethod
    @property
    def WEAVE(cls) -> HatchStyle:
        '''Specifies a hatch that has the appearance of a woven material.'''
        ...
    
    @classmethod
    @property
    def PLAID(cls) -> HatchStyle:
        '''Specifies a hatch that has the appearance of a plaid material.'''
        ...
    
    @classmethod
    @property
    def DIVOT(cls) -> HatchStyle:
        '''Specifies a hatch that has the appearance of divots.'''
        ...
    
    @classmethod
    @property
    def DOTTED_GRID(cls) -> HatchStyle:
        '''Specifies horizontal and vertical lines, each of which is composed of dots, that cross.'''
        ...
    
    @classmethod
    @property
    def DOTTED_DIAMOND(cls) -> HatchStyle:
        '''Specifies forward diagonal and backward diagonal lines, each of which is composed of dots, that cross.'''
        ...
    
    @classmethod
    @property
    def SHINGLE(cls) -> HatchStyle:
        '''Specifies a hatch that has the appearance of diagonally layered shingles that slant to the right from top points to bottom points.'''
        ...
    
    @classmethod
    @property
    def TRELLIS(cls) -> HatchStyle:
        '''Specifies a hatch that has the appearance of a trellis.'''
        ...
    
    @classmethod
    @property
    def SPHERE(cls) -> HatchStyle:
        '''Specifies a hatch that has the appearance of spheres laid adjacent to one another.'''
        ...
    
    @classmethod
    @property
    def SMALL_GRID(cls) -> HatchStyle:
        '''Specifies horizontal and vertical lines that cross and are spaced 50 percent closer together than hatch style Cross.'''
        ...
    
    @classmethod
    @property
    def SMALL_CHECKER_BOARD(cls) -> HatchStyle:
        '''Specifies a hatch that has the appearance of a checkerboard.'''
        ...
    
    @classmethod
    @property
    def LARGE_CHECKER_BOARD(cls) -> HatchStyle:
        '''Specifies a hatch that has the appearance of a checkerboard with squares that are twice the size of SmallCheckerBoard.'''
        ...
    
    @classmethod
    @property
    def OUTLINED_DIAMOND(cls) -> HatchStyle:
        '''Specifies forward diagonal and backward diagonal lines that cross but are not antialiased.'''
        ...
    
    @classmethod
    @property
    def SOLID_DIAMOND(cls) -> HatchStyle:
        '''Specifies a hatch that has the appearance of a checkerboard placed diagonally.'''
        ...
    
    ...

class HotkeyPrefix:
    '''Specifies the type of display for hot-key prefixes that relate to text.'''
    
    @classmethod
    @property
    def NONE(cls) -> HotkeyPrefix:
        '''No hot-key prefix.'''
        ...
    
    @classmethod
    @property
    def SHOW(cls) -> HotkeyPrefix:
        '''Display the hot-key prefix.'''
        ...
    
    @classmethod
    @property
    def HIDE(cls) -> HotkeyPrefix:
        '''Do not display the hot-key prefix.'''
        ...
    
    ...

class ImageFilterType:
    '''Image filters to use'''
    
    @classmethod
    @property
    def NONE(cls) -> ImageFilterType:
        '''Nothing filter used'''
        ...
    
    @classmethod
    @property
    def BIG_RECTANGULAR(cls) -> ImageFilterType:
        '''The big rectangular filter'''
        ...
    
    @classmethod
    @property
    def SMALL_RECTANGULAR(cls) -> ImageFilterType:
        '''The small rectangular filter'''
        ...
    
    ...

class InterpolationMode:
    '''The :py:class:`aspose.psd.InterpolationMode` enumeration specifies the algorithm that is used when images are scaled or rotated.'''
    
    @classmethod
    @property
    def INVALID(cls) -> InterpolationMode:
        '''Invalid interpolation mode.'''
        ...
    
    @classmethod
    @property
    def DEFAULT(cls) -> InterpolationMode:
        '''Specifies default mode.'''
        ...
    
    @classmethod
    @property
    def LOW(cls) -> InterpolationMode:
        '''Specifies low quality interpolation.'''
        ...
    
    @classmethod
    @property
    def HIGH(cls) -> InterpolationMode:
        '''Specifies high quality interpolation.'''
        ...
    
    @classmethod
    @property
    def BILINEAR(cls) -> InterpolationMode:
        '''Specifies bilinear interpolation. No prefiltering is done. This mode is not suitable for shrinking an image below 50 percent of its original size.'''
        ...
    
    @classmethod
    @property
    def BICUBIC(cls) -> InterpolationMode:
        '''Specifies bicubic interpolation. No prefiltering is done. This mode is not suitable for shrinking an image below 25 percent of its original size.'''
        ...
    
    @classmethod
    @property
    def NEAREST_NEIGHBOR(cls) -> InterpolationMode:
        '''Specifies nearest-neighbor interpolation.'''
        ...
    
    @classmethod
    @property
    def HIGH_QUALITY_BILINEAR(cls) -> InterpolationMode:
        '''Specifies high-quality, bilinear interpolation. Prefiltering is performed to ensure high-quality shrinking.'''
        ...
    
    @classmethod
    @property
    def HIGH_QUALITY_BICUBIC(cls) -> InterpolationMode:
        '''Specifies high-quality, bicubic interpolation. Prefiltering is performed to ensure high-quality shrinking. This mode produces the highest quality transformed images.'''
        ...
    
    ...

class KnownColor:
    '''Specifies the known system colors.'''
    
    @classmethod
    @property
    def TRANSPARENT(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def ALICE_BLUE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def ANTIQUE_WHITE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def AQUA(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def AQUAMARINE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def AZURE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def BEIGE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def BISQUE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def BLACK(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def BLANCHED_ALMOND(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def BLUE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def BLUE_VIOLET(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def BROWN(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def BURLY_WOOD(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def CADET_BLUE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def CHARTREUSE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def CHOCOLATE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def CORAL(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def CORNFLOWER_BLUE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def CORNSILK(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def CRIMSON(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def CYAN(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def DARK_BLUE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def DARK_CYAN(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def DARK_GOLDENROD(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def DARK_GRAY(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def DARK_GREEN(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def DARK_KHAKI(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def DARK_MAGENTA(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def DARK_OLIVE_GREEN(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def DARK_ORANGE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def DARK_ORCHID(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def DARK_RED(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def DARK_SALMON(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def DARK_SEA_GREEN(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def DARK_SLATE_BLUE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def DARK_SLATE_GRAY(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def DARK_TURQUOISE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def DARK_VIOLET(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def DEEP_PINK(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def DEEP_SKY_BLUE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def DIM_GRAY(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def DODGER_BLUE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def FIREBRICK(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def FLORAL_WHITE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def FOREST_GREEN(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def FUCHSIA(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def GAINSBORO(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def GHOST_WHITE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def GOLD(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def GOLDENROD(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def GRAY(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def GREEN(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def GREEN_YELLOW(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def HONEYDEW(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def HOT_PINK(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def INDIAN_RED(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def INDIGO(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def IVORY(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def KHAKI(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def LAVENDER(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def LAVENDER_BLUSH(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def LAWN_GREEN(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def LEMON_CHIFFON(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def LIGHT_BLUE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def LIGHT_CORAL(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def LIGHT_CYAN(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def LIGHT_GOLDENROD_YELLOW(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def LIGHT_GRAY(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def LIGHT_GREEN(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def LIGHT_PINK(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def LIGHT_SALMON(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def LIGHT_SEA_GREEN(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def LIGHT_SKY_BLUE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def LIGHT_SLATE_GRAY(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def LIGHT_STEEL_BLUE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def LIGHT_YELLOW(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def LIME(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def LIME_GREEN(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def LINEN(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def MAGENTA(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def MAROON(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def MEDIUM_AQUAMARINE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def MEDIUM_BLUE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def MEDIUM_ORCHID(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def MEDIUM_PURPLE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def MEDIUM_SEA_GREEN(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def MEDIUM_SLATE_BLUE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def MEDIUM_SPRING_GREEN(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def MEDIUM_TURQUOISE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def MEDIUM_VIOLET_RED(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def MIDNIGHT_BLUE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def MINT_CREAM(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def MISTY_ROSE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def MOCCASIN(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def NAVAJO_WHITE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def NAVY(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def OLD_LACE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def OLIVE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def OLIVE_DRAB(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def ORANGE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def ORANGE_RED(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def ORCHID(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def PALE_GOLDENROD(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def PALE_GREEN(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def PALE_TURQUOISE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def PALE_VIOLET_RED(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def PAPAYA_WHIP(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def PEACH_PUFF(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def PERU(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def PINK(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def PLUM(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def POWDER_BLUE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def PURPLE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def RED(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def ROSY_BROWN(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def ROYAL_BLUE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def SADDLE_BROWN(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def SALMON(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def SANDY_BROWN(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def SEA_GREEN(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def SEA_SHELL(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def SIENNA(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def SILVER(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def SKY_BLUE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def SLATE_BLUE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def SLATE_GRAY(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def SNOW(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def SPRING_GREEN(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def STEEL_BLUE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def TAN(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def TEAL(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def THISTLE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def TOMATO(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def TURQUOISE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def VIOLET(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def WHEAT(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def WHITE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def WHITE_SMOKE(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def YELLOW(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    @classmethod
    @property
    def YELLOW_GREEN(cls) -> KnownColor:
        '''A system-defined color.'''
        ...
    
    ...

class LineCap:
    '''Specifies the available cap styles with which a :py:class:`aspose.psd.Pen` object can end a line.'''
    
    @classmethod
    @property
    def FLAT(cls) -> LineCap:
        '''Specifies a flat line cap.'''
        ...
    
    @classmethod
    @property
    def SQUARE(cls) -> LineCap:
        '''Specifies a square line cap.'''
        ...
    
    @classmethod
    @property
    def ROUND(cls) -> LineCap:
        '''Specifies a round line cap.'''
        ...
    
    @classmethod
    @property
    def TRIANGLE(cls) -> LineCap:
        '''Specifies a triangular line cap.'''
        ...
    
    @classmethod
    @property
    def NO_ANCHOR(cls) -> LineCap:
        '''Specifies no anchor.'''
        ...
    
    @classmethod
    @property
    def SQUARE_ANCHOR(cls) -> LineCap:
        '''Specifies a square anchor line cap.'''
        ...
    
    @classmethod
    @property
    def ROUND_ANCHOR(cls) -> LineCap:
        '''Specifies a round anchor cap.'''
        ...
    
    @classmethod
    @property
    def DIAMOND_ANCHOR(cls) -> LineCap:
        '''Specifies a diamond anchor cap.'''
        ...
    
    @classmethod
    @property
    def ARROW_ANCHOR(cls) -> LineCap:
        '''Specifies an arrow-shaped anchor cap.'''
        ...
    
    @classmethod
    @property
    def ANCHOR_MASK(cls) -> LineCap:
        '''Specifies a custom line cap.'''
        ...
    
    @classmethod
    @property
    def CUSTOM(cls) -> LineCap:
        '''Specifies a mask used to check whether a line cap is an anchor cap.'''
        ...
    
    ...

class LineJoin:
    '''Specifies how to join consecutive line or curve segments in a figure (subpath) contained in a :py:class:`aspose.psd.GraphicsPath` object.'''
    
    @classmethod
    @property
    def MITER(cls) -> LineJoin:
        '''Specifies a mitered join. This produces a sharp corner or a clipped corner, depending on whether the length of the miter exceeds the miter limit.'''
        ...
    
    @classmethod
    @property
    def BEVEL(cls) -> LineJoin:
        '''Specifies a beveled join. This produces a diagonal corner.'''
        ...
    
    @classmethod
    @property
    def ROUND(cls) -> LineJoin:
        '''Specifies a circular join. This produces a smooth, circular arc between the lines.'''
        ...
    
    @classmethod
    @property
    def MITER_CLIPPED(cls) -> LineJoin:
        '''Specifies a mitered join. This produces a sharp corner or a beveled corner, depending on whether the length of the miter exceeds the miter limit.'''
        ...
    
    ...

class MatrixOrder:
    '''Specifies the order for matrix transform operations.'''
    
    @classmethod
    @property
    def PREPEND(cls) -> MatrixOrder:
        '''The new operation is applied before the old operation.'''
        ...
    
    @classmethod
    @property
    def APPEND(cls) -> MatrixOrder:
        '''The new operation is applied after the old operation.'''
        ...
    
    ...

class PdfComplianceVersion:
    '''Specifies the PDF compliance level to output file.'''
    
    @classmethod
    @property
    def PDF15(cls) -> PdfComplianceVersion:
        '''The output file will be PDF 1.5 compliant.'''
        ...
    
    @classmethod
    @property
    def PDF_A1A(cls) -> PdfComplianceVersion:
        '''The output file will be PDF/A-1a compliant.'''
        ...
    
    @classmethod
    @property
    def PDF_A1B(cls) -> PdfComplianceVersion:
        '''The output file will be PDF/A-1b compliant.'''
        ...
    
    ...

class PenAlignment:
    '''Specifies the alignment of a :py:class:`aspose.psd.Pen` object in relation to the theoretical, zero-width line.'''
    
    @classmethod
    @property
    def CENTER(cls) -> PenAlignment:
        '''Specifies that the :py:class:`aspose.psd.Pen` object is centered over the theoretical line.'''
        ...
    
    @classmethod
    @property
    def INSET(cls) -> PenAlignment:
        '''Specifies that the :py:class:`aspose.psd.Pen` is positioned on the inside of the theoretical line.'''
        ...
    
    @classmethod
    @property
    def OUTSET(cls) -> PenAlignment:
        '''Specifies the :py:class:`aspose.psd.Pen` is positioned on the outside of the theoretical line.'''
        ...
    
    @classmethod
    @property
    def LEFT(cls) -> PenAlignment:
        '''Specifies the :py:class:`aspose.psd.Pen` is positioned to the left of the theoretical line.'''
        ...
    
    @classmethod
    @property
    def RIGHT(cls) -> PenAlignment:
        '''Specifies the :py:class:`aspose.psd.Pen` is positioned to the right of the theoretical line.'''
        ...
    
    ...

class PenType:
    '''Specifies the type of fill a :py:class:`aspose.psd.Pen` object uses to fill lines.'''
    
    @classmethod
    @property
    def SOLID_COLOR(cls) -> PenType:
        '''Specifies a solid fill.'''
        ...
    
    @classmethod
    @property
    def HATCH_FILL(cls) -> PenType:
        '''Specifies a hatch fill.'''
        ...
    
    @classmethod
    @property
    def TEXTURE_FILL(cls) -> PenType:
        '''Specifies a bitmap texture fill.'''
        ...
    
    @classmethod
    @property
    def PATH_GRADIENT(cls) -> PenType:
        '''Specifies a path gradient fill.'''
        ...
    
    @classmethod
    @property
    def LINEAR_GRADIENT(cls) -> PenType:
        '''Specifies a linear gradient fill.'''
        ...
    
    ...

class PixelFormat:
    '''The pixel data format actual meaning.'''
    
    @classmethod
    @property
    def GRAYSCALE(cls) -> PixelFormat:
        '''The grayscale color space'''
        ...
    
    @classmethod
    @property
    def BGR(cls) -> PixelFormat:
        '''The BGR color space.'''
        ...
    
    @classmethod
    @property
    def RGB(cls) -> PixelFormat:
        '''The RGB color space.'''
        ...
    
    @classmethod
    @property
    def Y_CB_CR(cls) -> PixelFormat:
        '''The YCbCr color space.'''
        ...
    
    @classmethod
    @property
    def CMYK(cls) -> PixelFormat:
        '''The CMYK color space.'''
        ...
    
    @classmethod
    @property
    def YCCK(cls) -> PixelFormat:
        '''The YCCK color space.'''
        ...
    
    @classmethod
    @property
    def CIE_LAB(cls) -> PixelFormat:
        '''The CIE lab color space.'''
        ...
    
    ...

class ResizeType:
    '''Specifies the resize type.'''
    
    @classmethod
    @property
    def NONE(cls) -> ResizeType:
        '''The pixels are not preserved during resize operation.'''
        ...
    
    @classmethod
    @property
    def LEFT_TOP_TO_LEFT_TOP(cls) -> ResizeType:
        '''Left top point of the new image will coincide with the left top point of the original image. Crop will occur if required.'''
        ...
    
    @classmethod
    @property
    def RIGHT_TOP_TO_RIGHT_TOP(cls) -> ResizeType:
        '''Right top point of the new image will coincide with the right top point of the original image. Crop will occur if required.'''
        ...
    
    @classmethod
    @property
    def RIGHT_BOTTOM_TO_RIGHT_BOTTOM(cls) -> ResizeType:
        '''Right bottom point of the new image will coincide with the right bottom point of the original image. Crop will occur if required.'''
        ...
    
    @classmethod
    @property
    def LEFT_BOTTOM_TO_LEFT_BOTTOM(cls) -> ResizeType:
        '''Left bottom point of the new image will coincide with the left bottom point of the original image. Crop will occur if required.'''
        ...
    
    @classmethod
    @property
    def CENTER_TO_CENTER(cls) -> ResizeType:
        '''Center of the new image will coincide with the center of the original image. Crop will occur if required.'''
        ...
    
    @classmethod
    @property
    def LANCZOS_RESAMPLE(cls) -> ResizeType:
        '''Resample using lanczos algorithm with a=3.'''
        ...
    
    @classmethod
    @property
    def NEAREST_NEIGHBOUR_RESAMPLE(cls) -> ResizeType:
        '''Resample using nearest neighbour algorithm.'''
        ...
    
    @classmethod
    @property
    def ADAPTIVE_RESAMPLE(cls) -> ResizeType:
        '''Resample using adaptive algorithm based on weighted and blended rational function and lanczos3 interpolation algorithms.'''
        ...
    
    @classmethod
    @property
    def BILINEAR_RESAMPLE(cls) -> ResizeType:
        '''Resample using bilinear interpolation. Image pre-filtering is allowed to remove the noice before resample, when needed'''
        ...
    
    @classmethod
    @property
    def HIGH_QUALITY_RESAMPLE(cls) -> ResizeType:
        '''The high quality resample'''
        ...
    
    @classmethod
    @property
    def CATMULL_ROM(cls) -> ResizeType:
        '''The Catmull-Rom cubic interpolation method.'''
        ...
    
    @classmethod
    @property
    def CUBIC_CONVOLUTION(cls) -> ResizeType:
        '''The Cubic Convolution interpolation method'''
        ...
    
    @classmethod
    @property
    def CUBIC_B_SPLINE(cls) -> ResizeType:
        '''The CubicBSpline cubic interpolation method'''
        ...
    
    @classmethod
    @property
    def MITCHELL(cls) -> ResizeType:
        '''The Mitchell cubic interpolation method'''
        ...
    
    @classmethod
    @property
    def SIN_C(cls) -> ResizeType:
        '''The Sinc (Lanczos3) cubic interpolation method'''
        ...
    
    @classmethod
    @property
    def BELL(cls) -> ResizeType:
        '''The Bell interpolation method'''
        ...
    
    ...

class ResolutionUnit:
    '''Resolution unit enum.'''
    
    @classmethod
    @property
    def NONE(cls) -> ResolutionUnit:
        '''Undefined units'''
        ...
    
    @classmethod
    @property
    def INCH(cls) -> ResolutionUnit:
        '''Inch units'''
        ...
    
    @classmethod
    @property
    def CM(cls) -> ResolutionUnit:
        '''Metric centimeter units'''
        ...
    
    ...

class RotateFlipType:
    '''Specifies how much an image is rotated and the axis used to flip the image.'''
    
    @classmethod
    @property
    def ROTATE_NONE_FLIP_NONE(cls) -> RotateFlipType:
        '''Specifies no clockwise rotation and no flipping.'''
        ...
    
    @classmethod
    @property
    def ROTATE_90_FLIP_NONE(cls) -> RotateFlipType:
        '''Specifies a 90-degree clockwise rotation without flipping.'''
        ...
    
    @classmethod
    @property
    def ROTATE_180_FLIP_NONE(cls) -> RotateFlipType:
        '''Specifies a 180-degree clockwise rotation without flipping.'''
        ...
    
    @classmethod
    @property
    def ROTATE_270_FLIP_NONE(cls) -> RotateFlipType:
        '''Specifies a 270-degree clockwise rotation without flipping.'''
        ...
    
    @classmethod
    @property
    def ROTATE_NONE_FLIP_X(cls) -> RotateFlipType:
        '''Specifies no clockwise rotation followed by a horizontal flip.'''
        ...
    
    @classmethod
    @property
    def ROTATE_90_FLIP_X(cls) -> RotateFlipType:
        '''Specifies a 90-degree clockwise rotation followed by a horizontal flip.'''
        ...
    
    @classmethod
    @property
    def ROTATE_180_FLIP_X(cls) -> RotateFlipType:
        '''Specifies a 180-degree clockwise rotation followed by a horizontal flip.'''
        ...
    
    @classmethod
    @property
    def ROTATE_270_FLIP_X(cls) -> RotateFlipType:
        '''Specifies a 270-degree clockwise rotation followed by a horizontal flip.'''
        ...
    
    @classmethod
    @property
    def ROTATE_NONE_FLIP_Y(cls) -> RotateFlipType:
        '''Specifies no clockwise rotation followed by a vertical flip.'''
        ...
    
    @classmethod
    @property
    def ROTATE_90_FLIP_Y(cls) -> RotateFlipType:
        '''Specifies a 90-degree clockwise rotation followed by a vertical flip.'''
        ...
    
    @classmethod
    @property
    def ROTATE_180_FLIP_Y(cls) -> RotateFlipType:
        '''Specifies a 180-degree clockwise rotation followed by a vertical flip.'''
        ...
    
    @classmethod
    @property
    def ROTATE_270_FLIP_Y(cls) -> RotateFlipType:
        '''Specifies a 270-degree clockwise rotation followed by a vertical flip.'''
        ...
    
    @classmethod
    @property
    def ROTATE_NONE_FLIP_XY(cls) -> RotateFlipType:
        '''Specifies no clockwise rotation followed by a horizontal and vertical flip.'''
        ...
    
    @classmethod
    @property
    def ROTATE_90_FLIP_XY(cls) -> RotateFlipType:
        '''Specifies a 90-degree clockwise rotation followed by a horizontal and vertical flip.'''
        ...
    
    @classmethod
    @property
    def ROTATE_180_FLIP_XY(cls) -> RotateFlipType:
        '''Specifies a 180-degree clockwise rotation followed by a horizontal and vertical flip.'''
        ...
    
    @classmethod
    @property
    def ROTATE_270_FLIP_XY(cls) -> RotateFlipType:
        '''Specifies a 270-degree clockwise rotation followed by a horizontal and vertical flip.'''
        ...
    
    ...

class SeekOrigin:
    '''Provides the fields that represent reference points in :py:class:`aspose.psd.StreamContainer` for seeking.'''
    
    @classmethod
    @property
    def BEGIN(cls) -> SeekOrigin:
        '''Specifies the beginning of a stream.'''
        ...
    
    @classmethod
    @property
    def CURRENT(cls) -> SeekOrigin:
        '''Specifies the current position within a stream.'''
        ...
    
    @classmethod
    @property
    def END(cls) -> SeekOrigin:
        '''Specifies the end of a stream.'''
        ...
    
    ...

class SmoothingMode:
    '''Specifies whether smoothing (antialiasing) is applied to lines and curves and the edges of filled areas.'''
    
    @classmethod
    @property
    def INVALID(cls) -> SmoothingMode:
        '''Specifies an invalid mode.'''
        ...
    
    @classmethod
    @property
    def DEFAULT(cls) -> SmoothingMode:
        '''Specifies no antialiasing.'''
        ...
    
    @classmethod
    @property
    def HIGH_SPEED(cls) -> SmoothingMode:
        '''Specifies no antialiasing.'''
        ...
    
    @classmethod
    @property
    def HIGH_QUALITY(cls) -> SmoothingMode:
        '''Specifies antialiased rendering.'''
        ...
    
    @classmethod
    @property
    def NONE(cls) -> SmoothingMode:
        '''Specifies no antialiasing.'''
        ...
    
    @classmethod
    @property
    def ANTI_ALIAS(cls) -> SmoothingMode:
        '''Specifies antialiased rendering.'''
        ...
    
    ...

class StringAlignment:
    '''Specifies the alignment of a text string relative to its layout rectangle.'''
    
    @classmethod
    @property
    def NEAR(cls) -> StringAlignment:
        '''Specifies the text be aligned near the layout. In a left-to-right layout, the near position is left. In a right-to-left layout, the near position is right.'''
        ...
    
    @classmethod
    @property
    def CENTER(cls) -> StringAlignment:
        '''Specifies that text is aligned in the center of the layout rectangle.'''
        ...
    
    @classmethod
    @property
    def FAR(cls) -> StringAlignment:
        '''Specifies that text is aligned far from the origin position of the layout rectangle. In a left-to-right layout, the far position is right. In a right-to-left layout, the far position is left.'''
        ...
    
    ...

class StringDigitSubstitute:
    '''The enumeration specifies how to substitute digits in a string according to a user's locale or language.'''
    
    @classmethod
    @property
    def USER(cls) -> StringDigitSubstitute:
        '''Specifies a user-defined substitution scheme.'''
        ...
    
    @classmethod
    @property
    def NONE(cls) -> StringDigitSubstitute:
        '''Specifies to disable substitutions.'''
        ...
    
    @classmethod
    @property
    def NATIONAL(cls) -> StringDigitSubstitute:
        '''Specifies substitution digits that correspond with the official national language of the user's locale.'''
        ...
    
    @classmethod
    @property
    def TRADITIONAL(cls) -> StringDigitSubstitute:
        '''Specifies substitution digits that correspond with the user's native script or language, which may be different from the official national language of the user's locale.'''
        ...
    
    ...

class StringFormatFlags:
    '''Specifies the display and layout information for text strings.'''
    
    @classmethod
    @property
    def DIRECTION_RIGHT_TO_LEFT(cls) -> StringFormatFlags:
        '''Text is displayed from right to left.'''
        ...
    
    @classmethod
    @property
    def DIRECTION_VERTICAL(cls) -> StringFormatFlags:
        '''Text is vertically aligned.'''
        ...
    
    @classmethod
    @property
    def FIT_BLACK_BOX(cls) -> StringFormatFlags:
        '''Parts of characters are allowed to overhang the string's layout rectangle. By default, characters are repositioned to avoid any overhang.'''
        ...
    
    @classmethod
    @property
    def DISPLAY_FORMAT_CONTROL(cls) -> StringFormatFlags:
        '''Control characters such as the left-to-right mark are shown in the output with a representative glyph.'''
        ...
    
    @classmethod
    @property
    def NO_FONT_FALLBACK(cls) -> StringFormatFlags:
        '''Fallback to alternate fonts for characters not supported in the requested font is disabled. Any missing characters are displayed with the fonts missing glyph, usually an open square.'''
        ...
    
    @classmethod
    @property
    def MEASURE_TRAILING_SPACES(cls) -> StringFormatFlags:
        '''Includes the trailing space at the end of each line. By default the boundary rectangle returned by the MeasureString method excludes the space at the end of each line. Set this flag to include that space in measurement.'''
        ...
    
    @classmethod
    @property
    def NO_WRAP(cls) -> StringFormatFlags:
        '''Text wrapping between lines when formatting within a rectangle is disabled. This flag is implied when a point is passed instead of a rectangle, or when the specified rectangle has a zero line length.'''
        ...
    
    @classmethod
    @property
    def LINE_LIMIT(cls) -> StringFormatFlags:
        '''Only entire lines are laid out in the formatting rectangle. By default layout continues until the end of the text, or until no more lines are visible as a result of clipping, whichever comes first.
        Note that the default settings allow the last line to be partially obscured by a formatting rectangle that is not a whole multiple of the line height. To ensure that only whole lines are seen,
        specify this value and be careful to provide a formatting rectangle at least as tall as the height of one line.'''
        ...
    
    @classmethod
    @property
    def NO_CLIP(cls) -> StringFormatFlags:
        '''Overhanging parts of glyphs, and unwrapped text reaching outside the formatting rectangle are allowed to show. By default all text and glyph parts reaching outside the formatting rectangle are clipped.'''
        ...
    
    @classmethod
    @property
    def EXACT_ALIGNMENT(cls) -> StringFormatFlags:
        '''The exact alignment, correct padding GDI+'''
        ...
    
    ...

class StringTrimming:
    '''Specifies how to trim characters from a string that does not completely fit into a layout shape.'''
    
    @classmethod
    @property
    def NONE(cls) -> StringTrimming:
        '''Specifies no trimming.'''
        ...
    
    @classmethod
    @property
    def CHARACTER(cls) -> StringTrimming:
        '''Specifies that the text is trimmed to the nearest character.'''
        ...
    
    @classmethod
    @property
    def WORD(cls) -> StringTrimming:
        '''Specifies that text is trimmed to the nearest word.'''
        ...
    
    @classmethod
    @property
    def ELLIPSIS_CHARACTER(cls) -> StringTrimming:
        '''Specifies that the text is trimmed to the nearest character, and an ellipsis is inserted at the end of a trimmed line.'''
        ...
    
    @classmethod
    @property
    def ELLIPSIS_WORD(cls) -> StringTrimming:
        '''Specifies that text is trimmed to the nearest word, and an ellipsis is inserted at the end of a trimmed line.'''
        ...
    
    @classmethod
    @property
    def ELLIPSIS_PATH(cls) -> StringTrimming:
        '''The center is removed from trimmed lines and replaced by an ellipsis. The algorithm keeps as much of the last slash-delimited segment of the line as possible.'''
        ...
    
    ...

class TextRenderingHint:
    '''Specifies the quality of text rendering.'''
    
    @classmethod
    @property
    def SYSTEM_DEFAULT(cls) -> TextRenderingHint:
        '''Each character is drawn using its glyph bitmap, with the system default rendering hint. The text will be drawn using whatever font-smoothing settings the user has selected for the system.'''
        ...
    
    @classmethod
    @property
    def SINGLE_BIT_PER_PIXEL_GRID_FIT(cls) -> TextRenderingHint:
        '''Each character is drawn using its glyph bitmap. Hinting is used to improve character appearance on stems and curvature.'''
        ...
    
    @classmethod
    @property
    def SINGLE_BIT_PER_PIXEL(cls) -> TextRenderingHint:
        '''Each character is drawn using its glyph bitmap. Hinting is not used.'''
        ...
    
    @classmethod
    @property
    def ANTI_ALIAS_GRID_FIT(cls) -> TextRenderingHint:
        '''Each character is drawn using its antialiased glyph bitmap with hinting. Much better quality due to antialiasing, but at a higher performance cost.'''
        ...
    
    @classmethod
    @property
    def ANTI_ALIAS(cls) -> TextRenderingHint:
        '''Each character is drawn using its antialiased glyph bitmap without hinting. Better quality due to antialiasing. Stem width differences may be noticeable because hinting is turned off.'''
        ...
    
    @classmethod
    @property
    def CLEAR_TYPE_GRID_FIT(cls) -> TextRenderingHint:
        '''Each character is drawn using its glyph ClearType bitmap with hinting. The highest quality setting. Used to take advantage of ClearType font features.'''
        ...
    
    ...

class WarpMode:
    '''Specifies the type of warp transformation applied.'''
    
    @classmethod
    @property
    def PERSPECTIVE(cls) -> WarpMode:
        '''Specifies a perspective warp.'''
        ...
    
    @classmethod
    @property
    def BILINEAR(cls) -> WarpMode:
        '''Specifies a bilinear warp.'''
        ...
    
    ...

class WrapMode:
    '''Specifies how a texture or gradient is tiled when it is smaller than the area being filled.'''
    
    @classmethod
    @property
    def TILE(cls) -> WrapMode:
        '''Tiles the gradient or texture.'''
        ...
    
    @classmethod
    @property
    def TILE_FLIP_X(cls) -> WrapMode:
        '''Reverses the texture or gradient horizontally and then tiles the texture or gradient.'''
        ...
    
    @classmethod
    @property
    def TILE_FLIP_Y(cls) -> WrapMode:
        '''Reverses the texture or gradient vertically and then tiles the texture or gradient.'''
        ...
    
    @classmethod
    @property
    def TILE_FLIP_XY(cls) -> WrapMode:
        '''Reverses the texture or gradient horizontally and vertically and then tiles the texture or gradient.'''
        ...
    
    @classmethod
    @property
    def CLAMP(cls) -> WrapMode:
        '''The texture or gradient is not tiled.'''
        ...
    
    ...

